unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, SimploXML;

type
  TfrmMain = class(TForm)
    memXML: TMemo;
    btnSimploXMLLoadFromFile: TButton;
    GroupBox1: TGroupBox;
    edtName: TEdit;
    Label1: TLabel;
    edtEmail: TEdit;
    Label2: TLabel;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    edtVersionNumber: TEdit;
    edtUpdated: TEdit;
    memComment: TMemo;
    Label5: TLabel;
    Label7: TLabel;
    btnAsString: TSpeedButton;
    btnLoadFromString: TSpeedButton;
    btnMemoLoadFromFile: TButton;
    GroupBox3: TGroupBox;
    Label8: TLabel;
    edtRoot: TEdit;
    SimploXML: TSimploXML;
    procedure btnMemoLoadFromFileClick(Sender: TObject);
    procedure btnLoadFromStringClick(Sender: TObject);
    procedure btnSimploXMLLoadFromFileClick(Sender: TObject);
    procedure btnAsStringClick(Sender: TObject);
    procedure SimploXMLXMLError(Sender: TObject);
  private
    { Private declarations }
    procedure ClearFields;
    procedure UpdateFields;
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.btnMemoLoadFromFileClick(Sender: TObject);
begin
  if FileExists('sample.xml') then
  begin
    memXML.Lines.Clear;
    memXML.Lines.LoadFromFile('sample.xml');
  end;
end;

procedure TfrmMain.btnLoadFromStringClick(Sender: TObject);
begin
  ClearFields;
  if SimploXML.LoadFromString(memXML.Text) then
    UpdateFields;
end;

procedure TfrmMain.btnSimploXMLLoadFromFileClick(Sender: TObject);
begin
  ClearFields;
  if SimploXML.LoadFromFile('sample.xml') then
    UpdateFields;
end;

procedure TfrmMain.ClearFields;
begin
  edtRoot.Text := '';
  edtName.Text := '';
  edtEmail.Text := '';
  edtVersionNumber.Text := '';
  edtUpdated.Text := '';
  memComment.Lines.Clear;
end;

procedure TfrmMain.UpdateFields;
var
  i: integer;
begin
  try
    edtroot.Text := SimploXML.Root.Name;
    edtName.Text := SimploXML.Root.ElementsByName('author')[0].ElementsByName('name')[0].Text;
    edtEmail.Text := SimploXML.Root.ElementsByName('author')[0].ElementsByName('email')[0].Text;
    edtVersionNumber.Text := SimploXML.Root.ElementsByName('version')[0].Text;
    edtUpdated.Text := SimploXML.Root.ElementsByName('version')[0].ElementsByName('updated')[0].Text;

    // Comments loop
    for i := 0 to length(SimploXML.Root.ElementsByName('version')[0].ElementsByName('comment'))-1 do
    begin
      memComment.Lines.Add(SimploXML.Root.ElementsByName('version')[0].ElementsByName('comment')[i].Text);
    end;
  except
    ShowMessage('UpdateFields Error');
  end;
end;

procedure TfrmMain.btnAsStringClick(Sender: TObject);
var
  i: integer;
begin
  SimploXML.CreateRoot(edtRoot.Text);

  with SimploXML.Root.AddElement('author') do
  begin
    with AddElement('name') do
      Text := edtName.Text;
    with AddElement('email') do
      Text := edtemail.Text;
  end;

  with SimploXML.Root.AddElement('version') do
  begin
    Text := edtVersionNumber.Text;
    with AddElement('updated') do
      Text := edtUpdated.Text;
    for i := 0 to memComment.Lines.Count-1 do
    begin
      with AddElement('comment') do
        Text := memComment.Lines[i];
    end;
  end;

  memXML.Text := SimploXML.AsString;
end;

procedure TfrmMain.SimploXMLXMLError(Sender: TObject);
begin
  ShowMessage('SimploXML Error');
end;

end.
