unit SimploXMLUtils;

interface
uses classes, cStrings, ufStrings, sysutils;

  type
    TExtractStatus = (esOutTag, esInTag);

    TTagRecord = record
      IsTag: boolean;
      Text: string;
    end;
    TTagList = array of TTagRecord;

  procedure ExtractXMLTags(var TagList: TTagList; XMLDoc: string);
  function XMLQuoted(Text: string): string;

implementation

procedure ExtractXMLTags(var TagList: TTagList; XMLDoc: string);
var
  i: integer;
  ExtractStatus: TExtractStatus;
  Character, LastTag: string;

  procedure AddTagList(IsTag: boolean; Text: string);
  begin
    if (Trim(Text) <> '') and (copy(Text, 1, 4) <> '?xml') then
    begin
      SetLength(TagList, length(TagList)+1);
      TagList[length(TagList)-1].IsTag := IsTag;
      TagList[length(TagList)-1].Text :=  Text;
    end;
  end;

begin
  ExtractStatus := esOutTag;
  for i := 1 to length(XMLDoc) do
  begin
    Character := Copy(XMLDoc,i,1);
    if Character[1] in cs_Portuguese_ASCII then
    begin
      if ExtractStatus = esOutTag then
      begin
        if Character = '<' then
        begin
          AddTagList(false, LastTag);
          LastTag := '';
          ExtractStatus := esInTag;
        end
        else
          LastTag := LastTag+Character;
      end
      else if ExtractStatus = esInTag then
      begin
        if Character= '>' then
        begin
          AddTagList(true, LastTag);
          LastTag := '';
          ExtractStatus := esOutTag;
        end
        else
          LastTag := LastTag+Character;
      end;
    end;
  end;
end;

function XMLQuoted(Text: string): string;
begin
  Result := '<'+Text+'>';
end;
end.
