
unit CySheetsDsg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,   ComCtrls, ToolWin, ActnList, Menus,
  DesignWindows,DesignIntf, DesignEditors ,
  CyExcel, Buttons;

type
  TCyExcelSheetsEditor = class(TDesignWindow)
    SheetsListBox: TListBox;
    ToolBar1: TToolBar;
    ActionList1: TActionList;
    PopupMenu1: TPopupMenu;
    NewCmd: TAction;
    DeleteCmd: TAction;
    MoveUpCmd: TAction;
    MoveDownCmd: TAction;
    AddCmd1: TMenuItem;
    DeleteCmd1: TMenuItem;
    MoveDownCmd1: TMenuItem;
    MoveUpCmd1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    Cut1: TMenuItem;
    CutCmd: TAction;
    PasteCmd: TAction;
    PasteCmd1: TMenuItem;
    CopyCmd: TAction;
    CopyCmd1: TMenuItem;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    ToolButton1: TToolButton;
    procedure SheetsListBoxClick(Sender: TObject);
    procedure NewCmdExecute(Sender: TObject);
    procedure DeleteCmdExecute(Sender: TObject);
    procedure MoveUpCmdExecute(Sender: TObject);
    procedure MoveDownCmdExecute(Sender: TObject);
  private
    FExcel: TCyExcel;
    procedure SetExcel(const Value: TCyExcel);
    { Private declarations }
  protected
    procedure Activated; override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    property Excel :TCyExcel read FExcel write SetExcel;
    procedure SelectionChanged(const ADesigner: IDesigner; const ASelection: IDesignerSelections); override;

  end;
  procedure ShowSheetsEditor(ADesigner: IDesigner; AExcel :TCyExcel) ;

var
  CyExcelSheetsEditor: TCyExcelSheetsEditor;

implementation
var
  BtnTypeName: array[0..3] of PChar = ('NEW', 'DELETE', 'UP','DOWN');

{$R *.dfm}
{$R CySheetsDsg.res}

procedure ShowSheetsEditor(ADesigner: IDesigner; AExcel :TCyExcel);
begin
  if CyExcelSheetsEditor = nil then
  begin
    CyExcelSheetsEditor := TCyExcelSheetsEditor.Create(Application);
  end;
  CyExcelSheetsEditor.FExcel := AExcel;
  CyExcelSheetsEditor.Designer :=ADesigner;
  CyExcelSheetsEditor.Show;
end;

{ TCyExcelSheetsEditor }

procedure TCyExcelSheetsEditor.Activated;
var
  I,lCount : integer;
  lName:String;
  lSelections :IDesignerSelections;
begin
  if Active then
  begin
    lCount := FExcel.Sheets.Count;
    SheetsListBox.Clear ;
    lSelections := TDesignerSelections.Create;
    for I := 0 to lCount - 1 do    // Iterate
    begin
      lName := FExcel.Sheets[I].Name ;
      SheetsListBox.Items.Add(lName);
      lSelections.Add(FExcel.Sheets[I]);
    end;    // for
    Designer.SetSelections(lSelections);
  end;
end;

procedure TCyExcelSheetsEditor.SelectionChanged(const ADesigner: IDesigner;
  const ASelection: IDesignerSelections);
begin
  inherited;
//  ADesigner.SelectComponent(ASelection.Items[0]);
end;

procedure TCyExcelSheetsEditor.SetExcel(const Value: TCyExcel);
begin
  FExcel := Value;
end;

procedure TCyExcelSheetsEditor.SheetsListBoxClick(Sender: TObject);
begin
  Designer.SelectComponent(FExcel.Sheets[SheetsListBox.ItemIndex ] );
  FExcel.SheetTabSet.TabIndex := SheetsListBox.ItemIndex ;

  if self.SheetsListBox.ItemIndex = 0 then
  begin
    SpeedButton3.Enabled := false ;
  end
  else begin
    SpeedButton3.Enabled := true;
  end;
  
  if Self.SheetsListBox.ItemIndex = SheetsListBox.Count -1 then
  begin
    SpeedButton4.Enabled := false ;
  end
  else begin
    SpeedButton4.Enabled := true;
  end;
end;

procedure TCyExcelSheetsEditor.NewCmdExecute(Sender: TObject);
var
  lIndex : Integer;
begin
  lIndex :=  FExcel.SheetTabSet.NewSheet('');
  SheetsListBox.Items.Insert(lIndex,FExcel.Sheets[lIndex].Caption );
end;

procedure TCyExcelSheetsEditor.DeleteCmdExecute(Sender: TObject);
var
  lIndex : Integer;
begin
  with SheetsListBox do
  begin
    if  SelCount = Count then
    begin
      raise Exception.Create('At Least Contain One Sheet ');
      exit;
    end;

    for lIndex := Count -1 downto 0 do
    begin
      if SheetsListBox.Selected[lIndex] then
      begin
        FExcel.SheetTabSet.DelSheet(lIndex);
      end;
    end;    // for
  end;    // with
end;

procedure TCyExcelSheetsEditor.MoveUpCmdExecute(Sender: TObject);
var
  lCurIndex , lNewIndex : integer ;
begin
  lCurIndex := SheetsListBox.ItemIndex ;
  if lCurIndex > 0  then
  begin
    lNewIndex := lCurIndex -1 ;
    FExcel.SheetTabSet.MoveUp;
    SheetsListBox.Items.Move(lCurIndex ,lNewIndex ) ;
  end;
end;

procedure TCyExcelSheetsEditor.MoveDownCmdExecute(Sender: TObject);
var
  lCurIndex , lNewIndex ,lCount : integer ;
begin
  lCurIndex := SheetsListBox.ItemIndex ;
  lCount := SheetsListBox.Count ;
  if lCurIndex < lCount -1   then
  begin
    lNewIndex := lCurIndex + 1 ;
    FExcel.SheetTabSet.MoveDown;
    SheetsListBox.Items.Move(lCurIndex ,lNewIndex ) ;
  end;

end;

constructor TCyExcelSheetsEditor.Create(AOwner: TComponent);
var
  lIndex , lCount  : Integer;
  lResName : String;
  lSpeedBtn :TSpeedButton;
begin
  inherited;
  lCount := 4;
  for  lIndex  := 0 to lCount - 1 do    // Iterate
  begin
    FmtStr(lResName, '%s', [BtnTypeName[lIndex]]);
    case lIndex  of    //
      0: lSpeedBtn := SpeedButton1;
      1: lSpeedBtn := SpeedButton2;
      2: lSpeedBtn := SpeedButton3;
      3: lSpeedBtn := SpeedButton4;
    end;    // case
    lSpeedBtn.Glyph.LoadFromResourceName(HInstance, lResName);
    lSpeedBtn.NumGlyphs := 2;
  end;    // for


end;

initialization
  CyExcelSheetsEditor := nil ;
end.
