program XLDemo;

uses
  Windows,
  Graphics,
  Forms,
  JPEG,
  XLEdits,
  XLGrids,
  XLColors,
  XLSheet;

{$R *.RES}

var
  Sheet: TXLSheet;
  Styler: TXLStyler;
  I: Integer;
begin
  Application.Initialize;
  Application.Title := 'XLGrid Demo';
  with Application do begin
    Sheet := TXLSheet.Create(nil);
    Styler := TXLStyler.Create(nil);
    Styler.Name := 'DemoStyler';
    Sheet.Styler := Styler;
    Sheet.Name := 'DemoSheet';
    Sheet.Title := Sheet.Name;
    Sheet.ColCount := 10;
    Sheet.RowCount := 30;
    for I := 0 to Sheet.RowCount - 1 do Sheet.Values[-1, I] := I + 1;
    for I := 0 to Sheet.ColCount - 1 do Sheet.Values[I, -1] := Char(I + 65);
    with Sheet[-1, -1] do begin
      Value := 'XLGrid 1.6';
      Color := clYellow;
    end;
    with Sheet[1,1] do begin
      Width := 5;
      Value := 'This is a demo XLGrid-package version!';
      Font.Style := [fsBold];
      HorzAlign := haCenter;
      EditorClass := TXLMemo;
    end;
    with Sheet[1,2] do begin
      Width := 5;
      Value := 'Column and row counts are limited';
      HorzAlign := haCenter;
      EditorClass := TXLMemo;
    end;
    with Sheet.Cells[1,5] do begin
      Width := 5;
      Value := 'Ctrl+Click to select title cells';
      HorzAlign := haCenter;
      Font.Style := [fsItalic];
      EditorClass := TXLMemo;
    end;
    with Sheet do
    try
      PrintLeftMargin := 15;
      PrintTopMargin := 0;
      PrintRightMargin := 0;
      PrintBottomMargin := 0;
      SetPrinter;
    except
      MessageBox('There is no default printer installed!', PChar(Title), MB_OK or MB_IconHand);
    end;
    OpenXLSheetDesigner(Sheet);
    Sheet.Free;
    Styler.Free;
  end;
end.
