unit XLCell;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, XLGrids, XLCells, Buttons, CheckLst, XLFonts, XLColors,
  XLEdits, Mask ,MaskUtils ;

type
  TXLCellDesigner = class(TForm)
    Pages: TPageControl;
    PageControl: TTabSheet;
    PageLayout: TTabSheet;
    PageColor: TTabSheet;
    PageFont: TTabSheet;
    PageBorder: TTabSheet;
    CellClasses: TListBox;
    LabelCellClass: TLabel;
    BOK: TButton;
    BCancel: TButton;
    BApply: TButton;
    Colors: TXLColorBox;
    LabelColor: TLabel;
    LabelFont: TLabel;
    Fonts: TFontBox;
    LabelOutline: TLabel;
    Outlines: TFontOutlineBox;
    LabelSize: TLabel;
    LabelColors: TLabel;
    PanelPreview: TPanel;
    BevelPreview: TBevel;
    Label2: TLabel;
    BevelEffects: TBevel;
    Underline: TCheckBox;
    Strikeout: TCheckBox;
    LabelTextColor: TLabel;
    LabelErrorText: TLabel;
    PanelTColor: TPanel;
    PanelEColor: TPanel;
    SBTextPopup: TSpeedButton;
    SBErrorPopup: TSpeedButton;
    PopupColors: TXLPopupPanel;
    Colors2: TXLColorBox;
    Sizes: TFontSizeBox;
    PanelError: TPanel;
    PanelBorder: TPanel;
    SBTop: TSpeedButton;
    SBHInternal: TSpeedButton;
    SBBottom: TSpeedButton;
    SBBias2: TSpeedButton;
    SBLeft: TSpeedButton;
    SBVInternal: TSpeedButton;
    SBRight: TSpeedButton;
    SBBias1: TSpeedButton;
    SBAll: TSpeedButton;
    SBInside: TSpeedButton;
    SBBorder: TSpeedButton;
    SBGrid: TSpeedButton;
    SBSingle: TSpeedButton;
    SBMedium: TSpeedButton;
    SBDouble: TSpeedButton;
    LabelBorder: TLabel;
    Bevel1: TBevel;
    BorderPanel: TPanel;
    BordersBox: TPaintBox;
    PanelLColor: TPanel;
    SBBorderColor: TSpeedButton;
    PanelFrame: TPanel;
    Bevel2: TBevel;
    LabelFrame: TLabel;
    PanelLayout: TPanel;
    LabelHAlign: TLabel;
    LabelIndent: TLabel;
    LabelVAlign: TLabel;
    LabelWrapMode: TLabel;
    HAlign: TComboBox;
    IndentEdit: TEdit;
    Indent: TUpDown;
    VAlign: TComboBox;
    WrapMode: TComboBox;
    Bevel3: TBevel;
    LabelLayout: TLabel;
    PanelDiverse: TPanel;
    BevelDiverse: TBevel;
    LabelFlags: TLabel;
    CBProtect: TCheckBox;
    CBHidden: TCheckBox;
    SBFrameNone: TSpeedButton;
    SBDeepUp: TSpeedButton;
    SBDeepDown: TSpeedButton;
    SBFlatDown: TSpeedButton;
    SBFlatUp: TSpeedButton;
    SBBevelUp: TSpeedButton;
    SBBevelDown: TSpeedButton;
    PageBasedOn: TTabSheet;
    GroupInclude: TGroupBox;
    CBStyleProps: TCheckListBox;
    LabelStyles: TLabel;
    LBStyles: TListBox;
    ColorDialog1: TColorDialog;
    PanelGColor: TPanel;
    SBGridColor: TSpeedButton;
    LabelGridLines: TLabel;
    DiversePanel: TPanel;
    Bevel4: TBevel;
    LabelDiverse: TLabel;
    CBMerged: TCheckBox;
    CBNotify: TCheckBox;
    CBExtHint: TCheckBox;
    CBReadOnly: TCheckBox;
    PanelFormat: TPanel;
    FormatSample: TEdit;
    LabelSample: TLabel;
    LabelFormat: TLabel;
    Formats: TComboBox;
    PanelEditors: TPanel;
    EditClasses: TListBox;
    LabelEditorClass: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure SelectCellClass(Sender: TObject);
    procedure BApplyClick(Sender: TObject);
    procedure ClassChanged(Sender: TObject);
    procedure FormatChanged(Sender: TObject);
    procedure LayoutChanged(Sender: TObject);
    procedure IndentChanging(Sender: TObject; var AllowChange: Boolean);
    procedure StylesChanged(Sender: TObject);
    procedure CBMergedClick(Sender: TObject);
    procedure ColorsChange(Sender: TObject);
    procedure PopupColor(Sender: TObject);
    procedure CloseColors(Sender: TObject);
    procedure Colors2Change(Sender: TObject);
    procedure PanelEColorExit(Sender: TObject);
    procedure PanelTColorExit(Sender: TObject);
    procedure FontChanged(Sender: TObject);
    procedure SelectLineWidth(Sender: TObject);
    procedure PanelLColorExit(Sender: TObject);
    procedure BordersBoxPaint(Sender: TObject);
    procedure SBGridClick(Sender: TObject);
    procedure SBBorderClick(Sender: TObject);
    procedure SBInsideClick(Sender: TObject);
    procedure SBAllClick(Sender: TObject);
    procedure SideSet(Sender: TObject);
    procedure BordersBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SelectFrame(Sender: TObject);
    procedure EditClassChanged(Sender: TObject);
    procedure PagesChanging(Sender: TObject; var AllowChange: Boolean);
    procedure LBStylesClick(Sender: TObject);
    procedure ColorsDblClick(Sender: TObject);
    procedure PanelPopupColor(Sender: TObject);
    procedure PanelGColorExit(Sender: TObject);
  private
    FSource: TXLPersistent;
    FChanges: TXLProps;
    FCellClass: TXLCellClass;
    FBorders: Array[TXLSide] of TXLSideBorder;
    FSBorder: TXLSideBorder;
    procedure SetSource(Value: TXLPersistent);
    procedure BuildClasses;
    procedure SetCellClass(Value: TXLCellClass);
    procedure BuildEditors;
    procedure BuildFormats;
    procedure AdjustMerge;
    procedure BuildFont;
    procedure SetBorders(ASides: TXLSides; OnOff: Boolean);
    procedure UpdateBorders;
    procedure AdjustError(AOn: Boolean);
    procedure AdjustBasedOn;
    procedure BuildSample;
  protected
    procedure Save; dynamic;
    procedure LoadProperty(AProp: TXLProp);
    procedure SaveProperty(AProp: TXLProp);
    procedure SetChanges(Value: TXLProps); virtual;
  public
    property Source: TXLPersistent read FSource write SetSource;
    property CellClass: TXLCellClass read FCellClass write SetCellClass;
    property Changes: TXLProps read FChanges write SetChanges;
  end;

function OpenXLCellDesigner(ASource: TXLPersistent): Boolean;

implementation

{$R *.DFM}

function OpenXLCellDesigner(ASource: TXLPersistent): Boolean;
var Designer: TXLCellDesigner;
begin
  Designer := TXLCellDesigner.Create(Nil);
  try
    Designer.Source := ASource;
    Result := Designer.ShowModal = mrOk;
  finally
    Designer.Free;
  end;
end;

{ TXLCellDesigner }

procedure TXLCellDesigner.LoadProperty(AProp: TXLProp);
var I: TXLSide;
begin
  case AProp of
 prControl: begin
               CellClass := Source.CellClass;
               EditClasses.ItemIndex := Source.Editor;
               Formats.Text := Source.Format;
               BuildSample;
               // Reset changes flag of Format
               Formats.Tag := 0;
               // Reset changes flag of Editor
               EditClasses.Tag := 0;
             end;
  prLayout: begin
              HAlign.ItemIndex := Integer(Source.HorzAlign);
              VAlign.ItemIndex := Integer(Source.VertAlign);
              WrapMode.ItemIndex := Integer(Source.WrapMode);
              Indent.Position := Source.Indent;
            end;
   prColor: Colors.ActiveColor := Source.Color;
    prFont: begin
              PanelTColor.Color := Source.Font.Color;
              Fonts.SelFont := Source.Font;
              Underline.Checked := fsUnderline in Source.Font.Style;
              Strikeout.Checked := fsStrikeout in Source.Font.Style;
            end;
  prBorder: begin
              if Source is TXLProRange then
              with TXLProRange(Source), Bounds do begin
                SBHInternal.Enabled := not Single and (Top < Bottom - 1);
                SBVInternal.Enabled := not Single and (Left < Right - 1);
              end else begin
                SBHInternal.Enabled := False;
                SBVInternal.Enabled := False;
              end;
              for I := Low(I) to High(I) do FBorders[I] := Source.Border[I];
              UpdateBorders;
            end;
   prFrame: case Integer(Source.Frame) of
              1: SBFlatUp.Down := True;
              2: SBFlatDown.Down := True;
              3: SBDeepUp.Down := True;
              4: SBDeepDown.Down := True;
              5: SBBevelUp.Down := True;
              6: SBBevelDown.Down := True;
              else SBFrameNone.Down := True;
            end;
 prBasedOn: AdjustBasedOn;
// Subsitution of ErrorColor and GridLines property of TXLBaseStyle
    prHint: begin
              if Source is TXLBaseStyle then begin
                PanelEColor.Color := TXLBaseStyle(Source).ErrorColor;
                PanelGColor.Color := TXLBaseStyle(Source).LinesColor;
              end;
              AdjustError(Source is TXLBaseStyle);
            end;
// Substitution of Merge
   prValue: AdjustMerge;
   prStyles: begin
              CBProtect.Checked := csProtect in Source.Styles;
              CBHidden.Checked := csHidden in Source.Styles;
              CBNotify.Checked := csNotify in Source.Styles;
              CBExtHint.Checked := csExtHint in Source.Styles;
              CBReadOnly.Checked := csReadOnly in Source.Styles;
            end;
  end;
end;

procedure TXLCellDesigner.SaveProperty(AProp: TXLProp);
var I: TXLSide;
    L: TXLLayout;
    F: TXLCellStyles;
begin
  case AProp of
  prControl: begin
               Source.CellClass := CellClass;
               // Editor changed
               if EditClasses.Tag > 0
               then Source.Editor := EditClasses.ItemIndex;
               // Format changed
               if Formats.Tag > 0
               then Source.Format := Formats.Text;
             end;
   prLayout: begin
               L.HorzAlign := THorzAlign(HAlign.ItemIndex);
               L.VertAlign := TVertAlign(VAlign.ItemIndex);
               L.WrapMode := TWrapMode(WrapMode.ItemIndex);
               L.Indent := Indent.Position;
               Source.Layout := L;
             end;
    prColor: Source.Color := Colors.ActiveColor;
     prFont: Source.Font := PanelPreview.Font;
   prBorder: for I := Low(I) to High(I) do Source.Border[I] := FBorders[I];
    prFrame: Source.Frame := TXLFrame(LabelFrame.Tag);
  prBasedOn: Source.BasedOn := TXLStyle(LBStyles.Items.Objects[LBStyles.ItemIndex]);
// ErrorColor
     prHint: begin
               TXLBaseStyle(Source).ErrorColor := PanelEColor.Color;
               TXLBaseStyle(Source).LinesColor := PanelGColor.Color;
             end;
// Merge
    prValue: with TXLProRange(Source) do begin
               if CBMerged.Checked then Merge else Split;
             end;
    prStyles: begin
               F := Source.Styles;
               if CBProtect.Checked then F := F + [csProtect] else F := F - [csProtect];
               if CBHidden.Checked then F := F + [csHidden] else F := F - [csHidden];
               if CBExtHint.Checked then F := F + [csExtHint] else F := F - [csExtHint];
               if CBNotify.Checked then F := F + [csNotify] else F := F - [csNotify];
               if CBReadOnly.Checked then F := F + [csReadOnly] else F := F - [csReadOnly];
               Source.Styles := F;
             end;
  end;
end;

procedure TXLCellDesigner.SetSource(Value: TXLPersistent);
var I: TXLProp;
    J: Integer;
begin
  FSource := Value;
  if Source <> Nil then begin
    Caption := Source.GetNamePath + ' Properties';
    for I := Low(I) to High(I) do LoadProperty(I);
  end else Caption := 'No Object Selected';
  for J := PageControl.TabIndex to Pages.PageCount - 1 do
    Pages.Pages[J].Enabled := Source <> Nil;
  Changes := [];
end;

procedure TXLCellDesigner.FormCreate(Sender: TObject);
begin
  FSBorder.Line := slSingle;
  BuildClasses;
  Source := Nil;
end;

procedure TXLCellDesigner.BuildClasses;
var I: Integer;
    CC: TXLCellClass;
begin
  for I := 0 to XLManager.CellClassCount - 1 do begin
    CC := XLManager.CellClasses[I];
    CellClasses.Items.AddObject(Copy(CC.ClassName, 5, 255), TObject(CC));
  end;
end;

procedure TXLCellDesigner.AdjustMerge;
begin
  DiversePanel.Visible := Source is TXLProCell;
  if DiversePanel.Visible then
  with TXLProCell(Source) do begin
    CBMerged.Enabled := True;
    if Merged
    then if Single
         then CBMerged.State := cbChecked
         else CBMerged.State := cbGrayed
    else if Single
         then CBMerged.Enabled := False
         else CBMerged.State := cbUnchecked;
  end;
end;

procedure TXLCellDesigner.BuildEditors;
var I: Integer;
    EC: TWinControlClass;
begin
  with EditClasses, Items do begin
    BeginUpdate;
    try
      Clear;
      for I := 0 to XLManager.EditClassCount[CellClass] - 1 do begin
        EC := XLManager.EditClasses[CellClass, I];
        AddObject(Copy(EC.ClassName, 4, 255), TObject(EC));
      end;
      if Count > 0 then ItemIndex := 0;
      PanelEditors.Visible := Count > 0;
    finally
      EndUpdate;
    end;
  end;
end;

procedure TXLCellDesigner.BuildFormats;
begin
  Formats.Items := XLManager.Formats[CellClass];
  PanelFormat.Visible := Formats.Items.Count > 0;
  BuildSample;
end;

procedure TXLCellDesigner.SetCellClass(Value: TXLCellClass);
begin
  if FCellClass <> Value then begin
    FCellClass := Value;
    with CellClasses do
    ItemIndex := Items.IndexOfObject(TObject(CellClass));
    BuildEditors;
    BuildFormats;
    ClassChanged(Self);
  end;
end;

procedure TXLCellDesigner.SelectCellClass(Sender: TObject);
begin
  with CellClasses do
    CellClass := TXLCellClass(Items.Objects[ItemIndex]);
end;

procedure TXLCellDesigner.Save;
var I: TXLProp;
begin
  for I := Low(I) to High(I) do if I in Changes then SaveProperty(I);
  if Changes <> [] then
  Changes := [];
end;

procedure TXLCellDesigner.BApplyClick(Sender: TObject);
begin
  Save;
end;

procedure TXLCellDesigner.SetChanges(Value: TXLProps);
begin
  FChanges := Value;
  BApply.Enabled := FChanges <> [];
end;

procedure TXLCellDesigner.ClassChanged(Sender: TObject);
begin
  Changes := Changes + [prControl];
  Formats.Tag := 1;
  EditClasses.Tag := 1;
end;

procedure TXLCellDesigner.BuildSample;
begin
  if CellClass.InheritsFrom(TXLCNumber)
  then FormatSample.Text := FormatFloatEx(Formats.Text, 0) else
  if CellClass.InheritsFrom(TXLCBoolean) then FormatSample.Text := ''
  else FormatSample.Text := FormatMaskText(Formats.Text, 'Sample');
end;

procedure TXLCellDesigner.FormatChanged(Sender: TObject);
begin
  BuildSample;
  Changes := Changes + [prControl];
  Formats.Tag := 1;
end;

procedure TXLCellDesigner.LayoutChanged(Sender: TObject);
begin
  Changes := Changes + [prLayout];
end;

procedure TXLCellDesigner.IndentChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  LayoutChanged(Sender);
end;

procedure TXLCellDesigner.StylesChanged(Sender: TObject);
begin
  Changes := Changes + [prStyles];
end;

procedure TXLCellDesigner.CBMergedClick(Sender: TObject);
begin
  Changes := Changes + [prValue];
end;

procedure TXLCellDesigner.ColorsChange(Sender: TObject);
begin
  PanelPreview.Color := Colors.ActiveColor;
  PanelError.Color := Colors.ActiveColor;
  Changes := Changes + [prColor];
end;

procedure TXLCellDesigner.PopupColor(Sender: TObject);
begin
  Colors2.ActiveColor := TPanel(TControl(Sender).Parent).Color;
  PopupColors.Popup(TControl(Sender), taRightJustify);
end;

procedure TXLCellDesigner.CloseColors(Sender: TObject);
begin
  PopupColors.Close;
end;

procedure TXLCellDesigner.Colors2Change(Sender: TObject);
var E: TNotifyEvent;
begin
  if PopupColors.Active then
  with TPanel(PopupColors.Caller.Parent) do begin
    Color := Colors2.ActiveColor;
    E := OnExit;
    if Assigned(E) then E(Nil);
  end;
end;

procedure TXLCellDesigner.PanelEColorExit(Sender: TObject);
begin
  if Sender = Nil then begin
    PanelError.Font.Color := PanelEColor.Color;
    Changes := Changes + [prHint];
  end;
end;

procedure TXLCellDesigner.PanelTColorExit(Sender: TObject);
begin
  if Sender = Nil then BuildFont;
end;

procedure TXLCellDesigner.FontChanged(Sender: TObject);
begin
  BuildFont;
end;

procedure TXLCellDesigner.BuildFont;
begin
  PanelPreview.Font := Fonts.SelFont;
  with PanelPreview.Font do begin
    Color := PanelTColor.Color;
    if Underline.Checked
    then Style := Style + [fsUnderline]
    else Style := Style - [fsUnderline];
    if Strikeout.Checked
    then Style := Style + [fsStrikeout]
    else Style := Style - [fsStrikeout];
  end;
  PanelError.Font := PanelPreview.Font;
  PanelError.Font.Color := PanelEColor.Color;
  Changes := Changes + [prFont];
end;

procedure TXLCellDesigner.SelectLineWidth(Sender: TObject);
begin
  FSBorder.Line := TXLSideLine(TComponent(Sender).Tag);
end;

procedure TXLCellDesigner.PanelLColorExit(Sender: TObject);
begin
  if Sender = Nil then FSBorder.Color := PanelLColor.Color;
end;

procedure TXLCellDesigner.SetBorders(ASides: TXLSides; OnOff: Boolean);
var SB: TXLSideBorder;
    I: TXLSide;
begin
  SB := FSBorder;
  if not OnOff then SB.Line := slNone;
  for I := Low(I) to High(I) do if I in ASides then FBOrders[I] := SB;
  UpdateBorders;
  Changes := Changes + [prBorder];
end;

procedure TXLCellDesigner.UpdateBorders;
begin
  SBTop.Down := FBorders[sTop].Line > slNone;
  SBLeft.Down := FBorders[sLeft].Line > slNone;
  SBRight.Down := FBorders[sRight].Line > slNone;
  SBBottom.Down := FBorders[sBottom].Line > slNone;
  SBBias1.Down := FBorders[sBias1].Line > slNone;
  SBBias2.Down := FBorders[sBias2].Line > slNone;
  SBHInternal.Down := FBorders[sHInside].Line > slNone;
  SBVInternal.Down := FBorders[sVInside].Line > slNone;
  BordersBox.Invalidate;
end;

procedure TXLCellDesigner.BordersBoxPaint(Sender: TObject);
var CW, CH: Integer;
    R1, R2: TRect;
begin
  with BordersBox, Canvas do
  begin
    CW := ClientWidth;
    CH := ClientHeight;
    FillRect(Rect(0, 0, CW, CH));
    Pen.Style := psSolid;
    Pen.Color := clGray;
    Pen.Width := 0;
    DrawFocusRect(Rect(5, -1, CW - 4, CH + 1));
    DrawFocusRect(Rect(-1, 5, CW + 1, CH - 4));
    MoveTo(5, 5);
    Pen.Color := FBorders[sTop].Color;
    Pen.Width := Integer(FBorders[sTop].Line);
    if Pen.Width = 0 then MoveTo(CW - 5, 5) else LineTo(CW - 5, 5);

    Pen.Color := FBorders[sRight].Color;
    Pen.Width := Integer(FBorders[sRight].Line);
    if Pen.Width = 0 then MoveTo(CW - 5, CH - 5) else LineTo(CW - 5, CH - 5);

    Pen.Color := FBorders[sBottom].Color;
    Pen.Width := Integer(FBorders[sBottom].Line);
    if Pen.Width = 0 then MoveTo(5, CH - 5) else LineTo(5, CH - 5);

    Pen.Color := FBorders[sLeft].Color;
    Pen.Width := Integer(FBorders[sLeft].Line);
    if Pen.Width = 0 then MoveTo(5, 5) else LineTo(5, 5);

    R1 := ClientRect;
    InflateRect(R1, -5, -5);

    R2 := R1;

    Pen.Width := Integer(FBorders[sHInside].Line);
    if SBHInternal.Enabled then begin
      R2.Bottom := (R2.Bottom + R2.Top) div 2;
      if (Pen.Width > 0) then begin
        Pen.Color := FBorders[sHInside].Color;
        MoveTo(5, CH div 2);
        LineTo(CW - 5, CH div 2);
      end;
    end;

    Pen.Width := Integer(FBorders[sVInside].Line);
    if SBVInternal.Enabled then begin
      R2.Right := (R2.Right + R2.Left) div 2;
      if (Pen.Width > 0) then begin
        Pen.Color := FBorders[sVInside].Color;
        MoveTo(CW div 2, 5);
        LineTo(CW div 2, CH - 5);
      end;
    end;

    while R2.Top < R1.Bottom do begin
      while R2.Left < R1.Right do begin
        Pen.Width := Integer(FBorders[sBias1].Line);
        if (Pen.Width > 0) then begin
          Pen.Color := FBorders[sBias1].Color;
          MoveTo(R2.Left, R2.Top);
          LineTo(R2.Right, R2.Bottom);
        end;
        Pen.Width := Integer(FBorders[sBias2].Line);
        if (Pen.Width > 0) then begin
          Pen.Color := FBorders[sBias2].Color;
          MoveTo(R2.Left, R2.Bottom);
          LineTo(R2.Right, R2.Top);
        end;
        OffsetRect(R2, R2.Right - R2.Left, 0);
      end;
      OffsetRect(R2, R1.Left - R2.Left, R2.Bottom - R2.Top);
    end;
  end;
end;

procedure TXLCellDesigner.SBGridClick(Sender: TObject);
begin
  SetBorders(sAll, False);
end;

procedure TXLCellDesigner.SBBorderClick(Sender: TObject);
begin
  SetBorders(sAround, True);
end;

procedure TXLCellDesigner.SBInsideClick(Sender: TObject);
begin
  SetBorders(sInside, True);
end;

procedure TXLCellDesigner.SBAllClick(Sender: TObject);
begin
  SetBorders(sAll - sBiases, True);
end;

procedure TXLCellDesigner.SideSet(Sender: TObject);
begin
  with TSpeedButton(Sender) do SetBorders([TXLSide(Tag)], Down);
end;

procedure TXLCellDesigner.BordersBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var S: TXLSide;
begin
  if Button = mbLeft then
  with BordersBox do
  begin
    if X < 10 then S := sLeft else
    if X > Width - 10 then S := sRight else
    if Y < 10 then S := sTop else
    if Y > Height - 10 then S := sBottom else
    if (Abs(X - (Width div 2)) < 5) and SBVInternal.Enabled then S := sVInside else
    if (Abs(Y - (Height div 2)) < 5) and SBHInternal.Enabled then S := sHInside else exit;
    SetBorders([S], (FBorders[S].Line = slNone) or not (ssDouble in Shift));
  end;
end;

procedure TXLCellDesigner.SelectFrame(Sender: TObject);
begin
  LabelFrame.Tag := TComponent(Sender).Tag;
  Changes := Changes + [prFrame];
end;

procedure TXLCellDesigner.AdjustError(AOn: Boolean);
begin
  LabelErrorText.Visible := AOn;
  PanelError.Visible := AOn;
  PanelEColor.Visible := AOn;
  LabelGridLines.Visible := AOn;
  PanelGColor.Visible := AOn;
end;

procedure TXLCellDesigner.EditClassChanged(Sender: TObject);
begin
  Changes := Changes + [prControl];
  EditClasses.Tag := 1;
end;

procedure TXLCellDesigner.PagesChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  AllowChange := Source <> Nil;
end;

procedure TXLCellDesigner.AdjustBasedOn;
var BOA: Boolean;
    I: Integer;
begin
  BOA := (Source is TXLProCell) and (TXLProCell(Source).Sheet.Styler <> Nil);
  PageBasedOn.TabVisible := BOA;
  if BOA then with LBStyles.Items, TXLProCell(Source).Sheet do begin
    BeginUpdate;
    try
      Clear;
      Add('[Default Base Style]');
      for I := 0 to Styler.StyleCount - 1 do
      AddObject(Styler.Styles[I].Alias, Styler.Styles[I]);
      LBStyles.ItemIndex := IndexOfObject(Source.BasedOn);
      LBStylesClick(Self);
    finally
      EndUpdate;
    end;
  end;
end;

procedure TXLCellDesigner.LBStylesClick(Sender: TObject);
var Def: Boolean;
    I: TXLProp;
    AStyle: TXLStyle;
begin
  Changes := Changes + [prBasedOn];
  AStyle := TXLStyle(LBStyles.Items.Objects[LBStyles.ItemIndex]);
  Def := AStyle = Nil;
  for I := prControl to prStyles do CBStyleProps.Checked[Integer(I) - 1] := Def or (I in AStyle.Props);
end;

procedure TXLCellDesigner.ColorsDblClick(Sender: TObject);
begin
  ColorDialog1.Color := Colors.ActiveColor;
  if ColorDialog1.Execute
  then Colors.Colors[Colors.ActiveIndex] := ColorDialog1.Color;
end;

procedure TXLCellDesigner.PanelPopupColor(Sender: TObject);
begin
  PopupColor(TWinControl(Sender).Controls[0]);
end;

procedure TXLCellDesigner.PanelGColorExit(Sender: TObject);
begin
  if Sender = Nil then begin
    Changes := Changes + [prHint];
  end;
end;

end.
