unit XLReg;

interface
uses Classes,
     //DsgnIntf,
     DesignIntf, DesignEditors,VCLEditors,Consts, Windows, Forms;

type
  TXLProProperty = class(TClassProperty)
    function  GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;

  TXLStylerEditor = class(TComponentEditor)
    procedure Edit; override;
  end;

  TXLSheetEditor = class(TComponentEditor)
    procedure Edit; override;
  end;

  TXLGridEditor = class(TComponentEditor)
    procedure Edit; override;
  end;

procedure Register;

implementation
uses XLGrids, XLStyler, XLSheet, XLCell, XLFonts, XLColors;

var SheetDesigner: TXLSheetDesigner ;

procedure Register;
begin
  RegisterPropertyEditor(TXLPersistent.ClassInfo, Nil, '', TXLProProperty);
  RegisterComponentEditor(TXLStyler, TXLStylerEditor);
  RegisterComponentEditor(TXLSheet, TXLSheetEditor);
  RegisterComponentEditor(TXLGrid, TXLGridEditor);
end;

// TXLProProperty

procedure TXLProProperty.Edit;
begin
  OpenXLCellDesigner(TXLPersistent(GetOrdValue));
end;

function TXLProProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paReadOnly, paDialog];
end;

// TXLStylerEditor
procedure TXLStylerEditor.Edit;
begin
  OpenXLStylerDesigner(TXLStyler(Component));
end;

procedure SheetDesign(ASheet: TXLSheet);
begin
  if SheetDesigner = Nil then SheetDesigner := TXLSheetDesigner.Create(Nil);
  SheetDesigner.Sheet := ASheet;
  SheetDesigner.Show;
  SheetDesigner.BringToFront;
end;

// TXLStylerEditor
procedure TXLSheetEditor.Edit;
begin
  SheetDesign(TXLSheet(Component));
end;


{ TXLGridEditor }

procedure TXLGridEditor.Edit;
begin
  with TXLGrid(Component) do
  if Sheet <> Nil then SheetDesign(Sheet);
end;

initialization
  SheetDesigner := Nil;
finalization
  SheetDesigner.Free;

end.
