unit XLSheet;

{$I Defines.Inc}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  XLGrids, ExtCtrls, Menus, StdCtrls, comctrls, ToolWin, ExtDlgs,
  {$IFDEF Delphi45} ImgList, {$ENDIF}
  XLColors, XLFonts, Buttons, XLEdits ;

type
  TXLSheetDesigner = class(TForm)
    SelectionMenu: TPopupMenu;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste2: TMenuItem;
    Delete1: TMenuItem;
    N3: TMenuItem;
    Properties1: TMenuItem;
    ToolImages: TImageList;
    StandardBar: TToolBar;
    BOpen: TToolButton;
    BSave: TToolButton;
    S1: TToolButton;
    BPrint: TToolButton;
    S2: TToolButton;
    BClear: TToolButton;
    BCut: TToolButton;
    BCopy: TToolButton;
    BPaste: TToolButton;
    S3: TToolButton;
    DefStyleDesign: TToolButton;
    ScaleSelector: TComboBox;
    FormattingBar: TToolBar;
    BBold: TToolButton;
    BItalic: TToolButton;
    BUnderline: TToolButton;
    S7: TToolButton;
    S8: TToolButton;
    BLeft: TToolButton;
    BCenter: TToolButton;
    BRight: TToolButton;
    S9: TToolButton;
    BTop: TToolButton;
    BVCenter: TToolButton;
    BBottom: TToolButton;
    S10: TToolButton;
    BMerge: TToolButton;
    BMergeLines: TToolButton;
    BSplit: TToolButton;
    S11: TToolButton;
    FontSelector: TFontBox;
    SizeSelector: TFontSizeBox;
    BRemoveBorders: TToolButton;
    BAllBorders: TToolButton;
    BFrameBorders: TToolButton;
    BInsideBorders: TToolButton;
    S5: TToolButton;
    BLeftBorder: TToolButton;
    BRightBorder: TToolButton;
    BTopBorder: TToolButton;
    BBottomBorder: TToolButton;
    S6: TToolButton;
    BBias1Border: TToolButton;
    BBias2Border: TToolButton;
    ToolButton1: TToolButton;
    BProtect: TToolButton;
    BHidden: TToolButton;
    ToolButton4: TToolButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    MIImport: TMenuItem;
    Save1: TMenuItem;
    N1: TMenuItem;
    Print1: TMenuItem;
    PageSetup1: TMenuItem;
    N2: TMenuItem;
    Close1: TMenuItem;
    Edit1: TMenuItem;
    Cut2: TMenuItem;
    Copy2: TMenuItem;
    Paste1: TMenuItem;
    N4: TMenuItem;
    Clear1: TMenuItem;
    All1: TMenuItem;
    N5: TMenuItem;
    Borders1: TMenuItem;
    Colors1: TMenuItem;
    Cells1: TMenuItem;
    Hints1: TMenuItem;
    Remove1: TMenuItem;
    Columns2: TMenuItem;
    Rows2: TMenuItem;
    View1: TMenuItem;
    NormalMode: TMenuItem;
    LayoutMode: TMenuItem;
    MIHint: TMenuItem;
    N7: TMenuItem;
    Scale1: TMenuItem;
    N1001: TMenuItem;
    N1002: TMenuItem;
    N751: TMenuItem;
    N501: TMenuItem;
    N251: TMenuItem;
    Insert1: TMenuItem;
    Insert2: TMenuItem;
    Columns3: TMenuItem;
    Rows3: TMenuItem;
    N10: TMenuItem;
    MIGrid: TMenuItem;
    Cells2: TMenuItem;
    N6: TMenuItem;
    Sheet1: TMenuItem;
    N11: TMenuItem;
    Open2: TMenuItem;
    Clear2: TMenuItem;
    N12: TMenuItem;
    BackgroundDialog: TOpenPictureDialog;
    InsertImage1: TMenuItem;
    BStyler: TToolButton;
    Styler1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Grid: TXLGrid;
    N9: TMenuItem;
    EnterDirection1: TMenuItem;
    Left1: TMenuItem;
    Right1: TMenuItem;
    Bottom1: TMenuItem;
    Top1: TMenuItem;
    StatusBar: TStatusBar;
    Client1: TMenuItem;
    Title1: TMenuItem;
    PopupColors: TXLPopupPanel;
    Colors: TXLColorBox;
    BTextColor: TColorToolButton;
    BCellColor: TColorToolButton;
    BBorderColor: TColorToolButton;
    ToolButton2: TToolButton;
    EHint: TMemo;
    PrinterSetupDialog1: TPrinterSetupDialog;
    PrintDialog1: TPrintDialog;
    DefaultWidth: TMenuItem;
    DefaultHeight: TMenuItem;
    N8: TMenuItem;
    N13: TMenuItem;
    Auto1: TMenuItem;
    N14: TMenuItem;
    MergeCells1: TMenuItem;
    SplitCells1: TMenuItem;
    Titles1: TMenuItem;
    SelectAll1: TMenuItem;
    N15: TMenuItem;
    DesignMode1: TMenuItem;
    ToolButton3: TToolButton;
    ClientPanel: TPanel;
    Splitter1: TSplitter;
    procedure MergeSelection(Sender: TObject);
    procedure SplitSelection(Sender: TObject);
    procedure UpdateSelProps(Sender: TObject);
    procedure DesignSelection(Sender: TObject);
    procedure SelectScale(Sender: TObject);
    procedure KeySelectScale(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure SelectFontStyle(Sender: TObject);
    procedure SelectHAlign(Sender: TObject);
    procedure SelectVAlign(Sender: TObject);
    procedure MergeLinesSelection(Sender: TObject);
    procedure SelectFillColor(Sender: TObject);
    procedure SelectFontColor(Sender: TObject);
    procedure DesignDefStyle(Sender: TObject);
    procedure RemoveBorders(Sender: TObject);
    procedure FrameBorders(Sender: TObject);
    procedure InsideBorders(Sender: TObject);
    procedure AllBorders(Sender: TObject);
    procedure SetSideBorder(Sender: TObject);
    procedure EHintChange(Sender: TObject);
    procedure GridCurChanged(Sender: TObject);
    procedure BProtectClick(Sender: TObject);
    procedure BHiddenClick(Sender: TObject);
    procedure ImportSheet(Sender: TObject);
    procedure ExportSheet(Sender: TObject);
    procedure PrintSection(Sender: TObject);
    procedure PreviewSection(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure ClearCells(Sender: TObject);
    procedure CutSelection(Sender: TObject);
    procedure CopySelection(Sender: TObject);
    procedure PasteSelection(Sender: TObject);
    procedure DesignStyles(Sender: TObject);
    procedure RemoveBackground(Sender: TObject);
    procedure OpenBackground(Sender: TObject);
    procedure AboutDesigner(Sender: TObject);
    procedure MIHintClick(Sender: TObject);
    procedure MIGridClick(Sender: TObject);
    procedure NormalModeClick(Sender: TObject);
    procedure LayoutModeClick(Sender: TObject);
    procedure SmartScaleSelect(Sender: TObject);
    procedure All1Click(Sender: TObject);
    procedure InsertImage1Click(Sender: TObject);
    procedure Borders1Click(Sender: TObject);
    procedure Colors1Click(Sender: TObject);
    procedure Hints1Click(Sender: TObject);
    procedure Top1Click(Sender: TObject);
    procedure GridEditModeChanged(Sender: TObject);
    procedure Client1Click(Sender: TObject);
    procedure Title1Click(Sender: TObject);
    procedure SelectFont(Sender: TObject);
    procedure ColorsPopup(Sender: TObject);
    procedure ColorsClick(Sender: TObject);
    procedure ColorsChange(Sender: TObject);
    procedure BBorderColorClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SetColWidth(Sender: TObject);
    procedure SetRowHeight(Sender: TObject);
    procedure SetColCount(Sender: TObject);
    procedure SetRowCount(Sender: TObject);
    procedure DefaultWidthClick(Sender: TObject);
    procedure DefaultHeightClick(Sender: TObject);
    procedure GridColDblClick(Sender: TObject; ACoord: TPoint);
    procedure GridRowDblClick(Sender: TObject; ACoord: TPoint);
    procedure Titles1Click(Sender: TObject);
    procedure SelectAll1Click(Sender: TObject);
    procedure DesignMode1Click(Sender: TObject);
    procedure GridScaleChanged(Sender: TObject);
    procedure PopupColorsClose(Sender: TObject);
  private
    { Private declarations }
    FSide: TXLSideBorder;
    FSheet: TXLCustomSheet;
    procedure SetSheet(const Value: TXLCustomSheet);
    procedure SetPaste(const Value: Boolean);
  public
    { Public declarations }
    property Sheet: TXLCustomSheet read FSheet write SetSheet;
  end;
  procedure OpenXLSheetDesigner(ASheet: TXLSheet);

var
  XLSheetDesigner:TXLSheetDesigner;

implementation

uses XLStyler, XLCell, XLCells;

{$R *.DFM}

procedure OpenXLSheetDesigner(ASheet: TXLSheet);
var SD: TXLSheetDesigner;
begin
  SD := TXLSheetDesigner.Create(Nil);
  try
    SD.Sheet := ASheet;
    SD.ShowModal;
  finally
    SD.Free;
  end;
end;

procedure TXLSheetDesigner.MergeSelection(Sender: TObject);
begin
  Grid.Selection.Merge;
end;

procedure TXLSheetDesigner.SplitSelection(Sender: TObject);
begin
  Grid.Selection.Split;
  UpdateSelProps(Sender);
end;

procedure TXLSheetDesigner.UpdateSelProps(Sender: TObject);
var ASingle: Boolean;
begin
  with Grid.Selection do
  begin
    ASingle := Single;
    BMerge.Enabled := not ASingle;
    BSplit.Enabled := Merged;
    BMergeLines.Enabled := BMerge.Enabled or BSplit.Enabled;
    MergeCells1.Visible := BMerge.Enabled;
    SplitCells1.Visible := BSplit.Enabled;
    N3.Visible := MergeCells1.Visible or SplitCells1.Visible;
    BBold.Down := fsBold in Font.Style;
    BItalic.Down := fsItalic in Font.Style;
    BUnderline.Down := fsUnderline in Font.Style;
    FontSelector.OnFontChange := Nil;
    FontSelector.SelFont := Font;
    FontSelector.OnFontChange := SelectFont;

{$IFNDEF Ver120}
    BLeft.Down := False;
    BRight.Down := False;
    BCenter.Down := False;
    BTop.Down := False;
    BBottom.Down := False;
    BVCenter.Down := False;
{$ENDIF}

    BLeftBorder.Down := Border[sLeft].Line > slNone;
    BTopBorder.Down := Border[sTop].Line > slNone;
    BRightBorder.Down := Border[sRight].Line > slNone;
    BBottomBorder.Down := Border[sBottom].Line > slNone;
    BBias2Border.Down := Border[sBias1].Line > slNone;
    BBias1Border.Down := Border[sBias2].Line > slNone;

    case Integer(Layout.HorzAlign) of
      0: BLeft.Down := True;
      1: BRight.Down := True;
      else BCenter.Down := True;
    end;
    case Integer(Layout.VertAlign) of
      0: BTop.Down := True;
      1: BBottom.Down := True;
      else BVCenter.Down := True;
    end;
    BProtect.Down := csProtect in Styles;
    BHidden.Down := csHidden in Styles;
    StatusBar.Panels[0].Text := Grid.Selection.GetNamePath;
    SetPaste(CanPaste);
    GridCurChanged(Sender);
  end;
end;

procedure TXLSheetDesigner.DesignSelection(Sender: TObject);
begin
  OpenXLCellDesigner(Grid.Selection);
  UpdateSelProps(Sender);
end;

procedure TXLSheetDesigner.SelectScale(Sender: TObject);
var SS: String;
    I: Integer;
begin
  SS := ScaleSelector.Text;
  I := Pos('%', SS);
  while I > 0 do
  begin
    Delete(SS, I, 1);
    I := Pos('%', SS);
  end;
  Grid.Scale := StrToInt(SS);
  ScaleSelector.Text := IntToStr(Grid.Scale) + '%';
  Grid.SetFocus;
end;

procedure TXLSheetDesigner.KeySelectScale(Sender: TObject; var Key: Char);
begin
  if Key = #13 then begin Key := #0; SelectScale(Sender); end;
end;

procedure TXLSheetDesigner.FormCreate(Sender: TObject);
begin
  FSide.Line := slSingle;
  Grid.DesignMode := True;
end;

procedure TXLSheetDesigner.SelectFontStyle(Sender: TObject);
begin
  with TToolButton(Sender), Grid.Selection.Font do
  if Down
    then Style := Style + [TFontStyle(Tag)]
    else Style := Style - [TFontStyle(Tag)];
end;

procedure TXLSheetDesigner.SelectHAlign(Sender: TObject);
begin
  with TToolButton(Sender), Grid.Selection do HorzAlign := THorzAlign(Tag);
end;

procedure TXLSheetDesigner.SelectVAlign(Sender: TObject);
begin
  with TToolButton(Sender), Grid.Selection do VertAlign := TVertAlign(Tag);
end;

procedure TXLSheetDesigner.MergeLinesSelection(Sender: TObject);
begin
  Grid.Selection.MergeLines;
end;

procedure TXLSheetDesigner.SelectFillColor(Sender: TObject);
begin
  Grid.Selection.Color := BCellColor.Color;
  if BCellColor.Color = clNone then
  if Grid.Selection.Sector = sClient
  then BCellColor.Color := Sheet.BaseClientStyle.Color
  else BCellColor.Color := Sheet.BaseTitleStyle.Color;
end;

procedure TXLSheetDesigner.SelectFontColor(Sender: TObject);
begin
  if BTextColor.Color = clNone then
    if Grid.Selection.Sector = sClient
    then BTextColor.Color := Sheet.BaseClientStyle.Font.Color
    else BTextColor.Color := Sheet.BaseTitleStyle.Font.Color;
  Grid.Selection.Font.Color := BTextColor.Color;
end;

procedure TXLSheetDesigner.DesignDefStyle(Sender: TObject);
begin
  if Grid.Selection.Sector = sClient
  then OpenXLCellDesigner(Sheet.BaseClientStyle)
  else OpenXLCellDesigner(Sheet.BaseTitleStyle);
end;

procedure TXLSheetDesigner.RemoveBorders(Sender: TObject);
begin
  Grid.Selection.Borders[sAll] := XLSideBorder(clBlack, slNone);
end;

procedure TXLSheetDesigner.FrameBorders(Sender: TObject);
begin
  Grid.Selection.Borders[sAround] := FSide;
end;

procedure TXLSheetDesigner.InsideBorders(Sender: TObject);
begin
  Grid.Selection.Borders[sInside] := FSide;
end;

procedure TXLSheetDesigner.AllBorders(Sender: TObject);
begin
  Grid.Selection.Borders[sAround + sInside] := FSide;
end;

procedure TXLSheetDesigner.SetSideBorder(Sender: TObject);
begin
  with TToolButton(Sender) do
    if Down
    then Grid.Selection.Border[TXLSide(Tag)] := FSide
    else Grid.Selection.Border[TXLSide(Tag)] := XLSideBorder(clBlack, slNone);
end;

procedure TXLSheetDesigner.EHintChange(Sender: TObject);
begin
  Sheet.Cells[Grid.CurCol, Grid.CurRow].Hint := EHint.Text;
end;

procedure TXLSheetDesigner.GridCurChanged(Sender: TObject);
var C: TXLCell;
    S: String;
begin
  S := '';
  C := Sheet.PeekCells[Grid.CurCol, Grid.CurRow];
  if C <> Nil then S := C.Hint;
  EHint.Text := S;
end;

procedure TXLSheetDesigner.BProtectClick(Sender: TObject);
begin
  with Grid.Selection do
  if BProtect.Down then Styles := Styles + [csProtect]
  else Styles := Styles - [csProtect];
end;

procedure TXLSheetDesigner.BHiddenClick(Sender: TObject);
begin
  with Grid.Selection do
  if BHidden.Down then Styles := Styles + [csHidden]
  else Styles := Styles - [csHidden];
end;

procedure TXLSheetDesigner.SetSheet(const Value: TXLCustomSheet);
begin
  if FSheet <> Value then
  begin
    FSheet := Value;
    Grid.Sheet := Value;
    EHint.Enabled := FSheet <> Nil;
    FormattingBar.Visible := FSheet <> Nil;
    StandardBar.Visible := FSheet <> Nil;
  end;
end;

procedure TXLSheetDesigner.ImportSheet(Sender: TObject);
begin
  if OpenDialog1.Execute then Sheet.LoadFromFile(OpenDialog1.FileName);
end;

procedure TXLSheetDesigner.ExportSheet(Sender: TObject);
begin
  if SaveDialog1.Execute then Sheet.SaveToFile(SaveDialog1.FileName);
end;

const
  NoPrinter : PChar = 'There is no default printer selected!';

procedure TXLSheetDesigner.PrintSection(Sender: TObject);
begin
  try
    Sheet.SetPrinter;
  except
    Application.MessageBox(NoPrinter,PChar(Caption), MB_OK or MB_IconHand);
    exit;
  end;
  with PrintDialog1 do begin
    Copies := 1;
    MaxPage := Sheet.PrintPageCount;
    FromPage := 1;
    ToPage := PrintDialog1.MaxPage;
    if Execute then Sheet.PrintPages(FromPage, ToPage);
  end;
end;

procedure TXLSheetDesigner.PreviewSection(Sender: TObject);
begin
  try
    if PrinterSetupDialog1.Execute then Sheet.SetPrinter;
  except
    Application.MessageBox(NoPrinter,PChar(Caption), MB_OK or MB_IconHand);
  end;
end;

procedure TXLSheetDesigner.Close1Click(Sender: TObject);
begin
  Close;
end;

procedure TXLSheetDesigner.ClearCells(Sender: TObject);
begin
  Grid.Selection.Clear;
end;

procedure TXLSheetDesigner.CutSelection(Sender: TObject);
begin
  Grid.Selection.Cut;
  SetPaste(Grid.Selection.CanPaste);
end;

procedure TXLSheetDesigner.CopySelection(Sender: TObject);
begin
  Grid.Selection.Copy;
  SetPaste(Grid.Selection.CanPaste);
end;

procedure TXLSheetDesigner.PasteSelection(Sender: TObject);
begin
  Grid.Selection.Paste;
  SetPaste(Grid.Selection.CanPaste);
end;

procedure TXLSheetDesigner.DesignStyles(Sender: TObject);
begin
  if Sheet.Styler <> Nil
  then OpenXLStylerDesigner(Sheet.Styler);
end;

procedure TXLSheetDesigner.RemoveBackground(Sender: TObject);
begin
  Grid.Sheet.Background := Nil;
  Clear2.Enabled := False;
end;

procedure TXLSheetDesigner.OpenBackground(Sender: TObject);
begin
  if BackgroundDialog.Execute
  then Grid.Sheet.Background.LoadFromFile(BAckgroundDialog.FileName);
  Clear2.Enabled := True;
end;

procedure TXLSheetDesigner.AboutDesigner(Sender: TObject);
begin
  Application.MessageBox('XLSheet Designer 1.6'^M'Copyright  1999 Gavina Int. Inc.'^M'http://www.gavina-software.com/software','About',MB_OK or MB_IconExclamation);
end;

procedure TXLSheetDesigner.MIHintClick(Sender: TObject);
begin
  MIHint.Checked := not MIHint.Checked;
  Grid.ShowHint := MIHint.Checked;
end;

procedure TXLSheetDesigner.MIGridClick(Sender: TObject);
begin
  MIGrid.Checked := not MIGrid.Checked;
  if MIGrid.Checked
  then Grid.Options := Grid.Options + [oVertLines, oHorzLines]
  else Grid.Options := Grid.Options - [oVertLines, oHorzLines]
end;

procedure TXLSheetDesigner.NormalModeClick(Sender: TObject);
begin
  Grid.Options := Grid.Options - [oPrintLayout];
  NormalMode.Checked := True;
end;     

procedure TXLSheetDesigner.LayoutModeClick(Sender: TObject);
begin
  Grid.Options := Grid.Options + [oPrintLayout];
  LayoutMode.Checked := True;
end;

procedure TXLSheetDesigner.SmartScaleSelect(Sender: TObject);
begin
  ScaleSelector.Text := TMenuItem(Sender).Caption;
  SelectScale(Sender);
end;

procedure TXLSheetDesigner.All1Click(Sender: TObject);
begin
  Borders1Click(Sender);
  Colors1Click(Sender);
  ClearCells(Sender);
end;

procedure TXLSheetDesigner.InsertImage1Click(Sender: TObject);
begin
  if BackgroundDialog.Execute then
  begin
    Grid.Selection.Merge;
    Grid.Selection.CellClass := TXLCPicture;
    TPicture(Sheet.Cells[Grid.CurCol, Grid.CurRow].AsObject).LoadFromFile(BackgroundDialog.FileName);
  end;
end;

procedure TXLSheetDesigner.Borders1Click(Sender: TObject);
begin
  Grid.Selection.Borders[sAll] := XLSideBorder(clNone, slNone);
end;

procedure TXLSheetDesigner.Colors1Click(Sender: TObject);
begin
  Grid.Selection.Color := clNone;
end;

procedure TXLSheetDesigner.Hints1Click(Sender: TObject);
begin
  Grid.Selection.ClearHints;
end;

procedure TXLSheetDesigner.Top1Click(Sender: TObject);
begin
  with TMenuItem(Sender) do
  begin
    Checked := True;
    Grid.EnterDir := TXLDirection(Tag);
  end;
end;

procedure TXLSheetDesigner.GridEditModeChanged(Sender: TObject);
const AMess: Array[TXLEditMode] of String = ('','Enter','Edit');
begin
  StatusBar.Panels[1].Text := AMess[Grid.EditMode];
end;

procedure TXLSheetDesigner.Client1Click(Sender: TObject);
begin
  OpenXLCellDesigner(Sheet.BaseClientStyle);
end;

procedure TXLSheetDesigner.Title1Click(Sender: TObject);
begin
  OpenXLCellDesigner(Sheet.BaseTitleStyle);
end;

procedure TXLSheetDesigner.SelectFont(Sender: TObject);
var
  I: Integer;
begin
  Grid.Selection.Font := FontSelector.SelFont;
  with Grid.Selection.SheetBounds do
  for I := Top to Bottom - 1 do Grid.Sheet.RowHeights[I] := -1;
end;

procedure TXLSheetDesigner.ColorsPopup(Sender: TObject);
begin
  Colors.ActiveColor := TColorToolButton(Sender).Color;
  Grid.SetFocus;
  PopupColors.Popup(TControl(Sender), taRightJustify);
end;

procedure TXLSheetDesigner.ColorsClick(Sender: TObject);
var NE: TNotifyEvent;
begin
  if PopupColors.Caller <> nil then begin
    NE := TColorToolButton(PopupColors.Caller).OnClick;
    if Assigned(NE) then NE(Self);
  end;
  PopupColors.Close;
end;

procedure TXLSheetDesigner.ColorsChange(Sender: TObject);
begin
  if PopupColors.Active then
  TColorToolButton(PopupColors.Caller).Color := Colors.ActiveColor;
end;

procedure TXLSheetDesigner.BBorderColorClick(Sender: TObject);
begin
  if BBorderColor.Color = clNone then BBorderColor.Color := clBlack;
  FSide.Color := BBorderColor.Color;
end;

procedure TXLSheetDesigner.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caHide;
  Sheet := Nil;
end;

procedure TXLSheetDesigner.SetColWidth(Sender: TObject);
var NewValue: Integer;
    I: Integer;
    R: TRect;
begin
  R := Grid.Selection.SheetBounds;
  NewValue := Sheet.ColWidths[R.Left];
  NewValue := StrToInt(InputBox('Columns width', 'Enter new columns width: ', IntToStr(NewValue)));
  for I := R.Left to R.Right - 1 do Sheet.ColWidths[I] := NewValue;
end;

procedure TXLSheetDesigner.SetRowHeight(Sender: TObject);
var NewValue: Integer;
    I: Integer;
    R: TRect;
begin
  R := Grid.Selection.SheetBounds;
  NewValue := Sheet.RowHeights[R.Top];
  NewValue := StrToInt(InputBox('Rows height', 'Enter new rows height: ', IntToStr(NewValue)));
  for I := R.Top to R.Bottom - 1 do
  Sheet.RowHeights[I] := NewValue;
end;

procedure TXLSheetDesigner.DefaultWidthClick(Sender: TObject);
var NewText: String;
begin
  NewText := IntToStr(Sheet.ColDefWidth);
  if InputQuery('Default columns width','Enter new columns width: ', NewText) then Sheet.ColDefWidth := StrToInt(NewText);
end;

procedure TXLSheetDesigner.DefaultHeightClick(Sender: TObject);
var NewText: String;
begin
  NewText := IntToStr(Sheet.RowDefHeight);
  if InputQuery('Default rows height','Enter new rows height: ', NewText) then Sheet.RowDefHeight := StrToInt(NewText);
end;

procedure TXLSheetDesigner.SetColCount(Sender: TObject);
begin
  if Grid.CurCol < 0
  then Sheet.TitleCols := StrToInt(InputBox('Title column count', 'Enter new number of title columns: ', IntToStr(Sheet.TitleCols)))
  else Sheet.ColCount := StrToInt(InputBox('Column count', 'Enter new number of columns: ', IntToStr(Sheet.ColCount)));
end;

procedure TXLSheetDesigner.SetRowCount(Sender: TObject);
begin
  if Grid.CurRow < 0
  then Sheet.TitleRows := StrToInt(InputBox('Title row count', 'Enter new number of title rows: ', IntToStr(Sheet.TitleRows)))
  else Sheet.RowCount := StrToInt(InputBox('Row count', 'Enter new number of rows: ', IntToStr(Sheet.RowCount)));
end;

procedure TXLSheetDesigner.SetPaste(const Value: Boolean);
begin
  BPaste.Enabled := Value;
  Paste1.Enabled := Value;
  Paste2.Enabled := Value;
end;

procedure TXLSheetDesigner.GridColDblClick(Sender: TObject; ACoord: TPoint);
begin
  Grid.Sheet.ColWidths[ACoord.X] := -1;
end;

procedure TXLSheetDesigner.GridRowDblClick(Sender: TObject;
  ACoord: TPoint);
begin
  Grid.Sheet.RowHeights[ACoord.Y] := -1;
end;

procedure TXLSheetDesigner.Titles1Click(Sender: TObject);
begin
  Titles1.Checked := not Titles1.Checked;
  if Titles1.Checked
  then Grid.Options := Grid.Options + [oTitleCols, oTitleRows]
  else Grid.Options := Grid.Options - [oTitleCols, oTitleRows]
end;

procedure TXLSheetDesigner.SelectAll1Click(Sender: TObject);
begin
  Grid.SelectAll;
end;

procedure TXLSheetDesigner.DesignMode1Click(Sender: TObject);
begin
  DesignMode1.Checked := not DesignMode1.Checked;
  Grid.DesignMode := DesignMode1.Checked;
end;

procedure TXLSheetDesigner.GridScaleChanged(Sender: TObject);
begin
  ScaleSelector.Text := IntToStr(Grid.Scale)+'%';
end;

procedure TXLSheetDesigner.PopupColorsClose(Sender: TObject);
begin
  ActiveControl := Grid;
end;

end.



