unit XLStream;

interface uses Classes;

type

 TXLStream = class(TStream)
  private
    function LoadInteger: Integer;
    function LoadDouble: Double;
    function LoadString: String;
    procedure SaveInteger(AValue: Integer);
    procedure SaveDouble(AValue: Double);
    procedure SaveString(const AValue: String);
  public
    property IntegerIO: Integer read LoadInteger write SaveInteger;
    property DoubleIO: Double read LoadDouble write SaveDouble;
    property StringIO: String read LoadString write SaveString;
  end;

implementation

{ TXLStream }

function TXLStream.LoadDouble: Double;
begin
  Read(Result, SizeOf(Result));
end;

function TXLStream.LoadInteger: Integer;
begin
  Read(Result, SizeOf(Result));
end;

function TXLStream.LoadString: String;
var Len: Integer;
begin
  Result := '';
  Read(Len, SizeOf(Integer));
  if Len > 0 then
  begin
    SetLength(Result, Len);
    Read(Pointer(Result)^, Len);
  end;
end;

procedure TXLStream.SaveDouble(AValue: Double);
begin
  Write(AValue, SizeOf(AValue));
end;

procedure TXLStream.SaveInteger(AValue: Integer);
begin
  Write(AValue, SizeOf(AValue));
end;

procedure TXLStream.SaveString(const AValue: String);
var Len: Integer;
begin
  Len := Length(AValue);
  Write(Len, SizeOf(Integer));
  if Len > 0 then Write(PChar(AValue)^, Len);
end;

end.
