unit Main;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms, StdCtrls;
  
type
  TFormMain = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    procedure FormShow(Sender: TObject);
  end;
  TProvaThread=class(TThread)
    procedure Execute; override;
  private
    procedure AProc(P1,P2:integer; ID: string); pascal; {IMPORTANT: use pascal calling convention}
  public
    AForm: TForm;
    ID: Integer;
  end;

var
  FormMain: TFormMain;

implementation

{$R *.dfm}

uses
  ParamSync;

{ The original procedure...

procedure TProvaThread.AProc(P1,P2: integer; ID: string);
var
  List: TStringList;
  P3: Integer;
  S: string;
begin
  P3 := P1 + P2;
  Self.AForm.Caption := IntToStr(P3);
  S := Self.AForm.Caption;
  List := TStringList.Create;
  List.Add('Prova' + ID);
  Self.AForm.Caption := List[0] + ' ' + Self.AForm.Caption;
  List.Free;
  case StrToInt(ID) of
    0: TFormMain(Self.AForm).Edit1.Text := S;
    1: TFormMain(Self.AForm).Edit2.Text := S;
    2: TFormMain(Self.AForm).Edit3.Text := S;
  end;
end;

}

{ The synchronized procedure... }

procedure TProvaThread.AProc(P1,P2: integer; ID: string);
var
  List: TStringList;
  P3: Integer;
  S: string;

procedure AProc;
begin
  P3 := P1 + P2;
  Self.AForm.Caption := IntToStr(P3);
  S := Self.AForm.Caption;
  List := TStringList.Create;
  List.Add('Prova' + ID);
  Self.AForm.Caption := List[0] + ' ' + Self.AForm.Caption;
  List.Free;
  case StrToInt(ID) of
    0: TFormMain(Self.AForm).Edit1.Text := S;
    1: TFormMain(Self.AForm).Edit2.Text := S;
    2: TFormMain(Self.AForm).Edit3.Text := S;
  end;
end;

begin
  ParamSynchronize(@AProc);
end;

procedure TProvaThread.Execute;
var
  I: Integer;
begin
  Sleep(500 * ID);
  I := 0;
  while I < 100 do begin
    AProc(ID * 1000,I,IntToStr(ID));
    Inc(I);
    Sleep(10 + ID * 1);
  end;
end;

procedure TFormMain.FormShow(Sender: TObject);
begin
  with TProvaThread.Create(true) do begin
    AForm := Self;
    ID := 0;
    Resume;
  end;
  with TProvaThread.Create(true) do begin
    AForm := Self;
    ID := 1;
    Resume;
  end;
  with TProvaThread.Create(true) do begin
    AForm := Self;
    ID := 2;
    Resume;
  end;
end;

end.
