{-----------------------------------------------------------------------------
 Unit Name: MSOAddIn_Utils

 Author:    Vadim Krochak
 Copyright:  2003 All rights reserved.
 E.Mail:    vkrochak@bezeqnt.net
 License:   Don't redistribute for cash.  Don't change and
  redistribute under your name.  Let me know if you fix anything or improve
  anything.

 Purpose: MSOAddIn helper routines implementation.
 History:
-----------------------------------------------------------------------------}

unit MSOAddIn_Utils;

interface

uses Office_TLB;

function FindCommandBar(CommandBars: CommandBars; const CmdBarName: WideString): Integer;

//******************************************************************************
//******************************************************************************

implementation

uses Windows, SysUtils;


//******************************************************************************
//******************************************************************************

{{*** VK ***********************************************************************
  Function   :FindCommandBar
  Purpose    :finds command bar in collection of bars
  Parameters :CommandBars - collection of bars; CmdBarName - name of bar
  Returns    :index of bar in collection if found
*******************************************************************************}
function FindCommandBar(CommandBars: CommandBars; const CmdBarName: WideString): Integer;
var
	I: Integer;
begin

	Result := 0;

  try

		for I := 1 to CommandBars.Count do
    begin

      if CommandBars.Item[I].Name = CmdBarName then
      begin
        Result := I;
        Break;
      end; // if

    end;// for

  except
    on E: Exception do
    begin
      {$IFDEF DEBUG}
      OutputDebugString(PChar(E.Message));
      {$ENDIF}
    end;
  end;// try-except

end;

end.
