unit MapTestForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, FileMapping;

type
  TForm1 = class(TForm)
    mmData: TMemo;
    Label1: TLabel;
    edMutex: TEdit;
    edFile: TEdit;
    edMap: TEdit;
    odFile: TOpenDialog;
    Label3: TLabel;
    Label4: TLabel;
    cmdFile: TButton;
    cmdGo: TButton;
    cmdWrite: TButton;
    cbTime: TComboBox;
    Timer1: TTimer;
    Label5: TLabel;
    Memo1: TMemo;
    Label2: TLabel;
    cbMutex: TComboBox;
    procedure cmdFileClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cmdGoClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure cbMutexChange(Sender: TObject);
    procedure cbTimeChange(Sender: TObject);
    procedure cmdWriteClick(Sender: TObject);
  private
    FMtx  : TMutex;
    FMap  : TFileMapping;
    FView : TFileView;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}
uses MapWriteForm;

procedure TForm1.cmdFileClick(Sender: TObject);
begin
  if odFile.Execute then
    edFile.Text := odFile.Files[0];
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  cbTime.ItemIndex := 0;
  cbMutex.ItemIndex := 0;
end;

procedure TForm1.cmdGoClick(Sender: TObject);
begin
  if edMap.Text <> '' then begin
    if edMutex.Text = '' then Exit;
    FMtx := TMutex.Create(edMutex.Text);
    FMtx.TimeOut := (cbMutex.ItemIndex + 1) * 1000;
    FMap := TFileMapping.Create(edFile.Text, edMap.Text, nil, PAGE_READWRITE, 0);
    FView := FMap.MakeView(FMtx, 0);
  end else begin
    FMtx := nil;
    FMap := TFileMapping.Create('', edMap.Text, nil, PAGE_READWRITE, 4096);
    FView := FMap.MakeView(nil, 0);
  end;
  cmdGo.Enabled := false;
  cmdWrite.Enabled := true;
  Timer1.Enabled := true;
  Timer1Timer(self);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if FView <> nil then FView.Free;
  if FMap <> nil then FMap.Free;
  if FMtx <> nil then FMtx.Free;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  s: string;
  l: cardinal;
begin
  mmData.Clear;

  SetLength(s, 4096);
  FView.Position := 0;
  l := FView.Read(PChar(s), 4096);
  if l > 0 then begin
    l := Pos(#0, s);
    if l > 0 then begin
      SetLength(s, l);
      mmData.Lines.Text := s;
    end;
  end;
end;

procedure TForm1.cbMutexChange(Sender: TObject);
begin
  if FMtx <> nil then
    FMtx.TimeOut := (cbMutex.ItemIndex + 1) * 1000;
end;

procedure TForm1.cbTimeChange(Sender: TObject);
begin
  Timer1.Interval := (cbTime.ItemIndex + 1) * 1000;
end;

procedure TForm1.cmdWriteClick(Sender: TObject);
var s : string;
begin
  WriteForm := TForm2.Create(self);
  WriteForm.ShowModal;
  s := WriteForm.mmWrite.Lines.Text;
  if Length(s) > 0 then begin
    FView.Position := 0;
    FView.Write(PChar(s), Length(s));
  end;
end;

end.
