{ TfmNormalPreview -      .
  (C) by Vladimir Kladov, 2002

  v1.0.1 (17.10.2002) -  
                      (   )
}

unit NormalPreview;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ToolWin, ExtCtrls, StdCtrls, Printers, Menus,
  ImgList, Buttons;

type
  TfmNormalPreview = class(TForm)
    Panel1: TPanel;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    Label1: TLabel;
    ScrollBox1: TScrollBox;
    ToolButton7: TToolButton;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    PaintPanel: TPanel;
    PaintBox1: TPaintBox;
    BelowPanel: TPanel;
    PopupMenu2: TPopupMenu;
    N4: TMenuItem;
    ToolButton8: TToolButton;
    ImageList1: TImageList;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    PrintDialog1: TPrintDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    ImageList2: TImageList;
    Panel2: TPanel;
    ToolBar2: TToolBar;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ScrollBox1Resize(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure ToolButton7Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure ToolButton8Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FCurrentPage: Integer;
    FReport: TObject;
    FFitMode: Integer;
    FPreviewBuf: TBitmap;
    FPreviewPage: Integer;
    procedure SetCurrentPage(const Value: Integer);
    function GetPrinter: TPrinter;
    procedure SetFitMode(const Value: Integer);
    { Private declarations }
  protected
    procedure EnableButtons;
    function ScaleToScreenX( X: Integer ): Integer;
    procedure AdjustFitMode;
    procedure PreparePages;
  public
    { Public declarations }
    property CurrentPage: Integer read FCurrentPage write SetCurrentPage;
    property Report: TObject read FReport write FReport;
    property Printer: TPrinter read GetPrinter;
    property FitMode: Integer read FFitMode write SetFitMode;
  end;

var
  fmNormalPreview: TfmNormalPreview;

implementation

uses
  NormalReport, NormalResources;

{$R *.DFM}

{ TfmNormalPreview }

procedure TfmNormalPreview.SetCurrentPage(const Value: Integer);
begin
  FCurrentPage := Value;
  AdjustFitMode;
  EnableButtons;
  PaintBox1.Invalidate;
end;

procedure TfmNormalPreview.ToolButton1Click(Sender: TObject);
begin
  CurrentPage := 0;
  EnableButtons;
end;

procedure TfmNormalPreview.ToolButton2Click(Sender: TObject);
begin
  if CurrentPage > 0 then
    CurrentPage := CurrentPage - 1;
  EnableButtons;
end;

procedure TfmNormalPreview.ToolButton3Click(Sender: TObject);
begin
  if CurrentPage < TNormalReport( Report ).PageCount-1 then
    CurrentPage := CurrentPage + 1;
  EnableButtons;
end;

procedure TfmNormalPreview.ToolButton4Click(Sender: TObject);
begin
  CurrentPage := TNormalReport( Report ).PageCount-1;
  EnableButtons;
end;

procedure TfmNormalPreview.FormShow(Sender: TObject);
begin
  EnableButtons;
  if  TNormalReport(Report).PageCount > 0 then
    SetCurrentPage( 0 );
end;

procedure TfmNormalPreview.EnableButtons;
begin
  if TNormalReport( Report ).PageCount = 0 then
  begin
    Label1.Caption := rsNoData;
    ToolButton1.Enabled := FALSE;
    ToolButton2.Enabled := FALSE;
    ToolButton3.Enabled := FALSE;
    ToolButton4.Enabled := FALSE;
    PaintBox1.Width := 0;
    ToolButton7.Enabled := FALSE;
    Exit;
  end;
  Label1.Caption := rsPage + ' ' + IntToStr( CurrentPage + 1 ) +
                 rsFrom + IntToStr( TNormalReport( Report ).PageCount ) + '   ';
  ToolButton1.Enabled := CurrentPage > 0;
  ToolButton2.Enabled := CurrentPage > 0;
  ToolButton3.Enabled := CurrentPage < TNormalReport( Report ).PageCount-1;
  ToolButton4.Enabled := CurrentPage < TNormalReport( Report ).PageCount-1;
  ToolButton7.Enabled := TRUE;
end;

procedure TfmNormalPreview.PaintBox1Paint(Sender: TObject);
var MF: HEnhMetafile;
    Tmp: TBitmap;
begin
  PaintBox1.Canvas.Brush.Color := clWhite;
  PaintBox1.Canvas.FillRect( PaintBox1.ClientRect );
  if CurrentPage >= TNormalReport( Report ).PageCount then Exit;
  MF := TNormalReport( Report ).Images[ CurrentPage ];
  AdjustFitMode;
  if (FPreviewPage <> CurrentPage) or (FPreviewBuf = nil) or
     (FPreviewBuf.Width <> PaintBox1.Width) or (FPreviewBuf.Height <> PaintBox1.Height) then
  begin
    FPreviewBuf.Free;
    FPreviewBuf := TBitmap.Create;
    FPreviewBuf.PixelFormat := pf24bit;
    FPreviewBuf.Width := PaintBox1.Width;
    FPreviewBuf.Height := PaintBox1.Height;
    FPreviewPage := CurrentPage;
    if FPreviewBuf.Width >= TNormalReport( Report ).PagePixelsSize.cx then
      PlayEnhMetaFile( FPreviewBuf.Canvas.Handle, MF,
                       Rect( 0, 0, FPreviewBuf.Width, FPreviewBuf.Height ) )
    else
    begin
      Tmp := TBitmap.Create;
      TRY
        Tmp.PixelFormat := pf24bit;
        Tmp.Width := TNormalReport( Report ).PagePixelsSize.cx;
        Tmp.Height := TNormalReport( Report ).PagePixelsSize.cy;
        Tmp.Canvas.Brush.Color := clWhite;
        Tmp.Canvas.FillRect( Rect( 0, 0, Tmp.Width, Tmp.Height ) );
        PlayEnhMetaFile( Tmp.Canvas.Handle, MF,
                         Rect( 0, 0, Tmp.Width, Tmp.Height ) );
        SetStretchBltMode( FPreviewBuf.Canvas.Handle, HALFTONE );
        SetBrushOrgEx( FPreviewBuf.Canvas.Handle, 0, 0, nil );
        StretchBlt( FPreviewBuf.Canvas.Handle, 0, 0, FPreviewBuf.Width, FPreviewBuf.Height,
                    Tmp.Canvas.Handle, 0, 0, Tmp.Width, Tmp.Height, SRCCOPY );
      FINALLY
        Tmp.Free;
      END;
    end;
    PaintBox1.Canvas.Draw( 0, 0, FPreviewBuf );
  end;
end;

procedure TfmNormalPreview.ToolButton5Click(Sender: TObject);
begin
  PrintDialog1.MinPage := 1;
  PrintDialog1.MaxPage := TNormalReport( Report ).PageCount;
  PrintDialog1.FromPage := 1;
  PrintDialog1.ToPage := TNormalReport( Report ).PageCount;
  if PrintDialog1.Execute then
  begin
    if Assigned( Report ) then
      ( Report as TNormalReport ).PrintPages( PrintDialog1.FromPage - 1,
        Printdialog1.ToPage - PrintDialog1.FromPage + 1 );
    Close;
  end;
end;

procedure TfmNormalPreview.ToolButton6Click(Sender: TObject);
begin
  Close;
end;

function TfmNormalPreview.ScaleToScreenX(X: Integer): Integer;
var Dc0: HDC;
begin
  Dc0 := GetDC(0);
  Result := Round(
         GetDeviceCaps( Dc0, LogPixelsX ) / Printer.PageWidth * 72 * X );
  ReleaseDC( 0, Dc0 );
end;

function TfmNormalPreview.GetPrinter: TPrinter;
begin
  if Assigned( Report ) then
    Result := TNormalReport( Report ).Printer
  else
    Result := Printers.Printer;
end;

procedure TfmNormalPreview.N1Click(Sender: TObject);
begin
  FitMode := 0;
end;

procedure TfmNormalPreview.N2Click(Sender: TObject);
begin
  FitMode := 1;
end;

procedure TfmNormalPreview.N3Click(Sender: TObject);
begin
  FitMode := 2;
end;

procedure TfmNormalPreview.SetFitMode(const Value: Integer);
begin
  FFitMode := Value;
  AdjustFitMode;
end;

procedure TfmNormalPreview.AdjustFitMode;
var K, D: Extended;
begin
  if TNormalReport( Report ).PageCount = 0 then Exit;
  K := TNormalReport( Report ).PagePixelsSize.cx;
  D := TNormalReport( Report ).PagePixelsSize.cy;
  K := K / D;
  case FFitMode of
  0: begin //  
       SetScrollPos( ScrollBox1.Handle, SB_VERT, 0, TRUE );
       BelowPanel.Height := 0;
       PaintPanel.Height := ScrollBox1.ClientHeight;
       PaintPanel.Width := Round( K * PaintPanel.Height );
       ScrollBox1.Color := clBtnFace;
     end;
  1: begin //  
       BelowPanel.Height := GetSystemMetrics( SM_CYHSCROLL );
       SetScrollPos( ScrollBox1.Handle, SB_HORZ, 0, TRUE );
       PaintPanel.Width := ScrollBox1.ClientWidth;
       PaintPanel.Height := Round( PaintPanel.Width / K );
       if PaintPanel.Width < ScrollBox1.ClientWidth then
       begin
         PaintPanel.Width := ScrollBox1.ClientWidth;
         PaintPanel.Height := Round( PaintPanel.Width / K );
       end;
       ScrollBox1.Color := clWhite;
     end;
  2: begin
       BelowPanel.Height := 0;
       PaintPanel.Width := TNormalReport( Report ).PagePixelsSize.cx;
       PaintPanel.Height := TNormalReport( Report ).PagePixelsSize.cy;
       ScrollBox1.Color := clBtnFace;
     end;
  end;
  PaintBox1.Width := PaintPanel.Width;
  PaintBox1.Height := PaintPanel.Height - BelowPanel.Height;
end;

procedure TfmNormalPreview.FormDestroy(Sender: TObject);
begin
  FPreviewBuf.Free;
end;

procedure TfmNormalPreview.ScrollBox1Resize(Sender: TObject);
begin
  AdjustFitMode;
end;

procedure TfmNormalPreview.PopupMenu1Popup(Sender: TObject);
begin
  case FFitMode of
  0: N1.Checked := TRUE;
  1: N2.Checked := TRUE;
  2: N3.Checked := TRUE;
  end;
end;

procedure TfmNormalPreview.ToolButton7Click(Sender: TObject);
var R: TRect;
begin
  R := ToolButton7.BoundsRect;
  R.Top := R.Bottom;
  R.TopLeft := Toolbar1.ClientToScreen( R.TopLeft );
  PopupMenu1.Popup( R.Left, R.Top );
end;

procedure TfmNormalPreview.N4Click(Sender: TObject);
begin
  if TNormalReport( Report ).PageCount > 0 then
    TNormalReport( Report ).PrintPages( CurrentPage, 1 );
end;

procedure TfmNormalPreview.ToolButton8Click(Sender: TObject);
begin
  if PrinterSetupDialog1.Execute then
    PreparePages;
end;

procedure TfmNormalPreview.PreparePages;
begin
  FCurrentPage := 0;
  if Assigned( TNormalReport( Report ).OnPrint ) then
  begin
    TNormalReport( Report ).Clear;
    TNormalReport( Report ).Stage := 1;
    TNormalReport( Report ).OnPrint( Self );
    if TNormalReport( report ).PageCount = 0 then Exit;
    TNormalReport( Report ).Clear;
    TNormalReport( Report ).Stage := 2;
    TNormalReport( Report ).OnPrint( Self );
  end;
  CurrentPage := 0;
  AdjustFitMode;
end;

procedure TfmNormalPreview.SpeedButton1Click(Sender: TObject);
var R: TRect;
begin
  SystemParametersInfo( SPI_GETWORKAREA, 0, @ R, 0 );
  Top := R.Top;
  Height := R.Bottom - R.Top;
end;

procedure TfmNormalPreview.FormCreate(Sender: TObject);
begin
  //   :
  N1.Caption := rsN1;
  N2.Caption := rsN2;
  N3.Caption := rsN3;
  N4.Caption := rsN4;
end;

end.
