{ TNormalReport -  .
  (C) by Vladimir Kladov, 2002
================================================================================

  v1.0.1 (17.10.2002) -  
                        (   )
  v1.1   (24.10.2002) -    , 
                            ( : 
			 ..)
  v1.2   (27.11.2002) -    VCL ( API),
			      ;
			NormalLabel   NormalBand (
			  TGraphicControl).
  v1.3   (5.12.2002)  -   ,    
			   /; 
			-    :
			   .
  v1.4   (11.12.2002) -  Autosize  TNormalLabel,   true.
			 ParentFont=true    TNormalLabel.
  v1.5   (15.01.2003) -     WordWrap  TNormalLabel,
			 WordWrap=false,      
			 .

     Delphi.   
    .    -  
,   ,       ()
 ,   ,    ...
  -  .   ,    
,    .       
    : ,     ,
   ,        
...     ,    
      Delphi (
 TNormalBand  TNormalLabel).     
    ,   Printer   
.     []  ,  
     [] .

    Key Objects Library   
  .         VCL.
    ()     
 QReport'.

 

e-mail: bonanzas@online.sinor.ru
WebPage: http://bonanzas.rinet.ru

ToDo: 1.     ()  
      .
      2.   -.
================================================================================
}


unit NormalReport;

interface

uses Windows, Messages, Forms, Dialogs, Classes, Printers, Controls, Graphics,
     SysUtils, NormalPreview, NormalProgress;

type
  ENormalReportException = class( Exception )
  end;

  TMF = HDC; // DC     

  TPaperSize = ( psA4, psA5, psA6, psA3, psLetter, psCustom );
  TBandLayout = ( blLeft, blCenter, blRight, blExpandRight );

  TProcOfObj = procedure of object;

  TPreviewScale = ( psFitPage, psFitWidth, psAsIs );

  TNormalReport = class( TComponent )
  private
    FPageTop: Boolean;
    FY: Integer;
    FOnNewPage: TNotifyEvent;
    FPrinter: TPrinter;
    FX: Integer;
    FPrinting: Boolean;
    FPages: TList;
    FImages: TList;
    FStage: Integer;
    FOnPrint: TNotifyEvent;
    FPreviewForm: TfmNormalPreview;
    FBottom: Integer;
    FPagePixelsSize: TSize;
    FPaperSize: TPaperSize;
    FCustomPaperSize: TSize;
    FPageWidth: Integer;
    FPageHeight: Integer;
    FDoubleBufferedPreview: Boolean;
    FCurBandHeight: Integer;
    FOnEndBand: TNotifyEvent;
    fEndBandHandling: Boolean;
    fNewPageHandling: Boolean;
    FExactScale: Boolean;
    FDocName: String;
    FTwoStagePrinting: Boolean;
    FShowProgress: Boolean;
    FOrientation: TPrinterOrientation;
    FSetOrientation: Boolean;
    FPreviewScale: TPreviewScale;
    FOnCreatePreviewForm: TNotifyEvent;
    FOnShowPreviewForm: TNotifyEvent;
    procedure SetPageTop(const Value: Boolean);
    procedure SetPrinter(const Value: TPrinter);
    function GetPagesCount: Integer;
    function GetPreviewForm: TfmNormalPreview;
    procedure SetPreviewForm(const Value: TfmNormalPreview);
    function GetCurrentPage: TMF;
    function GetPrinter: TPrinter;
    function GetPagePixelsSize: TSize;
    function GetOrientation: TPrinterOrientation;
    procedure SetPaperSize(const Value: TPaperSize);
    procedure SetCustomPaperSize(const Value: TSize);
    function GetPageHeight: Integer;
    function GetPageWidth: Integer;
    procedure GetPageWidthHeight;
    procedure SetX(const Value: Integer);
    procedure SetY(const Value: Integer);
    function GetPage: Integer;
    function GetImages(Idx: Integer): HEnhMetafile;
    function GetPages(Idx: Integer): TMF;
    function GetPageCount: Integer;
    procedure SetTwoStagePrinting(const Value: Boolean);
    procedure SetShowProgress(const Value: Boolean);
    procedure SetOrientation(const Value: TPrinterOrientation);
    procedure SetPreviewScale(const Value: TPreviewScale);
  protected
    FFastAndDraft: Boolean;
    FPagesAfterStage1: Integer;
    FProgress: TfmNormalProgress;
    FCancelled: Boolean;
    function AddPage: TMF;
    function PaintBand( MF: TMF; Band: TWinControl; X, Y: Integer ): Integer;
    function ScaleX( X: Integer ): Integer;
    function ScaleY( Y: Integer ): Integer;
    procedure PreparePages;
  public
    Constructor Create( AOwner: TComponent ); override;
    Destructor Destroy; override;
    procedure Clear;
    procedure DoPrintPreview( Proc: TProcOfObj );
    procedure DoPrint;
    procedure DoPreview;
    procedure DoPreviewModal;
    property PreviewForm: TfmNormalPreview read GetPreviewForm write SetPreviewForm;
    property PagePixelsSize: TSize read GetPagePixelsSize;
    property PaperSize: TPaperSize read FPaperSize write SetPaperSize;
    property CustomPaperSize: TSize read FCustomPaperSize write SetCustomPaperSize;
    property Page: Integer read GetPage;
    property PageWidth: Integer read GetPageWidth;
    property PageHeight: Integer read GetPageHeight;
    property CurrentPage: TMF read GetCurrentPage;
    property Printer: TPrinter read GetPrinter write SetPrinter;
    property PageTop: Boolean read FPageTop write SetPageTop;
    property X: Integer read FX write SetX;
    property Y: Integer read FY write SetY;
    property Pages[ Idx: Integer ]: TMF read GetPages;
    property Images[ Idx: Integer ]: HEnhMetafile read GetImages;
    property PageCount: Integer read GetPageCount;
    property Cancelled: Boolean read FCancelled;
    procedure Cancel( const Reason: String );
  published
    procedure AddBand( Band: TWinControl; BandLayout: TBandLayout = blLeft );
    procedure AddFooter( Band: TWinControl; BandLayout: TBandLayout = blLeft );
    procedure AddRight(Band: TWinControl; AllowWrapBand: Boolean = TRUE);
    procedure NewPage;
    procedure NewLine;
    property Bottom: Integer read FBottom;
    property PagesCount: Integer read GetPagesCount;
    procedure PrintPages( Start, Count: Integer );
    procedure Print;
    procedure Preview;
    procedure PreviewModal;
    procedure Abort;
    property Printing: Boolean read FPrinting;
    property Stage: Integer read FStage write FStage;
    property OnPrint: TNotifyEvent read FOnPrint write FOnPrint;
    property OnNewPage: TNotifyEvent read FOnNewPage write FOnNewPage;
    property OnEndBand: TNotifyEvent read FOnEndBand write FOnEndBand;
    function HeightAvailable: Integer;
    property DoubleBufferedPreview: Boolean read FDoubleBufferedPreview write FDoubleBufferedPreview;
    property ExactScalePrint: Boolean read FExactScale write FExactScale;
    property DocumentName: String read FDocName write FDocName;
    property TwoStagePrinting: Boolean read FTwoStagePrinting write SetTwoStagePrinting;
    property ShowProgress: Boolean read FShowProgress write SetShowProgress;
    property Orientation: TPrinterOrientation read GetOrientation write SetOrientation;
    property PreviewScale: TPreviewScale read FPreviewScale write SetPreviewScale;
    property OnCreatePreviewForm: TNotifyEvent read FOnCreatePreviewForm write FOnCreatePreviewForm;
    property OnShowPreviewForm: TNotifyEvent read FOnShowPreviewForm write FOnShowPreviewForm;
  end;

procedure Register;

{$R *.DCR}

implementation

uses
  NormalBands, NormalResources;

procedure Register;
begin
  RegisterComponents( 'Kladov', [ TNormalReport, TNormalBand, TNormalLabel ] );
end;

{ TNormalReport }

procedure TNormalReport.Abort;
begin
  Clear;
  if Assigned( FPrinter ) then
  begin
    if Printer.Printing then
      Printer.Abort;
  end;
end;

procedure TNormalReport.AddBand(Band: TWinControl; BandLayout: TBandLayout = blLeft);
var MF: TMF;
    OldW: Integer;
begin
  if FCurBandHeight > 0 then
  begin
    if not fEndBandHandling then
    if Assigned( OnEndBand ) then
    begin
      fEndBandHandling := TRUE;
      OnEndBand( Self );
      fEndBandHandling := FALSE;
    end;
    FX := 0;
    FY := FY + FCurBandHeight;
  end;
  if Band.Height > HeightAvailable then
    NewPage;
  MF := CurrentPage;
  case BandLayout of
  blLeft:  FY := FY + PaintBand( MF, Band, X, Y );
  blRight: FY := FY + PaintBand( MF, Band, PagePixelsSize.cx - Band.Width, Y );
  blCenter: FY := FY + PaintBand( MF, Band, (PagePixelsSize.cx - Band.Width) div 2, Y );
  blExpandRight: begin
                   OldW := Band.Width;
                   try
                     Band.Width := PagePixelsSize.cx - X;
                     FY := FY + PaintBand( MF, Band, X, Y );
                   finally
                     Band.Width := OldW;
                   end;
                 end;
  end;
  FPageTop := FALSE;
  FCurBandHeight := 0;
end;

procedure TNormalReport.AddFooter(Band: TWinControl; BandLayout: TBandLayout = blLeft);
var MF: TMF;
    OldW: Integer;
begin
  if Band.Height > HeightAvailable then
    NewPage;
  MF := CurrentPage;
  case BandLayout of
  blLeft:  FBottom := FBottom - PaintBand( MF, Band, 0, FBottom - Band.Height );
  blRight: FBottom := FBottom - PaintBand( MF, Band, PagePixelsSize.cx - Band.Width, FBottom - Band.Height );
  blCenter: FBottom := FBottom - PaintBand( MF, Band, (PagePixelsSize.cx - Band.Width) div 2, FBottom - Band.Height );
  blExpandRight: begin
                   OldW := Band.Width;
                   try
                     Band.Width := PagePixelsSize.cx;
                     FBottom := FBottom - PaintBand( MF, Band, 0, FBottom - Band.Height );
                   finally
                     Band.Width := OldW;
                   end;
                 end;
  end;
end;

function TNormalReport.AddPage: TMF;
var MF: TMF;
    R: TRect;
    DC0: HDC;

    procedure SimulateProgress;
    begin
      if FProgress.ProgressBar1.Position mod 2 = 0 then
      begin
        FProgress.ProgressBar1.Position := FProgress.ProgressBar1.Position + 10;
        if FProgress.ProgressBar1.Position >= 100 then
          FProgress.ProgressBar1.Position := 99;
      end
        else
      begin
        FProgress.ProgressBar1.Position := FProgress.ProgressBar1.Position - 10;
        if FProgress.ProgressBar1.Position <= 0 then
          FProgress.ProgressBar1.Position := 0;
      end;
    end;

begin
  FY := 0;
  FX := 0;
  DC0 := GetDC( 0 );
  R := Rect( 0, 0,
       MulDiv(PagePixelsSize.cx, GetDeviceCaps(DC0, HORZSIZE)*100, GetDeviceCaps(DC0, HORZRES)),
       MulDiv(PagePixelsSize.cy, GetDeviceCaps(DC0, VERTSIZE)*100, GetDeviceCaps(DC0, VERTRES)) );
  MF := CreateEnhMetaFile( DC0, nil, @ R, '' );
  ReleaseDC( 0, DC0 );
  FPages.Add( Pointer( MF ) );
  FBottom := PagePixelsSize.cy;
  Result := MF;
  if not fNewPageHandling then
  if Assigned( OnNewPage ) then
  begin
    fNewPageHandling := TRUE;
    OnNewPage( Self );
    fNewPageHandling := FALSE;
  end;
  FPageTop := TRUE;
  if FProgress <> nil then
  begin
    if TwoStagePrinting then
    begin
      if FStage = 1 then
      begin
        FProgress.Label1.Caption := rsStage + ' 1 ' + rsPage + ' ' + IntToStr( FPages.Count );
        SimulateProgress;
      end
      else
      begin
        FProgress.Label1.Caption := rsStage + ' 2 ' + rsPage + ' ' + IntToStr( FPages.Count ) +
                                 rsFrom + IntToStr( FPagesAfterStage1 );
        FProgress.ProgressBar1.Position := FPages.Count * 100 div FPagesAfterStage1;
      end;
    end
      else
    begin
      FProgress.Label1.Caption := rsPage + ' ' + IntToStr( FPages.Count );
      SimulateProgress;
    end;
  end;
  Application.ProcessMessages;
  if Assigned( FProgress ) and FProgress.Cancelled then
  begin
    FCancelled := TRUE;
    raise ENormalReportException.Create( rsErr0001 );
  end;
end;

procedure TNormalReport.AddRight(Band: TWinControl; AllowWrapBand: Boolean = TRUE);
var MF: TMF;
begin
  if Band.Height > HeightAvailable then
    NewPage;
  MF := CurrentPage;
  if AllowWrapBand and (Band.Width > PagePixelsSize.cx - X) then
  begin
    if not fEndBandHandling then
    if Assigned( OnEndBand ) then
    begin
      fEndBandHandling := TRUE;
      OnEndBand( Self );
      fEndBandHandling := FALSE;
    end;
    FX := 0;
    FY := FY + FCurBandHeight;
    FCurBandHeight := 0;
  end;
  PaintBand( MF, Band, X, Y );
  FX := X + Band.Width;
  if FCurBandHeight < Band.Height then
    FCurBandHeight := Band.Height;
  FPageTop := FALSE;
end;

procedure TNormalReport.Cancel( const Reason: String );
begin
  FCancelled := TRUE;
  raise ENormalReportException.Create( Reason );
end;

procedure TNormalReport.Clear;
var I: Integer;
begin
  FPagePixelsSize.cx := 0;
  FPagePixelsSize.cy := 0;
  for I := FPages.Count-1 downto 0 do
    DeleteEnhMetaFile( Images[ I ] );
  FImages.Clear;
  FPages.Clear;
end;

constructor TNormalReport.Create(AOwner: TComponent);
begin
  inherited;
  FPages := TList.Create;
  FImages := TList.Create;
  FCustomPaperSize.cx := 210;
  FCustomPaperSize.cy := 270;
  FExactScale := TRUE;
  FShowProgress := TRUE;
  FOrientation := poPortrait;
  FPreviewScale := psFitWidth;
end;

destructor TNormalReport.Destroy;
begin
  Clear;
  FPages.Free;
  FImages.Free;
  inherited;
end;

procedure TNormalReport.DoPreview;
begin
  if FCancelled then Exit;
  if PagesCount = 0 then Exit;
  PreviewForm.ScrollBox1.DoubleBuffered := DoubleBufferedPreview;
  PreviewForm.Report := Self;
  if FProgress <> nil then
    FProgress.Hide;
  if Assigned( OnShowPreviewForm ) then
    OnShowPreviewForm( PreviewForm );
  PreviewForm.Show;
end;

procedure TNormalReport.DoPreviewModal;
begin
  if FCancelled then Exit;
  PreviewForm.ScrollBox1.DoubleBuffered := DoubleBufferedPreview;
  PreviewForm.Report := Self;
  if FProgress <> nil then
    FProgress.Hide;
  PreviewForm.ShowModal;
  FreeAndNil( FPreviewForm );
end;

procedure TNormalReport.DoPrint;
begin
  if FPages.Count > 0 then
    PrintPages( 0, FPages.Count );
end;

procedure TNormalReport.DoPrintPreview(Proc: TProcOfObj);
begin
  FCancelled := FALSE;
  if ShowProgress then
  begin
    FProgress := TfmNormalProgress.Create( Application );
    FProgress.Show;
  end
  else
    FProgress := nil;
  TRY
    if Printing then Abort;
    PreparePages;
    if FCancelled then Exit;
    Proc;
  FINALLY
    FreeAndNil( FProgress );
  END;
end;

function TNormalReport.GetCurrentPage: TMF;
begin
  if FPages.Count = 0 then
    Result := AddPage
  else
    Result := TMF( FPages[ FPages.Count-1 ] );
end;

function TNormalReport.GetImages(Idx: Integer): HEnhMetafile;
begin
  while FImages.Count <= Idx do
    FImages.Add( nil );
  if FImages.Items[ Idx ] = nil then
  begin
    FImages.Items[ Idx ] := Pointer( CloseEnhMetafile( Pages[ Idx ] ) );
    FPages.Items[ Idx ] := nil;
  end;
  Result := HENHMETAFILE( FImages.Items[ Idx ] );
end;

function TNormalReport.GetOrientation: TPrinterOrientation;
begin
  if FPrinter = nil then
    Result := FOrientation
  else
    Result := Printer.Orientation;
end;

function TNormalReport.GetPage: Integer;
begin
  Result := FPages.Count;
end;

function TNormalReport.GetPageCount: Integer;
begin
  Result := FPages.Count;
end;

function TNormalReport.GetPageHeight: Integer;
begin
  GetPageWidthHeight;
  Result := FPageHeight;
end;

function TNormalReport.GetPagePixelsSize: TSize;
var I: Integer;
    P: TPoint;
    DC0: HDC;
begin
  if (FPagePixelsSize.cx = 0) or (FPagePixelsSize.cy = 0) then
  begin
    case PaperSize of
    psA3: P := Point( 297, 420 );
    psA4: P := Point( 210, 297 );
    psA5: P := Point( 148, 210 );
    psA6: P := Point( 105, 148 );
    psLetter: P := Point( 216, 280 );
    else      P := Point( FCustomPaperSize.cx, FCustomPaperSize.cy );
    end;
    DC0 := GetDC( 0 );
    FPagePixelsSize.cx := Round( (P.x * 0.039370) * GetDeviceCaps( DC0, LOGPIXELSX ) );
    FPagePixelsSize.cy := Round( (P.y * 0.039370) * GetDeviceCaps( DC0, LOGPIXELSY ) );
    ReleaseDC( 0, DC0 );
  end;
  Result := FPagePixelsSize;
  if Orientation = poLandscape then
  begin
    I := Result.cx;
    Result.cx := Result.cy;
    Result.cy := I;
  end;
end;

function TNormalReport.GetPages(Idx: Integer): TMF;
begin
  Result := TMF( FPages[ Idx ] ); 
end;

function TNormalReport.GetPagesCount: Integer;
begin
  Result := FPages.Count;
  if Result = 0 then
  begin
    if Assigned( OnPrint ) then
    begin
      FFastAndDraft := TRUE;
      TRY
      Clear;
      FStage := 1;
      FOnPrint( Self );
      if PagesCount = 0 then Exit;
      FPagesAfterStage1 := FPages.Count;
      if TwoStagePrinting then
      begin
        Clear;
        FStage := 2;
        FOnPrint( Self );
      end;
      Result := FPages.Count;
      FINALLY
        Clear;
        FFastAndDraft := FALSE;
      END;
      Exit;
    end;
  end;
  Result := FPages.Count;
end;

function TNormalReport.GetPageWidth: Integer;
begin
  GetPageWidthHeight;
  Result := FPageWidth;
end;

procedure TNormalReport.GetPageWidthHeight;
begin
  if (FPageWidth <> 0) and (FPageHeight <> 0) then Exit;
  if Printer.Printing then
  begin
    FPageWidth := Printer.PageWidth;
    FPageHeight := Printer.PageHeight;
  end
    else
  begin
    Printer.BeginDoc;
    TRY
      FPageWidth := Printer.PageWidth;
      FPageHeight := Printer.PageHeight;
    FINALLY
      Printer.Abort;
    END;
  end;
end;

function TNormalReport.GetPreviewForm: TfmNormalPreview;
begin
  if FPreviewForm = nil then
  begin
    FPreviewForm := TfmNormalPreview.Create( Application );
    FPreviewForm.Report := Self;
    FPreviewForm.FitMode := Integer( FPreviewScale );
    if Assigned( OnCreatePreviewForm ) then
      OnCreatePreviewForm( FPreviewForm );
  end;
  Result := FPreviewForm;
end;

function TNormalReport.GetPrinter: TPrinter;
begin
  if FPrinter = nil then
  begin
    FPrinter := Printers.Printer;
    FPrinter.Orientation := FOrientation;
  end;
  Result := FPrinter;
end;

function TNormalReport.HeightAvailable: Integer;
begin
  Result := FBottom - FY;
end;

procedure TNormalReport.NewLine;
begin
  if FCurBandHeight > HeightAvailable then
    NewPage;
  if not fEndBandHandling then
  if Assigned( OnEndBand ) then
  begin
    fEndBandHandling := TRUE;
    OnEndBand( Self );
    fEndBandHandling := FALSE;
  end;
  FX := 0;
  FY := FY + FCurBandHeight;
  FCurBandHeight := 0;
  FPageTop := FALSE;
end;

procedure TNormalReport.NewPage;
begin
  AddPage;
end;

function TNormalReport.PaintBand(MF: TMF; Band: TWinControl; X,
  Y: Integer): Integer;

var OldParent: TWinControl;
    WasVisible: Boolean;
begin
  Result := Band.Height;

  if FFastAndDraft then Exit;
  
  OldParent := Band.Parent;
  WasVisible := Band.Visible;
  try
    SetParent( Band.Handle, Application.Handle );
    Band.Visible := TRUE;
    Band.PaintTo( MF, X, Y );
  finally
    Band.Visible := WasVisible;
    SetParent( Band.Handle, OldParent.Handle );
  end;
end;

procedure TNormalReport.PreparePages;
begin
  if FPages.Count > 0 then Exit; //  
  if Assigned( FOnPrint ) then
  begin
    Clear;
    FStage := 1;
    TRY
    FOnPrint( Self );
    EXCEPT on E: Exception do
           begin
             if E is ENormalReportException then
             begin
               FCancelled := TRUE;
               Exit;
             end;
             raise;
           end;
    END;
    FPagesAfterStage1 := FPages.Count;
    if FPagesAfterStage1 = 0 then Exit;
    if FCancelled then Exit;
    if TwoStagePrinting then
    begin
      Clear;
      FStage := 2;
      TRY
      FOnPrint( Self );
      Assert( FPagesAfterStage1 = FPages.Count,
              rsErr0002 );
      EXCEPT on E: Exception do
             begin
               if E is ENormalReportException then
               begin
                 FCancelled := TRUE;
                 Exit;
               end;
               raise;
             end;
      END;
    end;
  end;
end;

procedure TNormalReport.Preview;
begin
  DoPrintPreview( DoPreview );
end;

procedure TNormalReport.PreviewModal;
begin
  DoPrintPreview( DoPreviewModal );
end;

procedure TNormalReport.Print;
begin
  DoPrintPreview( DoPrint );
end;

procedure TNormalReport.PrintPages(Start, Count: Integer);
var I, j, ToIdx: Integer;
    MF: HEnhMetafile;
    PrintingStarted: Boolean;
    RemoveProgress: Boolean;
begin
  if PagesCount = 0 then Exit;
  if FCancelled then Exit;
  RemoveProgress := FALSE;
  if (FProgress = nil) and ShowProgress then
  begin
    FProgress := TfmNormalProgress.Create( Application );
    RemoveProgress := TRUE;
  end;
  if FProgress <> nil then
  begin
    FProgress.Caption := rsPrintingInProgress;
    FProgress.Label1.Caption := rsPage + ' 1' + rsFrom + IntToStr( Count );
    FProgress.ProgressBar1.Position := 0;
    FProgress.Show;
    Application.ProcessMessages;
  end;
  TRY
    if FPages.Count = 0 then
    begin
      PreparePages;
      if FCancelled then Exit;
    end;
    PrintingStarted := FALSE;
    j := 0;
    TRY
      ToIdx := Start + Count - 1;
      if ToIdx >= PagesCount then
        ToIdx := PagesCount - 1;
      for I := Start to ToIdx do
      begin
        MF := HEnhMetafile( Images[ I ] );
        if j = 0 then
        begin
          Printer.Title := DocumentName;
          Printer.BeginDoc;
          PrintingStarted := TRUE;
        end;
        PlayEnhMetaFile( Printer.Canvas.Handle, MF,
                         Rect( 0, 0, PageWidth-1, PageHeight-1 ) );
        Inc( j );
        if FProgress <> nil then
        begin
          FProgress.Label1.Caption := rsPage + ' ' + IntToStr( J + 1 ) + rsFrom +
                                   IntToStr(Count);
          FProgress.ProgressBar1.Position := (J + 1) * 100 div Count;
          Application.ProcessMessages;
          if FProgress.Cancelled then
          begin
            if j > 0 then
              Printer.Abort;
            FCancelled := TRUE;
            Exit;
          end;
        end;
        if I < ToIdx then
          Printer.NewPage;
      end;
    FINALLY
      if PrintingStarted and not FCancelled then
        Printer.EndDoc;
    END;
  FINALLY
    if RemoveProgress then
      FreeAndNil( FProgress );
  END;
end;

function TNormalReport.ScaleX(X: Integer): Integer;
begin
  Result := Round( X * Printer.PageWidth / PagePixelsSize.cx );
end;

function TNormalReport.ScaleY(Y: Integer): Integer;
begin
  Result := Round( Y * Printer.PageHeight / PagePixelsSize.cy );
end;

procedure TNormalReport.SetCustomPaperSize(const Value: TSize);
begin
  FCustomPaperSize := Value;
  PaperSize := psCustom;
end;

procedure TNormalReport.SetOrientation(const Value: TPrinterOrientation);
begin
  FSetOrientation := TRUE;
  FOrientation := Value;
  Printer.Orientation := Value;
end;

procedure TNormalReport.SetPageTop(const Value: Boolean);
begin
  FPageTop := Value;
end;

procedure TNormalReport.SetPaperSize(const Value: TPaperSize);
begin
  if FPaperSize = Value then Exit;
  if FPrinting then Abort;
  FPaperSize := Value;
end;

procedure TNormalReport.SetPreviewForm(const Value: TfmNormalPreview);
begin
  if FPreviewForm = Value then Exit;
  if FPreviewForm <> nil then
    FPreviewForm.Free;
  FPreviewForm := Value;
end;

procedure TNormalReport.SetPreviewScale(const Value: TPreviewScale);
begin
  FPreviewScale := Value;
end;

procedure TNormalReport.SetPrinter(const Value: TPrinter);
begin
  if FPrinter = Value then Exit;
  if FPrinting then Abort;
  FPrinter := Value;
  FPageWidth := 0;
  FPageHeight := 0;
end;

procedure TNormalReport.SetShowProgress(const Value: Boolean);
begin
  FShowProgress := Value;
end;

procedure TNormalReport.SetTwoStagePrinting(const Value: Boolean);
begin
  FTwoStagePrinting := Value;
end;

procedure TNormalReport.SetX(const Value: Integer);
begin
  if FX = Value then Exit;
  FX := Value;
end;

procedure TNormalReport.SetY(const Value: Integer);
begin
  if FY = Value then Exit;
  FY := Value;
  FCurBandHeight := 0;
end;

end.
