{******************************************************************************

ParamSynchronize Version 1.00

Copyright (C) 2003 by OCEM SpA - Mauro Venturini - e-mail: mpv@acm.org

You  are  free  to  use  ParamSynchronize  in compiled  form  for any  purpose.
However, use in commercial or shareware applications requires registration. The
ParamSynchronize source code, in  whole or in part, modified or unmodified, may
not be redistributed  for profit or as part of another  commercial or shareware
software package without express written permission from me or  my company.  It
can be redistributed as freeware provided this banner is not removed or altered
in any way.

This software is distributed AS IS without any warranties, express or  implied,
of  its  correctness  or  of  its  suitability  to  any  particular purpose. No
responsability is accepted for any damage, direct or indirect, due to its use.

******************************************************************************}

unit ParamSync;

interface

uses
  Classes, SysUtils;

procedure ParamSynchronize(Jolly: TProcedure);

implementation

uses
  Windows;

procedure CallProc(EBP: TProcedure);
asm
        {now in main stack}
        push    EDI
        push    ESI
        push    EBX
        push    EBP

        mov     EBP,EAX

        mov     ECX,EAX
        sub     ECX,256 {IMPORTANT: move forward the stack pointer to preserve the StaticSynchronize context}

        xchg    ESP,ECX {stack swap, now in thread stack}
        push    ECX

        mov     EAX,[EBP - 8] {Read Proc as declared inside ParamSynchronize}

        mov     EBP,[EBP] {Backstep to previous stack frame}

        push    EBP
        call    EAX
        pop     EBP

        pop     ECX
        xchg    ESP,ECX {stack swap, now in main stack}

        pop     EBP
        pop     EBX
        pop     ESI
        pop     EDI
end;

function PackProcAndBP(Proc: TProcedure): TThreadMethod;
asm
        mov     [EDX],EAX
        mov     [EDX + 4],EBP
end;

{$O-} {IMPORTANT: force Proc allocation and updating (*)}
procedure ParamSynchronize(Jolly: TProcedure);
var
  Proc: TProcedure;
begin
  if (GetCurrentThreadId = MainThreadID) then {Jolly contains EBP, Proc contains the procedure to be called}
    CallProc(Jolly)
  else begin {Jolly contains the procedure to be called}
    Proc := Jolly; {*}
    TThread.StaticSynchronize(nil,PackProcAndBP(@ParamSynchronize));
  end;
end;
{$O+}

end.

