//==============================================================================
//    Config.pas - Module of TestTool. Implements a interactive form for
//                 configuring TestTool parameters. TestTool is part of CGI
//                 Framework package.
//    Copyright (C) 2002-2003  Ivan Camilo da Cruz
//==============================================================================
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//==============================================================================
//    Este programa  software livre; voc pode redistribu-lo e/ou
//    modific-lo sob os termos da Licena Pblica Geral GNU, conforme
//    publicada pela Free Software Foundation; tanto a verso 2 da
//    Licena como (a seu critrio) qualquer verso mais nova.
//
//    Este programa  distribudo na expectativa de ser til, mas SEM
//    QUALQUER GARANTIA; sem mesmo a garantia implcita de
//    COMERCIALIZAO ou de ADEQUAO A QUALQUER PROPSITO EM
//    PARTICULAR. Consulte a Licena Pblica Geral GNU para obter mais
//    detalhes.
//
//    Voc deve ter recebido uma cpia da Licena Pblica Geral GNU
//    junto com este programa; se no, escreva para a Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
//    02111-1307, USA.
//==============================================================================

unit Config;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QButtons;

type
  TFrmConfig = class(TForm)
    Label1: TLabel;
    EdtDatabase: TEdit;
    Label2: TLabel;
    EdtTemplate: TEdit;
    BtnOk: TBitBtn;
    BtnCancel: TBitBtn;
    Label3: TLabel;
    EdtPreview: TEdit;
    procedure FormShow(Sender: TObject);
    procedure BtnOkClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmConfig: TFrmConfig;

implementation

uses Globals;

{$R *.xfm}

procedure TFrmConfig.FormShow ( Sender: TObject );
  begin
    EdtDatabase.Text := ConfigIni.ReadString ( 'Database', 'Path', '' );
    EdtTemplate.Text := ConfigIni.ReadString ( 'Template', 'Path', '' );
    EdtPreview.Text := ConfigIni.ReadString ( 'Preview', 'Command', '' );
  end;

procedure TFrmConfig.BtnOkClick(Sender: TObject);
  begin
    ConfigIni.WriteString ( 'Database', 'Path', EdtDatabase.Text );
    ConfigIni.WriteString ( 'Template', 'Path', EdtTemplate.Text );
    ConfigIni.WriteString ( 'Preview', 'Command', EdtPreview.Text );
    ConfigIni.UpdateFile;
    
    ModalResult := mrOk;
  end;

end.
