unit XLGrids;

{$I defines.inc}

{$R-,T-,H+,X+}

interface

uses
  Windows, Messages, SysUtils, Classes, Menus, Graphics,
  Controls, StdCtrls, ExtCtrls, Forms, XLStream, XLLists,
  Printers , Variants ;

type
  TXLScale       = 25..500;
  TXLDirection   = (dNone, dRight, dDown, dLeft, dUp, dAuto);
  TXLSector      = (sCols, sRows, sTitle, sClient);
  TXLSectors     = set of TXLSector;
  TXLAxis        = sCols..sRows;
  TXLAxes        = set of TXLAxis;
  TXLScroll      = ssHorizontal..ssVertical;
  TXLScrolls     = set of TXLScroll;
  TXLSize        = record
  case Integer of
   0: (AsArray: array[TXLAxis] of Integer);
   1: (sCols, sRows: Integer);
  end;
  TXLOptions     = set of (oTitleCols, oTitleRows,
                           oVertLines, oHorzLines,
                           oColSizing, oRowSizing,
                           oDrawFocus, oPrintLayout,
                           oReadOnly,
                           oPermEdit,
                           oRowSelect, oRangeSelect,
                           oTracking,  oWrapKeys);

  TXLAlterPhase  = (pScan, pInit, pWork, pDone, pCancel);
  TXLHitResult   = (hrNowhere, hrCell, hrColBorder, hrRowBorder, hrSelFrame);

  TXLCellState   = (csEditing, csInvalidate, csError, csStyle, csAssign, csReformat, csUnited);
  TXLCellStates  = set of TXLCellState;
  TXLCellStyle   = (csHidden, csProtect, csReadOnly, csNotify, csExtHint);
  TXLCellStyles  = set of TXLCellStyle;
  TXLCellInfo    = (ciLeft, ciTop, ciRight, ciBottom, ciBias1, ciBias2, ciHInside, ciVInside, ciColor, ciFrame, ciStyles, ciLayout);
  TXLSheetInfo   = (siColLines, siRowLines, siBias1, siBias2, siColor, siFrame, siStyles, siLayout);
  TXLSheetInfos  = set of TXLSheetInfo;
  TXLInvalidate  = (iFull, iFrame, iInterior);
  THorzAlign     = (haLeft, haRight, haCenter);
  TVertAlign     = (vaTop, vaBottom, vaCenter);
  TWrapMode      = (wmClip, wmEllipsis, wmWrapWords);
  TXLSide        = (sLeft, sTop, sRight, sBottom, sBias1, sBias2, sHInside, sVInside);
  TXLSides       = set of TXLSide;
  TXLSideLine    = (slNone, slSingle, slMedium, slDouble);
  TXLSideBorder  = record
    Line         : TXLSideLine;
    Color        : TColor;
  end;
  TXLFrame       = (frNone, frFlatUp, frFlatDown, frDeepUp, frDeepDown, frBevelUp, frBevelDown);
  PIntArray      = ^TIntArray;
  TIntArray      = array[0..MaxListSize] of Integer;
  TIntRect       = array[0..3] of Integer;

const
  sAround        = [sLeft, sTop, sRight, sBottom];
  sInside        = [sHInside, sVInside];
  sBiases        = [sBias1, sBias2];
  sAll           = sAround + sInside + sBiases;

  XL_EDITINFO    = WM_USER + $752;
  XL_LOADCELL    = WM_USER + $753;
  XL_SAVECELL    = WM_USER + $754;
  XL_LAYOUT      = WM_USER + $755;
  XL_EDITSIZE    = WM_USER + $756;

const
  pAll           = $0;
// Control Properties
  pcClass        = $1;
  pcEditor       = $2;
  pcFormat       = $4;
// Font Properties
  pfBold         = $1;
  pfItalic       = $2;
  pfUnderline    = $4;
  pfStrikeOut    = $8;
  pfName         = $10;
  pfSize         = $20;
  pfColor        = $40;
  pfCharset      = $80;
// Layout Properties
  plHorzAlign    = $1;
  plVertAlign    = $2;
  plIndent       = $4;
  plWrapMode     = $8;


type
  TXLPersistent  = class;
  TXLProCell     = class;
  TXLCell        = class; TXLCellClass = class of TXLCell;
  TXLSection     = class;
  TXLCustomSheet       = class;
  TXLProStyle    = class;
  TXLBaseStyle   = class;
  TXLStyle       = class;
  TXLStyler      = class;
  TXLView        = class;
  TXLCustomGrid        = class;
  TXLSizeList    = class(TZeroSList);

  TXLProp        = (prBasedOn, prControl, prLayout, prColor, prFont, prBorder, prFrame, prStyles, prValue, prHint);
  TXLProps       = set of TXLProp;

  TXLCellTextEvent     = procedure (Sender: TXLCustomSheet; ACoord: TPoint; var AText: String) of object;
  TXLCellEvent         = procedure (Sender: TXLCustomSheet; ACell: TXLCell) of object;
  TXLCellValidateEvent = procedure (Sender: TXLCustomSheet; ACell: TXLCell; var Valid: Boolean) of object;
  TXLCoordEnumProc     = procedure (ACoord: TPoint; AData: Integer; var Stop: Boolean) of object;
  TXLCellEnumProc      = procedure (ACell: TXLCell; AData: Integer; var Stop: Boolean) of object;
  TXLGridEvent         = procedure (Sender: TObject; ACoord: TPoint) of object;
  TXLNotifyEvent       = procedure (Sender: TXLPersistent; AProp: TXLProp) of object;
  TXLSizingEvent       = procedure (Sender: TObject; AAxis: TXLAxis; AIndex: Integer; var AValue: Integer) of object;
  TXLGetFrameProc      = function (ACol, ARow: Integer): TXLFrame of object;

  PXLLayout = ^TXLLayout;
  TXLLayout = record
    HorzAlign: THorzAlign;
    VertAlign: TVertAlign;
    Indent: Word;
    WrapMode: TWrapMode;
  end;

  TXLEditInfo = record
    Msg: Cardinal;
    Control: ^TWinControl;
    Handle: ^HWND;
    Result: Longint;
  end;

  TXLEditCell = record
    Msg: Cardinal;
    Cell: TXLCell;
    Unused: Longint;
    Result: Longint;
  end;

  TXLCellLayout = record
    Msg: Cardinal;
    Layout: PXLLayout;
    Unused: Longint;
    Result: Longint;
  end;

  TXLEditSize = record
    Msg: Cardinal;
    ANewWidth,
    ANewHeight: Longint;
    Result: Longint;
  end;

  TXLControl = record
    CellClass: TXLCellClass;
    Editor: Integer;
    Format: String;
  end;

  TXLDraw = record
    Canvas: TCanvas;
    Layout: TXLLayout;
    Font: TFont;
    Error: TColor;
    Scale: TXLScale;
    Design: Boolean;
    Frame: TXLFrame;
    Styles: TXLCellStyles;
    Coord: TPoint;
  end;

  PXLPaintStruct = ^TXLPaintStruct;
  TXLPaintStruct = record
    Sizes: Array[TXLAxis] of TXLSizeList;
    Coords: Array[TXLAxis] of PIntArray;
    Unions: TList;
    Scale: TXLSize;
    Canvas: TCanvas;
    Handle: HDC;
    GridRect,
    ViewRect,
    Update: TRect;
    Grids: array[TXLAxis] of Boolean;
    DesignMode,
    HintMode: Boolean;
    GetFrameProc: TXLGetFrameProc;
    CellRgn: HRGN;
    PaintGround: procedure (PS: PXLPaintStruct) of object;
  end;

  EXLGridError = class(Exception);

  TXLPersistent = class(TPersistent)
  private
    FContainer: TPersistent;
    FFont: TFont;
    FEditor: Integer;
    FStates: TXLCellStates;
    FProps: TXLProps;
    FFormat: String;
    function  GetBasedOn: TXLStyle; virtual; abstract;
    procedure SetBasedOn(AStyle: TXLStyle); virtual; abstract;
    function  GetCellClass: TXLCellClass; virtual; abstract;
    procedure SetCellClass(Value: TXLCellClass); virtual; abstract;
    function  GetCellInfo(ASide: TXLCellInfo; var AllEqual: Boolean): Pointer; virtual; abstract;
    procedure SetCellInfo(ASide: TXLCellInfo; AColorPointer: Pointer); virtual; abstract;
    function  GetFont: TFont;
    procedure SetFont(AFont: TFont);
    function  GetLayout: TXLLayout;
    procedure SetLayout(const ALayout: TXLLayout);
    procedure FontChange(Sender: TObject);
    procedure SetProps(AProps: TXLProps);
    function  SaveState(AState: TXLCellState): Boolean;
    procedure RestoreState(AState: TXLCellState; ASaved: Boolean);
    function  GetEditor: Integer;
    function  GetBorder(ASide: TXLSide): TXLSideBorder;
    procedure SetBorder(ASide: TXLSide; const Value: TXLSideBorder);
    function  GetSides: TXLSides;
    procedure SetSides(const Value: TXLSides);
    procedure SetHorzAlign(AAlign: THorzAlign);
    procedure SetVertAlign(AAlign: TVertAlign);
    procedure SetIndent(AIndent: Integer);
    procedure SetWrap(AWrap: TWrapMode);
    function  GetHorzAlign: THorzAlign;
    function  GetVertAlign: TVertAlign;
    function  GetIndent: Integer;
    function  GetWrap: TWrapMode;
    procedure SetBorders(ASides: TXLSides; const Value: TXLSideBorder);
    procedure SetFormat(const Value: String);
    function  GetControl: TXLControl;
    procedure SetControl(const Value: TXLControl);
    procedure SetEditor(Value: Integer);
    function  GetColor: TColor;
    procedure SetColor(Value: TColor);
    function  GetFrame: TXLFrame;
    procedure SetFrame(Value: TXLFrame);
    function  GetStyles: TXLCellStyles;
    procedure SetStyles(AFlags: TXLCellStyles);
    function  GetAssignedFont(ASource: TFont): TFont;
    procedure IntSetLayout(const ALayout: TXLLayout);
    function  GetCellEditor: TWinControlClass;
    procedure SetCellEditor(Value: TWinControlClass);
    function  GetEditorCount: Integer;
    function GetDisplayFormat: String;
  protected
    procedure NotifyChanges(AProp: TXLProp; AChanges: Integer); virtual;
    procedure ReloadProperty(AProp: TXLProp; AChanges: Integer);
    procedure AssignProperty(Source: TXLPersistent; AProp: TXLProp; AData: Integer); virtual;
    function  FindProperty(AProp: TXLProp): TXLPersistent; virtual;
    procedure Load(AStream: TXLStream); virtual;
    procedure Save(AStream: TXLStream); virtual;
    property  Container: TPersistent read FContainer;
    function  FormatText: String; virtual;
  public
    function  GetOwner: TPersistent; override;
    function  LoadFromStream(AStream: TXLStream): Boolean;
    procedure SaveToStream(AStream: TXLStream);
    constructor Create(AContainer: TPersistent);
    procedure Assign(Source: TPersistent); override;
    destructor Destroy; override;
// Properties
    property Borders[ASides: TXLSides]: TXLSideBorder write SetBorders;
    property Border[ASide: TXLSide]: TXLSideBorder read GetBorder write SetBorder;
    property Layout: TXLLayout read GetLayout write SetLayout;
    property Control: TXLControl read GetControl write SetControl;
    property CellClass: TXLCellClass read GetCellClass write SetCellClass;
    property EditorCount: Integer read GetEditorCount;
    property EditorClass: TWinControlClass read GetCellEditor write SetCellEditor;
    property BasedOn: TXLStyle read GetBasedOn write SetBasedOn;
    property DisplayFormat: String read GetDisplayFormat;
  published
    property Frame: TXLFrame read GetFrame write SetFrame stored False;
    property HorzAlign: THorzAlign read GetHorzAlign write SetHorzAlign stored False;
    property VertAlign: TVertAlign read GetVertAlign write SetVertAlign stored False;
    property Indent: Integer read GetIndent write SetIndent stored False;
    property WrapMode: TWrapMode read GetWrap write SetWrap stored False;
    property Sides: TXLSides read GetSides write SetSides stored False;
    property Editor: Integer read GetEditor write SetEditor stored False;
    property Props: TXLProps read FProps write SetProps stored False;
    property Font: TFont read GetFont write SetFont stored False;
    property Color: TColor read GetColor write SetColor stored False;
    property Styles: TXLCellStyles read GetStyles write SetStyles stored False;
    property Format: String read FFormat write SetFormat stored False;
  end;

  TXLValue = class(TXLPersistent)
  private
    FRText: String;
    function GetText: String;
  protected
    procedure Draw(const ADraw: TXLDraw; var ARect: TRect); virtual;
    function  GetDouble: Double; virtual;
    function  GetDateTime: TDateTime; virtual;
    function  GetInteger: Integer; virtual;
    function  GetString: String; virtual;
    function  GetBoolean: Boolean; virtual;
    function  GetObject: TPersistent; virtual;
    function  GetCurrency: Currency; virtual;
    function  GetValue: Variant; virtual;
    procedure SetDouble(const AValue: Double); virtual;
    procedure SetDateTime(const AValue: TDateTime); virtual;
    procedure SetInteger(AValue: Integer); virtual;
    procedure SetString(const AValue: String); virtual;
    procedure SetBoolean(AValue: Boolean); virtual;
    procedure SetObject(AObject: TPersistent); virtual;
    procedure SetCurrency(const AValue: Currency); virtual;
    procedure SetValue(const AValue: Variant); virtual;
  public
    procedure Changed;
    procedure AssignProperty(Source: TXLPersistent; AProp: TXLProp; AChanges: Integer); override;
    property AsInteger: Integer read GetInteger write SetInteger;
    property AsDouble: Double read GetDouble write SetDouble;
    property AsString: String read GetString write SetString;
    property AsBoolean: Boolean read GetBoolean write SetBoolean;
    property AsDateTime: TDateTime read GetDateTime write SetDateTime;
    property AsCurrency: Currency read GetCurrency write SetCurrency;
    property AsObject: TPersistent read GetObject write SetObject;
    property Value: Variant read GetValue write SetValue;
    property Text: String read GetText;
  end;

  TXLProCell = class(TXLValue)
  private
    function GetSheet: TXLCustomSheet;
    function  GetCellInfo(ASide: TXLCellInfo; var AllEqual: Boolean): Pointer; override;
    procedure SetCellInfo(ASide: TXLCellInfo; AColorPointer: Pointer); override;
    function GetSection: TXLSection; virtual; abstract;
    function GetBounds: TRect; virtual; abstract;
    procedure SetBounds(ABounds: TRect); virtual; abstract;
    function GetPosition: TPoint;
    function GetWidth: Word;
    procedure SetWidth(AWidth: Word);
    function GetHeight: Word;
    procedure SetHeight(AHeight: Word);
    function GetSingle: Boolean;
    function GetMerged: Boolean;
    procedure SetPosition(const Value: TPoint);
    function GetSector: TXLSector;
    function GetMapBounds: TRect;
  protected
    property Section: TXLSection read GetSection;
  public
    function GetNamePath: String; override;
    procedure Split;
    procedure Assign(Source: TPersistent); override;
    property SheetBounds: TRect read GetMapBounds;
    property Sector: TXLSector read GetSector;
    property Sheet: TXLCustomSheet read GetSheet;
    property Single: Boolean read GetSingle;
    property Merged: Boolean read GetMerged;
    property Bounds: TRect read GetBounds write SetBounds;
    property Position: TPoint read GetPosition write SetPosition;
  published
    property Width: Word read GetWidth write SetWidth stored False;
    property Height: Word read GetHeight write SetHeight stored False;
  end;

  TXLProRange = class(TXLProCell)
  private
    FOldFont: TFont;
    function  GetBasedOn: TXLStyle; override;
    procedure SetBasedOn(AStyle: TXLStyle); override;
    function  GetCellClass: TXLCellClass; override;
    procedure SetCellClass(Value: TXLCellClass); override;
    procedure UpdateCells(ACell: TXLCell; AData: Integer; var Stop: Boolean);
    procedure UpdateCellsClass(ACoord: TPoint; AData: Integer; var Stop: Boolean);
    procedure ResetHints(ACell: TXLCell; AData: Integer; var Stop: Boolean);
    procedure CopyCell(ACoord: TPoint; AData: Integer; var Stop: Boolean);
  protected
    function  GetValue: Variant; override;
    procedure SetValue(const AValue: Variant); override;
    procedure NotifyChanges(AProp: TXLProp; AChanges: Integer); override;
  public
    constructor Create(AContainer: TPersistent);
    destructor Destroy; override;
    procedure Cut;
    procedure Copy;
    procedure Paste;
    function CanPaste: Boolean;
    function Merge: Boolean; dynamic;
    function MergeLines: Boolean; dynamic;
    function Clear: Boolean; dynamic;
    procedure ClearHints;
    procedure Assign(Source: TPersistent); override;
  end;

  TXLSectionRange = class(TXLProRange)
  private
    FBounds: TRect;
    function GetSection: TXLSection; override;
    function  GetBounds: TRect; override;
    procedure SetBounds(ABounds: TRect); override;
  public
    constructor Create(ASection: TXLSection; const ABounds: TRect);
  end;

  TXLRange = class(TXLSectionRange)
    constructor Create(ASheet: TXLCustomSheet; const ABounds: TRect);
  end;

  TXLCell = class(TXLProCell) // other way to set props
  private
    FBasedOn: TXLStyle;
    FCol: Integer;
    function  GetBasedOn: TXLStyle; override;
    procedure SetBasedOn(AStyle: TXLStyle); override;
    function  GetSection: TXLSection; override;
    procedure SetHint(const AHint: String);
    function  GetEditing: Boolean;
    function  GetBounds: TRect; override;
    procedure SetBounds(ABounds: TRect); override;
    function  GetCellClass: TXLCellClass; override;
    procedure SetCellClass(Value: TXLCellClass); override;
    constructor Create(ASection: TXLSection; ACoord: TPoint);
  protected
    function  RecommendedSize(ACanvas: TCanvas): TPoint; virtual;
    function  FindProperty(AProp: TXLProp): TXLPersistent; override;
    procedure NotifyChanges(AProp: TXLProp; AChanges: Integer); override;
    function  GetHint: String; virtual;
    procedure Load(AStream: TXLStream); override;
    procedure Save(AStream: TXLStream); override;
    procedure Click; dynamic;
    procedure DblClick; dynamic;
    procedure KeyPress(var Key: Char); dynamic;
    procedure Init; virtual;
    procedure Done; virtual;
    procedure Invalidate;
  public
    procedure CancelEdit;
    procedure AssignProperty(Source: TXLPersistent; AProp: TXLProp; AChanges: Integer); override;
    destructor Destroy; override;
    property Editing: Boolean read GetEditing;
  published
    property Hint: String read GetHint write SetHint;
  end;

  TXLRow = class(TObjectSList)
  private
    FRowIndex: Integer;
    FSection: TXLSection;
  public
    procedure Renumerate(AFrom, ATo: Integer); override;
    procedure Clear; override;
    property RowIndex: Integer read FRowIndex;
    property Section: TXLSection read FSection;
  end;

  TXLUnion = class
  private
    FSection: TXLSection;
    FBounds: TRect;
    FScreen: TRect;
    FCell: TXLCell;
    procedure SetBounds(const ABounds: TRect);
  public
    procedure ClearBorder;
    procedure Clear;
    function Update(AAxis: TXLAxis; ANew: Integer): Boolean;
    constructor Create(ASection: TXLSection; const ABounds: TRect; ACell: TXLCell);
    destructor Destroy; override;
    property Cell: TXLCell read FCell;
    property Bounds: TRect read FBounds write SetBounds;
    property Section: TXLSection read FSection;
  end;

  TXLSection = class(TListSList)
  private
    FUnions: TList;
    FHints: TStringList;
    FSheet: TXLCustomSheet;
    FSector: TXLSector;
    FBaseStyle: TXLBaseStyle;
    FInfos: Array[TXLSheetInfo] of TListSList;
    function  GetColor(ACoord: TPoint): TColor;
    procedure SetColor(ACoord: TPoint; AColor: TColor);
    function  GetCell(ACoord: TPoint): TXLCell;
    function  GetPeekCell(ACoord: TPoint): TXLCell;
    function  SeekUnion(ACell: TXLCell): TXLUnion;
    function  AddUnion(const ARect: TRect; ACell: TXLCell): TXLUnion;
    function  TestUnion(const ARect: TRect; AUnion: TXLUnion): TXLUnion;
    function  FindUnion(const APoint: TPoint; IncludeOwner: Boolean): TXLUnion;
    procedure KillUnion(var AUnion: TXLUnion);
    procedure UpdateSize(AAxis: TXLAxis; ANew: Integer);
    function  CropRect(var ARect: TRect): Boolean;
    function  ExpandArea(const AArea: TRect): TRect;
    function  Redirect(ACoord: TPoint): TPoint;
    procedure SetSheetInfo(AInfo: TXLSheetInfo; AIndex, AIndex2, AStart, AEnd: Integer; AData: Pointer);
    function  GetSheetInfo(AInfo: TXLSheetInfo; AIndex, AIndex2, AStart, AEnd: Integer; var AllEqual: Boolean): Pointer;
    function  GetFrameData(ACol, ARow: Integer): TXLFrame;
    function  GetSheetInfo2(AInfo: TXLSheetInfo; ACol, ARow: Integer): Pointer;
    procedure SetSheetInfo2(AInfo: TXLSheetInfo; const AArea: TRect; AData: Pointer);
    function  SetSheetInfoDef(AInfo: TXLSheetInfo; const AArea: TRect; AData: Pointer): Pointer;
    procedure ZeroInfos(AInfo: TXLSheetInfo; ADef: Integer);
    procedure Change(AProStyle: TXLProStyle; AProp: TXLProp; AChanges: Integer);
    procedure SerializeStyles(AStream: TXLStream; AReading: Boolean);
    procedure ClearStyles(AStyle: TXLStyle);
    procedure Refresh(const AArea: TRect);
    procedure Load(AStream: TXLStream; AOldFormat: Boolean);
    procedure Save(AStream: TXLStream);
    function  GetClassCell(ACoord: TPoint; ACellClass: TXLCellClass): TXLCell;
    function  GetCellClass(ACoord: TPoint): TXLCellClass;
    procedure SetCell(ACoord: TPoint; Value: TXLCell);
    procedure SetCellClass(ACoord: TPoint; Value: TXLCellClass);
    procedure AddHint(const AHint: String; ACell: TXLCell);
    procedure RemoveHint(ACell: TXLCell);
    function  GetHint(ACell: TXLCell): String;
    function  GetCellHint(ACoord: TPoint): String;
    procedure CellChanged(ACell: TXLCell);
    procedure DestroyUnions;
    procedure PaintRect(var PS: TXLPaintStruct);
    procedure UpdateStyles;

    procedure PaintCell(const PS: TXLPaintStruct; var ADraw: TXLDraw; const ARect: TRect; ACell: TXLCell);
    procedure PaintOther(const PS: TXLPaintStruct; var ADraw: TXLDraw; ARect: TRect);
    procedure AdjustFrameRect(var ARect: TRect; AFrame: TXLFrame);
    procedure PrepareFont(AFont: TFont; AScale: Integer; AScaled, AError: Boolean);
    function GetStyles(ACoord: TPoint): TXLCellStyles;
    function GetLayout(ACoord: TPoint): TXLLayout;
    function GetExtents: TRect;
  public
    function  MapToClient(const ARect: TRect): TRect;
    procedure Prepare(AList: TSList; AIndex: Integer); override;
    function  EnumCells(AArea: TRect; ACreate: Boolean; AEnumProc: TXLCellEnumProc; AData: Integer): Integer;
    function  EnumCoords(AArea: TRect; AEnumProc: TXLCoordEnumProc; AData: Integer): Integer;
    procedure Renumerate(AFrom, ATo: Integer); override;
    constructor Create(ASheet: TXLCustomSheet; ASector: TXLSector);
    destructor Destroy; override;
    procedure SplitArea(const AArea: TRect);
    function  MergedArea(const AArea: TRect): Boolean;
    procedure MergeArea(AArea: TRect);
    procedure ClearArea(const AArea: TRect);
    procedure Zap;
    property PeekCells[ACoord: TPoint]: TXLCell read GetPeekCell;
    property CellColors[ACoord: TPoint]: TColor read GetColor write SetColor;
    property Cells[ACoord: TPoint]: TXLCell read GetCell write SetCell;
    property CellClasses[ACoord: TPoint]: TXLCellClass read GetCellClass write SetCellClass;
    property CellStyles[ACoord: TPoint]: TXLCellStyles read GetStyles;
    property CellLayouts[ACoord: TPoint]: TXLLayout read GetLayout;
    property Sheet: TXLCustomSheet read FSheet;
    property Sector: TXLSector read FSector;
    property BaseStyle: TXLBaseStyle read FBaseStyle;
    property SectionExtents: TRect read GetExtents;
  end;

  TXLProStyle = class(TXLPersistent)
  private
    FInfos: array[TXLCellInfo] of Pointer;
    FCellClass: TXLCellClass;
    function  GetBasedOn: TXLStyle; override;
    procedure SetBasedOn(AStyle: TXLStyle); override;
    function  GetCellClass: TXLCellClass; override;
    procedure SetCellClass(Value: TXLCellClass); override;
    function  GetCellInfo(ASide: TXLCellInfo; var AllEqual: Boolean): Pointer; override;
    procedure SetCellInfo(ASide: TXLCellInfo; AColorPointer: Pointer); override;
  protected
    procedure Load(AStream: TXLStream); override;
    procedure Save(AStream: TXLStream); override;
  public
    constructor Create(AContainer: TPersistent);
  end;

  TXLBaseStyle = class(TXLProStyle)
  private
    FErrorColor: TColor;
    FLinesColor: TColor;
    FClient: Boolean;
    function  GetSheet: TXLCustomSheet;
    procedure SetErrorColor(Value: TColor);
    procedure SetLinesColor(Value: TColor);
    procedure InvalidateViews;
  protected
    procedure Load(AStream: TXLStream); override;
    procedure Save(AStream: TXLStream); override;
    procedure NotifyChanges(AProp: TXLProp; AChanges: Integer); override;
    procedure SetCellInfo(ASide: TXLCellInfo; AColorPointer: Pointer); override;
  public
    function GetNamePath: String; override;
    constructor Create(ASheet: TXLCustomSheet; AClient: Boolean);
    property Sheet: TXLCustomSheet read GetSheet;
  published
    property ErrorColor: TColor read FErrorColor write SetErrorColor;
    property LinesColor: TColor read FLinesColor write SetLinesColor;
  end;

  IXLSheetUser = interface
    ['{09287E8F-989A-11D2-97BB-BA2A046AD645}']
    procedure InvalidateArea(ASector: TXLSector; const AArea: TRect; AMode: TXLInvalidate);
    procedure InvalidateSector(ASector: TXLSector);
    procedure InvalidateAll;
    procedure LayoutChanged;
    procedure SelectionChanged(ASector: TXLSector);
    procedure SheetSizeChanged(AAxes: TXLAxes; AClient: Boolean);
    procedure CellSizeChanged(AAxis: TXLAxis; AClient: Boolean; AIndex: Integer);
    procedure AreaChanged(ASector: TXLSector; AArea: PRect);
    procedure Disconnect;
    procedure CloseEditor(ACell: TXLCell);
    procedure ResetSelection(AZap: Boolean);
  end;

  TXLSizes = array[TXLAxis, Boolean] of TXLSizeList;

  TXLCustomSheet = class(TComponent)
  private
    FUsers: TList;
    FBaseStyles: array[0..1] of TXLBaseStyle;
    FStyler: TXLStyler;
    FSizes: TXLSizes;
    FSections: array[TXLSector] of TXLSection;
    FMaxSize: TXLSize;
    FBackground: TPicture;
    FOnSizing: TXLSizingEvent;
    FReadOnly: Boolean;
    FOnStylerChanged: TNotifyEvent;
    FModified: Boolean;
    FOnModified: TNotifyEvent;
    FLockCount: Integer;
    FPageDPI: TPoint;
    FPageRect: TRect;
    FPageOffsRight: Integer;
    FPageOffsBottom: Integer;
    FPageOffsTop: Integer;
    FPageOffsLeft: Integer;
    FTitle: String;
    FGridLines: Boolean;
    FOnCellClick: TXLGridEvent;
    FOnCellDblClick: TXLGridEvent;
    FOnCellChanged: TXLGridEvent;
    FOnGetCellHint: TXLCellTextEvent;
    function GetUserCount: Integer;
    function GetUser(AIndex: Integer): IXLSheetUser;
    procedure SetStyler(AStyler: TXLStyler);
    procedure SetBackground(APicture: TPicture);
    procedure InvalidateArea(Sector: TXLSector; const AArea: TRect; AMode: TXLInvalidate);
    procedure InvalidateSector(Sector: TXLSector);

    function  GetSheetSize(Index: Integer): Integer;
    procedure SetSheetSize(Index, ACount: Integer);

    function  GetTitleSize(Index: Integer): Integer;
    procedure SetTitleSize(Index, ACount: Integer);

    procedure SetMaxCellSize(Index, ASize: Integer);
    function  GetMaxCellSize(Index: Integer): Integer;

    procedure SetDefCellSize(Index, ASize: Integer);
    function  GetDefCellSize(Index: Integer): Integer;

    function  GetCellSize(AIndex, Index: Integer): Integer;
    procedure SetCellSize(AIndex, Index, AValue: Integer);

    procedure SizeChanged(AAxes: TXLAxes; AClient: Boolean);
    procedure CellChanged(Caller: IXLSheetUser; AAxis: TXLAxis; AClient: Boolean; AIndex: Integer);
    procedure BackgroundChanged(Sender: TObject);
    procedure Sizing(AAxis: TXLAxis; AClient: Boolean; AIndex: Integer; var AValue: Integer);
    function  GetBaseStyle(Index: Integer): TXLBaseStyle;
    procedure SetBaseStyle(Index: Integer; ADefStyle: TXLBaseStyle);
    function GetBoolean(ACol, ARow: Integer): Boolean;
    function GetCell(ACol, ARow: Integer): TXLCell;
    function GetPeekCell(ACol, ARow: Integer): TXLCell;
    function GetCurrency(ACol, ARow: Integer): Currency;
    function GetDateTime(ACol, ARow: Integer): TDateTime;
    function GetFloat(ACol, ARow: Integer): Double;
    function GetInteger(ACol, ARow: Integer): Integer;
    function GetObject(ACol, ARow: Integer): TPersistent;
    function GetString(ACol, ARow: Integer): String;
    function GetValue(ACol, ARow: Integer): Variant;
    procedure SetBoolean(ACol, ARow: Integer; Value: Boolean);
    procedure SetCell(ACol, ARow: Integer; Value: TXLCell);
    procedure SetCurrency(ACol, ARow: Integer; const Value: Currency);
    procedure SetDateTime(ACol, ARow: Integer; const Value: TDateTime);
    procedure SetFloat(ACol, ARow: Integer; const Value: Double);
    procedure SetInteger(ACol, ARow: Integer; Value: Integer);
    procedure SetObject(ACol, ARow: Integer; Value: TPersistent);
    procedure SetString(ACol, ARow: Integer; const Value: String);
    procedure SetValue(ACol, ARow: Integer; const Value: Variant);
    function MapToSector(ACol, ARow: Integer; var ACoord: TPoint): TXLSector;
    procedure AreaChanged(ASector: TXLSector; AArea: PRect);
    procedure ReloadSelection(ASector: TXLSector);
    procedure CloseEditor(AFrom: TXLCell);
    procedure StylerChanged;
    procedure SetModified(Value: Boolean);
    procedure Load(AStream: TStream);
    procedure Save(AStream: TStream);
    function  GetCellClass(ACol, ARow: Integer): TXLCellClass;
    procedure SetCellClass(ACol, ARow: Integer; Value: TXLCellClass);
    procedure CalcPrintLayout(AListX, AListY: TList);
    procedure CalcPages(ASizes: TXLSizes; AListX, AListY: TList; const APage: TRect);
    function GetExtents: TRect;
    procedure CheckCellSize(ACell: TXLCell; AData: Integer; var AStop: Boolean);
    function CheckRectSize(const ARect: TRect; AFont: TFont; ACols: Boolean): TPoint;
    procedure UpdateUnions(AAxis: TXLAxis; AClient: Boolean;
      ANew: Integer);
    procedure PrintGround(PS: PXLPaintStruct);
  protected
    procedure DefineProperties(Filer: TFiler); override;
    procedure Loaded; override;
  public
    function EnumCells(const AArea: TRect; ACreate: Boolean; AEnumProc: TXLCellEnumProc; AData: Integer): Integer;
    function EnumCoords(const AArea: TRect; AEnumProc: TXLCoordEnumProc; AData: Integer; AIncX, AIncY: Boolean): Integer;
    function CalcColWidth(ACol: Integer): Integer;
    function CalcRowHeight(ARow: Integer): Integer;
    function PrintPageCount: Integer;
    procedure PrintPages(AStart, AStop: Integer);
    procedure SetPrinter;
    procedure AddUser(AUser: IXLSheetUser);
    procedure RemoveUser(AUser: IXLSheetUser);
    procedure Zap;
    procedure BeginUpdate;
    procedure EndUpdate;
    procedure LoadFromFile(const AFileName: String);
    procedure SaveToFile(const AFileName: String);
    procedure LoadFromStream(AStream: TXLStream);
    procedure SaveToStream(AStream: TXLStream);
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Extents: TRect read GetExtents;
    property PageRect: TRect read FPageRect;
    property UserCount: Integer read GetUserCount;
    property Users[AIndex: Integer]: IXLSheetUser read GetUser;
    property ColWidths[ACol: Integer]: Integer index 0 read GetCellSize write SetCellSize;
    property RowHeights[ARow: Integer]: Integer index 1 read GetCellSize write SetCellSize;
    property Cells[ACol, ARow: Integer]: TXLCell read GetCell write SetCell; default;
    property PeekCells[ACol, ARow: Integer]: TXLCell read GetPeekCell;
    property CellClasses[ACol, ARow: Integer]: TXLCellClass read GetCellClass write SetCellClass;
// Value access
    property Values[ACol, ARow: Integer]: Variant read GetValue write SetValue;
    property Integers[ACol, ARow: Integer]: Integer read GetInteger write SetInteger;
    property Doubles[ACol, ARow: Integer]: Double read GetFloat write SetFloat;
    property Currencies[ACol, ARow: Integer]: Currency read GetCurrency write SetCurrency;
    property Strings[ACol, ARow: Integer]: String read GetString write SetString;
    property DateTimes[ACol, ARow: Integer]: TDateTime read GetDateTime write SetDateTime;
    property Booleans[ACol, ARow: Integer]: Boolean read GetBoolean write SetBoolean;
    property Objects[ACol, ARow: Integer]: TPersistent read GetObject write SetObject;
// Modified Flag
    property Modified: Boolean read FModified write SetModified;
        property Title: String read FTitle write FTitle;
    property PrintLeftMargin: Integer read FPageOffsLeft write FPageOffsLeft;
    property PrintTopMargin: Integer read FPageOffsTop write FPageOffsTop;
    property PrintRightMargin: Integer read FPageOffsRight write FPageOffsRight;
    property PrintBottomMargin: Integer read FPageOffsBottom write FPageOffsBottom;
    property PrintGridLines: Boolean read FGridLines write FGridLines;
    property Styler: TXLStyler read FStyler write SetStyler;
    property ColCount: Integer index 0 read GetSheetSize write SetSheetSize;
    property ColDefWidth: Integer index 0 read GetDefCellSize write SetDefCellSize;
    property ColMaxWidth: Integer index 0 read GetMaxCellSize write SetMaxCellSize;
    property RowCount: Integer index 1 read GetSheetSize write SetSheetSize;
    property RowDefHeight: Integer index 1 read GetDefCellSize write SetDefCellSize;
    property RowMaxHeight: Integer index 1 read GetMaxCellSize write SetMaxCellSize;
    property TitleCols: Integer index 0 read GetTitleSize write SetTitleSize;
    property TitleRows: Integer index 1 read GetTitleSize write SetTitleSize;
    property Background: TPicture read FBackground write SetBackground;
    property ReadOnly: Boolean read FReadOnly write FReadOnly;
    property BaseClientStyle: TXLBaseStyle index 0 read GetBaseStyle write SetBaseStyle stored False;
    property BaseTitleStyle: TXLBaseStyle index 1 read GetBaseStyle write SetBaseStyle stored False;

    property OnSizing: TXLSizingEvent read FOnSizing write FOnSizing;
    property OnModified: TNotifyEvent read FOnModified write FOnModified;
    property OnCellClick: TXLGridEvent read FOnCellClick write FOnCellClick;
    property OnCellDblClick: TXLGridEvent read FOnCellDblClick write FOnCellDblClick;
    property OnStylerChanged: TNotifyEvent read FOnStylerChanged write FOnStylerChanged;

    property OnGetCellHint: TXLCellTextEvent read FOnGetCellHint write FOnGetCellHint;
    property OnCellChanged: TXLGridEvent read FOnCellChanged write FOnCellChanged;
  end;

  TXLSheet = class(TXLCustomSheet)
  published
    property Title;
    property PrintLeftMargin ;
    property PrintTopMargin  ;
    property PrintRightMargin;
    property PrintBottomMargin;
    property PrintGridLines;
    property Styler;
    property ColCount;
    property ColDefWidth;
    property ColMaxWidth;
    property RowCount;
    property RowDefHeight;
    property RowMaxHeight;
    property TitleCols;
    property TitleRows;
    property Background;
    property ReadOnly;
    property BaseClientStyle;
    property BaseTitleStyle ;

    property OnSizing        ;
    property OnModified       ;
    property OnCellClick      ;
    property OnCellDblClick   ;
    property OnStylerChanged  ;

    property OnGetCellHint ;
    property OnCellChanged ;
  end;

  TXLStyle = class(TXLProStyle)
  private
    FAlias: String;
    FColor: TColor;
    procedure SetAlias(const AAlias: String);
    function  GetStyler: TXLStyler;
    function GetIndex: Integer;
  protected
    procedure Load(AStream: TXLStream); override;
    procedure Save(AStream: TXLStream); override;
    procedure NotifyChanges(AProp: TXLProp; AChanges: Integer); override;
  public
    function  GetNamePath: String; override;
    constructor Create(AStyler: TXLStyler);
    destructor Destroy; override;
    property Styler: TXLStyler read GetStyler;
    property Index: Integer read GetIndex;
  published
    property Alias: String read FAlias write SetAlias;
  end;

  TXLStyler = class(TComponent)
  private
    FSheets: TList;
    FStyles: TList;
    FModified: Boolean;
    FOnModified: TNotifyEvent;
    FOnChange: TNotifyEvent;
    function GetSheetCount: Integer;
    function GetSheet(AIndex: Integer): TXLCustomSheet;
    function GetStyleCount: Integer;
    function GetStyleByAlias(const AAlias: String): TXLStyle;
    function GetStyleByIndex(AIndex: Integer): TXLStyle;
    procedure ReadStyles(Stream: TStream);
    procedure SaveStyles(Stream: TStream);
    procedure SetModified(Value: Boolean);
    procedure Changed;
  protected
    procedure DefineProperties(Filer: TFiler); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property SheetCount: Integer read GetSheetCount;
    property Sheets[AIndex: Integer]: TXLCustomSheet read GetSheet;
    function Add(const AAlias: String): TXLStyle;
    function FindStyle(const AAlias: String): TXLStyle; // without exception
    property StylesAlias[const AAlias: String]: TXLStyle read GetStyleByAlias; default; // exception
    property Styles[AIndex: Integer]: TXLStyle read GetStyleByIndex; // exception
    property StyleCount: Integer read GetStyleCount;
    property Modified: Boolean read FModified write SetModified;
  published
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
    property OnModified: TNotifyEvent read FOnModified write FOnModified;
  end;

  TXLSelection = class(TXLProRange)
  private
    function  GetBounds: TRect; override;
    procedure SetBounds(ABounds: TRect); override;
    function  GetSection: TXLSection; override;
    function  GetView: TXLView;
    function  GetGrid: TXLCustomGrid;
  protected
    procedure NotifyChanges(AProp: TXLProp; AChanges: Integer); override;
    property  View: TXLView read GetView;
  public
    function Clear: Boolean; override;
    function Merge: Boolean; override;
    function MergeLines: Boolean; override;
    property Grid: TXLCustomGrid read GetGrid;
  end;

{$IFNDEF Delphi45}
  TWMMouseWheel = record
    Msg: Cardinal;
    Keys: SmallInt;
    WheelDelta: SmallInt;
    case Integer of
      0: (
        XPos: Smallint;
        YPos: Smallint);
      1: (
        Pos: TSmallPoint;
        Result: Longint);
  end;

  TCMMouseWheel = record
    Msg: Cardinal;
    ShiftState: TShiftState;
    Unused: Byte;
    WheelDelta: SmallInt;
    case Integer of
      0: (
        XPos: Smallint;
        YPos: Smallint);
      1: (
        Pos: TSmallPoint;
        Result: Longint);
  end;
{$ENDIF}

  TXLCalcMode = (cmFull, cmSkipFrame, cmInterior);

  TXLView = class(TWinControl)
  private
    FSector: TXLSector;
    FSection: TXLSection;
    FSelection: TXLSelection;
    FLinked: array[TXLAxis] of TXLView;
    FLocked: Integer;
    FSizes: array[TXLAxis] of TXLSizeList;
    FScales,
    FSize,
    FOffset: TXLSize;
    FOnCellClick: TXLGridEvent;
    FOnCellDblClick: TXLGridEvent;
    FSelBounds: TRect;
    FKeyCurr: TPoint;
    FCurrent: TPoint;
    FSelCache: TRect;
    function  GetGrid: TXLCustomGrid;
    function  GetClientSize: TXLSize;
    function  HasBackground: TGraphic;
    procedure SetSize(ASize: TXLSize);
    procedure SendOffset;
    function  GetTitleFrame(ACol, ARow: Integer): TXLFrame;
    function  SetOffset(AOffset: TXLSize): Boolean;
    function  AdjustOffset(AOffset: TXLSize): Boolean;
    procedure AdjustScrollBars(AAdjustOffset: Boolean);
    function  ClientToCell(AClient: TPoint; AExpand: Boolean; var Coord: TPoint): Boolean;
    function  CalcView(const AView: TRect; var AArea: TRect): Boolean;
    function  CalcRect(const AArea: TRect; var ARect: TRect; AMode: TXLCalcMode): Boolean;
    procedure MakeVisible(const AArea: TRect);
    procedure InvalidateArea(const AArea: TRect; Expand: Boolean; AMode: TXLInvalidate);
    procedure InvalidateXOR(AArea1, AArea2: TRect);
    procedure AdjustSizeChange(AAxis: TXLAxis; AStart, AOffset1, AOffset2: Integer);
    procedure XLSizing(AOld, ANew: Integer);
    procedure PaintLayout(const PS: TXLPaintStruct);
    function  ProcessScroll(Bar: TXLAxis; Code, Pos: Integer): Integer;
    function  CanSelect(ACoord: TPoint): Boolean;
    function  CanEdit(ACoord: TPoint): Boolean;
    function  CreateSelectionRgn(const ASelection: TRect; ACurrent: TPoint): HRgn;
    procedure SetCurrent(ACurrent: TPoint);
    procedure MoveCurrent(ACurrent: TPoint; AResetSelection, AVisible: Boolean);
    procedure SelectionChanged(const ANewSelection: TRect; AOldCurrent: TPoint);
    procedure Select(ABounds: TRect; AOldCurrent: TPoint; ADelegator: TXLView);
    function  GetEditable: Boolean;
    function  GetEditing: Boolean;
    procedure SetEditing(Value: Boolean);
    procedure SetEditCoord(ACoord: TPoint);
    procedure ResetSelection;
    procedure ProcessSelect(Key: Word);
    procedure LockUpdate;
    procedure UnlockUpdate;
    procedure PaintGround(PS: PXLPaintStruct);
    function  SetOffsetXY(AOffsetX, AOffsetY: Integer): Boolean;
  protected
    procedure DragOver(Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean); override;
    procedure DoEndDrag(Target: TObject; X, Y: Integer); override;
    procedure DoStartDrag(var DragObject: TDragObject); override;

    function  GetPalette: HPalette; override;
    procedure WMHScroll(var Msg: TWMScroll); message WM_HSCROLL;
    procedure WMVScroll(var Msg: TWMScroll); message WM_VSCROLL;
    procedure WMPaint(var Msg: TWMPaint); message WM_PAINT;
    procedure WMRButtonUp(var Msg: TWMRButtonDown); message WM_RBUTTONUP;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure Click; override;
    procedure DblClick; override;
    procedure CellClick(const APoint: TPoint); dynamic;
    procedure CellDblClick(const APoint: TPoint); dynamic;
    procedure WMEraseBkgnd(var Msg: TWMEraseBkgnd); message WM_ERASEBKGND;
    procedure WMNCHitTest(var Msg: TWMNCHitTest); message WM_NCHITTEST;
    procedure CMCtl3DChanged(var Msg: TMessage); message CM_CTL3DCHANGED;
    procedure CMDesignHitTest(var Msg: TMessage); message CM_DESIGNHITTEST;
    procedure CMShowHintChanged(var Msg: TMessage); message CM_SHOWHINTCHANGED;
    procedure CMWantSpecialKey(var Msg: TCMWantSpecialKey); message CM_WANTSPECIALKEY;
    procedure WMSetCursor(var Msg: TWMSetCursor); message WM_SETCURSOR;
    procedure WMSize(var Msg: TWMSize); message WM_SIZE;
    procedure WMGetDlgCode(var Msg: TWMGetDlgCode); message WM_GETDLGCODE;
    procedure WMIMEStartComposition(var Msg: TMessage); message WM_IME_STARTCOMPOSITION;
    procedure WMIMEComposition(var Msg: TMessage); message WM_IME_COMPOSITION;
    procedure WMIMENotify(var Msg: TMessage); message WM_IME_NOTIFY;
    procedure WMIMEEndComposition(var Msg: TMessage); message WM_IME_ENDCOMPOSITION;
    procedure WMChar(var Msg: TWMChar); message WM_CHAR;
    procedure WMRButtonDown(var Msg: TWMMouse); message WM_RBUTTONDOWN;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CropPoint(var ACoord: TPoint);
    function  CropArea(var AArea: TRect): Boolean;
    function  Redirect(ACoord: TPoint): TPoint;
    function  ExpandArea(const AArea: TRect): TRect;
    function  HitResult(APoint: TPoint; var Coord: TPoint): TXLHitResult;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure KeyPress(var Key: Char); override;
    function  FindNext(var APoint: TPoint; ADir: TXLDirection; InSelection: Boolean): Boolean;
  public
    constructor CreateControl(AGrid: TXLCustomGrid; ASector: TXLSector);
    destructor Destroy; override;
    procedure DragDrop(Source: TObject; X, Y: Integer); override;
    function  MapToClient(ACoord: TPoint): TPoint;
    procedure Invalidate; override;
    property  Editable: Boolean read GetEditable;
    property  Editing: Boolean read GetEditing write SetEditing;
    property  SelBounds: TRect read FSelBounds;
    property  Selection: TXLSelection read FSelection;
    property  Sector: TXLSector read FSector;
    property  Grid: TXLCustomGrid read GetGrid;
    property  Section: TXLSection read FSection;
    property  Size: TXLSize read FSize;
    property  ClientSize: TXLSize read GetClientSize;
    property  Offset: TXLSize read FOffset;
    property  Current: TPoint read FCurrent write SetCurrent;
    property  OnClick;
    property  OnDblClick;
    property  OnCellClick: TXLGridEvent read FOnCellClick write FOnCellClick;
    property  OnCellDblClick: TXLGridEvent read FOnCellDblClick write FOnCellDblClick;
  end;

  TXLEdit = class(TWinControl)
  private
    FGrid: TXLCustomGrid;
    FView: TXLView;
    FControl: TWinControl;
    FWorkControl: TWinControl;
    FWorkHandle: HWND;
    FPopupSave: TPopupMenu;
    FEditClass: TWinControlClass;
    FCell: TXLCell;
    FEntering: Boolean;
    FAlign: TVertAlign;
    function GetEditing: Boolean;
    procedure SetCell(ACell: TXLCell; ASave: Boolean);
    procedure SetEditClass(AClass: TWinControlClass);
    procedure SetEditing(Value: Boolean);
    procedure Read;
    procedure ControlKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ControlKeyPress(Sender: TObject; var Key: Char);
    procedure SetEditView(AView: TXLView);
    procedure SetEntering(Value: Boolean);
    procedure SendMessage(var Msg: TMessage);
    procedure SetEditCell(AView: TXLView; ACell: TXLCell);
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure AlignControls(AControl: TControl; var ARect: TRect); override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
  public
    constructor Create(AOwner: TComponent); override;
    procedure UpdateEditor;
    procedure Relocate;
    procedure ShowWithMessage(var Msg: TMessage);
    procedure Show;
    procedure Cancel;
    property Grid: TXLCustomGrid read FGrid;
    property View: TXLView read FView write SetEditView;
    property EditClass: TWinControlClass read FEditClass write SetEditClass;
    property EditCell: TXLCell read FCell;
    property Editing: Boolean read GetEditing write SetEditing;
    property Entering: Boolean read FEntering write SetEntering;
  end;

  TXLViews = record
  case Integer of
  0: (Sectors: Array[TXLSector] of TXLView);
  1: (ColsView,
      RowsView,
      TitleView,
      ClientView: TXLView);
  end;

  TXLAlteringProc = procedure (Sender: TXLView; APoint: TPoint; AShift: TShiftState) of object;
  TXLEditMode = (emNone, emEnter, emEdit);

  TXLCustomGrid = class(TCustomPanel, IXLSheetUser)
  private
    FViews: TXLViews;
    FSheet: TXLCustomSheet;
    FEditor: TXLEdit;
    FScale: TXLScale;
    FSizes: TXLSizes;
    FOptions: TXLOptions;
    FScrolls: TXLScrolls;
    FOnCellClick: TXLGridEvent;
    FOnCellDblClick: TXLGridEvent;
    FOnSelChanged: TNotifyEvent;
    FOnCurChanged: TNotifyEvent;
    FLastDir: TXLDirection;
    FGridDir: TXLDirection;
    FTimer: TXLView;
    FHitTest: TPoint;
    FPhaseWork: Boolean;
    FSAxis: TXLAxis;
    FSSheet: Boolean;
    FSIndex: Integer;
    FSStart: Integer;
    FSSave: Integer;
    FSOld: Integer;
    FSNew: Integer;
    FHorzLink: TXLCustomGrid;
    FVertLink: TXLCustomGrid;
    FOnSheetChanged: TNotifyEvent;
    FDesignMode: Boolean;
    FOnEditModeChanged: TNotifyEvent;
    FOnColDblClick: TXLGridEvent;
    FOnRowDblClick: TXLGridEvent;
    FOnScaleChanged: TNotifyEvent;
    function  GetEditMode: TXLEditMode;
    procedure SetEditMode(AMode: TXLEditMode);
    procedure SetHorzLink(ALink: TXLCustomGrid);
    procedure SetVertLink(ALink: TXLCustomGrid);
    procedure SetTimer(ATimer: TXLView);
    procedure SetSheet(ASheet: TXLCustomSheet);
    function  GetList(ASector: TXLSector; AAxis: TXLAxis): TXLSizeList;
    procedure SetScale(AScale: TXLScale);
    procedure SetOptions(AOptions: TXLOptions);
    procedure SetScrolls(AScrolls: TXLScrolls);
    procedure Init;
    procedure Done;
    procedure IntDisconnect;
    procedure LockUpdate;
    procedure UnlockUpdate;
    procedure GetPair(AAxis: TXLAxis; ASheet: Boolean; var P1, P2: TXLSector);
    procedure Altering(Sender: TXLView; APhase: TXLAlterPhase; APoint: TPoint; AShift: TShiftState);
    function  GetCurCol: Integer;
    function  GetCurRow: Integer;
    procedure SetCurCol(ACol: Integer);
    procedure SetCurRow(ARow: Integer);
    function  GetCurPos: TPoint;
    procedure SetCurPos(ACoord: TPoint);
    procedure CurrentChanged(Sender: TXLView);
    function  DrawCurrent: Boolean;
    procedure SheetChanged;
    procedure SetDesignMode(Value: Boolean);
    procedure PrepareSheetData;
    procedure ScrollLinked(AOffset: TXLSize);
    function  IsActive: Boolean;
    function  CheckFocus(AView: TXLView; ASwitch: Boolean): Boolean;
    procedure SmartFocus;
    function  GetSelection: TXLProRange;
    procedure SetSelection(Value: TXLProRange);
{Interface declaration begins}
{$IFNDEF Delphi45}
{Delphi 3.0 GetInterface Bug workaround}
   function QueryInterface(const IID: TGUID; out Obj): Integer; stdcall;
   function _AddRef: Integer; stdcall;
   function _Release: Integer; stdcall;
{$ENDIF}
    procedure InvalidateArea(ASector: TXLSector; const AArea: TRect; AMode: TXLInvalidate);
    procedure InvalidateSector(ASector: TXLSector);
    procedure SheetSizeChanged(AAxes: TXLAxes; AClient: Boolean);
    procedure CellSizeChanged(AAxis: TXLAxis; AClient: Boolean; AIndex: Integer);
    procedure AreaChanged(ASector: TXLSector; AArea: PRect);
    procedure Disconnect;
    procedure CloseEditor(ACell: TXLCell);
    procedure ResetSelection(AZap: Boolean);
    procedure SelectionChanged(ASector: TXLSector);
    procedure LayoutChanged;
    function  GetEnterDir: TXLDirection;
    procedure UpdateViews;
{Interface declaration ends}
  protected
    FPhase: TXLAlterPhase;
    FProcess: TXLAlteringProc;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure DestroyWnd; override;
{$IFDEF Delphi45}
    function DoMouseWheel(Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint): Boolean; override;
{$ELSE}
    procedure WMMouseWheel(var Message: TWMMouseWheel); message WM_MOUSEWHEEL;
{$ENDIF}
    function  DoWheel(Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint): Boolean;
    function  ScanAlter(Sender: TXLView; APoint: TPoint): TCursor; virtual;
    procedure XLSelecting(Sender: TXLView; APoint: TPoint; AShift: TShiftState);
    procedure XLSizing(Sender: TXLView; APoint: TPoint; AShift: TShiftState);
    procedure XLMoving(Sender: TXLView; APoint: TPoint; AShift: TShiftState);
    procedure XLScrolling(Sender: TXLView; APoint: TPoint; AShift: TShiftState);
    procedure Loaded; override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure WMTimer(var Msg: TWMTimer); message WM_TIMER;
    procedure WMSetFocus(var Msg: TWMSetFocus); message WM_SETFOCUS;
    procedure WMEraseBkgnd(var Msg: TWMEraseBkgnd); message WM_ERASEBKGND;
    property  Timer: TXLView read FTimer write SetTimer;
    property  Phase: TXLAlterPhase read FPhase;
    property  PhaseWork: Boolean read FPhaseWork;
    property  Editor: TXLEdit read FEditor;
    property  RealDir: TXLDirection read GetEnterDir;
    property  Views: TXLViews read FViews;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    procedure InvalidateAll;
    procedure SelectNext(ADir: TXLDirection; ABackwards: Boolean);
    procedure SelectAll;
    procedure AlignControls(AControl: TControl; var Rect: TRect); override;
    function  ToOriginal(AScaled: Integer): Integer;
    function  ToScaled(AOriginal: Integer): Integer;
    function  HitTest(AClient: TPoint; var ASector: TXLSector; var Coord: TPoint): Boolean;
    property  Selection: TXLProRange read GetSelection write SetSelection;
    property  CurCol: Integer read GetCurCol write SetCurCol;
    property  CurRow: Integer read GetCurRow write SetCurRow;
    property  CurPos: TPoint read GetCurPos write SetCurPos;
    property  DesignMode: Boolean read FDesignMode write SetDesignMode;
    property  EditMode: TXLEditMode read GetEditMode write SetEditMode;
    property  LastDir: TXLDirection read FLastDir;
    
    property  Sheet: TXLCustomSheet read FSheet write SetSheet;
    property  Scale: TXLScale read FScale write SetScale default 100;
    property  Options: TXLOptions read FOptions write SetOptions default [oTitleCols, oTitleRows, oDrawFocus, oTracking, oVertLines, oHorzLines, oRangeSelect];
    property  Scrolls: TXLScrolls read FScrolls write SetScrolls default [ssVertical, ssHorizontal];
    property  OnColDblClick: TXLGridEvent read FOnColDblClick write FOnColDblClick;
    property  OnRowDblClick: TXLGridEvent read FOnRowDblClick write FOnRowDblClick;
    property  OnCellClick: TXLGridEvent read FOnCellClick write FOnCellClick;
    property  OnCellDblClick: TXLGridEvent read FOnCellDblClick write FOnCellDblClick;
    property  OnSelChanged: TNotifyEvent read FOnSelChanged write FOnSelChanged;
    property  OnCurChanged: TNotifyEvent read FOnCurChanged write FOnCurChanged;
    property  OnSheetChanged: TNotifyEvent read FOnSheetChanged write FOnSheetChanged;
    property  OnEditModeChanged: TNotifyEvent read FOnEditModeChanged write FOnEditModeChanged;
    property  OnScaleChanged: TNotifyEvent read FOnScaleChanged write FOnScaleChanged;
    property  HorzLink: TXLCustomGrid read FHorzLink write SetHorzLink;
    property  VertLink: TXLCustomGrid read FVertLink write SetVertLink;
    property  EnterDir: TXLDirection read FGridDir write FGridDir default dAuto;

  end;
  TXLGrid = class(TXLCustomGrid)
  published
    property  Sheet               ;
    property  Scale               ;
    property  Options             ;
    property  Scrolls             ;
    property  OnColDblClick       ;
    property  OnRowDblClick       ;
    property  OnCellClick         ;
    property  OnCellDblClick      ;
    property  OnSelChanged        ;
    property  OnCurChanged        ;
    property  OnSheetChanged      ;
    property  OnEditModeChanged   ;
    property  OnScaleChanged      ;
    property  HorzLink            ;
    property  VertLink            ;
    property  EnterDir            ;
  published // TCustomPanel
    property Align;
    property BevelInner;
    property BevelOuter;
    property BevelWidth;
    property BorderWidth;
    property BorderStyle;
    property Color default clWindow;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnResize;
    property OnStartDrag;
{$IFDEF Delphi45}
    property Alignment;
    property Anchors;
    property AutoSize;
    property BiDiMode;
    property Caption;
    property Constraints;
    property UseDockManager default True;
    property DockSite;
    property DragKind;
    property ImeMode;
    property ImeName;
    property ParentBiDiMode;
    property OnCanResize;
    property OnConstrainedResize;
    property OnDockDrop;
    property OnDockOver;
    property OnEndDock;
    property OnGetSiteInfo;
    property OnStartDock;
    property OnUnDock;
{$ENDIF}
  end;

  TXLManager = class
  private
    FCellClasses: TList;
    FEditClasses: TList;
    FCellFormats: TList;
    function GetCellClass(AIndex: Integer): TXLCellClass;
    function GetCellClassCount: Integer;
    function GetEditClass(ACellClass: TXLCellClass; AIndex: Integer): TWinControlClass;
    function GetEditClassCount(ACellClass: TXLCellClass): Integer;
    function HashCodeOf(AClass: TClass): Integer;
    function FindClassBy(AHashCode: Integer): TXLCellClass;
    function EnsureCellClass(ACellClass: TXLCellClass): Integer;
    function GetFormats(ACellClass: TXLCellClass): TStrings;
    procedure SetFormats(ACellClass: TXLCellClass; AFormats: TStrings);
  public
    constructor Create;
    destructor Destroy; override;
    procedure RegisterClasses(const ACellClasses: Array of TXLCellClass; const ACellEdits: Array of TWinControlClass);
    procedure RegisterCellClasses(const ACellClasses: Array of TXLCellClass);
    procedure UnregisterCellClasses(const ACellClasses: Array of TXLCellClass);
    procedure UnregisterEditClasses(const AEditClasses: Array of TWinControlClass);
    function  FindEditClass(ACellClass: TXLCellClass; AEditClass: TWinControlClass): Integer;

    property  CellClassCount: Integer read GetCellClassCount;
    property  CellClasses[AIndex: Integer]: TXLCellClass read GetCellClass;

    property  EditClassCount[ACellClass: TXLCellClass]: Integer read GetEditClassCount;
    property  EditClasses[ACellClass: TXLCellClass; AIndex: Integer]: TWinControlClass read GetEditClass;

    property  Formats[ACellClass: TXLCellClass]: TStrings read GetFormats write SetFormats;
  end;

// Workaround routines
  function  UnpackSuffix(const AFormat: String; ADel: Char): String;
  function  UnpackPrefix(const AFormat: String; ADel: Char): String;
  procedure DesignerModified(Sender: TComponent);
  function  Area(const APoint1, APoint2: TPoint): TRect;
  function  HasRelation(SelfHandle, TestHandle: HWnd): Boolean;
  procedure InvalidOp(const id: string);
  function  UnpackColorPointer(AData: Pointer): TXLSideBorder;
  function  PackColorPointer(const AData: TXLSideBorder): Pointer;
  function  XLSideBorder(AColor: TColor; ALine: TXLSideLine): TXLSideBorder;
  function  XLSize(AX, AY: Integer): TXLSize;
  function  SectorOf(ASector: TXLSector; const ARect: TRect): TRect;
  function  XLManager: TXLManager;
  function  XLClipboard: TXLCustomSheet;
procedure Register;
implementation
uses XLCells, XLEdits, Imm;

{$R *.RES}

const
  BorderSize     = 3;
  MinSize        = 5;
  HitBorderSize  = 1;
var
  FXLManager     : TXLManager = Nil;
  FXLClipboard   : TXLCustomSheet   = Nil;
  HiddenBitmap   : TBitmap    = Nil;
  HiddenBrush    : TBrush     = Nil;
  SheetInfoMapper : Array[TXLSheetInfo] of TXLCellInfo = (ciLeft, ciTop, ciBias1, ciBias2, ciColor, ciFrame, ciStyles, ciLayout);
  CellInfoMapper  : Array[TXLCellInfo] of TXLSheetInfo
  = (siColLines, siRowLines, siColLines, siRowLines, siBias1, siBias2, siColLines, siRowLines, siColor, siFrame, siStyles, siLayout);

function XLClipboard: TXLCustomSheet;
begin
  if FXLClipboard = Nil then begin
    FXLClipboard := TXLCustomSheet.Create(nil);
    FXLClipboard.TitleCols := 0;
    FXLClipboard.TitleRows := 0;
  end;
  Result := FXLClipboard;
end;

function  XLManager: TXLManager;
begin
  if FXLManager = Nil then FXLManager := TXLManager.Create;
  Result := FXLManager;
end;

function  UnpackSuffix(const AFormat: String; ADel: Char): String;
var
  I: Integer;
begin
  Result := '';
  I := Pos(ADel, AFormat);
  if I > 0 then Result := Copy(AFormat, I + 1, Length(AFormat) - I);
end;

function  UnpackPrefix(const AFormat: String; ADel: Char): String;
var
  I: Integer;
begin
  Result := AFormat;
  I := Pos(ADel, AFormat);
  if I > 0 then Result := Copy(Result, 1, I - 1);
end;

function SectorOf(ASector: TXLSector; const ARect: TRect): TRect;
begin
  Result := ARect;
  if ASector in [sCols, sClient] then Result.Left := 0
  else Result.Right := 0;
  if ASector in [sCols, sTitle] then Result.Bottom := 0
  else Result.Top := 0;
  Result.Left := IMin(Result.Right, Result.Left);
  Result.Top := IMin(Result.Top, Result.Bottom);
end;

procedure InvalidOp(const id: string);
begin
  raise EXLGridError.Create(id);
end;

function  HasRelation(SelfHandle, TestHandle: HWnd): Boolean;
begin
  Result := True;
  while (TestHandle <> 0) do
    if TestHandle <> SelfHandle
    then TestHandle := GetParent(TestHandle)
    else exit;
  Result := False;
end;

const
  cmColorMask   = $60000000;// Color mask

function UnpackColorPointer(AData: Pointer): TXLSideBorder;
begin
  with Result do
  begin
    if AData = Nil then
    begin
      Color := clNone;
      Line := slNone;
    end else
    begin
      Line := TXLSideLine((Integer(AData) and cmColorMask) shr 29);
      Color := Integer(AData) and not cmColorMask;
    end;
  end;
end;

function PackColorPointer(const AData: TXLSideBorder): Pointer;
begin
  Result := Nil;
  with AData do
    if (Color <> clNone) and (Line <> slNone)
    then Result := Pointer((Color and not cmColorMask) or (Integer(Line) shl 29));
end;

function UnpackLayoutPointer(AData: Pointer): TXLLayout;
var
  FLayout: Integer;
begin
  with Result do begin
    FLayout := Integer(AData);
    Indent := FLayout and $FFFF;
    HorzAlign := THorzAlign((FLayout and $000F0000) shr 16);
    VertAlign := TVertAlign((FLayout and $00F00000) shr 20);
    WrapMode := TWrapMode((FLayout and $0F000000) shr 24);
  end;
end;

function PackLayoutPointer(const ALayout: TXLLayout): Pointer;
begin
  with ALayout do
  Result := Pointer((Indent and $FFFF) or
                    (Integer(HorzAlign) shl 16) or
                    (Integer(VertAlign) shl 20) or
                    (Integer(WrapMode) shl 24));
end;

function XLSideBorder(AColor: TColor; ALine: TXLSideLine): TXLSideBorder;
begin
  Result.Color := AColor;
  Result.Line := ALine;
end;

function XLSize(AX, AY: Integer): TXLSize;
begin
  Result.sCols := AX;
  Result.sRows := AY;
end;

function Area(const APoint1, APoint2: TPoint): TRect;
begin
  with Result do
  begin
    TopLeft := APoint1;
    BottomRight := APoint2;
    if Left > Right then begin Left := Right; Right := APoint1.X; end;
    if Top > Bottom then begin Top := Bottom; Bottom := APoint1.Y; end;
    Inc(Right); Inc(Bottom);
  end;
end;

type
  TXorRects  = array[0..3] of TRect;

procedure XorRects(const R1, R2: TRect; var XorRects: TXorRects);
var
  Intersect, Union: TRect;

  function PtInRect(X, Y: Integer; const Rect: TRect): Boolean;
  begin
    with Rect do Result := (X >= Left) and (X <= Right) and (Y >= Top) and
      (Y <= Bottom);
  end;

  function Includes(const P1: TPoint; var P2: TPoint): Boolean;
  begin
    with P1 do
    begin
      Result := PtInRect(X, Y, R1) or PtInRect(X, Y, R2);
      if Result then P2 := P1;
    end;
  end;

  function Build(var R: TRect; const P1, P2, P3: TPoint): Boolean;
  begin
    Build := True;
    with R do
      if Includes(P1, TopLeft) then
      begin
        if not Includes(P3, BottomRight) then BottomRight := P2;
      end
      else if Includes(P2, TopLeft) then BottomRight := P3
      else Build := False;
  end;

begin
  FillChar(XorRects, SizeOf(XorRects), 0);
  if not IntersectRect(Intersect, R1, R2) then
  begin
    { Don't intersect so its simple }
    XorRects[0] := R1;
    XorRects[1] := R2;
  end else
  begin
    UnionRect(Union, R1, R2);
    if Build(XorRects[0], Point(Union.Left, Union.Top), Point(Union.Left, Intersect.Top), Point(Union.Left, Intersect.Bottom))
    then XorRects[0].Right := Intersect.Left;
    if Build(XorRects[1], Point(Intersect.Left, Union.Top), Point(Intersect.Right, Union.Top), Point(Union.Right, Union.Top))
    then XorRects[1].Bottom := Intersect.Top;
    if Build(XorRects[2], Point(Union.Right, Intersect.Top), Point(Union.Right, Intersect.Bottom), Point(Union.Right, Union.Bottom))
    then XorRects[2].Left := Intersect.Right;
    if Build(XorRects[3], Point(Union.Left, Union.Bottom), Point(Intersect.Left, Union.Bottom), Point(Intersect.Right, Union.Bottom))
    then XorRects[3].Top := Intersect.Bottom;
  end;
end;

procedure DesignerModified(Sender: TComponent);
begin
  while Sender <> Nil do
  begin
    if Sender is TForm then
    begin
      if Assigned(TForm(Sender).Designer) and
      ([csDesigning, csUpdating, csReading] * Sender.ComponentState = [csDesigning])
      then TForm(Sender).Designer.Modified;
    end;
    Sender := Sender.Owner;
  end;
end;

// TXLPersistent

function TXLPersistent.LoadFromStream(AStream: TXLStream): Boolean;
var CP, CS: Integer;
begin
  Result := True;
  CP := AStream.Position;
  AStream.Read(CS, SizeOf(Integer));
  try
    Load(AStream);
  except
    Result := False;
  end;
  AStream.Seek(CP + CS, 0);
end;

procedure TXLPersistent.SaveToStream(AStream: TXLStream);
var CP, CS, NP: Integer;
begin
  CP := AStream.Position;
  AStream.Write(CP, SizeOf(Integer));
  Save(AStream);
  NP := AStream.Position;
  CS := NP - CP;
  AStream.Seek(CP, 0);
  AStream.Write(CS, SizeOf(Integer));
  AStream.Seek(NP, 0);
end;

constructor TXLPersistent.Create(AContainer: TPersistent);
begin
  inherited Create;
  FContainer := AContainer;
end;

function  TXLPersistent.SaveState(AState: TXLCellState): Boolean;
begin
  Result := AState in FStates;
  Include(FStates, AState);
end;

procedure TXLPersistent.RestoreState(AState: TXLCellState; ASaved: Boolean);
begin
  if not ASaved then Exclude(FStates, AState);
end;

function TXLPersistent.GetAssignedFont(ASource: TFont): TFont;
begin
  if FFont = Nil then
  begin
    FFont := TFont.Create;
    FFont.Name := 'Arial';
    if ASource = Nil then ReloadProperty(prFont, pAll);
    FFont.OnChange := FontChange;
  end;
  if ASource <> Nil then FFont.Assign(ASource);
  Result := FFont;
end;

function  TXLPersistent.GetFont: TFont;
begin
  Result := GetAssignedFont(nil);
end;

procedure TXLPersistent.SetFont(AFont: TFont);
begin
  GetAssignedFont(AFont);
end;

function  TXLPersistent.GetLayout: TXLLayout;
var
  AE: Boolean;
begin
  Result := UnpackLayoutPointer(GetCellInfo(ciLayout, AE));
end;

procedure TXLPersistent.IntSetLayout(const ALayout: TXLLayout);
begin
  SetCellInfo(ciLayout, PackLayoutPointer(ALayout));
end;

procedure TXLPersistent.SetHorzAlign(AAlign: THorzAlign);
var TL: TXLLayout;
begin
  TL := Layout;
  if (TL.HorzAlign <> AAlign) or (csStyle in FStates) then begin
    TL.HorzAlign := AAlign;
    IntSetLayout(TL);
    NotifyChanges(prLayout, plHorzAlign);
  end;
end;

procedure TXLPersistent.SetVertAlign(AAlign: TVertAlign);
var TL: TXLLayout;
begin
  TL := Layout;
  if (TL.VertAlign <> AAlign) or (csStyle in FStates) then begin
    TL.VertAlign := AAlign;
    IntSetLayout(TL);
    NotifyChanges(prLayout, plVertAlign);
  end;
end;

procedure TXLPersistent.SetWrap(AWrap: TWrapMode);
var TL: TXLLayout;
begin
  TL := Layout;
  if (TL.WrapMode <> AWrap) or (csStyle in FStates) then begin
    TL.WrapMode := AWrap;
    IntSetLayout(TL);
    NotifyChanges(prLayout, plWrapMode);
  end;
end;

procedure TXLPersistent.SetIndent(AIndent: Integer);
var TL: TXLLayout;
begin
  TL := Layout;
  if (TL.Indent <> AIndent) or (csStyle in FStates) then begin
    TL.Indent := AIndent;
    IntSetLayout(TL);
    NotifyChanges(prLayout, plIndent);
  end;
end;

procedure TXLPersistent.SetLayout(const ALayout: TXLLayout);
begin
  IntSetLayout(ALayout);
  NotifyChanges(prLayout, pAll);
end;

procedure TXLPersistent.FontChange(Sender: TObject);
begin
  NotifyChanges(prFont, pAll);
end;

destructor TXLPersistent.Destroy;
begin
  FFont.Free;
  inherited Destroy;
end;

procedure TXLPersistent.SetProps(AProps: TXLProps);
var Changes: TXLProps;
    I: TXLProp;
begin
  if AProps <> FProps then
  begin
    Changes := (FProps - AProps) + (AProps - FProps);
    FProps := AProps;
    for I := Low(I) to High(I) do
    if I in Changes then ReloadProperty(I, pAll);
  end;
end;

procedure TXLPersistent.ReloadProperty(AProp: TXLProp; AChanges: Integer);
var Source: TXLPersistent;
    SS: Boolean;
begin
  Source := FindProperty(AProp);
  if (Source <> Nil) and (Source <> Self) then
  begin
    SS := SaveState(csAssign);
    try
      AssignProperty(Source, AProp, AChanges);
    finally
      RestoreState(csAssign, SS);
    end;
  end;
end;

procedure TXLPersistent.AssignProperty(Source: TXLPersistent; AProp: TXLProp; AData: Integer);
var WS: TXLSides;
    I: TXLSide;
    TF: TFont;
    TL: TXLLayout;
    FS: TFontStyle;
begin
{!!!}
  case AProp of
    prBasedOn : BasedOn := Source.BasedOn;
    prControl : if AData = pAll then Control := Source.Control else begin
                  if (pcClass and AData) <> 0 then CellClass := Source.CellClass;
                  if Source.CellClass = CellClass then begin
                    if (pcEditor and AData) <> 0 then Editor := Source.Editor;
                    if (pcFormat and AData) <> 0 then Format := Source.Format;
                  end;
                end;
    prLayout  : if AData = pAll then Layout := Source.Layout else begin
                  TL := Source.Layout;
                  if (plHorzAlign and AData) <> 0 then HorzAlign := TL.HorzAlign;
                  if (plVertAlign and AData) <> 0 then VertAlign := TL.VertAlign;
                  if (plIndent and AData) <> 0 then Indent := TL.Indent;
                  if (plWrapMode and AData) <> 0 then WrapMode := TL.WrapMode;
                end;
    prColor   : Color := Source.Color;
    prFont    : if AData = pAll then Font := Source.Font else begin
                  TF := Source.Font;
                  with Font do begin
                    if (pfName and AData) <> 0 then Name := TF.Name;
                    if (pfColor and AData) <> 0 then Color := TF.Color;
                    if (pfCharset and AData) <> 0 then Charset := TF.Charset;
                    if (pfSize and AData) <> 0 then Size := TF.Size;
                    for FS := fsBold to fsStrikeOut do
                      if ((1 shl Integer(FS)) and AData) <> 0 then
                        if FS in TF.Style then Style := Style + [FS]
                        else Style := Style - [FS];
                  end;
                end;
    prBorder  : if Source is TXLProStyle then begin
                  WS := Source.Sides;
                  for I := Low(I) to High(I) do
                  if I in WS then Border[I] := Source.Border[I];
                end;
    prFrame   : Frame := Source.Frame;
    prStyles  : Styles := Source.Styles;
  end;
end;

procedure TXLPersistent.Load(AStream: TXLStream);

  procedure LoadFont;
  begin
    Font.Name := AStream.StringIO;
    Font.Charset := AStream.IntegerIO;
    Font.Style := TFontStyles(Byte(AStream.IntegerIO));
    Font.Height := AStream.IntegerIO;
    Font.Color := AStream.IntegerIO;
  end;
  procedure LoadFormat;
  var I: Integer;
  begin
    I := AStream.IntegerIO;
    if I < 0 then Format := AStream.StringIO
    else Format := XLManager.Formats[CellClass][I];
  end;
begin
  AStream.Read(FProps, SizeOf(FProps));
  if prFont in FProps then LoadFont;
  if prControl in FProps then begin
    if csStyle in FStates then CellClass := XLManager.FindClassBy(AStream.IntegerIO);
    Editor := AStream.IntegerIO;
    LoadFormat;
  end;
end;

procedure TXLPersistent.Save(AStream: TXLStream);
  procedure SaveFont;
  begin
    AStream.StringIO := Font.Name;
    AStream.IntegerIO := Font.Charset;
    AStream.IntegerIO := Byte(Font.Style);
    AStream.IntegerIO := Font.Height;
    AStream.IntegerIO := Font.Color;
  end;
  procedure SaveFormat;
  var I: Integer;
  begin
    I := XLManager.Formats[CellClass].IndexOf(Format);
    AStream.IntegerIO := I;
    if I < 0 then AStream.StringIO := Format;
  end;
begin
  AStream.Write(FProps, SizeOf(FProps));
  if prFont in FProps then SaveFont;
  if prControl in FProps then begin
    if csStyle in FStates then AStream.IntegerIO := XLManager.HashCodeOf(CellClass);
    AStream.IntegerIO := Editor;
    SaveFormat;
  end;
end;

procedure TXLPersistent.NotifyChanges(AProp: TXLProp; AChanges: Integer);
begin
  if not (csAssign in FStates) then Include(FProps, AProp);
end;

procedure TXLPersistent.Assign(Source: TPersistent);
var I: TXLProp;
begin
  if Source is TXLPersistent then
  begin
    FProps := [];
    for I := Low(I) to High(I) do
      AssignProperty(TXLPersistent(Source), I, pAll)
  end else inherited Assign(Source);
end;

procedure TXLPersistent.SetBorders(ASides: TXLSides; const Value: TXLSideBorder);
var I: TXLSide;
begin
  for I := Low(I) to High(I) do
  if I in ASides then SetCellInfo(TXLCellInfo(I), PackColorPointer(Value));
end;

function TXLPersistent.GetEditor: Integer;
begin
  Result := FEditor;
end;

function TXLPersistent.GetBorder(ASide: TXLSide): TXLSideBorder;
var AE: Boolean;
begin
  Result := UnpackColorPointer(GetCellInfo(TXLCellInfo(ASide), AE));
end;

function TXLPersistent.GetHorzAlign: THorzAlign;
begin
  Result := Layout.HorzAlign;
end;

function TXLPersistent.GetIndent: Integer;
begin
  Result := Layout.Indent;
end;

function TXLPersistent.GetSides: TXLSides;
var I: TXLSide;
    AE: Boolean;
begin
  Result := [];
  for I := Low(I) to High(I) do
    if (GetCellInfo(TXLCellInfo(I), AE) <> Nil) and AE
    then Include(Result, I);
end;

function TXLPersistent.GetVertAlign: TVertAlign;
begin
  Result := Layout.VertAlign;
end;

function TXLPersistent.GetWrap: TWrapMode;
begin
  Result := Layout.WrapMode;
end;

procedure TXLPersistent.SetBorder(ASide: TXLSide; const Value: TXLSideBorder);
begin
  SetCellInfo(TXLCellInfo(ASide), PackColorPointer(Value));
end;

procedure TXLPersistent.SetSides(const Value: TXLSides);
var ToSet,
    ToRemove: TXLSides;
    I: TXLSide;
begin
  ToSet := Value - Sides;
  ToRemove := Sides - Value;
  for I := Low(I) to High(I) do if I in ToSet then SetCellInfo(TXLCellInfo(I), PackColorPointer(XLSideBorder(clBlack, slSingle)));
  for I := Low(I) to High(I) do if I in ToRemove then SetCellInfo(TXLCellInfo(I), Nil);
end;

function TXLPersistent.GetOwner: TPersistent;
begin
  Result := FContainer;
end;

function TXLPersistent.FormatText: String;
begin
  Result := '';
end;

procedure TXLPersistent.SetControl(const Value: TXLControl);
begin
  CellClass := Value.CellClass;
  if CellClass = Value.CellClass then begin
    Editor := Value.Editor;
    Format := Value.Format;
  end;
end;

function TXLPersistent.GetEditorCount: Integer;
begin
  Result := XLManager.EditClassCount[CellClass];
end;

procedure TXLPersistent.SetEditor(Value: Integer);
begin
  if (Value >= EditorCount) or (Value < 0) then Value := 0;
  if (Value <> Editor) or (csStyle in FStates) then
  begin
    FEditor := Value;
    NotifyChanges(prControl, pcEditor);
  end;
end;

procedure TXLPersistent.SetFormat(const Value: String);
begin
  if (FFormat <> Value) or (csStyle in FStates) then
  begin
    FFormat := Value;
    Include(FStates, csReformat);
    NotifyChanges(prControl, pcFormat);
  end;
end;

function TXLPersistent.FindProperty(AProp: TXLProp): TXLPersistent;
begin
  Result := Self;
  while Result <> Nil do
    if AProp in Result.Props
    then break
    else Result := Result.BasedOn;
end;

function TXLPersistent.GetControl: TXLControl;
begin
  Result.CellClass := CellClass;
  Result.Editor := Editor;
  Result.Format := Format;
end;

function TXLPersistent.GetColor: TColor;
var AE: Boolean;
begin
  Result := TColor(GetCellInfo(ciColor, AE));
end;

procedure TXLPersistent.SetColor(Value: TColor);
begin
  SetCellInfo(ciColor, Pointer(Value));
end;

function TXLPersistent.GetFrame: TXLFrame;
var AE: Boolean;
begin
  Result := TXLFrame(GetCellInfo(ciFrame, AE));
end;

procedure TXLPersistent.SetFrame(Value: TXLFrame);
begin
  SetCellInfo(ciFrame, Pointer(Value));
end;

function TXLPersistent.GetStyles: TXLCellStyles;
var AE: Boolean;
begin
  Result := TXLCellStyles(Byte(GetCellInfo(ciStyles, AE)));
end;

procedure TXLPersistent.SetStyles(AFlags: TXLCellStyles);
begin
  SetCellInfo(ciStyles, Pointer(Byte(AFlags)));
end;

function TXLPersistent.GetCellEditor: TWinControlClass;
begin
  Result := XLManager.EditClasses[CellClass, Editor];
end;

procedure TXLPersistent.SetCellEditor(Value: TWinControlClass);
var
  EditIndex: Integer;
begin
  EditIndex := XLManager.FindEditClass(CellClass, Value);
  if EditIndex < 0 then InvalidOp('Unregistered cell editor!')
  else Editor := EditIndex;
end;

function TXLPersistent.GetDisplayFormat: String;
begin
  Result := UnpackPrefix(Format,'|');
end;

// TXLValue
function  TXLValue.GetDouble: Double;
begin
  Result := Value;
end;

function  TXLValue.GetDateTime: TDateTime;
begin
  Result := Value;
end;

function  TXLValue.GetInteger: Integer;
begin
  Result := Value;
end;

function  TXLValue.GetString: String;
begin
  Result := Value;
end;

function  TXLValue.GetBoolean: Boolean;
begin
  Result := Value;
end;

function  TXLValue.GetCurrency: Currency;
begin
  Result := Value;
end;

function TXLValue.GetObject: TPersistent;
begin
  Result := nil; // Not implemented
end;

procedure TXLValue.SetDouble(const AValue: Double);
begin
  Value := AValue;
end;

procedure TXLValue.SetDateTime(const AValue: TDateTime);
begin
  Value := AValue;
end;

procedure TXLValue.SetInteger(AValue: Integer);
begin
  Value := AValue;
end;

procedure TXLValue.SetString(const AValue: String);
begin
  Value := AValue;
end;

procedure TXLValue.SetBoolean(AValue: Boolean);
begin
  Value := AValue;
end;

procedure TXLValue.SetCurrency(const AValue: Currency);
begin
  Value := AValue;
end;

procedure TXLValue.SetObject(AObject: TPersistent);
begin
  // Not implemented
end;

procedure TXLValue.Draw(const ADraw: TXLDraw; var ARect: TRect);
var SR: TRect;
    DrawFlags: Integer;
    Len: Integer;
begin
  Len := Length(Text);
  if Len > 0 then
  begin
    DrawFlags := DT_NOPREFIX or DT_NOCLIP or DT_EXPANDTABS;
    case ADraw.Layout.HorzAlign of
      haCenter: DrawFlags := DrawFlags or DT_CENTER;
      haRight: DrawFlags := DrawFlags or DT_RIGHT;
    end;
    case ADraw.Layout.WrapMode of
      wmEllipsis: DrawFlags := DrawFlags or DT_END_ELLIPSIS;
      wmWrapWords: DrawFlags := DrawFlags or DT_WORDBREAK;
    end;
    if ADraw.Layout.VertAlign > vaTop then
    begin
      SR := ARect;
      SR.Top := 0;
      SR.Bottom := $FFFF;
      DrawTextEx(ADraw.Canvas.Handle, PChar(FRText), Len, SR, DrawFlags or DT_CALCRECT, Nil);
      if ADraw.Layout.VertAlign = vaCenter
      then ARect.Top := (ARect.Bottom + ARect.Top - (SR.Bottom - SR.Top)) div 2
      else ARect.Top := ARect.Bottom - (SR.Bottom - SR.Top);
    end;
    DrawTextEx(ADraw.Canvas.Handle, PChar(FRText), Len, ARect, DrawFlags, Nil);
  end;
end;

procedure TXLValue.AssignProperty(Source: TXLPersistent; AProp: TXLProp; AChanges: Integer);
begin
  if (AProp = prValue) then
  begin
    if (Source is TXLValue) then begin
      Value := TXLValue(Source).Value;
      if CellClass = Source.CellClass
      then AsObject := TXLValue(Source).AsObject;
    end;
  end else
  inherited AssignProperty(Source, AProp, AChanges);
end;

procedure TXLValue.Changed;
begin
  Include(FStates, csReformat);
  NotifyChanges(prValue, pAll);
end;

function TXLValue.GetValue: Variant;
begin
  Result := Unassigned;
end;

procedure TXLValue.SetValue(const AValue: Variant);
begin
  Changed;
end;

function TXLValue.GetText: String;
begin
  if csReformat in FStates then begin
    FRText := FormatText;
    Exclude(FStates, csReformat);
  end;
  Result := FRText;
end;

// TXLProCell
function TXLProCell.GetSingle: Boolean;
var A: TRect;
begin
  A := Bounds;
  with A do
    Result := (((Right - Left) = 1) and ((Bottom - Top) = 1)) or Section.MergedArea(A);
end;

function TXLProCell.GetMerged: Boolean;
begin
  Result := Section.TestUnion(Bounds, Nil) <> Nil;
end;

procedure TXLProCell.Split;
begin
  Section.SplitArea(Bounds);
end;

function TXLProCell.GetPosition: TPoint;
begin
  Result := Bounds.TopLeft;
end;

procedure TXLProCell.SetPosition(const Value: TPoint);
begin
  Bounds := Classes.Bounds(Value.X, Value.Y, 1, 1);
end;

function TXLProCell.GetWidth: Word;
begin
  with Bounds do Result := Right - Left;
end;

procedure TXLProCell.SetWidth(AWidth: Word);
begin
  with Bounds do Bounds := Rect(Left, Top, Left + AWidth, Bottom);
end;

function TXLProCell.GetHeight: Word;
begin
  with Bounds do Result := Bottom - Top;
end;

procedure TXLProCell.SetHeight(AHeight: Word);
begin
  with Bounds do Bounds := Rect(Left, Top, Right, Top + AHeight);
end;

function TXLProCell.GetCellInfo(ASide: TXLCellInfo; var AllEqual: Boolean): Pointer;
var
  R: TRect;
begin
  AllEqual := True;
  R := Bounds;
  with Section, R do
  case ASide of
    ciLeft: Result := GetSheetInfo(siColLines, Left, Left, Top, Bottom - 1, AllEqual);
    ciTop: Result := GetSheetInfo(siRowLines, Top, Top, Left, Right - 1, AllEqual);
    ciRight: Result := GetSheetInfo(siColLines, Right, Right, Top, Bottom - 1, AllEqual);
    ciBottom: Result := GetSheetInfo(siRowLines, Bottom, Bottom, Left, Right - 1, AllEqual);
    ciHInside: Result := GetSheetInfo(siRowLines, Top + 1, Bottom -1, Left, Right - 1, AllEqual);
    ciVInside: Result := GetSheetInfo(siColLines, Left + 1, Right - 1, Top, Bottom - 1, AllEqual);
    ciColor: Result := Pointer(UnpackColorPointer(GetSheetInfo2(CellInfoMapper[ASide], Left, Top)).Color);
    else Result := GetSheetInfo2(CellInfoMapper[ASide], Left, Top);
  end;
end;

procedure TXLProCell.SetCellInfo(ASide: TXLCellInfo; AColorPointer: Pointer);
var R: TRect;
begin
  if (CellClass <> Self.ClassType) and (csAssign in FStates) then exit;
  R := Bounds;
  with Section, R do
  begin
    case ASide of
      ciLeft: SetSheetInfo(siColLines, Left, Left, Top, Bottom - 1, AColorPointer);
      ciTop: SetSheetInfo(siRowLines, Top, Top, Left, Right - 1, AColorPointer);
      ciRight: SetSheetInfo(siColLines, Right, Right, Top, Bottom - 1, AColorPointer);
      ciBottom: SetSheetInfo(siRowLines, Bottom, Bottom, Left, Right - 1, AColorPointer);
      ciVInside: SetSheetInfo(siColLines, Left + 1, Right - 1, Top, Bottom - 1, AColorPointer);
      ciHInside: SetSheetInfo(siRowLines, Top + 1, Bottom - 1, Left, Right - 1, AColorPointer);
      ciBias1: SetSheetInfo2(siBias1, R, AColorPointer);
      ciBias2: SetSheetInfo2(siBias2, R, AColorPointer);
      ciColor: SetSheetInfo2(siColor, R, AColorPointer);
      else SetSheetInfo2(CellInfoMapper[ASide], R, AColorPointer);
    end;
//    ChangeProperty(prBorder);
    Refresh(R);
    if ASide > ciBottom
    then Sheet.InvalidateArea(Sector, R, iFull)
    else Sheet.InvalidateArea(Sector, R, iFrame);
  end;
end;

function TXLProCell.GetNamePath: String;
var PosText: String;
    Rect: TRect;
begin
  Rect := SheetBounds;
  PosText := IntToStr(Rect.Left) + ', ' + IntToStr(Rect.Top);
  if Single
  then Result := 'Cell [' + PosText +']'
  else Result := 'Cells [' + PosText + ' : ' + IntToStr(Rect.Right - 1) + ', ' + IntToStr(Rect.Bottom - 1) +']';
end;

procedure TXLProCell.Assign(Source: TPersistent);
begin
  if Source is TXLProRange
  then Bounds := TXLProCell(Source).Bounds;
  inherited Assign(Source);
end;

function TXLProCell.GetSheet: TXLCustomSheet;
begin
  Result := Section.Sheet;
end;

function TXLProCell.GetSector: TXLSector;
begin
  Result := Section.Sector;
end;

function TXLProCell.GetMapBounds: TRect;
begin
  Result := Section.MapToClient(Bounds);
end;

// TXLProRange
procedure TXLProRange.Assign(Source: TPersistent);
begin
  inherited Assign(Source);
  FOldFont.Assign(Font);
end;

type
  PXLUpdate = ^TXLUpdate;
  TXLUpdate = record
    Prop: TXLProp;
    Changes: Integer;
  end;

procedure TXLProRange.UpdateCells(ACell: TXLCell; AData: Integer; var Stop: Boolean);
begin
  Include(ACell.FStates, csInvalidate);
  with PXLUpdate(AData)^ do ACell.AssignProperty(Self, Prop, Changes);
end;

procedure TXLProRange.ResetHints(ACell: TXLCell; AData: Integer; var Stop: Boolean);
begin
  Include(ACell.FStates, csInvalidate);
  ACell.Hint := '';
end;

procedure TXLProRange.UpdateCellsClass(ACoord: TPoint; AData: Integer; var Stop: Boolean);
begin
  Section.CellClasses[ACoord] := TXLCellClass(AData);
end;

procedure TXLProRange.NotifyChanges(AProp: TXLProp; AChanges: Integer);
var
  Update: TXLUpdate;

procedure PrepareFontChanges;
begin
  Update.Changes := 0;
  with Update do begin
    if FOldFont.Name <> Font.Name then Changes := Changes or pfName;
    if FOldFont.Charset <> Font.Charset then Changes := Changes or pfCharset;
    if FOldFont.Color <> Font.Color then Changes := Changes or pfColor;
    if FOldFont.Size <> Font.Size then Changes := Changes or pfSize;
    if (fsBold in FOldFont.Style) <> (fsBold in Font.Style) then Changes := Changes or pfBold;
    if (fsItalic in FOldFont.Style) <> (fsItalic in Font.Style) then Changes := Changes or pfItalic;
    if (fsUnderline in FOldFont.Style) <> (fsUnderline in Font.Style) then Changes := Changes or pfUnderline;
    if (fsStrikeOut in FOldFont.Style) <> (fsStrikeOut in Font.Style) then Changes := Changes or pfStrikeOut;
  end;
end;

begin
  if not (csAssign in FStates) then begin
    Section.Sheet.InvalidateArea(Section.Sector, Bounds, iFull);
    Update.Prop := AProp;
    Update.Changes := AChanges;
    // Before
    case AProp of
      prControl: if ((pcClass and AChanges) <> 0) or (AChanges = pAll)
                 then Section.EnumCoords(Bounds, UpdateCellsClass, Integer(CellClass));
      prFont: PrepareFontChanges;
      prHint: begin
                Section.EnumCells(Bounds, False, ResetHints, 0);
                exit;
              end;
      else exit;
    end;
    Section.EnumCells(Bounds, True, UpdateCells, Integer(@Update));
    // After
    case AProp of
      prFont: FOldFont.Assign(Font);
    end;
  end;
end;

function TXLProRange.Merge: Boolean;
begin
  Result := not Single;
  if Result then Section.MergeArea(Bounds);
end;

function TXLProRange.MergeLines: Boolean;
var NR: TRect;
    OB: Integer;
begin
  Result := True;
  NR := Bounds;
  OB := NR.Bottom;
  NR.Bottom := NR.Top + 1;
  while NR.Bottom <= OB do
  begin
    Section.MergeArea(NR);
    OffsetRect(NR, 0, 1);
  end;
end;

function TXLProRange.Clear: Boolean;
begin
  Result := True;
  Section.ClearArea(Bounds);
end;

function TXLProRange.GetValue: Variant;
begin
  Result := Sheet.Values[Position.X, Position.Y];
end;

procedure TXLProRange.SetValue(const AValue: Variant);
begin
  if not (csAssign in FStates) then begin
    Sheet.Values[Position.X, Position.Y] := AValue;
    NotifyChanges(prValue, pAll);
  end;
end;

constructor TXLProRange.Create(AContainer: TPersistent);
begin
  inherited Create(AContainer);
  Include(FStates, csStyle);
  FOldFont := TFont.Create;
end;

destructor TXLProRange.Destroy;
begin
  FOldFont.Free;
  inherited Destroy;
end;

function TXLProRange.GetCellClass: TXLCellClass;
begin
  Result := Section.CellClasses[Position];
end;

procedure TXLProRange.SetCellClass(Value: TXLCellClass);
begin
  if not (csAssign in FStates) then begin
    Section.CellClasses[Position] := Value;
    NotifyChanges(prControl, pcClass);
  end;
end;

function TXLProRange.GetBasedOn: TXLStyle;
var TC: TXLCell;
begin
  Result := Nil;
  TC := Section.PeekCells[Position];
  if TC <> Nil then Result := TC.BasedOn;
end;

procedure TXLProRange.SetBasedOn(AStyle: TXLStyle);
begin
  if BasedOn <> AStyle
  then Section.Cells[Position].BasedOn := AStyle;
  NotifyChanges(prBasedOn, pAll);
end;

procedure TXLProRange.ClearHints;
begin
  NotifyChanges(prHint, pAll);
end;

function TXLProRange.CanPaste: Boolean;
var
  R: TRect;
begin
  Result := (FXLClipboard <> Nil);
  if Result then begin
    R := XLClipboard.Extents;
    OffsetRect(R, Bounds.Left, Bounds.Top);
    Result := Section.CropRect(R);
  end;
end;

type
  PXLCopyParams = ^TXLCopyParams;
  TXLCopyParams = record
    SrcSection,
    DstSection: TXLSection;
    SrcRect,
    DstRect: TRect;
  end;

procedure TXLProRange.CopyCell(ACoord: TPoint; AData: Integer; var Stop: Boolean);
var DP: TPoint;
    U: TXLUnion;
    R1, R2: TXLSectionRange;
    I: TXLCellInfo;
    AE: Boolean;
    P: Pointer;
begin
  with PXLCopyParams(AData)^ do begin
    DP.X := ACoord.X - SrcRect.Left + DstRect.Left;
    DP.Y := ACoord.Y - SrcRect.Top + DstRect.Top;
    // Creating range objects
    U := SrcSection.FindUnion(ACoord, True);
    if U <> Nil then R1 := TXLSectionRange.Create(SrcSection, U.Bounds)
    else R1 := TXLSectionRange.Create(SrcSection, Classes.Bounds(ACoord.X, ACoord.Y, 1, 1));

    R2 := TXLSectionRange.Create(DstSection, Classes.Bounds(DP.X, DP.Y, R1.Width, R1.Height));

    if R1.Merged then R2.Merge else R2.Split;

    R2.Color := R1.Color;
    R2.Styles := R1.Styles;

    for I := Low(I) to High(I) do
      if I in [ciLeft .. ciBias2, ciColor .. ciLayout] then begin
        P := R1.GetCellInfo(I, AE);
        if AE then R2.SetCellInfo(I, P);
      end;

    DstSection.Cells[DP] := SrcSection.PeekCells[ACoord];

    R2.Free;
    R1.Free;
  end;
end;

procedure TXLProRange.Copy;
var
  Params: TXLCopyParams;
begin
  with XLClipboard do begin
    ColCount := Self.Width;
    RowCount := Self.Height;
    Zap;
    Styler := Self.Sheet.Styler;
  end;
  Params.SrcSection := Section;
  Params.DstSection := XLClipboard.FSections[sClient];
  Params.SrcRect := Bounds;
  Params.DstRect := Params.SrcRect;
  OffsetRect(Params.DstRect, - Params.DstRect.Left, - Params.DstRect.Top);
  Params.SrcSection.EnumCoords(Params.SrcRect, CopyCell, Integer(@Params));
end;

procedure TXLProRange.Cut;
begin
  Copy;
  Clear;
end;

procedure TXLProRange.Paste;
var
  Params: TXLCopyParams;
begin
  if CanPaste then begin
    Params.SrcSection := XLClipboard.FSections[sClient];
    Params.DstSection := Section;
    Params.SrcRect := XLClipboard.Extents;
    Params.DstRect := Params.SrcRect;
    OffsetRect(Params.DstRect, - Params.DstRect.Left, - Params.DstRect.Top);
    OffsetRect(Params.DstRect, Bounds.Left, Bounds.Top);
    Bounds := Params.DstRect;
    Split;
    Bounds := Params.DstRect;
    Params.SrcSection.EnumCoords(Params.SrcRect, CopyCell, Integer(@Params));
  end;
end;

{ TXLRange }

constructor TXLRange.Create(ASheet: TXLCustomSheet; const ABounds: TRect);
var
  I, J: TXLSector;

  R: TRect;
begin
  for I := Low(I) to High(I) do begin
    J := I;
    R := SectorOf(I, ABounds);
    if EqualRect(R, ABounds) then Break;
  end;
  inherited Create(ASheet.FSections[J], R);
end;


{ TXLSectionRange }

constructor TXLSectionRange.Create(ASection: TXLSection; const ABounds: TRect);
begin
  inherited Create(TPersistent(ASection));
  FBounds := ABounds;
end;

function TXLSectionRange.GetBounds: TRect;
begin
  Result := FBounds;
end;

function TXLSectionRange.GetSection: TXLSection;
begin
  Result := TXLSection(Container);
end;

procedure TXLSectionRange.SetBounds(ABounds: TRect);
begin
  FBounds := ABounds;
end;

// TXLSelection
function TXLSelection.Clear: Boolean;
begin
  Result := inherited Clear;
  if Result then Grid.SelectionChanged(View.Sector);
end;

function TXLSelection.Merge: Boolean;
begin
  Result := inherited Merge;
  if Result then Grid.SelectionChanged(View.Sector);
end;

function TXLSelection.MergeLines: Boolean;
begin
  Result := inherited MergeLines;
  if Result then Grid.SelectionChanged(View.Sector);
end;

function TXLSelection.GetView: TXLView;
begin
  Result := TXLView(Container);
end;

function TXLSelection.GetSection: TXLSection;
begin
  Result := View.Section;
end;

function  TXLSelection.GetBounds: TRect;
begin
  Result := View.SelBounds;
end;

procedure TXLSelection.SetBounds(ABounds: TRect);
begin
  View.Select(ABounds, ABounds.TopLeft, nil);
end;

function TXLSelection.GetGrid: TXLCustomGrid;
begin
  Result := View.Grid;
end;

procedure TXLSelection.NotifyChanges(AProp: TXLProp; AChanges: Integer);
begin
  inherited NotifyChanges(AProp, AChanges);
  if not (csAssign in FStates) then begin
    Grid.SelectionChanged(View.Sector);
    DesignerModified(Grid.Sheet);
  end;
end;

// TXLCell
function TXLCell.GetBasedOn: TXLStyle;
begin
  Result := FBasedOn;
end;

procedure TXLCell.SetBasedOn(AStyle: TXLStyle);
begin
  if (AStyle <> Nil) and (AStyle is TXLStyle) and (TXLStyle(AStyle).Styler <> Section.Sheet.Styler)
  then InvalidOp('Cannot use Style from disconnected Styler!');
  if (AStyle <> FBasedOn) or (AStyle = Nil) then begin
    FBasedOn := AStyle;
    NotifyChanges(prBasedOn, pAll);
  end;
end;

function TXLCell.GetSection: TXLSection;
begin
  Result := TXLRow(Container).Section;
end;

function TXLCell.GetBounds: TRect;
var Union: TXLUnion;
begin
  Union := Section.SeekUnion(Self);
  if Union <> Nil then Result := Union.Bounds
  else Result := Classes.Bounds(FCol, TXLRow(Container).RowIndex, 1, 1);
end;

procedure TXLCell.SetBounds(ABounds: TRect);
var Union: TXLUnion;
begin
  Union := Section.SeekUnion(Self);
  OffsetRect(ABounds, FCol - ABounds.Left, TXLRow(Container).RowIndex - ABounds.Top);
  if Section.CropRect(ABounds) and
  (((ABounds.Right - ABounds.Left) > 1) or ((ABounds.Bottom - ABounds.Top) > 1)) then
  begin
    if Union = Nil
    then Union := Section.AddUnion(ABounds, Self)
    else Union.Bounds := ABounds;
    Include(FStates, csUnited);
  end else begin
    if Union <> Nil then Section.KillUnion(Union);
    Exclude(FStates, csUnited);
  end;
end;

procedure TXLCell.SetHint(const AHint: String);
var WC: Boolean;
begin
  WC := True;
  if (AHint = '') then begin
    WC := prHint in Props;
    if WC then Section.RemoveHint(Self)
  end else Section.AddHint(AHint, Self);
  if WC then NotifyChanges(prHint, pAll);
  if AHint = '' then Props := Props - [prHint];
end;

function TXLCell.GetHint: String;
begin
  Result := '';
  if prHint in Props then Result := Section.GetHint(Self);
end;

function TXLCell.GetEditing: Boolean;
begin
  Result := csEditing in FStates;
end;

procedure TXLCell.CancelEdit;
begin
  if csEditing in FStates then Section.Sheet.CloseEditor(Self);
end;

destructor TXLCell.Destroy;
var Union: TXLUnion;
begin
  CancelEdit;
  Done;
  FBasedOn := nil;
  if (TXLRow(Container).RowIndex >= 0) then
  begin
    TXLRow(Container)[FCol] := Nil;
    Section.Sheet.InvalidateArea(Sector, Bounds, iFull);
  end;
  Union := Section.SeekUnion(Self);
  if Union <> Nil then Union.FCell := Nil;
  inherited Destroy;
end;

constructor TXLCell.Create(ASection: TXLSection; ACoord: TPoint);
var Union: TXLUnion;
begin
  Union := ASection.FindUnion(ACoord, True);
  if Union <> Nil then
  begin
    ACoord := Union.Bounds.TopLeft;
    Union.FCell := Self;
    Include(FStates, csUnited);
  end;
  inherited Create(TPersistent(ASection.Ensure(ACoord.Y)));
  FCol := ACoord.X;
  TXLRow(Container)[FCol] := Self;
  Init;
  Include(FStates, csReformat);
  Invalidate;
end;

procedure TXLCell.Invalidate;
begin
  if not (csInvalidate in FStates) then
  begin
    Include(FStates, csInvalidate);
    with Section do Sheet.InvalidateArea(Sector, Bounds, iFull);
  end;
end;

procedure TXLCell.NotifyChanges(AProp: TXLProp; AChanges: Integer);
var I: TXLProp;
begin
  inherited NotifyChanges(AProp, AChanges);
  if AProp = prBasedOn then begin
    if FBasedOn = Nil then FProps := FProps * [prValue, prHint];
    for I := prControl to prStyles do
      if not (I in FProps) then ReloadProperty(I, pAll);
  end else begin
    if not (AProp in [prBorder, prColor, prFrame]) then
    begin
      Invalidate;
      if (AProp in [prBasedOn, prControl, prFont, prLayout]) and ([csEditing, csAssign] * FStates = [csEditing])
      then Section.Sheet.CloseEditor(Self);
      if (AProp = prValue) then Section.CellChanged(Self);
    end;
  end;
  Section.Sheet.Modified := True;
end;

procedure TXLCell.Load(AStream: TXLStream);
begin
  inherited Load(AStream);
  if prHint in Props then Hint := AStream.StringIO;
  if prBasedOn in Props then FBasedOn := Pointer(AStream.IntegerIO);
end;

procedure TXLCell.Save(AStream: TXLStream);
begin
  if (prBasedOn in Props) or (BasedOn = Nil) then Exclude(FProps, prBasedOn);
  inherited Save(AStream);
  if prHint in Props then AStream.StringIO := Hint;
  if prBasedOn in Props then AStream.IntegerIO := BasedOn.Index;
end;

procedure TXLCell.AssignProperty(Source: TXLPersistent; AProp: TXLProp; AChanges: Integer);
begin
  inherited AssignProperty(Source, AProp, AChanges);
  if (Source is TXLCell) and (AProp = prHint)
  then Hint := TXLCell(Source).Hint;
end;

procedure TXLCell.Init;
begin
  // Do nothing
end;

procedure TXLCell.Done;
begin
  // Do nothing
end;

function TXLCell.GetCellClass: TXLCellClass;
begin
  Result := TXLCellClass(Self.ClassType);
end;

procedure TXLCell.SetCellClass(Value: TXLCellClass);
begin
  {}
end;

function TXLCell.FindProperty(AProp: TXLProp): TXLPersistent;
begin
  Result := inherited FindProperty(AProp);
  if Result = Nil then Result := Section.BaseStyle;
end;

procedure TXLCell.Click;
begin
  {}
end;

procedure TXLCell.DblClick;
begin
  {}
end;

procedure TXLCell.KeyPress(var Key: Char);
begin
  {}
end;

function TXLCell.RecommendedSize(ACanvas: TCanvas): TPoint;
var
  FV: String;
begin
  Result.X := 0;
  Result.Y := 0;
  FV := Text;
  if FV <> '' then begin
    if FFont <> Nil then ACanvas.Font.Assign(FFont);
    Result.X := ACanvas.TextWidth(FV) + 2 + Indent;
    Result.Y := ACanvas.TextHeight(FV) + 2;
  end;
end;

// TXLRow

procedure TXLRow.Renumerate(AFrom, ATo: Integer);
var I: Integer;
    C: TXLCell;
begin
  for I := AFrom to ATo do
  begin
    C := TXLCell(Items[I]);
    if C <> Nil then C.FCol := I;
  end;
end;

procedure TXLRow.Clear;
begin
  FRowIndex := -1;
  inherited Clear;
end;

// TXLSection

procedure TXLSection.SerializeStyles(AStream: TXLStream; AReading: Boolean);

function SaveRow(TheIndex: Integer; TheRow: TXLRow): Integer;
var I, C: Integer;
    Cell: TXLCell;
begin
  C := 0;
  for I := 0 to TheRow.HighBound do
  begin
    Cell := TXLCell(TheRow[I]);
    if (Cell <> Nil) and (Cell.BasedOn <> Nil) then Inc(C);
  end;
  AStream.Write(C, SizeOf(C));
  for I := 0 to TheRow.HighBound do
  begin
    Cell := TXLCell(TheRow[I]);
    if (Cell <> Nil) and (Cell.BasedOn <> Nil) then
    begin
      C := Cell.FCol;
      AStream.Write(C, SizeOf(C));
      AStream.StringIO := TXLStyle(Cell.BasedOn).Alias;
      Cell.BasedOn := Nil;
    end;
  end;
  Result := 0;
end;

function LoadRow(TheIndex: Integer; TheRow: TXLRow): Integer;
var I, C: Integer;
    Cell: TXLCell;
begin
  AStream.Read(C, SizeOf(C));
  for I := 0 to C - 1 do
  begin
    AStream.Read(C, SizeOf(C));
    Cell := TXLCell(TheRow[C]);
    Cell.BasedOn := Sheet.Styler.FindStyle(AStream.StringIO);
  end;
  Result := 0;
end;

begin
  if AReading
  then ForAll(@LoadRow)
  else ForAll(@SaveRow);
end;

procedure TXLSection.ClearStyles(AStyle: TXLStyle);

function ClearRow(TheIndex: Integer; TheRow: TXLRow): Integer;
var I: Integer;
    Cell: TXLCell;
begin
  for I := 0 to TheRow.HighBound do
  begin
    Cell := TXLCell(TheRow[I]);
    if (Cell <> Nil) and ((AStyle = Nil) or (Cell.BasedOn = AStyle)) then Cell.BasedOn := Nil;
  end;
  Result := 0;
end;

begin
  ForAll(@ClearRow);
end;

constructor TXLSection.Create(ASheet: TXLCustomSheet; ASector: TXLSector);
var I: TXLSheetInfo;
begin
  inherited Create(TXLRow);
  FSheet := ASheet;
  FSector := ASector;
  FUnions := TList.Create;
  FHints := TStringList.Create;
  for I := Low(I) to siRowLines do FInfos[I] := TListSList.Create(TSList);
  for I := siBias1 to High(I) do FInfos[I] := TListSList.Create(TDefSList);
end;

destructor TXLSection.Destroy;
var I: TXLSheetInfo;
begin
  for I := Low(I) to High(I) do FreeObject(FInfos[I]);
  inherited Destroy;
  FreeObject(FHints);
  DestroyUnions;
  FreeObject(FUnions);
end;

procedure TXLSection.Renumerate(AFrom, ATo: Integer);
var I: Integer;
    CL: TXLRow;
begin
  for I := AFrom to ATo do
  begin
    CL := TXLRow(Items[I]);
    if CL <> Nil then CL.FRowIndex := I;
  end;
end;

function TXLSection.MergedArea(const AArea: TRect): Boolean;
var I: Integer;
begin
  Result := True;
  for I := 0 to FUnions.Count - 1 do
      if EqualRect(AArea, TXLUnion(FUnions[I]).Bounds) then exit;
  Result := False;
end;

procedure TXLSection.MergeArea(AArea: TRect);
begin
  if CropRect(AArea) and ((AArea.Right > AArea.Left + 1) or (AArea.Bottom > AArea.Top + 1)) then
  begin
    SplitArea(AArea);
    AddUnion(AArea, Nil);
    Sheet.ReloadSelection(Sector);
  end;
end;

procedure TXLSection.SplitArea(const AArea: TRect);
var Union: TXLUnion;
begin
  Union := TestUnion(AArea, Nil);
  while Union <> Nil do
  begin
    KillUnion(Union);
    Union := TestUnion(AArea, Nil);
  end;
end;

function  TXLSection.GetColor(ACoord: TPoint): TColor;
begin
  Result := UnpackColorPointer(GetSheetInfo2(siColor, ACoord.X, ACoord.Y)).Color;
end;

procedure TXLSection.SetColor(ACoord: TPoint; AColor: TColor);
begin
  SetSheetInfo2(siColor, Area(ACoord, ACoord), Pointer(AColor));
end;

function  TXLSection.Redirect(ACoord: TPoint): TPoint;
var Union: TXLUnion;
begin
  Union := FindUnion(ACoord, False);
  if Union <> Nil then Result := Union.Bounds.TopLeft else Result := ACoord;
end;

procedure TXLSection.Prepare(AList: TSList; AIndex: Integer);
begin
  with TXLRow(AList) do
  begin
    FRowIndex := AIndex;
    FSection := Self;
  end;  
end;

function  TXLSection.GetCell(ACoord: TPoint): TXLCell;
begin
  ACoord := Redirect(ACoord);
  Result := TXLCell(Ensure(ACoord.Y)[ACoord.X]);
  if Result = Nil then Result := BaseStyle.CellClass.Create(Self, ACoord);
end;

function  TXLSection.GetPeekCell(ACoord: TPoint): TXLCell;
var XLRow: TXLRow;
begin
  ACoord := Redirect(ACoord);
  Result := Nil; XLRow := TXLRow(Items[ACoord.Y]);
  if XLRow <> Nil then Result := TXLCell(XLRow[ACoord.X]);
end;

function TXLSection.AddUnion(const ARect: TRect; ACell: TXLCell): TXLUnion;
begin
  if ACell = Nil then ACell := PeekCells[ARect.TopLeft];
  Result := TXLUnion.Create(Self, ARect, ACell);
  FUnions.Add(Result);
  Result.Bounds := ARect;
end;

procedure TXLSection.KillUnion(var AUnion: TXLUnion);
begin
  FUnions.Remove(AUnion);
  Sheet.InvalidateArea(Sector, AUnion.Bounds, iFull);
  AUnion.Free;
  AUnion := Nil;
end;

function TXLSection.SeekUnion(ACell: TXLCell): TXLUnion;
var I: Integer;
begin
  if FUnions <> Nil then
  for I := FUnions.Count - 1 downto 0 do
  begin
    Result := TXLUnion(FUnions[I]);
    if Result.Cell = ACell then exit;
  end;
  Result := Nil;
end;

function TXLSection.FindUnion(const APoint: TPoint; IncludeOwner: Boolean): TXLUnion;
var I: Integer;
begin
  for I := FUnions.Count - 1 downto 0 do
  begin
    Result := TXLUnion(FUnions[I]);
    if PtInRect(Result.Bounds, APoint) and (IncludeOwner or ((Result.Bounds.Left <> APoint.X) or (Result.Bounds.Top <> APoint.Y))) then exit;
  end;
  Result := Nil;
end;

function TXLSection.TestUnion(const ARect: TRect; AUnion: TXLUnion): TXLUnion;
var I: Integer;
    R: TRect;
begin
  for I := 0 to FUnions.Count - 1 do begin
    Result := TXLUnion(FUnions[I]);
    if (Result <> AUnion) and IntersectRect(R, ARect, Result.Bounds) then exit;
  end;
  Result := Nil;
end;

procedure TXLSection.DestroyUnions;
var I: Integer;
begin
  for I := FUnions.Count - 1 downto 0 do TXLUnion(FUnions[I]).Free;
  FUnions.Clear;
end;

procedure TXLSection.UpdateSize(AAxis: TXLAxis; ANew: Integer);

function CurRow(TheIndex: Integer; TheRow: TXLRow): Integer;
begin
  TheRow.Count := ANew + 1;
  Result := 0;
end;

var I: Integer;
    U: TXLUnion;
begin
  if AAxis = sRows then Count := ANew
  else ForAll(@CurRow);
  for I := FUnions.Count - 1 downto 0 do begin
    U := TXLUnion(FUnions[I]);
    if U.Update(AAxis, ANew) then begin
      U.Free;
      FUnions.Delete(I);
    end;
  end;
end;

function  TXLSection.ExpandArea(const AArea: TRect): TRect;
var TR,RR: TRect;
    I: Integer;
    Union: TXLUnion;
begin
  Result := AArea;
  repeat
    RR := Result;
    for I := 0 to FUnions.Count - 1 do
    begin
      Union := TXLUnion(FUnions[I]);
      if IntersectRect(TR, Result, Union.Bounds)
      then UnionRect(Result, Result, Union.Bounds);
    end;
  until EqualRect(RR, Result);
end;

type
   TGetCellFunc = function (ACoord: TPoint): TXLCell of object;

function TXLSection.EnumCoords(AArea: TRect; AEnumProc: TXLCoordEnumProc; AData: Integer): Integer;
var X,  Y: Integer;
    Coord: TPoint;
    U: TXLUnion;
    Stop: Boolean;
begin
  Result := 0;
  Stop := False;
  for Y := AArea.Top to AArea.Bottom - 1 do begin
    Coord.Y := Y;
    for X := AArea.Left to AArea.Right - 1 do begin
      Coord.X := X;
      U := FindUnion(Coord, True);
      if (U = Nil) or ((U.Bounds.Top = Y) and (U.Bounds.Left = X)) then begin
        AEnumProc(Coord, AData, Stop);
        Inc(Result);
        if Stop then exit;
      end;
    end;
  end;
end;

function  TXLSection.EnumCells(AArea: TRect; ACreate: Boolean; AEnumProc: TXLCellEnumProc; AData: Integer): Integer;
var X, Y: Integer;
    Coord: TPoint;
    U: TXLUnion;
    Stop: Boolean;
    GCP: TGetCellFunc;
    C: TXLCell;
begin
  Result := 0;
  Stop := False;
  if ACreate then GCP := GetCell else GCP := GetPeekCell;
//  if CropArea(AArea) then
  begin
    for Y := AArea.Top to AArea.Bottom - 1 do begin
      Coord.Y := Y;
      for X := AArea.Left to AArea.Right - 1 do begin
        Coord.X := X;
        U := FindUnion(Coord, True);
        if (U = Nil) or ((U.Bounds.Top = Y) and (U.Bounds.Left = X)) then begin
          C := GCP(Coord);
          if C <> Nil then begin
            AEnumProc(C, AData, Stop);
            Inc(Result);
            if Stop then exit;
          end;
        end;
      end;
    end;
  end;
end;

procedure TXLSection.Refresh(const AArea: TRect);
var I: Integer;
    R: TRect;
begin
  for I := 0 to FUnions.Count - 1 do
  with TXLUnion(FUnions[I]) do
    if IntersectRect(R, AArea, Bounds)
    then Clear;
end;

function TXLSection.SetSheetInfoDef(AInfo: TXLSheetInfo; const AArea: TRect; AData: Pointer): Pointer;
var I, J: Integer;
    List: TDefSList;
begin
  Result := BaseStyle.FInfos[SheetInfoMapper[AInfo]];
  for I := AArea.Top to AArea.Bottom - 1 do begin
    List := TDefSList(FInfos[AInfo][I]);
    if (List = Nil) then begin
      if (Result = AData) then Continue else begin
        List := TDefSList(FInfos[AInfo].Ensure(I));
        List.Zero := Integer(Result);
      end;
    end;
    for J := AArea.Left to AArea.Right - 1 do List[J] := Integer(AData);
  end;
end;

function TXLSection.GetFrameData(ACol, ARow: Integer): TXLFrame;
begin
  Result := TXLFrame(GetSheetInfo2(siFrame, ACol, ARow));
end;

procedure TXLSection.SetSheetInfo2(AInfo: TXLSheetInfo; const AArea: TRect; AData: Pointer);
var A: TRect;
begin
  A := ExpandArea(AArea);
  if (AInfo = siColor) and (Integer(AData) = clNone)
  then AData := Pointer(BaseStyle.Color);
  SetSheetInfoDef(AInfo, A, AData);
  Sheet.InvalidateArea(Sector, A, iFull);
  Sheet.AreaChanged(Sector, @A);
end;

procedure TXLSection.ClearArea(const AArea: TRect);
var X, Y: Integer;
    XLRow: TXLRow;
begin
  for Y := AArea.Top to AArea.Bottom - 1 do
  begin
    XLRow := TXLRow(Items[Y]);
    if XLRow <> Nil then
    for X := AArea.Left to AArea.Right - 1 do XLRow[X].Free;
  end;
end;

procedure TXLSection.SetSheetInfo(AInfo: TXLSheetInfo; AIndex, AIndex2, AStart, AEnd: Integer; AData: Pointer);
var WL: TListSList;
    SL: TSList;
    I,J: Integer;
begin
  WL := FInfos[AInfo];
  for J := AIndex to AIndex2 do begin
    SL := TSList(WL[J]);
    if (SL = Nil) then if (AData = Nil) then Continue else SL := WL.Ensure(J);
    for I := AStart to AEnd do SL[I] := AData;
  end;
end;

function TXLSection.GetSheetInfo(AInfo: TXLSheetInfo; AIndex, AIndex2, AStart, AEnd: Integer; var AllEqual: Boolean): Pointer;

function  GetListData(AList: TSList): Pointer;
var
   I: Integer;
begin
  AllEqual := False;
  Result := Nil;
  if (AList <> Nil) then
  begin
    Result := AList[AStart];
    for I := AEnd downto AStart + 1 do
      if Result <> AList[I] then exit;
  end;
  AllEqual := True;
end;

var TR: Pointer;
    I: Integer;
begin
  Result := nil;
  if AIndex <= AIndex2 then begin
    Result := GetListData(TSList(FInfos[AInfo][AIndex]));
    if AllEqual then
    for I := AIndex + 1 to AIndex2 do begin
      TR := GetListData(TSList(FInfos[AInfo][I]));
      AllEqual := (TR = Result) and AllEqual;
      Result := Pointer(IMax(Integer(Result), Integer(TR)));
      if not AllEqual then break;
    end;
  end;
end;

procedure TXLSection.UpdateStyles;

function UpdateStyle(TheIndex: Integer; TheRow: TXLRow): Integer;
var I: Integer;
    Cell: TXLCell;
begin
  for I := 0 to TheRow.HighBound do
  begin
    Cell := TXLCell(TheRow[I]);
    if (Cell <> Nil) and (prBasedOn in Cell.Props)
    then Cell.FBasedOn := Sheet.Styler.Styles[Integer(Cell.FBasedOn)];
  end;
  Result := 0;
end;

function ClearStyle(TheIndex: Integer; TheRow: TXLRow): Integer;
var I: Integer;
    Cell: TXLCell;
begin
  for I := 0 to TheRow.HighBound do
  begin
    Cell := TXLCell(TheRow[I]);
    if (Cell <> Nil) then begin
      Cell.FBasedOn := Nil;
      Exclude(Cell.FProps, prBasedOn);
    end;
  end;
  Result := 0;
end;

begin
  if Sheet.Styler <> Nil then ForAll(@UpdateStyle) else ForAll(@ClearStyle);
end;

procedure TXLSection.Change(AProStyle: TXLProStyle; AProp: TXLProp; AChanges: Integer);

function ScanForStyle(TheIndex: Integer; TheRow: TXLRow): Integer;
var I: Integer;
    Cell: TXLCell;
begin
  for I := 0 to TheRow.HighBound do
  begin
    Cell := TXLCell(TheRow[I]);
    if (Cell <> Nil) and (Cell.BasedOn = AProStyle)
    then Cell.ReloadProperty(AProp, AChanges);
  end;
  Result := 0;
end;

function ScanAll(TheIndex: Integer; TheRow: TXLRow): Integer;
var I: Integer;
    Cell: TXLCell;
begin
  for I := 0 to TheRow.HighBound do
  begin
    Cell := TXLCell(TheRow[I]);
    if (Cell <> Nil) then Cell.ReloadProperty(AProp, AChanges);
  end;
  Result := 0;
end;

begin
  if AProStyle = Nil then ForAll(@ScanAll) else ForAll(@ScanForStyle);
end;

function TXLSection.GetClassCell(ACoord: TPoint; ACellClass: TXLCellClass): TXLCell;
var
  OldCell: TXLCell;
  SLayout: TXLLayout;
  SFont: TFont;        
  SValue: Variant;
begin
  ACoord := Redirect(ACoord);
  OldCell := TXLCell(Ensure(ACoord.Y)[ACoord.X]);
  if (OldCell = Nil) then Result := ACellClass.Create(Self, ACoord)
  else if (OldCell.ClassType = ACellClass) then Result := OldCell else begin
         SFont := TFont.Create;
         SFont.Assign(OldCell.Font);
         SLayout := OldCell.Layout;
         SValue := OldCell.Value;

         OldCell.Free;
         Result := ACellClass.Create(Self, ACoord);
         try
           Result.Layout := SLayout;
           Result.Font := SFont;
           Result.Value := SValue;
         except
           {Do nothing}
         end;
       end;
end;

procedure TXLSection.Load(AStream: TXLStream; AOldFormat: Boolean);
var CC: TXLCell;

procedure LoadCells;
var I, J: Integer;
begin
  I := AStream.IntegerIO;
  while I <> -1 do
  begin
    J := AStream.IntegerIO;
    while J <> -1 do
    begin
      CC := GetClassCell(Point(J, I), XLManager.FindClassBy(AStream.IntegerIO));
      CC.LoadFromStream(AStream);
      J := AStream.IntegerIO;
    end;
    I := AStream.IntegerIO;
  end;
end;

var I,J: Integer;
    R: TRect;
    StreamInfo: Integer;
    SIs: TXLSheetInfos;
    SI: TXLSheetInfo;
begin
  Zap;
  if AOldFormat then begin
  // Load old format

  end else begin
    AStream.Read(StreamInfo, SizeOf(Integer));
  // Load Unions
    if (StreamInfo and $1) <> 0 then begin
      J := AStream.IntegerIO - 1;
      for I := 0 to J do begin
        AStream.Read(R, SizeOf(TRect));
        AddUnion(R, Nil).Bounds := R;
      end;
    end;
  // Load Cells
    if (StreamInfo and $2) <> 0 then LoadCells;
  // Load Other plans
    SIs := TXLSheetInfos(Byte(StreamInfo shr 2));
    for SI := Low(SI) to High(SI) do
      if SI in SIs then
        FInfos[SI].StreamLoad(AStream);
  end;
end;

procedure TXLSection.Save(AStream: TXLStream);

procedure SaveCells;
var ACell: TXLCell;
    XLRow: TXLRow;
    I, J: Integer;
begin
  for I := 0 to HighBound do
  begin
    XLRow := TXLRow(Items[I]);
    if (XLRow <> Nil) and not XLRow.Empty then
    begin
      AStream.IntegerIO := I;
      for J := 0 to XLRow.HighBound do
      begin
        ACell := TXLCell(XLRow[J]);
        if (ACell <> Nil) then
        begin
          AStream.IntegerIO := J;
          AStream.IntegerIO := XLManager.HashCodeOf(ACell.ClassType);
          ACell.SaveToStream(AStream);
        end;
      end;
      AStream.IntegerIO := -1;
    end;
  end;
  AStream.IntegerIO := -1;
end;

var I, UC: Integer;
    SIs: TXLSheetInfos;
    SI: TXLSheetInfo;
    StreamInfo: Integer;
begin
// Check Planes to save
  SIs := [];
  for SI := Low(SI) to High(SI) do
    if not FInfos[SI].Empty then
      SIs := SIs + [SI];
// Convert to Integer
  StreamInfo := Integer(Byte(SIs)) shl 2;
// Need to Save Unions
  UC := FUnions.Count;
  if UC > 0 then
    StreamInfo := StreamInfo or $1;
// Need to Save Cells
  if not Empty then
    StreamInfo := StreamInfo or $2;
// Streaming
  AStream.Write(StreamInfo, SizeOf(Integer));
// Save Unions
  if (StreamInfo and $1) <> 0 then begin
    AStream.IntegerIO := UC;
    for I := 0 to UC - 1 do
      AStream.Write(TXLUnion(FUnions[I]).FBounds, SizeOf(TRect));
  end;
// Save Cells
  if (StreamInfo and $2) <> 0 then
    SaveCells;
// Save Sheet Infos
  for SI := Low(SI) to High(SI) do
    if SI in SIs then
      FInfos[SI].StreamSave(AStream);
end;

function TXLSection.GetCellClass(ACoord: TPoint): TXLCellClass;
var Cell: TXLCell;
begin
  Cell := PeekCells[ACoord];
  if Cell = Nil
  then Result := FBaseStyle.CellClass
  else Result := Cell.CellClass;
end;

procedure TXLSection.SetCell(ACoord: TPoint; Value: TXLCell);
begin
  if Value <> Nil then
  begin
    CellClasses[ACoord] := Value.CellClass;
    Cells[ACoord].Assign(Value);
  end else PeekCells[ACoord].Free;
end;

procedure TXLSection.SetCellClass(ACoord: TPoint; Value: TXLCellClass);
begin
  if Value <> CellClasses[ACoord] then GetClassCell(ACoord, Value);
end;

procedure TXLSection.AddHint(const AHint: String; ACell: TXLCell);
var I: Integer;
begin
  I := FHints.IndexOfObject(ACell);
  if I < 0 then FHints.AddObject(AHint, ACell)
  else FHints[I] := AHint;
end;

function TXLSection.GetHint(ACell: TXLCell): String;
var I: Integer;
begin
  Result := '';
  I := FHints.IndexOfObject(ACell);
  if I >= 0 then Result := FHints[I];
end;

procedure TXLSection.RemoveHint(ACell: TXLCell);
var I: Integer;
begin
  I := FHints.IndexOfObject(ACell);
  if I >= 0 then FHints.Delete(I);
end;

procedure TXLSection.ZeroInfos(AInfo: TXLSheetInfo; ADef: Integer);
var I: Integer;
    List: TDefSList;
begin
  if AInfo > siRowLines then begin
    for I := 0 to FInfos[AInfo].HighBound do begin
      List := TDefSList(FInfos[AInfo][I]);
      if List <> Nil then List.Zero := ADef;
    end;
    Sheet.AreaChanged(Sector, nil);
  end;
end;

procedure TXLSection.Zap;
var I: TXLSheetInfo;
begin
  Clear;
  for I := Low(I) to High(I) do FInfos[I].Clear;
  FHints.Clear;
  DestroyUnions;
end;

procedure TXLSection.PrepareFont(AFont: TFont; AScale: Integer; AScaled, AError: Boolean);
begin
  if AError then AFont.Color := BaseStyle.ErrorColor;
  if AScaled then begin
    AScale := (AFont.Size * AScale) div 100;
    AFont.Size := AScale;
    Assert(AFont.Size = AScale); 
  end;
end;

const
  CFrames : array[TXLFrame] of Integer = (0, BDR_RAISEDINNER, BDR_SUNKENINNER,
                                            EDGE_RAISED, EDGE_SUNKEN,
                                            EDGE_BUMP, EDGE_ETCHED);
  CStyles : array[TXLFrame] of Integer = (0, 0, BF_SOFT,
                                            BF_SOFT, BF_SOFT,
                                            0, 0);

  Inflates : array[TXLFrame] of Integer = (0, -1, -1, -2, -2, -2, -2);

procedure TXLSection.AdjustFrameRect(var ARect: TRect; AFrame: TXLFrame);
begin
  if AFrame < frFlatUp then begin
    Dec(ARect.Right);
    Dec(ARect.Bottom);
  end else InflateRect(ARect, Inflates[AFrame], Inflates[AFrame]);
end;

procedure TXLSection.PaintOther(const PS: TXLPaintStruct; var ADraw: TXLDraw; ARect: TRect);
var
  SB1: TXLSideBorder;
  SB2: TXLSideBorder;
  SDC: Integer;
  NCL: Boolean;
  OBrush: HBrush;
begin
  // Paint Frame
  if ADraw.Design or not (csHidden in ADraw.Styles) then
  DrawEdge(PS.Handle, ARect, CFrames[ADraw.Frame], CStyles[ADraw.Frame] or BF_RECT);
  // Paint Diagonal Borders
  // Paint Diagonal Borders
  SB1 := UnpackColorPointer(GetSheetInfo2(siBias1, ADraw.Coord.X, ADraw.Coord.Y));
  SB2 := UnpackColorPointer(GetSheetInfo2(siBias2, ADraw.Coord.X, ADraw.Coord.Y));
  NCL := (SB1.Line >= slDouble) or (SB2.Line >= slDouble);
  if NCL or ((Integer(SB1.Line) or Integer(SB2.Line)) <> 0) then begin
    SDC := 0;
    if NCL then begin
      SDC := SaveDC(PS.Handle);
      IntersectClipRect(PS.Handle, ARect.Left, ARect.Top, ARect.Right, ARect.Bottom);
    end;
    PS.Canvas.Handle := PS.Handle;
    try
      with PS.Canvas do begin
        if SB1.Line > slNone then begin
          Pen.Width := Integer(SB1.Line);
          Pen.Color := SB1.Color;
          MoveTo(ARect.Left, ARect.Top);
          LineTo(ARect.Right - 1, ARect.Bottom - 1);
        end;
        if SB2.Line > slNone then begin
          Pen.Width := Integer(SB2.Line);
          Pen.Color := SB2.Color;
          MoveTo(ARect.Right - 1, ARect.Top);
          LineTo(ARect.Left, ARect.Bottom - 1);
        end;
      end;
    finally
      PS.Canvas.Handle := 0;
      if NCL then RestoreDC(PS.Handle, SDC);
    end;
  end;
  if ADraw.Design then begin
    // Paint Protect sign
     if (csProtect in ADraw.Styles) then with ARect do
       InvertRect(PS.Handle, Rect(Left, Top, Left + 3, Top + 3));
    // Paint Hidden sign
     if (csHidden in ADraw.Styles) then with ARect do begin
       SetBrushOrgEx(PS.Handle, Left, Top, nil);
       OBrush := SelectObject(PS.Handle, HiddenBrush.Handle);
       PatBlt(PS.Handle, Left, Top, Right - Left, Bottom - Top, PATINVERT);
       SelectObject(PS.Handle, OBrush);
     end;
    // Paint Notify sign
     if (csNotify in ADraw.Styles) then begin
    //   InflateRect(ARect, -1, -1);
       DrawFocusRect(PS.Handle, ARect);
     end;
   end;
end;

procedure TXLSection.PaintCell(const PS: TXLPaintStruct; var ADraw: TXLDraw; const ARect: TRect; ACell: TXLCell);
var ABounds: TRect;
    States: TXLCellStates;
    SDC: Integer;
begin
  Exclude(ACell.FStates, csInvalidate);
  States := ACell.FStates;
  if not (csEditing in States) and (ADraw.Design or not (csHidden in ADraw.Styles)) then
    with ADraw.Canvas do begin
      ABounds := ARect;
      SDC := SaveDC(PS.Handle);
      Handle := PS.Handle;
    // Adjust border corresponding to frame
      AdjustFrameRect(ABounds, ADraw.Frame);
    // Clip cell
      with ABounds do
      IntersectClipRect(Handle, Left, Top, Right, Bottom);
    // Prepare Props
      ADraw.Font := ACell.FindProperty(prFont).Font;
      ADraw.Layout := CellLayouts[ADraw.Coord];
      InflateRect(ABounds, -ADraw.Layout.Indent, 0);
    // Prepare Font and scale
      Font.Assign(ADraw.Font);
      PrepareFont(Font, ADraw.Scale, True, csError in States);
    // Font.PixelsPerInch := (ADraw.Scale * 96) div 100;
    // Paint cell
      SetBkMode(Handle, TRANSPARENT);
      ACell.Draw(ADraw, ABounds);
    // Paint hint sign
      if PS.HintMode and (prHint in ACell.Props) then begin
        Brush.Color := clRed;
        Pen.Color := clRed;
        with ARect do Polygon([Point(Right - 5, Top), Point(Right - 1, Top), Point(Right - 1, Top + 4)]);

      end;
    // Remove clip
      Handle := 0;
      RestoreDC(PS.Handle, SDC);
    end;
end;

procedure FillDWord(var Dest; Count, Value: Integer); register;
asm
  XCHG  EDX, ECX
  PUSH  EDI
  MOV   EDI, EAX
  MOV   EAX, EDX
  REP   STOSD
  POP   EDI
end;

{ StackAlloc allocates a 'small' block of memory from the stack by
  decrementing SP.  This provides the allocation speed of a local variable,
  but the runtime size flexibility of heap allocated memory.  }
function StackAlloc(Size: Integer): Pointer; register;
asm
  POP   ECX          { return address }
  MOV   EDX, ESP
  ADD   EAX, 3
  AND   EAX, not 3   // round up to keep ESP dword aligned
  CMP   EAX, 4092
  JLE   @@2
@@1:
  SUB   ESP, 4092
  PUSH  EAX          { make sure we touch guard page, to grow stack }
  SUB   EAX, 4096
  JNS   @@1
  ADD   EAX, 4096
@@2:
  SUB   ESP, EAX
  MOV   EAX, ESP     { function result = low memory address of block }
  PUSH  EDX          { save original SP, for cleanup }
  MOV   EDX, ESP
  SUB   EDX, 4
  PUSH  EDX          { save current SP, for sanity check  (sp = [sp]) }
  PUSH  ECX          { return to caller }
end;

{ StackFree pops the memory allocated by StackAlloc off the stack.
- Calling StackFree is optional - SP will be restored when the calling routine
  exits, but it's a good idea to free the stack allocated memory ASAP anyway.
- StackFree must be called in the same stack context as StackAlloc - not in
  a subroutine or finally block.
- Multiple StackFree calls must occur in reverse order of their corresponding
  StackAlloc calls.
- Built-in sanity checks guarantee that an improper call to StackFree will not
  corrupt the stack. Worst case is that the stack block is not released until
  the calling routine exits. }
procedure StackFree(P: Pointer); register;
asm
  POP   ECX                     { return address }
  MOV   EDX, DWORD PTR [ESP]
  SUB   EAX, 8
  CMP   EDX, ESP                { sanity check #1 (SP = [SP]) }
  JNE   @@1
  CMP   EDX, EAX                { sanity check #2 (P = this stack block) }
  JNE   @@1
  MOV   ESP, DWORD PTR [ESP+4]  { restore previous SP  }
@@1:
  PUSH  ECX                     { return to caller }
end;

procedure TXLSection.PaintRect(var PS: TXLPaintStruct);
var
  BS: TXLBaseStyle;

  procedure ExcludeUnited;
  var I: Integer;
  begin
    for I := 0 to PS.Unions.Count - 1 do
    with TXLUnion(PS.Unions[I]).FScreen do
      ExcludeClipRect(PS.Handle, Left, Top, Right - 1, Bottom - 1);
  end;

  procedure PaintBorders;

  type
    TInt3 = array[1..3] of TXLSideBorder;

    procedure UnpackList(AList: TSList; APos: Integer; var Int3: TInt3);
    var I: Integer;
    begin
      for I := 1 to 3 do Int3[I] := UnpackColorPointer(AList[I + APos - 2]);
    end;

    procedure DrawSides(const ARect: TRect;
                        StartX, StartY: Integer;
                        ColList, RowList: TListSList;
                        ColSize, RowSize: PIntArray;
                        Swap: Integer);

    function UnpackListMax(AList: TSList; APos: Integer): Integer;
    begin
      Result := IMax((Integer(AList[APos]) and cmColorMask) shr 29, (Integer(AList[APos - 1]) and cmColorMask) shr 29);
    end;

    var
      C, R, sC, sR: Integer;
      Where: TRect;
      BList: TSList;
      sInts: TInt3;
      StartW: Integer;
      P1, P2: Array[0..1] of Integer;
      OPen,
      Pen: HPen;
      OColor,
      OWidth: Integer;
    begin
  //  Vertical Lines at Left Side of Cell
      Where.Right := StartX - 1;
      OColor := clBlack;
      OWidth := 1;
      Pen := CreatePen(PS_SOLID, OWidth, OColor);
      OPen := SelectObject(PS.Handle, Pen);
      try
        sC := 0;
        for C := ARect.Left to IMin(ARect.Right, ColList.HighBound) do begin
          BList := TSList(ColList[C]);
          // Left Side of Cells
          Where.Left := Where.Right;
          P1[0] := Where.Left;
          P2[0] := Where.Left;
          Inc(Where.Right, ColSize^[sC]);
          if (BList <> Nil) and (Where.Right > Where.Left) then begin
            Where.Bottom := StartY - 1;
            UnpackList(BList, ARect.Top - 1, sInts);
            sR := 0;
            for R := ARect.Top to IMin(ARect.Bottom, BList.HighBound) do begin
              // Rectangle shift
              Where.Top := Where.Bottom;
              Inc(Where.Bottom, RowSize^[sR]);
              // Triple data shift
              sInts[1] := sInts[2];
              sInts[2] := sInts[3];
              // Third element
              StartW := Integer(BList[R + 1]);
              sInts[3].Color := StartW and not cmColorMask;
              sInts[3].Line := TXLSideLine((StartW and cmColorMask) shr 29);

              if (sInts[2].Line > slNone) and (Where.Bottom > Where.Top) then
              begin
                P1[1] := Where.Top;
                P2[1] := Where.Bottom;
                if (OColor <> sInts[2].Color) or (OWidth <> Integer(sInts[2].Line)) then begin
                  SelectObject(PS.Handle, OPen);
                  DeleteObject(Pen);
                  OColor := sInts[2].Color;
                  OWidth := Integer(sInts[2].Line);
                  Pen := CreatePen(PS_SOLID, OWidth, OColor);
                  SelectObject(PS.Handle, Pen);
                end;
                MoveToEx(PS.Handle, P2[0 xor Swap], P2[1 xor Swap], nil);
                LineTo(PS.Handle, P1[0 xor Swap], P1[1 xor Swap]);
              end;
              Inc(sR);
            end;
          end;
          Inc(sC);
        end;
      finally
        SelectObject(PS.Handle, OPen);
        DeleteObject(Pen);
      end;
    end;

  var IGridRect: TRect;
  begin
    DrawSides(PS.GridRect,
              PS.ViewRect.Left, PS.ViewRect.Top,
              FInfos[siColLines], FInfos[siRowLines],
              PS.Coords[sCols], PS.Coords[sRows], 0);

    IGridRect.Left := PS.GridRect.Top;
    IGridRect.Top := PS.GridRect.Left;
    IGridRect.Right := PS.GridRect.Bottom;
    IGridRect.Bottom := PS.GridRect.Right;

    DrawSides(IGridRect,
              PS.ViewRect.Top, PS.ViewRect.Left,
              FInfos[siRowLines], FInfos[siColLines],
              PS.Coords[sRows], PS.Coords[sCols], 1);
  end;

  procedure PaintLines(AVert, AHorz: Boolean);
  var
    PointsList: PIntArray;
    StrokeList: PIntArray;
    MaxStroke: Integer;

    procedure DrawAxisLines(AList: PIntArray; const AGridRect, AViewRect: TIntRect; MajorIndex: Integer);
    var
      Line: Integer;
      Index,
      X, Max: Integer;
      Points: PIntArray;
      Start,
      Stop: Integer;
    begin
      Points := PointsList;
      Line   := AViewRect[MajorIndex] - 1;
      Start  := AViewRect[MajorIndex xor 1];
      Stop   := AViewRect[2 + (MajorIndex xor 1)];
      Index  := 0;
      Max    := AViewRect[2 + MajorIndex];
      X      := 0;
      while Line < Max do
      begin
        Points^[Index + MajorIndex] := Line;
        Points^[Index + (MajorIndex xor 1)] := Start;
        Inc(Index, 2);
        Points^[Index + MajorIndex] := Line;
        Points^[Index + (MajorIndex xor 1)] := Stop;
        Inc(Index, 2);
        Inc(Line, AList^[X]);
        Inc(X);
      end;
      PolyPolyLine(PS.Handle, Points^, StrokeList^, Index shr 2);
    end;

  var OP, NP: HPEN;
  begin
    if AVert or AHorz then
    begin
      MaxStroke := 3 + IMax(PS.GridRect.Right - PS.GridRect.Left, PS.GridRect.Bottom - PS.GridRect.Top);

      PointsList := StackAlloc(MaxStroke * sizeof(TPoint) * 2);
      StrokeList := StackAlloc(MaxStroke * sizeof(Integer));

      FillDWord(StrokeList^, MaxStroke, 2);

      NP := CreatePen(PS_SOLID, 0, ColorToRGB(BS.LinesColor));
      OP := SelectObject(PS.Handle, NP);
      if AHorz then DrawAxisLines(PS.Coords[sRows], TIntRect(PS.GridRect), TIntRect(PS.ViewRect), 1);
      if AVert then DrawAxisLines(PS.Coords[sCols], TIntRect(PS.GridRect), TIntRect(PS.ViewRect), 0);
      SelectObject(PS.Handle, OP);
      DeleteObject(NP);

      StackFree(StrokeList);
      StackFree(PointsList);
    end;
  end;

  procedure PaintCells;
  var
    C, R, sC, sR, I: Integer;
    CellRect: TRect;
    ADraw: TXLDraw;
    Union: TXLUnion;
    Cell: TXLCell;
    Row: TXLRow;
  begin
    ADraw.Error := BaseStyle.ErrorColor;
    ADraw.Scale := PS.Scale.sCols;
    ADraw.Canvas := PS.Canvas;
    ADraw.Design := PS.DesignMode;
    for I := 0 to PS.Unions.Count - 1 do begin
      Union := PS.Unions[I];
      Cell := Union.Cell;
      ADraw.Coord := Union.Bounds.TopLeft;
      ADraw.Frame := PS.GetFrameProc(ADraw.Coord.X, ADraw.Coord.Y);
      ADraw.Styles := CellStyles[ADraw.Coord];
      if (Cell <> Nil) then PaintCell(PS, ADraw, Union.FScreen, Cell);
      PaintOther(PS, ADraw, Union.FScreen);
      with Union.FScreen do ExcludeClipRect(PS.Handle, Left, Top, Right, Bottom);
    end;
    sR := 0;
    CellRect.Bottom := PS.ViewRect.Top;
    for R := PS.GridRect.Top to PS.GridRect.Bottom - 1 do begin
      ADraw.Coord.Y := R;
      sC := 0;
      CellRect.Top := CellRect.Bottom;
      Inc(CellRect.Bottom, PS.Coords[sRows]^[sR]);
      CellRect.Right := PS.ViewRect.Left;
      Row := TXLRow(Items[R]);
      for C := PS.GridRect.Left to PS.GridRect.Right - 1 do begin
        // Shift Rectangle X
        CellRect.Left := CellRect.Right;
        Inc(CellRect.Right, PS.Coords[sCols]^[sC]);
        // Paint cell if present and single
        Cell := Nil;
        if (Row <> Nil) then Cell := TXLCell(Row[C]);
        ADraw.Coord.X := C;
        ADraw.Frame := PS.GetFrameProc(C, R);
        ADraw.Styles := CellStyles[ADraw.Coord];
        if (Cell <> Nil) then begin
          if not (csUnited in Cell.FStates) then begin
            PaintCell(PS, ADraw, CellRect, Cell);
            PaintOther(PS, ADraw, CellRect);
          end;
        end else PaintOther(PS, ADraw, CellRect);
        // Next column
        Inc(sC);
      end;
      Inc(sR);
    end;
  end;

  procedure PaintColors;
  var
    R, C, sR, sC: Integer;
    CellRect: TRect;
    Colors: TListSList;
    ColorRow: TDefSList;
    FillBrush: HBrush;
    OldColor,
    DefColor,
    NewColor: TColor;
  begin
    Colors := FInfos[siColor];
    if not Colors.Empty then begin
      // Prepare Brush
      DefColor := ColorToRGB(BaseStyle.Color);
      OldColor := DefColor;
      FillBrush := CreateSolidBrush(DefColor);
      // Setup Y
      sR := 0;
      CellRect.Bottom := PS.ViewRect.Top;
      for R := PS.GridRect.Top to IMin(Colors.HighBound, PS.GridRect.Bottom - 1) do begin
        // Shift Y
        CellRect.Top := CellRect.Bottom;
        Inc(CellRect.Bottom, PS.Coords[sRows]^[sR]);
        // Setup X
        CellRect.Right := PS.ViewRect.Left;
        // Get Color Row
        ColorRow := TDefSList(Colors[R]);
        if (ColorRow <> Nil) then begin
          // Setup X
          sC := 0;
          for C := PS.GridRect.Left to IMin(ColorRow.HighBound, PS.GridRect.Right - 1) do begin
            // Shift X
            CellRect.Left := CellRect.Right;
            Inc(CellRect.Right, PS.Coords[sCols]^[sC]);
            // Get Color
            NewColor := ColorToRGB(ColorRow[C]);
            // Fill Interior if needed
            if NewColor <> DefColor then begin
              if (OldColor <> NewColor) then begin
                // Recreate Brush
                DeleteObject(FillBrush);
                FillBrush := CreateSolidBrush(NewColor);
                OldColor := NewColor;
              end;
              Dec(CellRect.Top); Dec(CellRect.Left);
              Windows.FillRect(PS.Handle, CellRect, FillBrush);
              ExcludeClipRect(PS.Handle, CellRect.Left, CellRect.Top, CellRect.Right, CellRect.Bottom);
              Inc(CellRect.Top);
            end;
            Inc(sC);
          end;
        end;
        Inc(sR);
      end;
      DeleteObject(FillBrush);
    end;
  end;

  procedure L2CacheSizes;
  var I: Integer;
  begin
    for I := PS.GridRect.Left to PS.GridRect.Right do PS.Coords[sCols]^[I - PS.GridRect.Left] := PS.Sizes[sCols][I];
    for I := PS.GridRect.Top to PS.GridRect.Bottom do PS.Coords[sRows]^[I - PS.GridRect.Top] := PS.Sizes[sRows][I];
  end;

begin
  {$IFDEF DEMO}
  with PS.GridRect do begin
    Right := IMin(41, Right);
    Bottom := IMin(42, Bottom);
    Left := IMin(Left, Right);
    Top := IMin(Top, Bottom);
  end;
  {$ENDIF}
  PS.Coords[sCols] := StackAlloc((PS.GridRect.Right - PS.GridRect.Left + 1) * SizeOf(Integer));
  PS.Coords[sRows] := StackAlloc((PS.GridRect.Bottom - PS.GridRect.Top + 1) * SizeOf(Integer));

  L2CacheSizes;
  PaintColors;
  PS.PaintGround(@PS);
  ExcludeUnited;
  BS := BaseStyle;
  if (BS.LinesColor <> BS.Color) and (PS.Scale.sCols > 25) then PaintLines(PS.Grids[sCols], PS.Grids[sRows]);
  SelectClipRgn(PS.Handle, 0);
  PaintCells;
  SelectClipRgn(PS.Handle, 0);
  if Sector = sClient then PaintBorders;
  PS.Canvas.Handle := PS.Handle;

  StackFree(PS.Coords[sRows]);
  StackFree(PS.Coords[sCols]);
end;

function TXLSection.MapToClient(const ARect: TRect): TRect;
var I: Integer;
begin
  Result := ARect;
  if Sector in [sCols, sTitle] then begin
    I := Sheet.TitleRows;
    Result.Top := - (I - Result.Top);
    Result.Bottom := - (I - Result.Bottom);
  end;
  if Sector in [sRows, sTitle] then begin
    I := Sheet.TitleCols;
    Result.Left := - (I - Result.Left);
    Result.Right := - (I - Result.Right);
  end;
end;

function TXLSection.CropRect(var ARect: TRect): Boolean;
begin
  Result := IntersectRect(ARect, ARect, SectionExtents);
end;

function TXLSection.GetSheetInfo2(AInfo: TXLSheetInfo; ACol, ARow: Integer): Pointer;
var
  CR: TDefSList;
begin
  Result := BaseStyle.FInfos[SheetInfoMapper[AInfo]];
  CR := TDefSList(FInfos[AInfo][ARow]);
  if (CR <> Nil) then Result := Pointer(CR[ACol]);
end;

function TXLSection.GetStyles(ACoord: TPoint): TXLCellStyles;
begin
  Result := TXLCellStyles(Byte(GetSheetInfo2(siStyles, ACoord.X, ACoord.Y)));
end;

function TXLSection.GetLayout(ACoord: TPoint): TXLLayout;
begin
  Result := UnpackLayoutPointer(GetSheetInfo2(siLayout, ACoord.X, ACoord.Y));
end;

function TXLSection.GetCellHint(ACoord: TPoint): String;
var
  C: TXLCell;
begin
  Result := '';
  C := PeekCells[ACoord];
  if ((C = Nil) or not (prHint in C.Props)) and (csExtHint in CellStyles[ACoord]) and Assigned(Sheet.FOnGetCellHint)
  then Sheet.FOnGetCellHint(Sheet, ACoord, Result)
  else Result := GetHint(C);
end;

procedure TXLSection.CellChanged(ACell: TXLCell);
var
  AArea: TRect;
begin
  if Assigned(Sheet.FOnCellChanged) then begin
    AArea := ACell.Bounds;
    if (csNotify in CellStyles[AArea.TopLeft])
    then Sheet.FOnCellChanged(Sheet, MapToClient(AArea).TopLeft);
  end;
end;

function TXLSection.GetExtents: TRect;
begin
  Result := Bounds(0, 0, Sheet.FSizes[sCols, Sector in [sCols, sClient]].Count,
                         Sheet.FSizes[sRows, Sector in [sRows, sClient]].Count);
end;

// TXLUnion

procedure TXLUnion.SetBounds(const ABounds: TRect);
begin
  if not EqualRect(FBounds, ABounds) then
  begin
    Section.Sheet.InvalidateArea(Section.Sector, FBounds, iFull);
    FBounds := ABounds;
    Clear;
  end;
end;

constructor TXLUnion.Create(ASection: TXLSection; const ABounds: TRect; ACell: TXLCell);
begin
  inherited Create;
  FCell := ACell;
  if FCell <> Nil then Include(FCell.FStates, csUnited);
  FSection := ASection;
  FBounds.TopLeft := ABounds.TopLeft;
  FBounds.BottomRight := ABounds.TopLeft;
end;

procedure TXLUnion.ClearBorder;
var CP: Pointer;
    AE: Boolean;
    Repaint: Boolean;
    I: TXLSheetInfo;
begin
  with Section, FBounds do
  begin
    GetSheetInfo(siColLines, Left, Left, Top, Bottom - 1, AE);
    if not AE then SetSheetInfo(siColLines, Left, Left, Top, Bottom - 1, Nil);
    Repaint := not AE;
    GetSheetInfo(siColLines, Right, Right, Top, Bottom - 1, AE);
    if not AE then SetSheetInfo(siColLines, Right, Right, Top, Bottom - 1, Nil);
    Repaint := Repaint or not AE;
    SetSheetInfo(siColLines, Left + 1, Right - 1, Top, Bottom - 1, Nil);
    GetSheetInfo(siRowLines, Top, Top, Left, Right - 1, AE);
    if not AE then SetSheetInfo(siRowLines, Top, Top, Left, Right - 1, Nil);
    Repaint := Repaint or not AE;
    GetSheetInfo(siRowLines, Bottom, Bottom, Left, Right - 1, AE);
    if not AE then SetSheetInfo(siRowLines, Bottom, Bottom, Left, Right - 1, Nil);
    Repaint := Repaint or not AE;
    SetSheetInfo(siRowLines, Top + 1, Bottom - 1, Left, Right - 1, Nil);
    CP := GetSheetInfo(siColor, Top, Top, Left, Left, AE);
    SetSheetInfo(siColor, Top, Bottom - 1, Left, Right - 1, CP);
    for I := siBias1 to siBias2 do begin
      CP := GetSheetInfo(I, Top, Bottom - 1, Left, Right - 1, AE);
      if not AE then CP := Nil;
      SetSheetInfo(I, Top, Bottom - 1, Left, Right - 1, CP);
    end;
    for I := siFrame to siLayout do begin
      CP := GetSheetInfo(I, Top, Top, Left, Left, AE);
      SetSheetInfo(I, Top, Bottom - 1, Left, Right - 1, CP);
    end;
    if Repaint then Section.Sheet.InvalidateArea(Section.Sector, FBounds, iFrame);
  end;
end;

procedure TXLUnion.Clear;
var Union: TXLUnion;
begin
  with Section do
  begin
    Union := TestUnion(Bounds, Self);
    while Union <> Nil do
    begin
      KillUnion(Union);
      Union := TestUnion(Bounds, Self);
    end;
    ClearBorder;
    if FCell <> Nil then
    begin
      TXLRow(FCell.Container)[FCell.FCol] := Nil;
      ClearArea(Bounds);
      TXLRow(FCell.Container)[FCell.FCol] := FCell;
    end else
    ClearArea(Bounds);
    Sheet.InvalidateArea(Sector, FBounds, iFull);
  end;
end;

destructor TXLUnion.Destroy;
begin
  if FCell <> Nil then begin
    Exclude(FCell.FStates, csUnited);
    FCell.CancelEdit;
  end;
  inherited Destroy;
end;

function TXLUnion.Update(AAxis: TXLAxis; ANew: Integer): Boolean;
var
  R: TRect;
begin
  Result := ANew <= TXLSize(Bounds.TopLeft).AsArray[AAxis];
  if not Result then begin
    R := Bounds;
    TXLSize(R.BottomRight).AsArray[AAxis] := IMin(ANew, TXLSize(R.BottomRight).AsArray[AAxis]);
    Bounds := R;
  end;
end;

// TXLProStyle
constructor TXLProStyle.Create(AContainer: TPersistent);
var SL: TStrings;
begin
  inherited Create(AContainer);
  Include(FStates, csStyle);
  FCellClass := XLManager.CellClasses[0];
  SL := XLManager.Formats[FCellClass];
  if (SL <> Nil) and (SL.Count > 0) then FFormat := SL[0];
end;

procedure TXLProStyle.Load(AStream: TXLStream);
begin
  inherited Load(AStream);
  AStream.Read(FInfos, SizeOf(FInfos));
end;

procedure TXLProStyle.Save(AStream: TXLStream);
begin
  inherited Save(AStream);
  AStream.Write(FInfos, SizeOf(FInfos));
end;

function TXLProStyle.GetCellInfo(ASide: TXLCellInfo; var AllEqual: Boolean): Pointer;
begin
  AllEqual := True;
  Result := FInfos[ASide];
end;

procedure TXLProStyle.SetCellInfo(ASide: TXLCellInfo; AColorPointer: Pointer);
begin
  if (FInfos[ASide] <> AColorPointer) or (csStyle in FStates) then
  begin
    FInfos[ASide] := AColorPointer;
    if ASide < ciColor then NotifyChanges(prBorder, pAll) else
    if ASide < ciFrame then NotifyChanges(prColor, pAll) else
    if ASide < ciStyles then NotifyChanges(prFrame, pAll) else
    NotifyChanges(prStyles, pAll);
  end;
end;

function TXLProStyle.GetCellClass: TXLCellClass;
begin
  Result := FCellClass;
end;

procedure TXLProStyle.SetCellClass(Value: TXLCellClass);
begin
  if (Value <> FCellClass) or (csStyle in FStates) then
  begin
    FCellClass := Value;
    FEditor := 0;
    NotifyChanges(prControl, pAll);
  end;
end;

function TXLProStyle.GetBasedOn: TXLStyle;
begin
  Result := Nil;
end;

procedure TXLProStyle.SetBasedOn(AStyle: TXLStyle);
begin
  {Do nothing}
end;

// TXLBaseStyle

constructor TXLBaseStyle.Create(ASheet: TXLCustomSheet; AClient: Boolean);
begin
  inherited Create(ASheet);
  FProps := [prControl, prLayout, prBorder, prValue, prColor, prFont, prBasedOn, prHint, prFrame, prStyles];
  Include(FStates, csAssign);
  FErrorColor := clRed;
  FClient := AClient;
  if not AClient then begin
    Frame := frFlatUp;
    Color := clBtnFace;
    FLinesColor := clBlack;
    HorzAlign := haCenter;
    VertAlign := vaCenter;
  end else begin
    WrapMode := wmWrapWords;
    VertAlign := vaBottom;
    Color := clWindow;
    FLinesColor := clBtnFace;
  end;
end;

function TXLBaseStyle.GetNamePath: String;
begin
  Result := Sheet.GetNamePath;
  if FClient
  then Result := Result + '.BaseClientStyle'
  else Result := Result + '.BaseTitleStyle';
end;

procedure TXLBaseStyle.InvalidateViews;
var I: TXLSector;
begin
  for I := Low(I) to High(I) do
  if (I = sClient) = FClient
  then Sheet.InvalidateSector(I);
end;

procedure TXLBaseStyle.SetCellInfo(ASide: TXLCellInfo; AColorPointer: Pointer);
  procedure ZeroColors(AInfo: TXLSheetInfo);
  var I: TXLSector;
  begin
    for I := Low(I) to High(I) do
    if (I = sClient) = FClient then with Sheet do begin
      FSections[I].ZeroInfos(AInfo, Integer(AColorPointer));
      InvalidateSector(I);
    end;
  end;

begin
  inherited SetCellInfo(ASide, AColorPointer);
  ZeroColors(CellInfoMapper[ASide]);
end;

procedure TXLBaseStyle.NotifyChanges(AProp: TXLProp; AChanges: Integer);

procedure NotifyViews;
var I: TXLSector;
begin
  for I := Low(I) to High(I) do
  if (I = sClient) = FClient
  then Sheet.FSections[I].Change(Nil, AProp, AChanges);
end;

begin
  Sheet.Modified := True;
  if AProp in [prColor, prBorder, prFrame] then exit;
  NotifyViews;
end;

function TXLBaseStyle.GetSheet: TXLCustomSheet;
begin
  Result := TXLCustomSheet(Container);
end;

procedure TXLBaseStyle.Load(AStream: TXLStream);
begin
  inherited Load(AStream);
  FErrorColor := AStream.IntegerIO;
  FLInesColor := AStream.IntegerIO;
end;

procedure TXLBaseStyle.Save(AStream: TXLStream);
begin
  inherited Save(AStream);
  AStream.IntegerIO := FErrorColor;
  AStream.IntegerIO := FLinesColor;
end;

procedure TXLBaseStyle.SetErrorColor(Value: TColor);
begin
  if FErrorColor <> Value then
  begin
    FErrorColor := Value;
    InvalidateViews;
  end;
end;

procedure TXLBaseStyle.SetLinesColor(Value: TColor);
begin
  if FLinesColor <> Value then
  begin
    FLinesColor := Value;
    InvalidateViews;
  end;
end;

// TXLCustomSheet
procedure TXLCustomSheet.SetBaseStyle(Index: Integer; ADefStyle: TXLBaseStyle);
begin
  FBaseStyles[Index].Assign(ADefStyle);
end;

function TXLCustomSheet.GetBaseStyle(Index: Integer): TXLBaseStyle;
begin
  Result := FBaseStyles[Index];
end;

function TXLCustomSheet.GetUserCount: Integer;
begin
  Result := FUsers.Count;
end;

function TXLCustomSheet.GetUser(AIndex: Integer): IXLSheetUser;
begin
  Result := IXLSheetUser(FUsers[AIndex]);
end;

procedure TXLCustomSheet.SetStyler(AStyler: TXLStyler);
var SerializeStyles: Boolean;
    I: TXLSector;
    MS: TMemoryStream;
begin
  if AStyler <> FStyler then
  begin
    MS := Nil;
    SerializeStyles := (FStyler <> Nil) and (AStyler <> Nil) and not (csLoading in ComponentState);
    if SerializeStyles then MS := TMemoryStream.Create;
    try
      if SerializeStyles then
      for I := Low(I) to High(I) do FSections[I].SerializeStyles(TXLStream(MS), False);

      if FStyler <> Nil then
      begin
        if not SerializeStyles and not (csDestroying in ComponentState) then
        for I := Low(I) to High(I) do FSections[I].ClearStyles(Nil);
        FStyler.FSheets.Remove(Self);
      end;
      FStyler := AStyler;
      if FStyler <> Nil then FStyler.FSheets.Add(Self);

      if SerializeStyles then
      begin
        MS.Seek(0,0);
        for I := Low(I) to High(I) do FSections[I].SerializeStyles(TXLStream(MS), True);
      end;
    finally
      MS.Free;
    end;
    StylerChanged;
  end;
end;

procedure TXLCustomSheet.StylerChanged;
begin
  if Assigned(FOnStylerChanged) then FOnStylerChanged(Self);
end;

procedure TXLCustomSheet.UpdateUnions(AAxis: TXLAxis; AClient: Boolean; ANew: Integer);
begin
  if AClient then begin
    FSections[AAxis].UpdateSize(AAxis, ANew);
    FSections[sClient].UpdateSize(AAxis, ANew);
  end else begin
    FSections[TXLAxis(Integer(AAxis) xor 1)].UpdateSize(AAxis, ANew);
    FSections[sTitle].UpdateSize(AAxis, ANew);
  end;
end;

procedure TXLCustomSheet.SizeChanged(AAxes: TXLAxes; AClient: Boolean);
var I: Integer;
begin
  for I := 0 to UserCount - 1 do Users[I].SheetSizeChanged(AAxes, AClient);
end;

procedure TXLCustomSheet.CellChanged(Caller: IXLSheetUser; AAxis: TXLAxis; AClient: Boolean; AIndex: Integer);
var I: Integer;
    G: IXLSheetUser;
begin
  for I := 0 to UserCount - 1 do
  begin
    G := Users[I];
    if G <> Caller then G.CellSizeChanged(AAxis, AClient, AIndex);
  end;
  DesignerModified(Self);
end;

function  TXLCustomSheet.GetSheetSize(Index: Integer): Integer;
begin
  Result := FSizes[TXLAxis(Index), True].Count;
end;

procedure TXLCustomSheet.SetSheetSize(Index, ACount: Integer);
begin
  ACount := IMax(0, ACount);
  {!!! Demo Version Limitation}
  {$IFDEF DEMO}
  ACount := IMin(ACount, 40);
  {$ENDIF}
  with FSizes[TXLAxis(Index), True] do
  if Count <> ACount then
  begin
    if ACount < Count then UpdateUnions(TXLAxis(Index), True, ACount);
    Count := ACount;
    SizeChanged([TXLAxis(Index)], True);
  end;
end;

function  TXLCustomSheet.GetTitleSize(Index: Integer): Integer;
begin
  Result := FSizes[TXLAxis(Index), False].Count;
end;

procedure TXLCustomSheet.SetTitleSize(Index, ACount: Integer);
begin
  ACount := IMax(0, ACount);
  with FSizes[TXLAxis(Index), False] do
  if Count <> ACount then
  begin
    if ACount < Count then UpdateUnions(TXLAxis(Index), False, ACount);
    Count := ACount;
    SizeChanged([TXLAxis(Index)], True);
  end;
end;

procedure TXLCustomSheet.SetDefCellSize(Index, ASize: Integer);
var I: Boolean;
begin
  for I := Low(I) to High(I) do
  with FSizes[TXLAxis(Index), I] do
  if (Zero <> ASize) or not Empty then
  begin
    Zero := ASize;
    SizeChanged([TXLAxis(Index)], I);
  end;
end;

function  TXLCustomSheet.GetDefCellSize(Index: Integer): Integer;
begin
  Result := FSizes[TXLAxis(Index), True].Zero;
end;

constructor TXLCustomSheet.Create(AOwner: TComponent);
var B: Boolean;
    A: TXLAxis;
    I: TXLSector;
begin
  inherited Create(AOwner);
  for A := Low(A) to High(A) do
  for B := Low(B) to High(B) do FSizes[A, B] := TXLSizeList.Create;
  FUsers := TList.Create;
  FBackground := TPicture.Create;
  FBackground.OnChange := BackgroundChanged;
  for I := sCols to sClient do FSections[I] := TXLSection.Create(Self, I);
  FBaseStyles[0] := TXLBaseStyle.Create(Self, True);
  FBaseStyles[1] := TXLBaseStyle.Create(Self, False);
  for I := sCols to sTitle do FSections[I].FBaseStyle := FBaseStyles[1];
  FSections[sClient].FBaseStyle := FBaseStyles[0];
  ColDefWidth := 60;
  RowDefHeight := 15;
//  ColMaxWidth := 200;
//  RowMaxHeight := 20;
  ColCount := 5;
  RowCount := 5;
  TitleCols := 1;
  TitleRows := 1;
  SetPrinter;
end;

destructor TXLCustomSheet.Destroy;
var I: Integer;
    B: Boolean;
    A: TXLAxis;
    J: TXLSector;
begin
  Destroying;
  for I := UserCount - 1 downto 0 do Users[I].Disconnect;
  for J := Low(J) to High(J) do FreeObject(FSections[J]);
  Styler := Nil;
  FreeObject(FBaseStyles[1]);
  FreeObject(FBaseStyles[0]);
  FreeObject(FBackground);
  FreeObject(FUsers);
  for A := Low(A) to High(A) do
  for B := Low(B) to High(B) do FreeObject(FSizes[A, B]);
  inherited Destroy;
end;

procedure TXLCustomSheet.CloseEditor(AFrom: TXLCell);
var I: Integer;
begin
  for I := 0 to UserCount - 1 do Users[I].CloseEditor(AFrom);
end;

procedure TXLCustomSheet.AreaChanged(ASector: TXLSector; AArea: PRect);
var I: Integer;
begin
  for I := 0 to UserCount - 1 do Users[I].AreaChanged(ASector, AArea);
  DesignerModified(Self);
end;

procedure TXLCustomSheet.Sizing(AAxis: TXLAxis; AClient: Boolean; AIndex: Integer; var AValue: Integer);
begin
  if Assigned(FOnSizing) then
  begin
    if not AClient then AIndex := -1 - AIndex;
    FOnSizing(Self, AAxis, AIndex, AValue);
  end;
  if FMaxSize.AsArray[AAxis] > 0 then AValue := IMin(AValue, FMaxSize.AsArray[AAxis]);
end;

function TXLCustomSheet.GetCellSize(AIndex, Index: Integer): Integer;
begin
  if AIndex < 0
  then Result := FSizes[TXLAxis(Index), True][-1 - AIndex]
  else Result := FSizes[TXLAxis(Index), True][AIndex];
end;

procedure TXLCustomSheet.SetCellSize(AIndex, Index, AValue: Integer);
var ASheet: Boolean;
begin
  if AValue = -1 then begin
    if Index = 0 then AValue := CalcColWidth(AIndex)
    else AValue := CalcRowHeight(AIndex);
  end;
  ASheet := AIndex >= 0;
  if not ASheet then AIndex := -1 - AIndex;
  Sizing(TXLAxis(Index), ASheet, AIndex, AValue);
  with FSizes[TXLAxis(Index), ASheet] do
  if AIndex < Count then
    if Ints[AIndex] <> AValue then
    begin
      Ints[AIndex] := AValue;
      CellChanged(Nil, TXLAxis(Index), ASheet, AIndex);
    end;
end;

procedure TXLCustomSheet.BackgroundChanged(Sender: TObject);
var I: Integer;
begin
  for I := 0 to UserCount - 1 do Users[I].InvalidateSector(sClient);
end;

procedure TXLCustomSheet.SetBackground(APicture: TPicture);
begin
  FBackground.Assign(APicture);
end;

function TXLCustomSheet.GetMaxCellSize(Index: Integer): Integer;
begin
  Result := FMaxSize.AsArray[TXLAxis(Index)];
end;

procedure TXLCustomSheet.SetMaxCellSize(Index, ASize: Integer);
var I: Integer;
begin
  if FMaxSize.AsArray[TXLAxis(Index)] <> ASize then
  begin
    FMaxSize.AsArray[TXLAxis(Index)] := ASize;
    if ASize > 0 then
    if GetDefCellSize(Index) > ASize then SetDefCellSize(Index, ASize) else
    for I := -GetTitleSize(Index) to GetSheetSize(Index) - 1 do
    if GetCellSize(I, Index) > ASize
    then SetCellSize(I, Index, ASize);
  end;
end;

procedure TXLCustomSheet.DefineProperties(Filer: TFiler);
begin
  inherited DefineProperties(Filer);
  Filer.DefineBinaryProperty('XLData', Load, Save, True);
end;

type
  TXLSStreamInfo  = (siTitleWidths, siTitleHeights, siClientWidths, siClientHeights);
  TXLSStreamInfos = set of TXLSStreamInfo;

procedure TXLCustomSheet.Load(AStream: TStream);

  procedure Refresh;
  var I: Integer;
      S: TXLSector;
      P: TXLSheetInfo;
  begin
    for S := Low(S) to High(S) do
      with FSections[S] do
        for P := Low(P) to High(P) do
          ZeroInfos(P, Integer(FBaseStyle.FInfos[SheetInfoMapper[P]]));
    for I := 0 to UserCount - 1 do
    with Users[I] do
    begin
      SheetSizeChanged([], True);
      ResetSelection(True);
      InvalidateAll;
    end;
  end;

var SI: TXLSStreamInfos;
    Signature: Array[0..3] of Char;
    OSF: Boolean;
begin
  BeginUpdate;
  try
    Zap;
    AStream.Read(Signature, 4);
    OSF := (Signature[0] <> 'X') or (Signature[1] <> 'L') or (Signature[2] <> 'G');
    if OSF then AStream.Seek(-4, soFromCurrent);
    if OSF then InvalidOp('Unknown XLGrid Stream format!');
    FBaseStyles[0].LoadFromStream(TXLStream(AStream));
    FBaseStyles[1].LoadFromStream(TXLStream(AStream));
  // Non reader data
    AStream.Read(SI, SizeOf(SI));
    if siTitleWidths in SI then FSizes[sCols, False].StreamLoad(AStream);
    if siTitleHeights in SI then FSizes[sRows, False].StreamLoad(AStream);
    if siClientWidths in SI then FSizes[sCols, True].StreamLoad(AStream);
    if siClientHeights in SI then FSizes[sRows, True].StreamLoad(AStream);
    if (ColCount > 0) and (TitleRows > 0) then FSections[sCols].Load(TXLStream(AStream), OSF);
    if (RowCount > 0) and (TitleCols > 0) then FSections[sRows].Load(TXLStream(AStream), OSF);
    if (TitleCols > 0) and (TitleRows > 0) then FSections[sTitle].Load(TXLStream(AStream), OSF);
    if (ColCount > 0) and (RowCount > 0) then FSections[sClient].Load(TXLStream(AStream), OSF);
    Refresh;
  finally
    EndUpdate;
    Modified := False;
  end;
end;

procedure TXLCustomSheet.Save(AStream: TStream);
var SI: TXLSStreamInfos;
    Signature: Array[0..3] of Char;
begin
  Signature := 'XLG' + Char($16);
  AStream.Write(Signature, 4);
  FBaseStyles[0].SaveToStream(TXLStream(AStream));
  FBaseStyles[1].SaveToStream(TXLStream(AStream));
  SI := [];
  if not FSizes[sCols, False].Empty then SI := SI + [siTitleWidths];
  if not FSizes[sRows, False].Empty then SI := SI + [siTitleHeights];
  if not FSizes[sCols, True].Empty then SI := SI + [siClientWidths];
  if not FSizes[sRows, True].Empty then SI := SI + [siClientHeights];
  AStream.Write(SI, SizeOf(SI));
  if siTitleWidths in SI then FSizes[sCols, False].StreamSave(AStream);
  if siTitleHeights in SI then FSizes[sRows, False].StreamSave(AStream);
  if siClientWidths in SI then FSizes[sCols, True].StreamSave(AStream);
  if siClientHeights in SI then FSizes[sRows, True].StreamSave(AStream);
  if (ColCount > 0) and (TitleRows > 0) then FSections[sCols].Save(TXLStream(AStream));
  if (RowCount > 0) and (TitleCols > 0) then FSections[sRows].Save(TXLStream(AStream));
  if (TitleCols > 0) and (TitleRows > 0) then FSections[sTitle].Save(TXLStream(AStream));
  if (ColCount > 0) and (RowCount > 0) then FSections[sClient].Save(TXLStream(AStream));
  Modified := False;
end;

procedure TXLCustomSheet.LoadFromStream(AStream: TXLStream);
begin
  BeginUpdate;
  try
    AStream.ReadComponent(Self);
  finally
    EndUpdate;
  end;
end;

procedure TXLCustomSheet.SaveToStream(AStream: TXLStream);
begin
  BeginUpdate;
  try
    AStream.WriteComponent(Self);
  finally
    EndUpdate;
  end;
end;

procedure TXLCustomSheet.LoadFromFile(const AFileName: String);
var F: TFileStream;
begin
  F := TFileStream.Create(AFileName, fmOpenRead);
  try
    LoadFromStream(TXLStream(F));
  finally
    F.Free;
  end;
end;

procedure TXLCustomSheet.SaveToFile(const AFileName: String);
var F: TFileStream;
begin
  F := TFileStream.Create(AFileName, fmCreate);
  try
    SaveToStream(TXLStream(F));
  finally
    F.Free;
  end;
end;

function  TXLCustomSheet.MapToSector(ACol, ARow: Integer; var ACoord: TPoint): TXLSector;
const
  Hitter: Array[Boolean, Boolean] of TXLSector = ((sTitle, sRows),(sCols, sClient));
var
  L1, L2: Boolean;
begin
  L1 := ACol >= 0; L2 := ARow >= 0;
  Result := Hitter[L1, L2];
  if L1 then ACoord.X := ACol else ACoord.X := FSizes[sCols, False].Count + ACol;
  if L2 then ACoord.Y := ARow else ACoord.Y := FSizes[sRows, False].Count + ARow;
end;

function TXLCustomSheet.GetBoolean(ACol, ARow: Integer): Boolean;
var C: TXLCell;
begin
  Result := False;
  C := PeekCells[ACol, ARow];
  if C <> Nil then Result := C.AsBoolean;
end;

function TXLCustomSheet.GetCell(ACol, ARow: Integer): TXLCell;
var C: TPoint;
begin
  Result := FSections[MapToSector(ACol, ARow, C)].Cells[C];
end;

function TXLCustomSheet.GetPeekCell(ACol, ARow: Integer): TXLCell;
var C: TPoint;
begin
  Result := FSections[MapToSector(ACol, ARow, C)].PeekCells[C];
end;

function TXLCustomSheet.GetCellClass(ACol, ARow: Integer): TXLCellClass;
var C: TPoint;
begin
  Result := FSections[MapToSector(ACol, ARow, C)].CellClasses[C];
end;

procedure TXLCustomSheet.SetCellClass(ACol, ARow: Integer; Value: TXLCellClass);
var C: TPoint;
begin
  FSections[MapToSector(ACol, ARow, C)].CellClasses[C] := Value;
end;

function TXLCustomSheet.GetCurrency(ACol, ARow: Integer): Currency;
var C: TXLCell;
begin
  Result := 0;
  C := PeekCells[ACol, ARow];
  if C <> Nil then Result := C.AsCurrency;
end;

function TXLCustomSheet.GetDateTime(ACol, ARow: Integer): TDateTime;
var C: TXLCell;
begin
  Result := 0;
  C := PeekCells[ACol, ARow];
  if C <> Nil then Result := C.AsDateTime;
end;

function TXLCustomSheet.GetFloat(ACol, ARow: Integer): Double;
var C: TXLCell;
begin
  Result := 0;
  C := PeekCells[ACol, ARow];
  if C <> Nil then Result := C.AsDouble;
end;

function TXLCustomSheet.GetInteger(ACol, ARow: Integer): Integer;
var C: TXLCell;
begin
  Result := 0;
  C := PeekCells[ACol, ARow];
  if C <> Nil then Result := C.AsInteger;
end;

function TXLCustomSheet.GetObject(ACol, ARow: Integer): TPersistent;
var C: TXLCell;
begin
  Result := Nil;
  C := PeekCells[ACol, ARow];
  if C <> Nil then Result := C.AsObject;
end;

function TXLCustomSheet.GetString(ACol, ARow: Integer): String;
var C: TXLCell;
begin
  Result := '';
  C := PeekCells[ACol, ARow];
  if C <> Nil then Result := C.AsString;
end;

function TXLCustomSheet.GetValue(ACol, ARow: Integer): Variant;
var C: TXLCell;
begin
  Result := Unassigned;
  C := PeekCells[ACol, ARow];
  if C <> Nil then Result := C.Value;
end;

procedure TXLCustomSheet.SetBoolean(ACol, ARow: Integer; Value: Boolean);
begin
  Cells[ACol, ARow].AsBoolean := Value;
end;

procedure TXLCustomSheet.SetCell(ACol, ARow: Integer; Value: TXLCell);
var
  C: TPoint;
begin
  FSections[MapToSector(ACol, ARow, C)].Cells[C] := Value;
end;

procedure TXLCustomSheet.SetCurrency(ACol, ARow: Integer; const Value: Currency);
begin
  Cells[ACol, ARow].AsCurrency := Value;
end;

procedure TXLCustomSheet.SetDateTime(ACol, ARow: Integer; const Value: TDateTime);
begin
  Cells[ACol, ARow].AsDateTime := Value;
end;

procedure TXLCustomSheet.SetFloat(ACol, ARow: Integer; const Value: Double);
begin
  Cells[ACol, ARow].AsDouble := Value;
end;

procedure TXLCustomSheet.SetInteger(ACol, ARow: Integer; Value: Integer);
begin
  Cells[ACol, ARow].AsInteger := Value;
end;

procedure TXLCustomSheet.SetObject(ACol, ARow: Integer; Value: TPersistent);
begin
  Cells[ACol, ARow].AsObject := Value;
end;

procedure TXLCustomSheet.SetString(ACol, ARow: Integer; const Value: String);
begin
  Cells[ACol, ARow].AsString := Value;
end;

procedure TXLCustomSheet.SetValue(ACol, ARow: Integer; const Value: Variant);
begin
  Cells[ACol, ARow].Value := Value;
end;

procedure TXLCustomSheet.ReloadSelection(ASector: TXLSector);
var I: Integer;
begin
  for I := 0 to UserCount - 1 do Users[I].ResetSelection(False);
end;

procedure TXLCustomSheet.SetModified(Value: Boolean);
begin
  if FModified <> Value then
  begin
    FModified := Value;
    if Assigned(FOnModified) then FOnModified(Self);
  end;
  if (csDesigning in ComponentState) and Value then DesignerModified(Self);
end;

procedure TXLCustomSheet.BeginUpdate;
begin
  Inc(FLockCount);
end;

procedure TXLCustomSheet.EndUpdate;
var I: Integer;
begin
  Dec(FLockCount);
  if FLockCount = 0
  then for I := 0 to UserCount - 1 do Users[I].InvalidateAll;
end;

procedure TXLCustomSheet.InvalidateArea(Sector: TXLSector; const AArea: TRect;
  AMode: TXLInvalidate);
var I: Integer;
begin
  if FLockCount = 0 then
  for I := 0 to UserCount - 1 do Users[I].InvalidateArea(Sector, AArea, AMode);
end;

procedure TXLCustomSheet.InvalidateSector(Sector: TXLSector);
var I: Integer;
begin
  if FLockCount = 0 then
  for I := 0 to UserCount - 1 do Users[I].InvalidateSector(Sector);
end;

procedure TXLCustomSheet.AddUser(AUser: IXLSheetUser);
begin
  if FUsers.IndexOf(Pointer(AUser)) < 0 then FUsers.Add(Pointer(AUser));
end;

procedure TXLCustomSheet.RemoveUser(AUser: IXLSheetUser);
begin
  FUsers.Remove(Pointer(AUser));
end;

procedure TXLCustomSheet.Zap;
var I: TXLSector;
begin
  for I := Low(I) to High(I) do FSections[I].Zap;
end;

function TXLCustomSheet.PrintPageCount: Integer;
var ListX, ListY: TList;
begin
  ListX := TList.Create;
  ListY := TList.Create;
  CalcPrintLayout(ListX, ListY);
  Result := ListX.Count * ListY.Count;
  ListX.Free;
  ListY.Free;
end;

procedure TXLCustomSheet.SetPrinter;
var I: Integer;
begin
  if Printer.Printers.Count > 0 then begin
    FPageDPI.X := GetDeviceCaps(Printer.Handle, LOGPIXELSX);
    FPageDPI.Y := GetDeviceCaps(Printer.Handle, LOGPIXELSY);
    FPageRect := Bounds(0, 0, Printer.PageWidth, Printer.PageHeight);
  end else begin
// in case of absence printer use default HP LaserJet 5P properties
    FPageDPI.X := 600;
    FPageDPI.Y := 600;
    FPageRect := Bounds(0, 0, 4676, 6744);
  end;

  FPageRect.Right := (FPageRect.Right * 96) div FPageDPI.X;
  FPageRect.Bottom := (FPageRect.Bottom * 96) div FPageDPI.Y;

  FPageRect.Top := (FPageOffsTop * FPageDPI.Y) div 96;
  FPageRect.Left := (FPageOffsLeft * FPageDPI.X) div 96;
  FPageRect.Right := FPageRect.Right - (FPageOffsRight * FPageDPI.X) div 96;
  FPageRect.Bottom := FPageRect.Bottom - (FPageOffsBottom * FPageDPI.Y) div 96;

  for I := 0 to UserCount - 1 do Users[I].LayoutChanged;
end;

procedure RecalcList(AScaled, AOriginal: TXLSizeList; AScale: Integer);
var I: Integer;
begin
  with AOriginal do
  begin
    AScaled.Count := Count;
    AScaled.Zero  := Zero * AScale div 100;
    for I := 0 to HighBound do
    AScaled[I] := Ints[I] * AScale div 100;
  end;
end;

procedure TXLCustomSheet.CalcPages(ASizes: TXLSizes; AListX, AListY: TList; const APage: TRect);
var
   List: array[TXLAxis] of TList;
   Axis: TXLAxis;
   Page,
   Curr,
   I,CW: Integer;
begin
  List[sCols] := AListX;
  List[sRows] := AListY;
  for Axis := sCols to sRows do begin
    with ASizes[Axis, False], APage do
      Page := TXLSize(BottomRight).AsArray[Axis] - TXLSize(TopLeft).AsArray[Axis] - SummTo(Count);
    Curr := 0;
    with ASizes[Axis, True] do begin
      for I := 0 to Count - 1 do begin
        CW := Ints[I];
        if CW + Curr > Page then begin
          List[Axis].Add(Pointer(I));
          Curr := 0;
        end;
        Inc(Curr, CW);
      end;
      List[Axis].Add(Pointer(Count));
    end;
  end;
end;

procedure TXLCustomSheet.CalcPrintLayout(AListX, AListY: TList);
var PS: TXLSizes;
    A: TXLAxis;
    B: Boolean;
    Scale: TXLSize;
    VR: TRect;
begin
  Scale.sCols := (FPageDPI.X * 100) div 96;
  Scale.sRows := (FPageDPI.Y * 100) div 96;
  for A := Low(A) to High(A) do
    for B := Low(B) to High(B) do begin
      PS[A, B] := TXLSizeList.Create;
      RecalcList(PS[A, B], FSizes[A, B], Scale.AsArray[A]);
    end;
  try
    VR := PageRect;
    VR.Top := (VR.Top * Scale.sRows) div 100;
    VR.Left := (VR.Left * Scale.sCols) div 100;
    VR.Right := (VR.Right * Scale.sCols) div 100;
    VR.Bottom := (VR.Bottom * Scale.sRows) div 100;
    CalcPages(PS, AListX, AListY, VR);
  finally
    for A := Low(A) to High(A) do
    for B := Low(B) to High(B) do PS[A,B].Free;
  end;
end;

procedure TXLCustomSheet.PrintPages(AStart, AStop: Integer);
var PC, X, Y, XC, YC: Integer;
    S: TXLSector;
    XPS: TXLPaintStruct;
    PS: TXLSizes;
    A: TXLAxis;
    B: Boolean;
    PL: array[TXLAxis] of TList;
    Center,
    PageCenter: TPoint;

  procedure CalcRect(Sector: TXLSector; const GR: TRect; var View: TRect);
  begin
    with View do begin
      with PS[sCols, Sector in [sCols, sClient]] do
      begin
        Left := SummTo(GR.Left) - XPS.ViewRect.Left;
        Right := SummTo(GR.Right) - XPS.ViewRect.Left;
      end;
      with PS[sRows, Sector in [sRows, sClient]] do
      begin
        Top := SummTo(GR.Top) - XPS.ViewRect.Top;
        Bottom := SummTo(GR.Bottom) - XPS.ViewRect.Top;
      end;
    end;
  end;

  procedure PrepareUnions(Sector: TXLSector);
  var I: Integer;
      Unions: TList;
      AUnion: TXLUnion;
      RUnion,
      RTemp: TRect;
  begin
    XPS.Unions.Clear;
    Unions := FSections[Sector].FUnions;
    for I := 0 to Unions.Count - 1 do begin
      AUnion := TXLUnion(Unions[I]);
      RUnion := AUnion.Bounds;
      if IntersectRect(RTemp, RUnion, XPS.GridRect) then begin
        CalcRect(Sector, RUnion, RTemp);
        AUnion.FScreen := RTemp;
        XPS.Unions.Add(AUnion);
      end;
    end;
  end;

  function SectorOf(const ARect: TRect; ACenter: TPoint; ASector: TXLSector): TRect;
  begin
    Result := ARect;
    if ASector in [sCols, sClient] then Result.Left := ACenter.X
    else Result.Right := ACenter.X;
    if ASector in [sRows, sClient] then Result.Top := ACenter.Y
    else Result.Bottom := ACenter.Y;
  end;

var
  VR, GR: TRect;
begin
  XPS.Scale.sCols := (FPageDPI.X * 100) div 96;
  XPS.Scale.sRows := (FPageDPI.Y * 100) div 96;
  XPS.Grids[sCols] := PrintGridLines;
  XPS.Grids[sRows] := PrintGridLines;
  XPS.HintMode := False;
  XPS.Unions := TList.Create;
  XPS.PaintGround := PrintGround;
  PL[sCols] := TList.Create;
  PL[sRows] := TList.Create;
  Printer.Title := Title;
  Printer.BeginDoc;
  with FPageRect do
  try
    VR := PageRect;
    VR.Top := (VR.Top * XPS.Scale.sRows) div 100;
    VR.Left := (VR.Left * XPS.Scale.sCols) div 100;
    VR.Right := (VR.Right * XPS.Scale.sCols) div 100;
    VR.Bottom := (VR.Bottom * XPS.Scale.sRows) div 100;
    for A := Low(A) to High(A) do
    for B := Low(B) to High(B) do begin
      PS[A, B] := TXLSizeList.Create;
      RecalcList(PS[A, B], FSizes[A, B], XPS.Scale.AsArray[A]);
    end;
    CalcPages(PS, PL[sCols], PL[sRows], VR);
    XPS.Scale.sCols := 100;
    XPS.Scale.sRows := 100;
    // Loading sector shifts
    with PS[sCols, False] do Center.X := SummTo(Count);
    with PS[sRows, False] do Center.Y := SummTo(Count);
    PageCenter.X := Center.X + VR.Left;
    PageCenter.Y := Center.Y + VR.Top;
    // begin
    XPS.Handle := Printer.Handle;
    XPS.Canvas := Printer.Canvas;
    try
      XC := PL[sCols].Count;
      YC := PL[sRows].Count;
      XPS.Update := VR;
      GR.Right := 0;
      VR.Right := 0;
      for X := 0 to XC - 1 do begin
        VR.Left := VR.Right;
        GR.Left := GR.Right;
        GR.Right := Integer(PL[sCols][X]);
        VR.Right := PS[sCols, True].SummTo(GR.Right);

        GR.Bottom := 0;
        VR.Bottom := 0;
        for Y := 0 to YC - 1 do begin

          VR.Top := VR.Bottom;
          GR.Top := GR.Bottom;
          GR.Bottom := Integer(PL[sRows][Y]);
          VR.Bottom := PS[sRows, True].SummTo(GR.Bottom);

          PC := YC * X + Y + 1;
          if (PC >= AStart) and (PC <= AStop) then begin
            for S := Low(S) to High(S) do
            with FSections[S] do begin
              XPS.GetFrameProc := GetFrameData;
              XPS.Sizes[sCols] := PS[sCols, S in [sCols, sClient]];
              XPS.Sizes[sRows] := PS[sRows, S in [sRows, sClient]];
              XPS.GridRect := GR;
              XPS.ViewRect := VR;
              if S in [sTitle, sRows] then begin
                XPS.ViewRect.Left := 0;
                XPS.ViewRect.Right := Center.X;
                XPS.GridRect.Left := 0;
                XPS.GridRect.Right := TitleCols;
              end;
              if S in [sTitle, sCols] then begin
                XPS.ViewRect.Top := 0;
                XPS.ViewRect.Bottom := Center.Y;
                XPS.GridRect.Top := 0;
                XPS.GridRect.Bottom := TitleRows;
              end;
              PrepareUnions(S);
              Dec(XPS.ViewRect.Top, Center.Y);
              Dec(XPS.ViewRect.Left, Center.X);
              OffsetRect(XPS.ViewRect, XPS.Update.Left-XPS.ViewRect.Left, XPS.Update.Top-XPS.ViewRect.Top);
              XPS.ViewRect := SectorOf(XPS.ViewRect, PageCenter, S);
              SetWindowOrgEx(XPS.Canvas.Handle, - XPS.ViewRect.Left, - XPS.ViewRect.Top, nil);
              OffsetRect(XPS.ViewRect, -XPS.ViewRect.Left, -XPS.ViewRect.Top);
              PaintRect(XPS);
            end;
            if (PC < AStop) then Printer.NewPage;
          end;
        end;
      end;
    finally
      for A := Low(A) to High(A) do
      for B := Low(B) to High(B) do PS[A,B].Free;
    end;
  finally
    FreeObject(XPS.Unions);
    FreeObject(PL[sCols]);
    FreeObject(PL[sRows]);
    Printer.EndDoc;
  end;
end;

type
  PXLEnumData = ^TXLEnumData;
  TXLEnumData = record
    Sector: TXLSector;
    Data: Integer;
    EnumProc: TXLCoordEnumProc;
  end;

function TXLCustomSheet.EnumCells(const AArea: TRect; ACreate: Boolean; AEnumProc: TXLCellEnumProc; AData: Integer): Integer;
var
  ANewRect: TRect;
  I: TXLSector;
begin
  Result := 0;
  for I := Low(TXLSector) to High(TXLSector) do with FSections[I] do begin
    if IntersectRect(ANewRect, AArea, SectorOf(I, Extents)) 
    then Inc(Result, EnumCells(ANewRect, ACreate, AEnumProc, AData));
  end;
end;

function TXLCustomSheet.EnumCoords(const AArea: TRect; AEnumProc: TXLCoordEnumProc; AData: Integer; AIncX, AIncY: Boolean): Integer;
var SX,
    I, J,
    X,  Y,
    IX, IY,
    CX, CY: Integer;
    Coord: TPoint;
    S: TXLSection;
    U: TXLUnion;
    Stop: Boolean;
begin
  Result := 0;
  Stop := False;
  CY := AArea.Bottom - AArea.Top - 1;
  if AIncY then begin
    Y := AArea.Top;
    IY := 1;
  end else begin
    Y := AArea.Bottom - 1;
    IY := -1;
  end;
  CX := AArea.Right - AArea.Left - 1;
  if AIncX then begin
    SX := AArea.Left;
    IX := 1;
  end else begin
    SX := AArea.Right - 1;
    IX := -1;
  end;
  for I := 0 to CY do begin
    X := SX;
    for J := 0 to CX do begin
      S := FSections[MapToSector(X, Y, Coord)];
      U := S.FindUnion(Coord, True);
      if (U = Nil) or ((U.Bounds.Top = Coord.Y) and (U.Bounds.Left = Coord.X)) then begin
        AEnumProc(Point(X, Y), AData, Stop);
        Inc(Result);
        if Stop then exit;
      end;
      Inc(X, IX);
    end;
    Inc(Y, IY);
  end;
end;

function TXLCustomSheet.GetExtents: TRect;
begin
  Result := Rect(-TitleCols, -TitleRows, ColCount, RowCount);
end;

type
  PXLCheckCell = ^TXLCheckCell;
  TXLCheckCell = record
    Canvas: TCanvas;
    Size: TPoint;
    Font: TFont;
    Columns: Boolean;
  end;

procedure TXLCustomSheet.CheckCellSize(ACell: TXLCell; AData: Integer; var AStop: Boolean);
var
  AResult: TPoint;
begin
  with PXLCheckCell(AData)^ do begin
    if (csUnited in ACell.FStates) and
       ((Columns and (ACell.Width > 1)) or
        (not Columns and (ACell.Height > 1))) then exit;
    Canvas.Font.Assign(Font);
    AResult := ACell.RecommendedSize(Canvas);
    Size.X := IMax(Size.X, AResult.X);
    Size.Y := IMax(Size.Y, AResult.Y);
  end;
end;

function TXLCustomSheet.CheckRectSize(const ARect: TRect; AFont: TFont; ACols: Boolean): TPoint;
var
  CC: TXLCheckCell;
  DC: HDC;
begin
  DC := CreateCompatibleDC(0);
  CC.Canvas := TCanvas.Create;
  CC.Canvas.Handle := DC;
  CC.Columns := ACols;
  try
    CC.Font := AFont;
    CC.Size := Point(0,0);
    EnumCells(ARect, False, CheckCellSize, Integer(@CC));
  finally
    CC.Canvas.Handle := 0;
    CC.Canvas.Free;
    DeleteDC(DC);
  end;
  Result := CC.Size;
end;

function TXLCustomSheet.CalcColWidth(ACol: Integer): Integer;
begin
  Result := IMax( CheckRectSize(Rect(ACol, -TitleRows, ACol + 1, 0), BaseTitleStyle.Font, True).X,
                  CheckRectSize(Rect(ACol, 0, ACol + 1, RowCount), BaseClientStyle.Font, True).X);
  if Result = 0 then Result := ColDefWidth;
end;

function TXLCustomSheet.CalcRowHeight(ARow: Integer): Integer;
begin
  Result := IMax( CheckRectSize(Rect(-TitleCols, ARow, 0, ARow + 1), BaseTitleStyle.Font, False).Y,
                  CheckRectSize(Rect(0, ARow, ColCount, ARow + 1), BaseClientStyle.Font, False).Y);
  if Result = 0 then Result := RowDefHeight;
end;

procedure TXLCustomSheet.Loaded;
var
  S: TXLSector;
begin
  inherited Loaded;
  for S := Low(S) to High(S) do FSections[S].UpdateStyles;
end;

procedure TXLCustomSheet.PrintGround(PS: PXLPaintStruct);
begin
  {Do nothing}
end;

//TXLStyle

function  TXLStyle.GetStyler: TXLStyler;
begin
  Result := TXLStyler(Container);
end;

procedure TXLStyle.SetAlias(const AAlias: String);
begin
  if AAlias <> FAlias then
  begin
    if Styler.FindStyle(AAlias) <> Nil
    then InvalidOp('Style named ' + AAlias + ' already exists!') else
    begin
      FAlias := AAlias;
      Styler.Changed;
    end;
  end;
end;

procedure TXLStyle.NotifyChanges(AProp: TXLProp; AChanges: Integer);
var I: Integer;
    S: TXLSector;
begin
  inherited NotifyChanges(AProp, AChanges);
  with Styler do
  begin
    for I := 0 to SheetCount - 1 do
    for S := Low(S) to High(S) do Sheets[I].FSections[S].Change(Self, AProp, AChanges);
    Changed;
  end;
end;

constructor TXLStyle.Create(AStyler: TXLStyler);
begin
  inherited Create(AStyler);
  FColor := clWindow;
  if Styler <> Nil then Styler.FStyles.Add(Self);
end;

destructor TXLStyle.Destroy;
var I: Integer;
    S: TXLSector;
begin
  if Styler <> Nil then
  with Styler do
  begin
    Styler.FStyles.Remove(Self);
    for I := 0 to SheetCount - 1 do
    for S := Low(S) to High(S) do Sheets[I].FSections[S].ClearStyles(Self);
    Changed;
  end;
  inherited Destroy;
end;

function  TXLStyle.GetNamePath: String;
begin
  Result := Styler.GetNamePath + '.Styles['+IntToStr(Styler.FStyles.IndexOf(Self))+']';
end;

procedure TXLStyle.Load(AStream: TXLStream);
begin
  inherited Load(AStream);
  Alias := AStream.StringIO;
end;

procedure TXLStyle.Save(AStream: TXLStream);
begin
  inherited Save(AStream);
  AStream.StringIO := Alias;
end;

function TXLStyle.GetIndex: Integer;
begin
  Result := Styler.FStyles.IndexOf(Self);
end;

// TXLStyler
function TXLStyler.GetSheetCount: Integer;
begin
  Result := FSheets.Count;
end;

function TXLStyler.GetSheet(AIndex: Integer): TXLCustomSheet;
begin
  Result := TXLCustomSheet(FSheets[AIndex]);
end;

constructor TXLStyler.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FSheets := TList.Create;
  FStyles := TList.Create;
end;

destructor TXLStyler.Destroy;
var I: Integer;
begin
  for I := SheetCount - 1 downto 0 do Sheets[I].Styler := Nil;
  for I := StyleCount - 1 downto 0 do Styles[I].Free;
  FreeObject(FStyles);
  FreeObject(FSheets);
  inherited Destroy;
end;

function  TXLStyler.GetStyleCount: Integer;
begin
  Result := FStyles.Count;
end;

function  TXLStyler.GetStyleByAlias(const AAlias: String): TXLStyle;
begin
  Result := FindStyle(AAlias);
  if Result = Nil then InvalidOp('Unknown style named ' + AAlias);
end;

function  TXLStyler.GetStyleByIndex(AIndex: Integer): TXLStyle;
begin
  Result := TXLStyle(FStyles[AIndex]);
end;

function  TXLStyler.Add(const AAlias: String): TXLStyle;
begin
  Result := FindStyle(AAlias);
  if Result = Nil then
  begin
    Result := TXLStyle.Create(Self);
    Result.FAlias := AAlias;
    Changed;
  end;
end;

function  TXLStyler.FindStyle(const AAlias: String): TXLStyle; // without exception
var I: Integer;
begin
  for I := 0 to StyleCount - 1 do
  begin
    Result := TXLStyle(FStyles[I]);
    if Result.Alias = AAlias then exit;
  end;
  Result := Nil;
end;

procedure TXLStyler.DefineProperties(Filer: TFiler);
begin
  inherited DefineProperties(Filer);
  Filer.DefineBinaryProperty('Styles', ReadStyles, SaveStyles, StyleCount > 0);
end;

procedure TXLStyler.SaveStyles(Stream: TStream);
var I: Integer;
begin
  TXLStream(Stream).IntegerIO := StyleCount;
  for I := 0 to FStyles.Count - 1 do Styles[I].Save(TXLStream(Stream));
  Modified := False;
end;

procedure TXLStyler.ReadStyles(Stream: TStream);
var I: Integer;
begin
  for I := 1 to TXLStream(Stream).IntegerIO do TXLStyle.Create(Self).Load(TXLStream(Stream));
  Modified := False;
end;

procedure TXLStyler.SetModified(Value: Boolean);
begin
  if FModified <> Value then
  begin
    FModified := Value;
    if Assigned(FOnModified) then FOnModified(Self);
  end;
  if ([csDesigning, csLoading] * ComponentState = [csDesigning]) and Value
  then DesignerModified(Self);
end;

procedure TXLStyler.Changed;
begin
  if Assigned(FOnChange) then FOnChange(Self);
  Modified := True;
end;

// TXLView

function TXLView.GetGrid: TXLCustomGrid;
begin
  Result := TXLCustomGrid(Owner);
end;

constructor TXLView.CreateControl(AGrid: TXLCustomGrid; ASector: TXLSector);
begin
  Create(AGrid);
  ControlStyle := [csCaptureMouse, csDoubleClicks, csClickEvents];
  FSector := ASector;
  FSizes[sCols] := AGrid.GetList(Sector, sCols);
  FSizes[sRows] := AGrid.GetList(Sector, sRows);
  AGrid.FViews.Sectors[ASector] := Self;
  Parent := AGrid;
  ParentColor := Sector = sClient;
  ParentShowHint := True;
  TabStop := Sector = sClient;
  FSelection := TXLSelection.Create(Self);
end;

function TXLView.AdjustOffset(AOffset: TXLSize): Boolean;
var Max: TXLSize;
    I: TXLAxis;
begin
  Max := ClientSize;
  Result := False;
  for I := sCols to sRows do
  begin
    if AOffset.AsArray[I] < 0 then AOffset.AsArray[I] := 0;
    if (AOffset.AsArray[I] + Max.AsArray[I] > Size.AsArray[I]) then
    begin
      if (Size.AsArray[I] > Max.AsArray[I])
      then AOffset.AsArray[I] := Size.AsArray[I] - Max.AsArray[I]
      else AOffset.AsArray[I] := 0;
    end;
    Result := Result or (AOffset.AsArray[I] <> Offset.AsArray[I]);
  end;
  if Result then SetOffset(AOffset);
end;

procedure TXLView.SendOffset;
var SO: TXLSize;
    J: TXLAxis;
begin
  if FLocked = 0 then Update;
  for J := sCols to sRows do
  if FLinked[J] <> Nil then begin
    SO := FLinked[J].FOffset;
    SO.AsArray[J] := FOffset.AsArray[J];
    FLinked[J].SetOffset(SO);
  end;
  if Sector = sClient then Grid.ScrollLinked(FOffset);
end;

procedure TXLView.SetSize(ASize: TXLSize);
var VR1, VR2: TRect;
    WV1, WV2: Boolean;
    XRects  : TXORRects;
    I       : Integer;

procedure SaveSize;
begin
  FSize := ASize;
end;

begin
  if FLocked > 0 then
  begin
    SaveSize;
    AdjustScrollBars(True);
  end else
  if (Size.sCols <> ASize.sCols) or (Size.sRows <> ASize.sRows) then
  begin
    if HandleAllocated then
    begin
      WV1 := IntersectRect(VR1, ClientRect, Rect(0, 0, Size.sCols - Offset.sCols, Size.sRows - Offset.sRows));
      SaveSize;
      AdjustScrollBars(True);
      WV2 := IntersectRect(VR2, ClientRect, Rect(0, 0, Size.sCols - Offset.sCols, Size.sRows - Offset.sRows));
      if WV1 or WV2 then
      begin
        XorRects(VR1, VR2, XRects);
        for I := 0 to 3 do
          if not IsRectEmpty(XRects[I])
          then Windows.InvalidateRect(Handle, @(XRects[I]), False);
      end;
    end else SaveSize;
  end;
end;

function TXLView.SetOffsetXY(AOffsetX, AOffsetY: Integer): Boolean;
var Params: Integer;
begin
  Result := (FOffset.sCols <> AOffsetX) or (FOffset.sRows <> AOffsetY);
  if Result then
  begin
    if HandleAllocated then
    begin
      Params := SW_INVALIDATE or SW_SCROLLCHILDREN;
      if FLocked = 0 then Update;
      ScrollWindowEx(Handle, FOffset.sCols - AOffsetX, FOffset.sRows - AOffsetY, Nil, Nil, 0, Nil, Params);
    end;
    FOffset.sCols := AOffsetX;
    FOffset.sRows := AOffsetY;
    AdjustScrollBars(False);
    SendOffset;
  end;
end;

function TXLView.SetOffset(AOffset: TXLSize): Boolean;
begin
  Result := SetOffsetXY(AOffset.sCols, AOffset.sRows);
end;

procedure TXLView.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  with Params do
  begin
    WindowClass.style := CS_DBLCLKS or CS_PARENTDC;
    ExStyle := 0;
    Style := (Style or WS_CLIPCHILDREN or WS_TABSTOP) and not (WS_BORDER or WS_VSCROLL or WS_HSCROLL);
  end;
end;

procedure TXLView.WMNCHitTest(var Msg: TWMNCHitTest);
begin
  DefaultHandler(Msg);
  Grid.FHitTest := ScreenToClient(SmallPointToPoint(Msg.Pos));
end;

procedure TXLView.CMDesignHitTest(var Msg: TMessage);
begin
  with Grid do Msg.Result := Longint(BOOL(TMethod(FProcess).Code = @TXLCustomGrid.XLSizing));
end;

function TXLView.ClientToCell(AClient: TPoint; AExpand: Boolean; var Coord: TPoint): Boolean;
begin
  Inc(AClient.X, Offset.sCols);
  Inc(AClient.Y, Offset.sRows);
  Result := AExpand or ((AClient.X >= 0) and (AClient.Y >= 0) and (AClient.X < Size.sCols) and (AClient.Y < Size.sRows));
  Coord := Redirect(Point(FSizes[sCols].ScanIndex(AClient.X), FSizes[sRows].ScanIndex(AClient.Y)));
end;

function TXLView.CalcView(const AView: TRect; var AArea: TRect): Boolean;
var Save: Integer;
begin
  Result := False;
// calculating screen coords
  with FSizes[sCols] do
  begin
    Save := AView.Left + Offset.sCols;
    AArea.Left := ScanIndex(Save);
    if AArea.Left >= Count then exit;
  end;
  with FSizes[sRows] do
  begin
    Save := AView.Top + Offset.sRows;
    AArea.Top := ScanIndex(Save);
    if AArea.Top >= Count then exit;
  end;

  Save := AView.Right + Offset.sCols;
  AArea.Right := FSizes[sCols].ScanIndex(Save);
  if AView.Right + Offset.sCols > Save then Inc(AArea.Right);

  Save := AView.Bottom + Offset.sRows;
  AArea.Bottom := FSizes[sRows].ScanIndex(Save);
  if AView.Bottom + Offset.sRows > Save then Inc(AArea.Bottom);

  Result := CropArea(AArea);
end;

function TXLView.CalcRect(const AArea: TRect; var ARect: TRect; AMode: TXLCalcMode): Boolean;
begin
  with ARect do
  begin
    with FSizes[sCols] do
    begin
      Left := SummTo(AArea.Left);
      Right := SummTo(AArea.Right);
    end;
    Result := (Left < Size.sCols) and (Right <= Size.sCols);
    if Result then
    with FSizes[sRows] do
    begin
      Top := SummTo(AArea.Top);
      Bottom := SummTo(AArea.Bottom);
    end;
    Result := Result and (Top < Size.sRows) and (Bottom <= Size.sRows) and not IsRectEmpty(ARect);
  end;
  OffsetRect(ARect, -Offset.sCols, -Offset.sRows);
  if Result then
  case AMode of
  cmSkipFrame: with ARect do
               begin
                 Inc(Left); Inc(Top);
                 Dec(Right, 2); Dec(Bottom, 2);
               end;
  cmInterior:  with ARect do
               begin
                 Inc(Left, 2); Inc(Top, 2);
                 Dec(Right, 3); Dec(Bottom, 3);
               end;
  end;
end;

procedure TXLView.MakeVisible(const AArea: TRect);
var ARect: TRect;
    NewOffset,
    AdjOffset,
    MaxSize,
    TestPoint: TXLSize;
    I: TXLAxis;
begin
  if CalcRect(AArea, ARect, cmFull) then
  begin
    NewOffset := Offset;
    MaxSize := ClientSize;
    for I := Low(I) to High(I) do
    begin
      if TXLSize(ARect.TopLeft).AsArray[I] <= 0
      then Inc(NewOffset.AsArray[I], TXLSize(ARect.TopLeft).AsArray[I])
      else if TXLSize(ARect.BottomRight).AsArray[I] > MaxSize.AsArray[I]
           then Inc(NewOffset.AsArray[I], TXLSize(ARect.BottomRight).AsArray[I] - MaxSize.AsArray[I]);
    end;
    if (NewOffset.sCols <> Offset.sCols) or (NewOffset.sRows <> Offset.sRows) then
    begin
      AdjOffset := NewOffset;
      for I := Low(I) to High(I) do
      begin
        TestPoint.AsArray[I] := FSizes[I].ScanIndex(AdjOffset.AsArray[I]);
        if (NewOffset.AsArray[I] > AdjOffset.AsArray[I]) and (TestPoint.AsArray[I] < TXLSize(AArea.TopLeft).AsArray[I])
        then NewOffset.AsArray[I] := AdjOffset.AsArray[I] + FSizes[I][TestPoint.AsArray[I]];
      end;
      AdjustOffset(NewOffset);
    end;
  end;
end;

procedure TXLView.InvalidateArea(const AArea: TRect; Expand: Boolean; AMode: TXLInvalidate);
var Rect: TRect;
    NI: Boolean;
    RGN1, RGN2: HRGN;
begin
  if not HandleAllocated then exit;
  if Expand
  then NI := CalcRect(ExpandArea(AArea), Rect, cmInterior)
  else NI := CalcRect(AArea, Rect, cmInterior);
  if NI then begin
    if Rect.Left < 0 then Rect.Left := 0;
    if Rect.Top < 0 then Rect.Top := 0;
    if Rect.Bottom > ClientHeight then Rect.Bottom := ClientHeight;
    if Rect.Right > CLientWidth then Rect.Right := CLientWidth;
    if (AMode = iFrame) then
    begin
      RGN1 := CreateRectRGNIndirect(Rect);
      InflateRect(Rect, BorderSize + 1, BorderSize + 1);
      RGN2 := CreateRectRGNIndirect(Rect);
      CombineRgn(RGN1, RGN2, RGN1, RGN_XOR);
      Windows.InvalidateRgn(Handle, RGN1, True);
      DeleteObject(RGN1);
      DeleteObject(RGN2);
    end else
    begin
      if AMode = iFull then InflateRect(Rect, BorderSize, BorderSize);
      Windows.InvalidateRect(Handle, @Rect, False);
    end;
  end;
end;

procedure TXLView.CellClick(const APoint: TPoint);
var C: TXLCell;
begin
  C := Section.PeekCells[APoint];
  if C <> Nil then C.Click;
  if Assigned(FOnCellClick) then FOnCellClick(Self, APoint);
  if Assigned(Grid.FOnCellClick) then Grid.FOnCellClick(Grid, APoint);
  if Assigned(Grid.Sheet.FOnCellClick) then Grid.Sheet.FOnCellClick(Grid.Sheet, APoint);
end;

procedure TXLView.CellDblClick(const APoint: TPoint);
begin
  Section.Cells[APoint].DblClick;
  if Assigned(FOnCellDblClick) then FOnCellDblClick(Self, APoint);
  if Assigned(Grid.FOnCellDblClick) then Grid.FOnCellDblClick(Grid, APoint);
  if Assigned(Grid.Sheet.FOnCellDblClick) then Grid.Sheet.FOnCellDblClick(Grid.Sheet, APoint);
end;

procedure TXLView.Click;
begin
  inherited;
  if Assigned(Grid.OnClick) then Grid.OnClick(Self);
end;

procedure TXLView.DblClick;
begin
  inherited;
  if Assigned(Grid.OnDblClick) then Grid.OnDblClick(Self);
end;

procedure TXLView.MouseDown(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin

  with Grid do
  begin
     CheckFocus(Self, (ssCtrl in Shift) or (Editor.View.Sector <> sClient));
     if (Button = mbLeft) and (Phase = pScan)
     then Altering(Self, pInit, Point(X,Y), Shift);
     inherited;
     if Assigned(OnMouseDown) then OnMouseDown(Self, Button, Shift, X + Self.Left, Y + Self.Top);
  end;
end;

procedure TXLView.MouseMove(Shift: TShiftState; X, Y: Integer);
var P: TPoint;
    H: String;
begin
  OutputDebugString('XLViewMouseMove');
  if Grid.Phase in [pWork, pInit]
  then Grid.Altering(Self, pWork, Point(X, Y), Shift) else
  if ShowHint then
  begin
    H := '';
    if (Section <> Nil) and ClientToCell(Point(X, Y), False, P)
    then H := Section.GetCellHint(P);
    if Hint <> H then
    begin
      Application.CancelHint;
      Hint := H;
    end;
  end;
  inherited;
  if Assigned(Grid.OnMouseMove) then Grid.OnMouseMove(Self, Shift, X + Left, Y + Top);
end;

procedure TXLView.MouseUp(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  if (Button = mbLeft) and (Grid.Phase in [pWork, pInit])
  then Grid.Altering(Self, pDone, Point(X, Y), Shift);
  inherited;
  if Assigned(Grid.OnMouseUp) then Grid.OnMouseUp(Self, Button, Shift, X + Self.Left, Y + Self.Top);
end;

procedure TXLView.PaintGround(PS: PXLPaintStruct);

procedure EraseBackground;
begin
  Windows.FillRect(PS.Handle, PS.Update, Brush.Handle);
end;

var sX, sY, oX,
    MinX, MinY,
    MaxX, MaxY,
    X,Y, XX,YY: Integer;
    Graphic: TGraphic;
begin
  Graphic := HasBackground;
  if (Graphic <> Nil) then
  begin
    if Graphic.Transparent then EraseBackground;
    sX := Graphic.Width;
    sY := Graphic.Height;
    MinX := (PS.Update.Left + Offset.sCols) div sX;
    MinY := (PS.Update.Top + Offset.sRows) div sY;
    MaxX := (PS.Update.Right + Offset.sCols + sX - 1) div sX;
    MaxY := (PS.Update.Bottom + Offset.sRows + sY - 1) div sY;
    oX := MinX * sX - Offset.sCols;
    Y := MinY * sY - Offset.sRows;
    for YY := MinY to MaxY do
    begin
      X := oX;
      for XX := MinX to MaxX do
      begin
        PS.Canvas.Draw(X, Y, Graphic);
        Inc(X, sX);
      end;
      Inc(Y, sY);
    end;
  end else EraseBackground;
end;

procedure TXLView.WMPaint(var Msg: TWMPaint);
var
  PS: TPaintStruct;
  XPS: TXLPaintStruct;
  ND: Boolean;
  SR: HRGN;

procedure PrepareUnions;
var I: Integer;
    Unions: TList;
    AUnion: TXLUnion;
    RUnion,
    RTemp: TRect;
begin
  Unions := Section.FUnions;
  for I := 0 to Unions.Count - 1 do begin
    AUnion := TXLUnion(Unions[I]);
    RUnion := AUnion.Bounds;
    if IntersectRect(RTemp, RUnion, XPS.GridRect) and CalcRect(RUnion, RTemp, cmFull) then begin
      AUnion.FScreen := RTemp;
      XPS.Unions.Add(AUnion);
    end;
  end;
end;

begin
  XPS.Handle := BeginPaint(Handle, PS);
  XPS.Update := PS.rcPaint;
  try
    ND := (Section <> Nil) and CalcView(XPS.Update, XPS.GridRect) and CalcRect(XPS.GridRect, XPS.ViewRect, cmFull);
    XPS.Unions := TList.Create;
    XPS.Canvas := TCanvas.Create;
    XPS.Canvas.Handle := XPS.Handle;
    XPS.CellRgn := CreateRectRgn(0, 0, 1, 2);
    XPS.PaintGround := Self.PaintGround;
    XPS.DesignMode := Grid.DesignMode;
    try
      if ND then begin
        XPS.Scale.sCols := Grid.Scale;
        XPS.Scale.sRows := Grid.Scale;
        XPS.Grids[sCols] := (Grid.Scale >= 25) and (oVertLines in Grid.Options);
        XPS.Grids[sRows] := (Grid.Scale >= 25) and (oHorzLines in Grid.Options);
        XPS.GetFrameProc := Section.GetFrameData;
        XPS.Sizes[sCols] := FSizes[sCols];
        XPS.Sizes[sRows] := FSizes[sRows];
        XPS.HintMode := ShowHint;
        PrepareUnions;
        if Ctl3D and (Sector <> sClient) and not Editable then begin
          FSelCache := Grid.Views.ClientView.SelBounds;
          case Sector of
            sCols: FSelCache := ExpandArea(Rect(FSelCache.Left, 0, FSelCache.Right, MaxInt));
            sRows: FSelCache := ExpandArea(Rect(0, FSelCache.Top, MaxInt, FSelCache.Bottom));
          end;
          XPS.GetFrameProc := GetTitleFrame;
        end;
        Section.PaintRect(XPS);
        if (Sector = sClient) and (oPrintLayout in Grid.Options)
        then PaintLayout(XPS);
        SR := CreateSelectionRgn(SelBounds, Current);
        InvertRgn(XPS.Handle, SR);
        DeleteObject(SR);
      end else
      PaintGround(@XPS);
    finally
      XPS.Canvas.Handle := 0;
      FreeObject(XPS.Canvas);
      FreeObject(XPS.Unions);
      DeleteObject(XPS.CellRgn);
    end;
  finally
    EndPaint(Handle, PS);
  end;
end;

function  TXLView.MapToClient(ACoord: TPoint): TPoint;
begin
  Result := ACoord;
  if Sector in [sCols, sTitle] then Result.Y := - (FSizes[sRows].Count - ACoord.Y);
  if Sector in [sRows, sTitle] then Result.X := - (FSizes[sCols].Count - ACoord.X);
end;

procedure TXLView.CropPoint(var ACoord: TPoint);
begin
  ACoord.X := IMax(IMin(ACoord.X, FSizes[sCols].Count - 1), 0);
  ACoord.Y := IMax(IMin(ACoord.Y, FSizes[sRows].Count - 1), 0);
end;

function TXLView.CropArea(var AArea: TRect): Boolean;
begin
  Result := IntersectRect(AArea, AArea, Rect(0, 0, FSizes[sCols].Count, FSizes[sRows].Count)) and not IsRectEmpty(AArea);
end;

function TXLView.Redirect(ACoord: TPoint): TPoint;
begin
  Result := ACoord;
  if Section <> Nil then Result := Section.Redirect(Result);
  CropPoint(Result);
end;

function TXLView.ExpandArea(const AArea: TRect): TRect;
begin
  Result := AArea;
  if Section <> Nil then Result := Section.ExpandArea(Result);
end;

function TXLView.HitResult(APoint: TPoint; var Coord: TPoint): TXLHitResult;
var ABX, ABY: Boolean;
    Redir: TPoint;

function AtBorder(AList: TXLSizeList; var Index: Integer; APos: Integer): Boolean;
var WPos: Integer;
begin
  WPos := APos;
  Index := AList.ScanIndex(WPos);
  Result := True;
  if Abs(WPos - APos) > HitBorderSize
  then Result := Abs(WPos + AList[Index] - APos) <= HitBorderSize
    else Dec(Index);
end;

begin
  Result := hrNowhere;
  if Section <> Nil then begin
    Inc(APoint.X, Offset.sCols); Inc(APoint.Y, Offset.sRows);
    if (APoint.X < Size.sCols) and (APoint.Y < Size.sRows) then
    begin
      with TXLCustomGrid(Parent) do begin
        ABX := AtBorder(Self.FSizes[sCols], Coord.X, APoint.X) and
        ((Sector <> sClient) or (DesignMode and (Views.ColsView.Height = 0)));
        ABY := AtBorder(Self.FSizes[sRows], Coord.Y, APoint.Y) and
        ((Sector <> sClient) or (DesignMode and (Views.RowsView.Width = 0)));
      end;
      if ABX then begin
        Redir.X := Coord.X + 1;
        Redir.Y := Coord.Y;
        Redir := Section.Redirect(Redir);
        ABX := Redir.X = Coord.X + 1;
      end;
      if ABY then begin
        Redir.X := Coord.X;
        Redir.Y := Coord.Y + 1;
        Redir := Section.Redirect(Redir);
        ABY := Redir.Y = Coord.Y + 1;
      end;
      if (not ABX) and (not ABY) then Result := hrCell
      else begin
        {Check Selection}
        if ABX and (Coord.X >= 0) then Result := hrColBorder else
        if ABY and (Coord.Y >= 0) then Result := hrRowBorder;
      end;
    end;
  end;
end;

procedure TXLView.WMSetCursor(var Msg: TWMSetCursor);
var
  Cur: HCURSOR;
begin
  Cur := 0;
  with Grid do
    if (GetFocus <> 0) and (Phase = pScan) and (Msg.HitTest = HTCLIENT)
    then Cur := Screen.Cursors[ScanAlter(Self, FHitTest)];
  if Cur <> 0
  then SetCursor(Cur)
  else inherited;
end;

procedure TXLView.Invalidate;
begin
  if FLocked = 0 then inherited;
end;

procedure TXLView.WMSize(var Msg: TWMSize);
begin
  inherited;
  AdjustScrollBars(True);
end;

procedure TXLView.AdjustScrollBars(AAdjustOffset: Boolean);

  procedure CreateSI(var SI: TScrollInfo; Pos, Page, Range: Integer; ABar: TXLAxis);
  begin
    FScales.AsArray[ABar] := 1;
    while Range > 32000 do
    begin
      Range := Range shr 1;
      Page := Page shr 1;
      Pos := Pos shr 1;
      FScales.AsArray[ABar] := FScales.AsArray[ABar] shl 1;
    end;
    SI.cbSize := SizeOf(SI);
    SI.fMask := SIF_PAGE or SIF_POS or SIF_RANGE;
    SI.nMin := 0;
    SI.nMax := Range - 1;
    SI.nPage := Page;
    SI.nPos := Pos;
  end;

var SI: TScrollInfo;
    CR: TRect;
    Scrolls: TXLScrolls;
begin
  if (Sector = sClient) and HandleAllocated then
  begin
    if AAdjustOffset and AdjustOffset(Offset) then exit;
    Scrolls := Grid.Scrolls;
    if (Scrolls <> []) then
    begin
      CR := ClientRect;
      if ssVertical in Scrolls then
      begin
        CreateSI(SI, FOffset.sRows, ClientHeight, Size.sRows, sRows);
        SetScrollInfo(Handle, SB_VERT, SI, True);
      end;
      if ssHorizontal in Scrolls then
      begin
        CreateSI(SI, FOffset.sCols, ClientWidth, Size.sCols, sCols);
        SetScrollInfo(Handle, SB_HORZ, SI, True);
      end;
      if not EqualRect(CR, ClientRect) then AdjustScrollBars(False);
    end;
  end;
end;

function  TXLView.ProcessScroll(Bar: TXLAxis; Code, Pos: Integer): Integer;
var Range: Integer;
    Temp: Integer;
    PageSize: Integer;
begin
  PageSize := ClientSize.AsArray[Bar];
  Range := Size.AsArray[Bar] - PageSize;
  Result := Offset.AsArray[Bar];
  case Code of
    SB_TOP: Result := 0;
    SB_BOTTOM: Result := Range;
    SB_LINELEFT: begin
                   Dec(Result);
                   FSizes[Bar].ScanIndex(Result);
                 end;
    SB_LINERIGHT:begin
                   Temp := FSizes[Bar].ScanIndex(Result);
                   Inc(Result, FSizes[Bar][Temp]);
                 end;
    SB_PAGELEFT: begin
                   Dec(Result, PageSize);
                   FSizes[Bar].ScanIndex(Result);
                 end;
    SB_PAGERIGHT: begin
                    Inc(Result, PageSize);
                    FSizes[Bar].ScanIndex(Result);
                  end;
    SB_THUMBTRACK: if oTracking in Grid.Options then Result := Pos;
    SB_THUMBPOSITION: begin
                        Result := Pos;
                        if not (oTracking in Grid.Options)
                        then FSizes[Bar].ScanIndex(Result);
                      end;
  end;
  if Result > Range then Result := Range;
  if Result < 0 then Result := 0;
end;

procedure TXLView.WMHScroll(var Msg: TWMScroll);
begin
  SetOffset(XLSize(ProcessScroll(sCols, Msg.ScrollCode, Msg.Pos * FScales.sCols), Offset.sRows));
end;

procedure TXLView.WMVScroll(var Msg: TWMScroll);
begin
  SetOffset(XLSize(Offset.sCols, ProcessScroll(sRows, Msg.ScrollCode, Msg.Pos * FScales.sRows)));
end;

procedure TXLView.AdjustSizeChange(AAxis: TXLAxis; AStart, AOffset1, AOffset2: Integer);
var CR, IR: TRect;
    Shift: TXLSize;
    Params: Integer;
    NeedUpdate: Boolean;
    AStop1, I,
    AStop2: Integer;
    U: TXLUnion;
    FBackground: Boolean;
begin
  if AOffset1 <> AOffset2 then
  begin
    FBackground := HasBackground <> Nil;
    CR := ClientRect;
    Shift := TXLSize(CR.TopLeft);
    Shift.AsArray[AAxis] := AOffset2 - AOffset1;
    // to less then view area origin
    if AStart < Offset.AsArray[AAxis] + TXLSize(CR.BottomRight).AsArray[AAxis] then
    begin
      AStop1 := AStart + AOffset1;
      AStop2 := AStart + AOffset2;
      // Changes are visible
      if (AStop1 > Offset.AsArray[AAxis]) or (AStop2 > Offset.AsArray[AAxis]) then
      begin
        IR := CR;
        NeedUpdate := FLocked = 0;
        if FBackground then
        begin
          if NeedUpdate then
          begin
            TXLSize(CR.TopLeft).AsArray[AAxis] := AStart - Offset.AsArray[AAxis];
            Windows.InvalidateRect(Handle, @CR, False);
          end;
        end else
        begin
          TXLSize(IR.TopLeft).AsArray[AAxis] := AStart - Offset.AsArray[AAxis];
          TXLSize(IR.BottomRight).AsArray[AAxis] := IMin(AStop1, AStop2) - Offset.AsArray[AAxis];
          TXLSize(CR.TopLeft).AsArray[AAxis] := AStop1 - Offset.AsArray[AAxis];
          Params := SW_INVALIDATE or SW_SCROLLCHILDREN;
          if NeedUpdate then Update;
          ScrollWindowEx(Handle, Shift.sCols, Shift.sRows, @CR, nil, 0, nil, Params);
          if NeedUpdate then
          begin
            Windows.InvalidateRect(Handle, @IR, False);
            TXLSize(IR.TopLeft).AsArray[AAxis] := TXLSize(CR.BottomRight).AsArray[AAxis] + Shift.AsArray[AAxis];
            if TXLSize(IR.TopLeft).AsArray[AAxis] < TXLSize(CR.TopLeft).AsArray[AAxis] then
            begin
              TXLSize(IR.BottomRight).AsArray[AAxis] := TXLSize(CR.TopLeft).AsArray[AAxis];
              Windows.InvalidateRect(Handle, @IR, False);
            end;
          end;
        end;
      end else
      begin
        Inc(FOffset.AsArray[AAxis], Shift.AsArray[AAxis]);
        SendOffset;
        if FBackground then Invalidate;
      end;
    end;
    Inc(FSize.AsArray[AAxis], Shift.AsArray[AAxis]);
    if {(Sector = sClient) and }(Section <> Nil) then
    begin
      if Grid.FSAxis = sCols
      then CR := Bounds(Grid.FSIndex, 0, 1, MaxInt div 2)
      else CR := Bounds(0, Grid.FSIndex, MaxInt div 2, 1);
      for I := 0 to Section.FUnions.Count - 1 do
      begin
        U := TXLUnion(Section.FUnions[I]);
        if IntersectRect(IR, CR, U.Bounds) and CalcRect(U.Bounds, IR, cmFull)
        then InvalidateRect(Handle, @IR, False);
      end;
    end;
    AdjustScrollBars(False);
  end;
  if not IsRectEmpty(ClientRect) then
  begin
    if Sector in [sTitle, sRows] then Width := Size.sCols;
    if Sector in [sTitle, sCols] then Height := Size.sRows;
  end;
end;

function TXLView.GetClientSize: TXLSize;
begin
  Result := TXLSize(ClientRect.BottomRight);
end;

procedure TXLView.XLSizing(AOld, ANew: Integer);
var Rect: TRect;
    DC: HDC;
begin
  if Sector = sClient then
  begin
    Rect := ClientRect;
    InflateRect(Rect, 1, 1);
    with Grid do
    begin
      if Phase <> pWork
      then TXLSize(Rect.TopLeft).AsArray[FSAxis] := FSStart - Offset.AsArray[FSAxis] - 1;
      TXLSize(Rect.BottomRight).AsArray[FSAxis] := FSStart + ANew - Offset.AsArray[FSAxis];
    end;

    DC := GetDC(Handle);
    DrawFocusRect(DC, Rect);
    ReleaseDC(Handle, DC);

    with Grid do
    if (Phase = pDone) then AdjustSizeChange(FSAxis, FSStart, FSSave, ANew);
  end else AdjustSizeChange(Grid.FSAxis, Grid.FSStart, AOld, ANew);
end;

procedure TXLView.WMEraseBkgnd(var Msg: TWMEraseBkgnd);
begin
  Msg.Result := 1;
end;

function  TXLView.GetPalette: HPalette;
var Graphic: TGraphic;
begin
  Result := 0;
  Graphic := HasBackground;
  if (Graphic <> Nil) then Result := Graphic.Palette;
end;

procedure TXLView.CMShowHintChanged(var Msg: TMessage);
begin
  inherited;
  Invalidate;
end;

procedure TXLView.WMRButtonUp(var Msg: TWMRButtonDown);
begin
  if (Msg.xPos < Size.sCols) and (Msg.yPos < Size.sRows) then inherited;
end;

function TXLView.CanSelect(ACoord: TPoint): Boolean;
begin
  Result := (ACoord.X >= 0) and (ACoord.Y >= 0)
        and (ACoord.X < FSizes[sCols].Count) and (ACoord.Y < FSizes[sRows].Count)
        and (FSizes[sCols][ACoord.X] > 0) and (FSizes[sRows][ACoord.Y] > 0)
        and (Section.FindUnion(ACoord, False) = Nil)
        and (Grid.DesignMode or (Section.CellStyles[ACoord] * [csHidden, csProtect] = []));
end;

function  TXLView.CanEdit(ACoord: TPoint): Boolean;
begin
  Result := (Section <> Nil) and
            (not Section.Sheet.ReadOnly or (csDesigning in Section.Sheet.ComponentState)) and
            (not ((oReadOnly in Grid.Options) or (csReadOnly in Section.CellStyles[ACoord])) or Grid.DesignMode) and
            (XLManager.EditClassCount[Section.CellClasses[ACoord]] > 0) and
            CanSelect(ACoord);
end;

procedure TXLView.MoveCurrent(ACurrent: TPoint; AResetSelection, AVisible: Boolean);
var OldCur: TPoint;
    NewSel: TRect;
begin
  CropPoint(ACurrent);
  ACurrent := Redirect(ACurrent);
  if ((ACurrent.X <> FCurrent.X) or (ACurrent.Y <> FCurrent.Y)) and CanSelect(ACurrent) then
  begin
    OldCur := FCurrent;
    Grid.Editor.SetEditCell(Self, Nil);
    FCurrent := ACurrent;
    if Sector = sClient then with Grid.Views do begin
      ColsView.FCurrent.X := FCurrent.X;
      RowsView.FCurrent.Y := FCurrent.Y;
    end;
    FKeyCurr := ACurrent;
    if AResetSelection or not (oRangeSelect in Grid.Options)
    then NewSel := Area(FCurrent, FCurrent)
    else NewSel := SelBounds;
    Select(NewSel, OldCur, nil);
    Grid.Editor.Editing := (oPermEdit in Grid.Options);
    if AVisible then MakeVisible(Area(FCurrent, FCurrent));
    Grid.CurrentChanged(Self);
  end;
end;

procedure TXLView.SetCurrent(ACurrent: TPoint);
begin
  MoveCurrent(ACurrent, True, False);
end;

procedure TXLView.WMRButtonDown(var Msg: TWMRButtonDown);
var NC: TPoint;
begin
  if ClientToCell(Point(Msg.xPos, Msg.yPos), False, NC)
  and not PtInRect(SelBounds, NC)
  then Current := NC;
  inherited;
end;

const
  BackMap: Array[TXLDirection] of TXLDirection = (dNone, dLeft, dUp, dRight, dDown, dNone);

procedure TXLView.KeyPress(var Key: Char);
begin
  if (Key in [#13, #27]) then
  begin
    if Key = #13 then Grid.SelectNext(dAuto, GetKeyState(VK_SHIFT) < 0)
    else Grid.Editor.Cancel;
    Key := #0;
  end else if Section <> Nil then Section.Cells[Current].KeyPress(Key);
  inherited;
end;

procedure TXLView.ProcessSelect(Key: Word);
var Anchor: TPoint;
    CurSel,
    NewSel: TRect;

procedure Prepare;
begin
  Anchor := NewSel.BottomRight;
  if (CurSel.Left = NewSel.Left) then {} else
  if (CurSel.Right = NewSel.Right) then Anchor.X := NewSel.Left + 1 else begin
    CurSel.Left := NewSel.Left;
    CurSel.Right := NewSel.Right;
  end;
  if (CurSel.Top = NewSel.Top) then {} else
  if (CurSel.Bottom = NewSel.Bottom) then Anchor.Y := NewSel.Top + 1 else begin
    CurSel.Top := NewSel.Top;
    CurSel.Bottom := NewSel.Bottom;
  end;
end;


var
  Stop  : Boolean;
  Stops,
  OldSel : TRect;
  Dir: TXLDirection;
begin
  NewSel := SelBounds;
  CurSel := ExpandArea(Area(Current, Current));
  Stops := Rect(0, 0, MaxInt, MaxInt);
  CropArea(Stops);
  Prepare;
  Stop := True;
  Dir := dNone;
  case Key of
    VK_HOME: Anchor.X := 1;
     VK_END: Anchor.X := Stops.Right;
    VK_LEFT: Dir := dLeft;
      VK_UP: Dir := dUp;
   VK_RIGHT: Dir := dRight;
    VK_DOWN: Dir := dDown;
        else exit;
  end;
  if Dir <> dNone then Grid.FLastDir := Dir;
  repeat
    OldSel := NewSel;

    if Dir <> dNone then
    case Dir of
     dLeft: begin
              Dec(Anchor.X);
              Stop := Anchor.X <= 1;
            end;
       dUp: begin
              Dec(Anchor.Y);
              Stop := Anchor.Y <= 1;
            end;
    dRight: begin
              Inc(Anchor.X);
              Stop := Anchor.X >= Stops.Right;
            end;
     dDown: begin
              Inc(Anchor.Y);
              Stop := Anchor.Y >= Stops.Bottom;
            end;
    end;

    NewSel.Left := IMin(Anchor.X - 1, CurSel.Left);
    NewSel.Top := IMin(Anchor.Y - 1, CurSel.Top);
    NewSel.Right := IMax(Anchor.X, CurSel.Right);
    NewSel.Bottom := IMax(Anchor.Y, CurSel.Bottom);

    NewSel := ExpandArea(NewSel);
  until Stop or not EqualRect(NewSel, OldSel);

  Select(NewSel, Current, nil);
  MakeVisible(Rect(Anchor.X - 1, Anchor.Y - 1, Anchor.X, Anchor.Y));
end;

procedure TXLView.KeyDown(var Key: Word; Shift: TShiftState);
var
  NO: TPoint;
  J : Integer;
  Direction: TXLDirection;
  MoveScroll: Boolean;
  LookNext: Boolean;
begin
  outputdebugstring('XLViewkeyDown');
  if (Grid.Phase <> pScan) and (Key = VK_ESCAPE)
  then Grid.Altering(Self, pCancel, Point(0,0), []);
  inherited KeyDown(Key, Shift);
  if (ssShift in Shift) and (oRangeSelect in Grid.Options) then begin
    if not (oPermEdit in Grid.Options) then Grid.Editor.Editing := False;
    ProcessSelect(Key);
  end else if not (ssAlt in Shift) then begin
    Direction := dNone;
    NO := TPoint(Offset);
    MoveScroll := ssCtrl in Shift;
    LookNext := True;
    case Key of
          VK_UP: begin
                   if MoveScroll then AdjustOffset(XLSize(NO.X, ProcessScroll(sRows, SB_LINELEFT, NO.Y)));
                   Direction := dUp;
                 end;
        VK_DOWN: begin
                   if MoveScroll then AdjustOffset(XLSize(NO.X, ProcessScroll(sRows, SB_LINERIGHT, NO.Y)));
                   Direction := dDown;
                 end;
        VK_LEFT: begin
                   if MoveScroll then AdjustOffset(XLSize(ProcessScroll(sCols, SB_LINELEFT, NO.X), NO.Y));
                   Direction := dLeft;
                 end;
       VK_RIGHT: begin
                   if MoveScroll then AdjustOffset(XLSize(ProcessScroll(sCols, SB_LINERIGHT, NO.X), NO.Y));
                   Direction := dRight;
                 end;
        VK_NEXT: begin
                   if MoveScroll then
                   begin
                     AdjustOffset(XLSize(NO.X, Size.sRows));
                     FKeyCurr.Y := FSizes[sRows].Count;
                   end else
                   begin
                     J := FSizes[sRows].SummTo(FKeyCurr.Y) + ClientHeight;
                     AdjustOffset(XLSize(NO.X, ProcessScroll(sRows, SB_PAGERIGHT, NO.Y)));
                     FKeyCurr.Y := FSizes[sRows].ScanIndex(J);
                   end;
                   Direction := dUp;
                   LookNext := False;
                 end;
       VK_PRIOR: begin
                   if MoveScroll then
                   begin
                     AdjustOffset(XLSize(NO.X, 0));
                     FKeyCurr.Y := 0;
                   end else
                   begin
                     J := FSizes[sRows].SummTo(FKeyCurr.Y) - ClientHeight;
                     AdjustOffset(XLSize(NO.X, ProcessScroll(sRows, SB_PAGELEFT, NO.Y)));
                     FKeyCurr.Y := FSizes[sRows].ScanIndex(J);
                   end;
                   Direction := dDown;
                   LookNext := False;
                 end;
        VK_HOME: begin
                   if MoveScroll then
                   begin
                     FKeyCurr.Y := 0;
                     AdjustOffset(XLSize(0,0));
                   end;
                   FKeyCurr.X := 0;
                   Direction := dRight;
                   LookNext := False;
                 end;
         VK_END: begin
                   if MoveScroll then
                   begin
                     FKeyCurr.Y := FSizes[sRows].Count;
                     AdjustOffset(Size);
                   end;
                   FKeyCurr.X := FSizes[sCols].Count;
                   Direction := dLeft;
                   LookNext := False;
                 end;
        VK_F2: if Shift = [] then Grid.EditMode := emEdit;
    end;
    if Direction = dNone then exit;
    Grid.FLastDir := Direction;
    CropPoint(FKeyCurr);
    if LookNext or not CanSelect(FKeyCurr)
    then FindNext(FKeyCurr, Direction, False);
    NO := FKeyCurr;
    MoveCurrent(NO, True, True);
    FKeyCurr := NO;
  end;
end;

procedure TXLView.WMGetDlgCode(var Msg: TWMGetDlgCode);
begin
  Msg.Result := DLGC_WANTARROWS;
  if CanEdit(Current) then Msg.Result := Msg.Result or DLGC_WANTCHARS;
end;

procedure TXLView.CMWantSpecialKey(var Msg: TCMWantSpecialKey);
begin
  inherited;
  if CanEdit(Current) and (Char(Msg.CharCode) = #13) then Msg.Result := 1;
end;

function  TXLView.FindNext(var APoint: TPoint; ADir: TXLDirection; InSelection: Boolean): Boolean;
var SPoint: TPoint;
    Wrap: Boolean;
    WasS: Boolean;
    ABounds: TRect;

// Next Cell in Direction
function NextCell: Boolean;
var NU: TXLUnion;
begin
  Result := True;
  NU := Section.FindUnion(SPoint, True);
  if NU <> Nil then
  begin
    case ADir of
      dLeft  : SPoint.X := NU.Bounds.Left;
      dUp    : SPoint.Y := NU.Bounds.Top;
      dRight : SPoint.X := NU.Bounds.Right - 1;
      dDown  : SPoint.Y := NU.Bounds.Bottom - 1;
    end;
    CropPoint(SPoint);
  end;
  with ABounds do
  case ADir of
   dLeft: if SPoint.X > Left then Dec(SPoint.X) else begin
            Result := Wrap;
            if Result then
            if SPoint.Y > Top then begin
              SPoint.X := Right - 1;
              Dec(SPoint.Y);
            end else begin
              SPoint.X := Right - 1;
              SPoint.Y := Bottom - 1;
            end;
          end;
     dUp: if SPoint.Y > Top then Dec(SPoint.Y) else
          begin
            Result := Wrap;
            if Result then
            begin
              SPoint.Y := Bottom - 1;
              if SPoint.X > Left then Dec(SPoint.X) else SPoint.X := Right - 1;
            end;
          end;
  dRight: if SPoint.X < Right - 1 then Inc(SPoint.X) else begin
            Result := Wrap;
            if Result then
            if SPoint.Y < Bottom - 1 then begin
              SPoint.X := Left;
              Inc(SPoint.Y);
            end else begin
              SPoint.X := Left;
              SPoint.Y := Top;
            end;
          end;
   dDown: if SPoint.Y < Bottom - 1 then Inc(SPoint.Y) else begin
            Result := Wrap;
            if Result then begin
              SPoint.Y := Top;
              if SPoint.X < Right - 1 then Inc(SPoint.X) else SPoint.X := Left;
            end;
          end;
     else Result := False;
  end;
  WasS := Result;
end;

begin
  ABounds := SelBounds;
  Wrap := True;
  if Selection.Single or not InSelection then begin
    ABounds := Rect(0, 0, FSizes[sCols].Count, FSizes[sRows].Count);
    Wrap := oWrapKeys in Grid.Options;
  end;
  SPoint := APoint;
  while NextCell and not CanSelect(Redirect(SPoint)) do ;
  Result := WasS;
  if Result then APoint := SPoint;
end;

function TXLView.CreateSelectionRgn(const ASelection: TRect; ACurrent: TPoint): HRgn;
var R: TRect;
    CR: HRgn;

procedure Crop;
begin
  R.Left := IMax(-10, R.Left);
  R.Right := IMax(-10, R.Right);
  R.Top := IMax(-10, R.Top);
  R.Bottom := IMax(-10, R.Bottom);
  R.Left := IMin(ClientWidth + 10, R.Left);
  R.Right := IMin(ClientWidth + 10, R.Right);
  R.Top := IMin(ClientHeight + 10, R.Top);
  R.Bottom := IMin(ClientHeight + 10, R.Bottom);
end;

begin
  Result := CreateRectRgn(0, 0, 0, 0);
  if not IsRectEmpty(ASelection) then
    if Editable then begin
      CalcRect(ASelection, R, cmSkipFrame);
      Crop;
      SetRectRgn(Result, R.Left, R.Top, R.Right, R.Bottom);
      InflateRect(R, 3, 3);
      CR := CreateRectRgnIndirect(R);
      if Ctl3D then
      begin
        CombineRgn(Result, Result, CR, RGN_XOR);
        InflateRect(R, -4, -4);
        SetRectRgn(CR, R.Left, R.Top, R.Right, R.Bottom);
        CombineRgn(Result, Result, CR, RGN_XOR);
      end;
      if (Grid.DrawCurrent or (oPermEdit in Grid.Options)) then begin
        CalcRect(ExpandArea(Area(ACurrent, ACurrent)), R, cmInterior);
        Crop;
        SetRectRgn(CR, R.Left, R.Top, R.Right, R.Bottom);
        CombineRgn(Result, Result, CR, RGN_XOR);
      end;
      DeleteObject(CR);
    end else begin
      CalcRect(ASelection, R, cmFull);
      Crop;
      SetRectRgn(Result, R.Left, R.Top, R.Right, R.Bottom);
    end;
end;

procedure TXLView.ResetSelection;
begin
  SelectionChanged(Rect(0, 0, 0, 0), Current);
end;

procedure TXLView.SelectionChanged(const ANewSelection: TRect; AOldCurrent: TPoint);
var R1, R2: HRGN;
    DHandle: HDC;
begin
  if HandleAllocated then
  begin
    DHandle := GetDC(Handle);
    try
      R1 := CreateSelectionRgn(SelBounds, AOldCurrent);
      R2 := CreateSelectionRgn(ANewSelection, Current);
      CombineRgn(R1, R1, R2, RGN_XOR);
      InvertRgn(DHandle, R1);
      DeleteObject(R1);
      DeleteObject(R2);
    finally
      ReleaseDC(Handle, DHandle);
    end;
    if (Sector = sClient) and Editable and Ctl3D then begin
      with Grid.Views do begin
        ColsView.InvalidateXOR(ANewSelection, SelBounds);
        RowsView.InvalidateXOR(ANewSelection, SelBounds);
      end;
    end;
  end;
  FSelBounds := ANewSelection;
end;

procedure TXLView.Select(ABounds: TRect; AOldCurrent: TPoint; ADelegator: TXLView);

procedure  DelegateSelection;
var NewSel: TRect;
    NewCurr: TPoint;
    I: TXLSector;
begin
  if Sector <> sClient then begin
    if not Editable then begin
      NewSel := Rect(0, 0, MaxInt, MaxInt);
      NewCurr := Point(0,0);
      case Sector of
      sCols: begin
               NewSel.Left := ABounds.Left;
               NewSel.Right := ABounds.Right;
               NewCurr.X := Current.X;
             end;
      sRows: begin
               NewSel.Top := ABounds.Top;
               NewSel.Bottom := ABounds.Bottom;
               NewCurr.Y := Current.Y;
             end;
      end;
      with Grid.Views.ClientView do begin
        if not PtInRect(NewSel, Current) then 
        MoveCurrent(NewCurr, False, True);
        Select(NewSel, Current, Self);
      end;
    end;
  end else if Editable then begin
    for I := sCols to sTitle do with Grid.Views do
    if Sectors[I] <> ADelegator then Sectors[I].ResetSelection;
  end;
end;

var SS: Boolean;
    AC: TXLPersistent;
    PR: TRect;
begin
  if Section <> Nil then
  begin
    if not IsRectEmpty(ABounds) then begin
      if Sector = sClient then begin
        if (oRowSelect in Grid.Options) and (not Grid.DesignMode) then
          with ABounds do begin Left := 0; Right := MaxInt; end;
      end else if not Editable then begin
        if (Sector in [sTitle, sRows]) then
          with ABounds do begin Left := 0; Right := MaxInt; end;
        if (Sector in [sTitle, sCols]) then
          with ABounds do begin Top := 0; Bottom := MaxInt; end;
        if Sector in [sCols, sRows] then begin
          repeat
            PR := ABounds;
            ABounds := Grid.Views.ClientView.ExpandArea(ExpandArea(ABounds));
          until EqualRect(ABounds, PR);
        end;
      end;
    end;
    ABounds := ExpandArea(ABounds);
    if CropArea(ABounds) and not EqualRect(ABounds, SelBounds) then begin
      SelectionChanged(ABounds, AOldCurrent);
      with Selection do begin
        SS := SaveState(csAssign);
        try
          AC := Section.PeekCells[SelBounds.TopLeft];
          if AC = Nil then AC := Section.BaseStyle;
          Assign(AC);
        finally
          RestoreState(csAssign, SS);
        end;
      end;
      Grid.SelectionChanged(Sector);
      DelegateSelection;
    end else SelectionChanged(ABounds, AOldCurrent);
  end;
end;

destructor TXLView.Destroy;
begin
  FreeObject(FSelection);
  inherited Destroy;
end;

function TXLView.HasBackground: TGraphic;
begin
  Result := Nil;
  if (Section <> Nil) and (Sector = sClient) then
  with Section.Sheet.Background do
  if (Graphic <> Nil) and (Width > 0) and (Height > 0)
  then Result := Graphic;
end;

procedure TXLView.CMCtl3DChanged(var Msg: TMessage);
begin
  inherited;
  Invalidate;
end;

function TXLView.GetEditing: Boolean;
begin
  with Grid.Editor do Result := (View = Self) and Editing;
end;

procedure TXLView.SetEditing(Value: Boolean);
begin
  with Grid.Editor do if View = Self then Editing := Value;
end;

procedure TXLView.SetEditCoord(ACoord: TPoint);
begin
  if CanEdit(ACoord)
  then Grid.Editor.SetEditCell(Self, Section.Cells[ACoord])
  else Editing := False;
end;

function TXLView.GetTitleFrame(ACol, ARow: Integer): TXLFrame;
begin
  case Sector of
    sCols: if (ACol >= FSelCache.Left) and (ACol < FSelCache.Right) then begin
             Result := frDeepUp;
             exit;
           end;
    sRows: if (ARow >= FSelCache.Top) and (ARow < FSelCache.Bottom) then begin
             Result := frDeepUp;
             exit;
           end;
  end;
  Result := Section.GetFrameData(ACol, ARow);
end;

function TXLView.GetEditable: Boolean;
begin
  Result := Grid.Editor.View = Self;
end;

procedure TXLView.LockUpdate;
begin
  Inc(FLocked);
end;

procedure TXLView.UnlockUpdate;
begin
  Dec(FLocked);
  Invalidate;
end;

procedure TXLView.PaintLayout(const PS: TXLPaintStruct);
var
   ListX,
   ListY: TList;
   I, J: Integer;
begin
  ListX := TList.Create;
  ListY := TList.Create;
  Grid.Sheet.CalcPrintLayout(ListX, ListY);
  with ListX do
  for I := 0 to Count - 1 do Items[I] := Pointer(FSizes[sCols].SummTo(Integer(Items[I])) - Offset.sCols);
  with ListY do
  for I := 0 to Count - 1 do Items[I] := Pointer(FSizes[sRows].SummTo(Integer(Items[I])) - Offset.sRows);
  with PS, Canvas do begin
// Paint Bounding rectangle
    Pen.Color := clBlack;
    Pen.Width := 2;
    with ListX do I := Integer(Items[Count - 1]);
    with ListY do J := Integer(Items[Count - 1]);
    MoveTo(0, J); LineTo(I, J);  LineTo(I, 0);
// Paint Page Bounding rectangles
    Pen.Color := clBlue;
    Pen.Width := 0;
    for I := 0 to ListX.Count - 1 do begin
      J := Integer(ListX[I]) - 1;
      MoveTo(J, ViewRect.Top); LineTo(J, ViewRect.Bottom);
    end;
    for I := 0 to ListY.Count - 1 do begin
      J := Integer(ListY[I]) - 1;
      MoveTo(ViewRect.Left, J); LineTo(ViewRect.Right, J);
    end;
  end;
  ListX.Free;
  ListY.Free;
end;

procedure TXLView.DragDrop(Source: TObject; X, Y: Integer);
begin
  TXLView(Grid).DragDrop(Source, X + Left, Y + Top);
end;

procedure TXLView.DoStartDrag(var DragObject: TDragObject);
begin
  TXLView(Grid).DoStartDrag(DragObject);
end;

procedure TXLView.DoEndDrag(Target: TObject; X, Y: Integer);
begin
  TXLView(Grid).DoEndDrag(Target, X + Left, Y + Top);
end;

procedure TXLView.DragOver(Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  TXLView(Grid).DragOver(Source, X + Left, Y + Top, State, Accept);
end;

procedure TXLView.InvalidateXOR(AArea1, AArea2: TRect);
var
  XORs: TXORRects;
  I: Integer;
begin
  if Sector = sCols then begin
    AArea1.Top := 0;
    AArea2.Top := 0;
    AArea1.Bottom := MaxInt;
    AArea2.Bottom := MaxInt;
  end else begin
    AArea1.Left := 0;
    AArea2.Left := 0;
    AArea1.Right := MaxInt;
    AArea2.Right := MaxInt;
  end;
  CropArea(AArea1);
  CropArea(AArea2);
  XORRects(ExpandArea(AArea1), ExpandArea(AArea2), XORs);
  for I := Low(XORs) to High(XORs) do begin
    AArea1 := XORs[I];
    if not IsRectEmpty(AArea1)
    then InvalidateArea(AArea1, True, iFull);
  end;
end;

procedure TXLView.WMChar(var Msg: TWMChar);
begin
  if (Char(Msg.CharCode) in [^H, #32..#255]) then
  with Grid do begin
    SetEditCoord(Current);
    if Editing then begin
      Editor.ShowWithMessage(TMessage(Msg));
      exit;
    end;
  end;
  inherited;
end;

procedure TXLView.WMIMEStartComposition(var Msg: TMessage);
begin
  Msg.Result := 0;
  with Grid do begin
    SetEditCoord(Current);
    if Editing then Editor.ShowWithMessage(Msg);
  end;
end;

procedure TXLView.WMIMEEndComposition(var Msg: TMessage);
begin
  Msg.Result := 0;
  if Editing then Grid.Editor.SendMessage(Msg);
end;

procedure TXLView.WMIMENotify(var Msg: TMessage);
begin
  Msg.Result := 0;
  if Editing then Grid.Editor.SendMessage(Msg);
end;

procedure TXLView.WMIMEComposition(var Msg: TMessage);
begin
  Msg.Result := 0;
  if Editing then Grid.Editor.SendMessage(Msg);  
end;

// TXLCustomGrid

constructor TXLCustomGrid.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FullRepaint := True;
  Init;
end;

destructor TXLCustomGrid.Destroy;
begin
  Destroying;
  Done;
  inherited Destroy;
end;

procedure TXLCustomGrid.Init;
begin
  ControlStyle := (ControlStyle + [csNoStdEvents]) - [csClickEvents];
  FLastDir := dDown;
  FScale := 100;
  FScrolls := [ssHorizontal, ssVertical];
  FGridDir := dAuto;
  FOptions := [oTitleCols, oTitleRows, oDrawFocus, oTracking, oVertLines, oHorzLines, oRangeSelect];
  FSizes[sCols, False] := TXLSizeList.Create;
  FSizes[sCols, True]  := TXLSizeList.Create;
  FSizes[sRows, False] := TXLSizeList.Create;
  FSizes[sRows, True]  := TXLSizeList.Create;
  FEditor := TXLEdit.Create(Self);
  TXLView.CreateControl(Self, sClient);
  TXLView.CreateControl(Self, sCols);
  TXLView.CreateControl(Self, sRows);
  TXLView.CreateControl(Self, sTitle);
  Views.ClientView.FLinked[sCols] := Views.ColsView;
  Views.ClientView.FLinked[sRows] := Views.RowsView;
  Views.ColsView.FLinked[sCols] := Views.ClientView;
  Views.RowsView.FLinked[sRows] := Views.ClientView;
  FEditor.View := Views.ClientView;
  TabStop := True;
end;

procedure TXLCustomGrid.Done;
begin
  EditMode := emNone;
  if HorzLink <> Nil then HorzLink := Nil;
  if VertLink <> Nil then VertLink := Nil;
  Sheet := Nil;
  FreeObject(FSizes[sRows, True]);
  FreeObject(FSizes[sRows, False]);
  FreeObject(FSizes[sCols, True]);
  FreeObject(FSizes[sCols, False]);
end;

function  TXLCustomGrid.GetCurCol: Integer;
begin
  Result := CurPos.X;
end;

function  TXLCustomGrid.GetCurRow: Integer;
begin
  Result := CurPos.Y;
end;

procedure TXLCustomGrid.SetCurCol(ACol: Integer);
begin
  CurPos := Point(ACol, CurRow);
end;

procedure TXLCustomGrid.SetCurRow(ARow: Integer);
begin
  CurPos := Point(CurCol, ARow);
end;

function  TXLCustomGrid.GetCurPos: TPoint;
begin
  with Editor.View do Result := MapToClient(Current);
end;

procedure TXLCustomGrid.SetCurPos(ACoord: TPoint);
var NewSector: TXLSector;
begin
  if (Sheet <> Nil) then begin
    NewSector := Sheet.MapToSector(ACoord.X, ACoord.Y, ACoord);
    Editor.View := Views.Sectors[NewSector];
    if Editor.View.Sector = NewSector then Editor.View.MoveCurrent(ACoord, True, True);
  end;
end;

procedure TXLCustomGrid.SelectionChanged(ASector: TXLSector);
begin
  if (ASector = Editor.View.Sector) and Assigned(FOnSelChanged) then FOnSelChanged(Self);
end;

procedure TXLCustomGrid.CurrentChanged(Sender: TXLView);
begin
  if (Sender = Editor.View) and Assigned(FOnCurChanged) then FOnCurChanged(Self);
end;

procedure TXLCustomGrid.SetScale(AScale: TXLScale);
begin
  AScale := IMax(25, AScale);
  if AScale <> FScale then
  begin
    FScale := AScale;
    LockUpdate;
    try
      SheetSizeChanged([], True);
      LayoutChanged;
      if Editor.Editing then Editor.Relocate;
    finally
      UnlockUpdate;
    end;
    if Assigned(FOnScaleChanged) then FOnScaleChanged(Self);
  end;
end;

procedure TXLCustomGrid.LockUpdate;
var I: TXLSector;
begin
  for I := Low(I) to High(I) do Views.Sectors[I].LockUpdate;
end;

procedure TXLCustomGrid.UnlockUpdate;
var I: TXLSector;
begin
  for I := Low(I) to High(I) do Views.Sectors[I].UnlockUpdate;
end;

procedure TXLCustomGrid.SetOptions(AOptions: TXLOptions);
var OOptions: TXLOptions;
begin
  if AOptions <> FOptions then
  begin
    OOptions := FOptions;
    FOptions := AOptions;
    if ([oTitleCols, oTitleRows] * OOptions) <> ([oTitleCols, oTitleRows] * AOptions)
    then Realign;
    if ([oVertLines, oHorzLines] * OOptions) <> ([oVertLines, oHorzLines] * AOptions)
    then InvalidateAll;
    if ([oPrintLayout] * OOptions) <> ([oPrintLayout] * AOptions)
    then InvalidateAll;
  end;
end;

procedure TXLCustomGrid.AlignControls(AControl: TControl; var Rect: TRect);
var ORect: TRect;
    AOffset: TXLSize;
begin
  {$IFDEF Delphi45}
  AdjustClientRect(Rect);
  {$ENDIF}
  inherited AlignControls(AControl, Rect);
  if Phase in [pScan, pDone, pCancel] then
  with Views do begin
    ORect := Rect;
    AOffset := TitleView.Size;
    if (oTitleRows in Options) then Inc(Rect.Left, AOffset.sCols);
    if (oTitleCols in Options) then Inc(Rect.Top, AOffset.sRows);
    with ClientView do BoundsRect := Rect;
    with ColsView   do BoundsRect := Classes.Rect(Rect.Left, ORect.Top, Rect.Right, Rect.Top);
    with RowsView   do BoundsRect := Classes.Rect(ORect.Left, Rect.Top, Rect.Left, Rect.Bottom);
    with TitleView  do BoundsRect := Classes.Rect(ORect.Left, ORect.Top, Rect.Left, Rect.Top);
  end;
end;

function TXLCustomGrid.GetList(ASector: TXLSector; AAxis: TXLAxis): TXLSizeList;
begin
  Result := FSizes[AAxis, (ASector = sClient) or (ASector = AAxis)];
end;

procedure TXLCustomGrid.Loaded;
begin
  inherited Loaded;
  SheetSizeChanged([], True);
end;

procedure TXLCustomGrid.SetScrolls(AScrolls: TXLScrolls);
begin
  if AScrolls <> FScrolls then
  begin
    FScrolls := AScrolls;
    Views.ClientView.RecreateWnd;
  end;
end;

procedure TXLCustomGrid.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) then begin
    if (AComponent = FHorzLink) then HorzLink := Nil;
    if (AComponent = FVertLink) then VertLink := Nil;
  end;
end;

procedure TXLCustomGrid.WMSetFocus(var Msg: TWMSetFocus);
begin
  inherited;
  if not (csDesigning in ComponentState) then Editor.View.SetFocus;
end;

function TXLCustomGrid.HitTest(AClient: TPoint; var ASector: TXLSector; var Coord: TPoint): Boolean;
const
   Hitter : Array[Boolean, Boolean] of TXLSector = ((sTitle, sCols),(sRows, sClient));
begin
  ASector := Hitter[not (oTitleCols in Options) or (AClient.X > Views.TitleView.Size.sCols),
                    not (oTitleRows in Options) or (AClient.Y > Views.TitleView.Size.sRows)];
  Result := Views.Sectors[ASector].ClientToCell(AClient, False, Coord);
end;

function  TXLCustomGrid.ToScaled(AOriginal: Integer): Integer;
begin
  Result := AOriginal;
  if FScale <> 100 then Result := (AOriginal * FScale) div 100;
end;

function  TXLCustomGrid.ToOriginal(AScaled: Integer): Integer;
begin
  Result := AScaled;
  if FScale <> 100 then Result := (AScaled * 100) div FScale;
end;

procedure TXLCustomGrid.WMEraseBkgnd(var Msg: TWMEraseBkgnd);
begin
  Msg.Result := 1;
end;

procedure TXLCustomGrid.SheetChanged;
begin
  if Assigned(FOnSheetChanged) then FOnSheetChanged(Self);
end;

procedure TXLCustomGrid.IntDisconnect;
begin
  if FSheet <> Nil then begin
    EditMode := emNone;
    FSheet.RemoveUser(Self);
    FSheet := Nil;
  end;
end;

procedure TXLCustomGrid.Disconnect;
begin
  Sheet := Nil;
end;

procedure TXLCustomGrid.SetSheet(ASheet: TXLCustomSheet);
begin
  if ASheet <> FSheet then begin
    IntDisconnect;
    FSheet := ASheet;
    if (FSheet <> Nil) then FSheet.AddUser(Self);
    if not (csDestroying in ComponentState)
    then PrepareSheetData;
    SheetChanged;
  end;
end;

procedure TXLCustomGrid.DestroyWnd;
begin
  Timer := Nil;
  inherited DestroyWnd;
end;

procedure TXLCustomGrid.SetTimer(ATimer: TXLView);
begin
  if ATimer <> FTimer then
  begin
    if FTimer <> Nil then KillTimer(Handle, 1);
    FTimer := ATimer;
    if FTimer <> Nil then Windows.SetTimer(Handle, 1, 40, Nil);
  end;
end;

procedure TXLCustomGrid.UpdateViews;
var
  J: TXLSector;
begin
  for J := Low(J) to High(J) do UpdateWindow(Views.Sectors[J].Handle);
end;

procedure TXLCustomGrid.WMTimer(var Msg: TWMTimer);
var Mouse: TPoint;
    NO,
    MS: TXLSize;
    I: TXLAxis;
begin
  if (Phase = pWork) and (TMethod(FProcess).Code <> @TXLCustomGrid.XLSizing) and GetCursorPos(Mouse) then
  begin
    Mouse := Timer.ScreenToClient(Mouse);
    NO := Views.ClientView.Offset;
    MS := Timer.ClientSize;
    for I := Low(I) to High(I) do
    if (Timer.Sector = sClient) or (Timer.Sector = I) then
      if TXLSize(Mouse).AsArray[I] < 0
      then NO.AsArray[I] := Views.ClientView.ProcessScroll(I, SB_LINELEFT, NO.AsArray[I])
      else if TXLSize(Mouse).AsArray[I] > MS.AsArray[I]
           then NO.AsArray[I] := Views.ClientView.ProcessScroll(I, SB_LINERIGHT, NO.AsArray[I]);
    Views.ClientView.SetOffset(NO);
    UpdateViews;
    Timer.MouseMove([], Mouse.X, Mouse.Y);
  end;
end;

procedure TXLCustomGrid.GetPair(AAxis: TXLAxis; ASheet: Boolean; var P1, P2: TXLSector);
begin
  if ASheet then
  begin
    P1 := sClient;
    P2 := AAxis;
  end else
  begin
    P1 := sTitle;
    P2 := TXLAxis(Integer(AAxis) xor 1);
  end;
end;

procedure TXLCustomGrid.SetHorzLink(ALink: TXLCustomGrid);
begin
  if ALink = Self then ALink := Nil;
  if ALink <> FHorzLink then
  begin
    if FHorzLink <> Nil then FHorzLink.FHorzLink := Nil;
    FHorzLink := ALink;
    if FHorzLink <> Nil then
    begin
      ScrollLinked(Views.ClientView.Offset);
      FHorzLink.HorzLink := Self;
    end;
  end;
end;

procedure TXLCustomGrid.SetVertLink(ALink: TXLCustomGrid);
begin
  if ALink = Self then ALink := Nil;
  if ALink <> FVertLink then
  begin
    if FVertLink <> Nil then FVertLink.FVertLink := Nil;
    FVertLink := ALink;
    if FVertLink <> Nil then
    begin
      ScrollLinked(Views.ClientView.Offset);
      FVertLink.VertLink := Self;
    end;
  end;
end;

function TXLCustomGrid.DoWheel(Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint): Boolean;
var
  RD: Integer;
  I: Integer;
begin
  Result := False;
  if Sheet <> Nil then begin
    if (TMethod(FProcess).Code <> @TXLCustomGrid.XLSizing) then begin
      if Shift = [ssCtrl] then begin
        if WheelDelta > 0 then begin
          if Scale >= 100 then I := 25 else I := 15;
        end else begin
          if Scale > 100 then I := -25 else I := -15;
        end;
        Scale := IMax(25, IMin(200, Scale + I));
      end else
      with Views.ClientView do begin
        RD := (WheelDelta div 2) div Sheet.RowDefHeight;
        if RD > 0
        then for I := 0 to RD do Perform(WM_VSCROLL, SB_LINELEFT, 0)
        else for I := RD to 0 do Perform(WM_VSCROLL, SB_LINERIGHT, 0);
      end;
    end;
    Result := True;
  end;
end;

{$IFDEF Delphi45}

function TXLCustomGrid.DoMouseWheel(Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint): Boolean;
begin
  Result := DoWheel(Shift, WheelDelta, MousePos);
  inherited DoMouseWheel(Shift, WheelDelta, MousePos);
end;

{$ELSE}

procedure TXLCustomGrid.WMMouseWheel(var Message: TWMMouseWheel);
begin
  TCMMouseWheel(Message).ShiftState := KeysToShiftState(Message.Keys);
  with TCMMouseWheel(Message) do
  begin
    Result := 0;
    DoWheel(ShiftState, WheelDelta, SmallPointToPoint(Pos));
    Message.Result := 1
  end;
end;
{$ENDIF}

function TXLCustomGrid.ScanAlter(Sender: TXLView; APoint: TPoint): TCursor;
var Coord: TPoint;
begin
  FProcess := Nil;
  Result := 0;
  if (Sheet <> Nil) and not (Sheet.ReadOnly) then
  case Sender.HitResult(APoint, Coord) of
  hrColBorder: if (oColSizing in Options) then
               begin
                 FProcess := XLSizing;
                 FSAxis := sCols;
                 FSIndex := Coord.X;
                 FSSheet := Sender.Sector in [sClient, sCols];
                 Result := crHSplit;
               end;
  hrRowBorder: if (oRowSizing in Options) then
               begin
                 FProcess := XLSizing;
                 FSAxis := sRows;
                 FSIndex := Coord.Y;
                 FSSheet := Sender.Sector in [sClient, sRows];
                 Result := crVSplit;
               end;
  hrSelFrame: if Sender = Editor.View then FProcess := XLMoving;
  hrCell: if DesignMode or
            (Sender.CanSelect(Sender.Redirect(Coord))) and
            ((oRangeSelect in Options) or (Sender.Sector = sClient))
            then FProcess := XLSelecting;
  end;
end;

procedure TXLCustomGrid.Altering(Sender: TXLView; APhase: TXLAlterPhase; APoint: TPoint; AShift: TShiftState);
begin

  if Assigned(FProcess) then
  begin
    FPhaseWork := FPhase = pWork;
    if (APhase in [pDone, pCancel]) then begin
      Timer := Nil;
      if not FPhaseWork then APhase := pCancel;
    end;
    FPhase := APhase;
    FProcess(Sender, APoint, AShift);

    if (FPhase in [pDone, pCancel]) then FPhase := pScan
    else if (FPhase = pWork) then Timer := Sender;
  end;
end;

procedure TXLCustomGrid.XLMoving(Sender: TXLView; APoint: TPoint; AShift: TShiftState);
begin

end;

procedure TXLCustomGrid.XLScrolling(Sender: TXLView; APoint: TPoint; AShift: TShiftState);
begin

end;

procedure TXLCustomGrid.XLSelecting(Sender: TXLView; APoint: TPoint; AShift: TShiftState);
var ACoord: TPoint;
begin
  with Sender do
  if ClientToCell(APoint, True, ACoord) then
  begin
    if ((Phase = pInit) and not (ssShift in AShift)) then begin
      Current := ACoord;
      if Editable and (ssDouble in AShift) then
        if Section.PeekCells[Current] = Nil
        then EditMode := emEnter
        else EditMode := emEdit;
    end;
    if not DesignMode and not (oRangeSelect in Options) then
    if CanSelect(ACoord) then Current := ACoord else ACoord := Current;
    Select(Area(Current, ACoord), Current, nil);
    if Phase = pDone then MakeVisible(Area(ACoord, ACoord));
    if (ssDouble in AShift) and (Phase = pInit)
    then CellDblClick(ACoord);
    if not (ssDouble in AShift) and (Phase in [pDone, pCancel])
    then CellClick(ACoord);
  end;
end;

procedure TXLCustomGrid.XLSizing(Sender: TXLView; APoint: TPoint; AShift: TShiftState);
var P1, P2: TXLSector;
    Rect: TRect;
    AIdx: Integer;
    I: Integer;
begin
  if Phase = pInit then
  begin
    EditMode := emNone;
    FSStart := FSizes[FSAxis, FSSheet].SummTo(FSIndex);
    FSSave  := FSizes[FSAxis, FSSheet][FSIndex];
    FSOld   := FSSave;
    FSNew   := FSSave;
    if ssDouble in AShift then
    begin
      FPhase := pCancel;
      AIdx := FSIndex;
      if FSAxis = sCols then
      begin
        if not FSSheet then AIdx := AIdx - Sheet.TitleCols;
        if Assigned(FOnColDblClick) then FOnColDblClick(Self, Point(AIdx, 0));
      end else
      begin
        if not FSSheet then AIdx := AIdx - Sheet.TitleRows;
        if Assigned(FOnRowDblClick) then FOnRowDblClick(Self, Point(0, AIdx));
      end;
      exit;
    end;
  end;

  if Phase = pWork then
  begin
    Rect := ClientRect;
    OffsetRect(Rect, -Sender.Left, -Sender.Top);
    if (TXLSize(APoint).AsArray[FSAxis] >= TXLSize(Rect.TopLeft).AsArray[FSAxis]) and
       (TXLSize(APoint).AsArray[FSAxis] <= TXLSize(Rect.BottomRight).AsArray[FSAxis]) then
    begin
      FSNew := IMax(ToOriginal(Sender.Offset.AsArray[FSAxis] + TXLSize(APoint).AsArray[FSAxis] - FSStart), MinSize);
      if (Sheet <> Nil) then Sheet.Sizing(FSAxis, FSSheet, FSIndex, FSNew);
      FSNew := ToScaled(FSNew);
    end else FSNew := FSSave;
    if not PhaseWork and (Sender.Sector = sClient)
    then if Abs(FSOld - FSNew) < MinSize then exit
         else FPhase := pInit
         else if (FSOld = FSNew) then exit;
  end;

  GetPair(FSAxis, FSSheet, P1, P2);
  // Remove sizing line in Client Area
  if (P1 = sClient) and (Phase in [pWork, pDone, pCancel])
  then Views.ClientView.XLSizing(FSOld, FSOld);

  if (Phase = pDone) and (Sheet <> Nil) then
  begin
    Sheet.FSizes[FSAxis, FSSheet][FSIndex] := ToOriginal(FSNew);
    Sheet.CellChanged(Self, FSAxis, FSSheet, FSIndex);
    Realign;
    LayoutChanged;
  end;

  if (Phase = pCancel) then FSNew := FSSave;

  // Save new Size
  FSizes[FSAxis, FSSheet][FSIndex] := FSNew;

  // Draw & Size
  if Phase in [pWork, pInit, pCancel] then
  begin
    Views.Sectors[P2].XLSizing(FSOld, FSNew);
    if not ((P1 = sClient) and (Phase = pCancel))
    then Views.Sectors[P1].XLSizing(FSOld, FSNew);
  end;

  if (Phase = pDone) and (Sheet <> Nil) and (ssAlt in AShift) then
  with Sender do
    if not IsRectEmpty(SelBounds) and not Editable then begin
      Self.LockUpdate;
      try
        for I := TXLSize(SelBounds.TopLeft).AsArray[FSAxis] to TXLSize(SelBounds.BottomRight).AsArray[FSAxis] - 1 do
        Sheet.SetCellSize(I, Integer(FSAxis), ToOriginal(FSNew));
      finally
        Self.UnlockUpdate;
      end;
    end;

  if (Phase in [pDone, pCancel]) and (oPermEdit in Options) then Editor.Editing := True;

  FSOld := FSNew;
end;

function TXLCustomGrid.IsActive: Boolean;
begin
  Result := HasRelation(Editor.View.Handle, GetFocus);
end;

procedure TXLCustomGrid.SmartFocus;
begin
  if HandleAllocated and CanFocus then SetFocus;
end;

function TXLCustomGrid.CheckFocus(AView: TXLView; ASwitch: Boolean): Boolean;
begin
  if DesignMode and ASwitch then Editor.View := AView;
  Result := IsActive;
  if not Result then SmartFocus;
end;

procedure TXLCustomGrid.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.Style := Params.Style or WS_CLIPCHILDREN;
  Params.WindowClass.Style := Params.WindowClass.Style or CS_CLASSDC;
end;

function TXLCustomGrid.DrawCurrent: Boolean;
begin
  Result := oDrawFocus in Options;
end;

procedure TXLCustomGrid.PrepareSheetData;
var I: TXLSector;
begin
  for I := Low(I) to High(I) do with Views.Sectors[I] do
  begin
    FSection := Nil;
    Color := Self.Color;
    if Sheet <> Nil then begin
      FSection := Self.Sheet.FSections[I];
      Color := FSection.BaseStyle.Color;
    end;
  end;
  SheetSizeChanged([], True);
  LayoutChanged;
  InvalidateAll;
  ResetSelection(True);
end;

procedure TXLCustomGrid.SetDesignMode(Value: Boolean);
begin
  if FDesignMode <> Value then
  begin
    FDesignMode := Value;
    PrepareSheetData;
  end;
end;

procedure TXLCustomGrid.ScrollLinked(AOffset: TXLSize);
var WOffset: TXLSize;
begin
  if (HorzLink <> Nil) or (VertLink <> Nil) then
  begin
    AOffset.sCols := ToOriginal(AOffset.sCols);
    AOffset.sRows := ToOriginal(AOffset.sRows);
    if (HorzLink = VertLink) then
    with HorzLink do
    begin
      WOffset.sCols := ToScaled(AOffset.sCols);
      WOffset.sRows := ToScaled(AOffset.sRows);
      Views.ClientView.SetOffset(WOffset);
    end else
    begin
      if (HorzLink <> Nil) then
      with HorzLink, Views.ClientView do
      begin
        WOffset.sCols := ToScaled(AOffset.sCols);
        WOffset.sRows := Offset.sRows;
        SetOffset(WOffset);
      end;
      if (VertLink <> Nil) then
      with VertLink, Views.ClientView do
      begin
        WOffset.sCols := Offset.sCols;
        WOffset.sRows := ToScaled(AOffset.sRows);
        SetOffset(WOffset);
      end;
    end;
  end;
end;

function TXLCustomGrid.GetSelection: TXLProRange;
begin
  Result := Editor.View.Selection;
  if Sheet = Nil then Result := Nil;
end;

procedure TXLCustomGrid.SetSelection(Value: TXLProRange);
begin
  Editor.View.Selection.Assign(Value);
end;

procedure TXLCustomGrid.InvalidateArea(ASector: TXLSector; const AArea: TRect; AMode: TXLInvalidate);
begin
  Views.Sectors[ASector].InvalidateArea(AArea, False, AMode);
end;

procedure TXLCustomGrid.InvalidateSector(ASector: TXLSector);
begin
  Views.Sectors[ASector].Invalidate;
end;

procedure TXLCustomGrid.InvalidateAll; 
var I: TXLSector;
begin
  for I := Low(I) to High(I) do FViews.Sectors[I].Invalidate;
end;

procedure TXLCustomGrid.SheetSizeChanged(AAxes: TXLAxes; AClient: Boolean);
var ScaledList,
    OriginList: TXLSizeList;

procedure RecalcList;
var I: Integer;
begin
  with OriginList do
  begin
    ScaledList.Count := Count;
    ScaledList.Zero  := Zero * FScale div 100;
    for I := 0 to HighBound do
    ScaledList[I] := Ints[I] * FScale div 100;
  end;
end;

var P1, P2: TXLSector;
    NewSizes: Array[TXLSector] of TXLSize;
    A: TXLAxis;
    M: Boolean;
begin
  if Sheet = Nil then
  begin
    for A := Low(A) to High(A) do
    for M := Low(M) to High(M) do FSizes[A, M].Count := 0;
    FillChar(NewSizes, SizeOf(NewSizes), 0);
  end else
  begin
// Saving old controls sizes
    for P1 := Low(P1) to High(P1) do NewSizes[P1] := Views.Sectors[P1].Size;
// Find out size lists to be recalced
    for A := Low(A) to High(A) do
    if (AAxes = []) or (A in AAxes) then
    for M := Low(M) to High(M) do
    begin
      GetPair(A, M, P1, P2);
      ScaledList := FSizes[A, M];
      OriginList := Sheet.FSizes[A, M];
      RecalcList;
      NewSizes[P1].AsArray[A] := ScaledList.SummTo(ScaledList.Count);
      NewSizes[P2].AsArray[A] := NewSizes[P1].AsArray[A];
      Views.Sectors[P1].Invalidate;
      Views.Sectors[P2].Invalidate;
    end;
  end;
// Setting new controls sizes
  for P1 := Low(P1) to High(P1) do Views.Sectors[P1].SetSize(NewSizes[P1]);
// Realign needed
  LayoutChanged;
  Realign;
  ResetSelection(False);  
end;

procedure TXLCustomGrid.CellSizeChanged(AAxis: TXLAxis; AClient: Boolean; AIndex: Integer);
var
  P1, P2: TXLSector;
  ST, NS, OS: Integer;
begin
  GetPair(AAxis, AClient, P1, P2);
  with FSizes[AAxis, AClient] do
  begin
    FSAxis := AAxis;
    FSSheet := AClient;
    FSIndex := AIndex;
    OS := Ints[AIndex];
    if Sheet <> Nil
    then NS := ToScaled(Sheet.FSizes[AAxis, AClient][AIndex])
    else NS := 0;
    if OS <> NS then
    begin
      ST := SummTo(AIndex);
      Ints[AIndex] := NS;
      Views.Sectors[P1].AdjustSizeChange(AAxis, ST, OS, NS);
      Views.Sectors[P2].AdjustSizeChange(AAxis, ST, OS, NS);
      Realign;
    end;
  end;
  if oPrintLayout in options then LayoutChanged;
end;

procedure TXLCustomGrid.AreaChanged(ASector: TXLSector; AArea: PRect);
begin
  if AArea = Nil then with Views.Sectors[ASector] do Color := Section.BaseStyle.Color
  else if (Editor.View.Sector = ASector) and (Editor.EditCell <> Nil) and PtInRect(AArea^, Editor.EditCell.Position)
       then Editor.UpdateEditor;
end;

procedure TXLCustomGrid.CloseEditor(ACell: TXLCell);
begin
  if Editor.EditCell = ACell then Editor.SetEditCell(nil, nil);
end;

procedure TXLCustomGrid.ResetSelection(AZap: Boolean);
var I: TXLSector;
begin
  for I := Low(I) to High(I) do
  with Views.Sectors[I] do
    if AZap then ResetSelection
    else Selection.Bounds := Selection.Bounds;
end;

{$IFNDEF Delphi45}

function TXLCustomGrid.QueryInterface(const IID: TGUID; out Obj): Integer;
const
  E_NOINTERFACE = $80004002;
begin
  if GetInterface(IID, Obj) then Result := 0 else Result := E_NOINTERFACE;
end;

function TXLCustomGrid._AddRef: Integer;
begin
  Result := -1;
end;

function TXLCustomGrid._Release: Integer;
begin
  Result := -1;
end;
{$ENDIF}

function TXLCustomGrid.GetEditMode: TXLEditMode;
begin
  Result := emNone;
  with Editor do if Editing then
    if Entering then Result := emEnter
    else Result := emEdit;
end;

procedure TXLCustomGrid.SetEditMode(AMode: TXLEditMode);
begin
  Editor.Entering := AMode = emEnter;
  Editor.Editing := AMode > emNone;
end;

procedure TXLCustomGrid.LayoutChanged;
begin
  if (Sheet <> Nil) and (oPrintLayout in Options) then Views.ClientView.Invalidate;
end;

function TXLCustomGrid.GetEnterDir: TXLDirection;
begin
  Result := FGridDir;
  if Result = dAuto then Result := LastDir;
end;

procedure TXLCustomGrid.SelectAll;
var
  EV: TXLView;
begin
  EV := Editor.View;
  if EV.Sector = sClient then EV := Views.TitleView;
  with EV do Select(Rect(0, 0, MaxInt, MaxInt), Current, nil);
end;

procedure TXLCustomGrid.SelectNext(ADir: TXLDirection; ABackwards: Boolean);
var P: TPoint;
    Sel: Boolean;
begin
  if (Sheet <> Nil) then
  with Editor.View do begin
    P := FKeyCurr;
    Sel := Selection.Single;
    if ADir = dAuto then ADir := RealDir;
    if ABackwards then ADir := BackMap[ADir];
    if FindNext(P, ADir, not Sel) then
    begin
      MoveCurrent(P, Sel, True);
      FKeyCurr := P;
    end else
    if not (oPermEdit in Grid.Options) then Editor.SetEditCell(nil, nil);
  end
end;

{ TXLEdit }

constructor TXLEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  if not (AOwner is TXLCustomGrid) then InvalidOp('XLEdit is designed for XLGrid only!');
  FGrid := TXLCustomGrid(AOwner);
  ParentColor := False;
  ParentFont := False;
  Visible := False;
  Parent := Grid;
end;

function TXLEdit.GetEditing: Boolean;
begin
  Result := (FControl <> Nil) and (FCell <> Nil);
end;

procedure TXLEdit.Relocate;
var
  R: TRect;
begin
  if EditCell <> Nil then begin
    View.CalcRect(EditCell.Bounds, R, cmFull);
    View.Section.AdjustFrameRect(R, EditCell.Frame);
    InflateRect(R, 2, 2);
    BoundsRect := R;
//    RequestAlign;
  end;
end;

procedure TXLEdit.Cancel;
begin
  SetCell(nil, False);
end;

procedure TXLEdit.SetCell(ACell: TXLCell; ASave: Boolean);
begin
  if ACell <> FCell then
  begin
    if (FCell <> Nil) then
    begin
      Exclude(FCell.FStates, csEditing);
      if ASave then
      try
        FControl.Perform(XL_SAVECELL, Integer(FCell), 0);
      except

      end;
    end;
    FCell := ACell;
    if (FCell <> Nil) then
    try
      FCell.Invalidate;
      Relocate;
      Read;
      Show;
      Include(FCell.FStates, csEditing);
    except
      FCell := Nil;
    end;
    if FCell = Nil then begin
      Hide;
      Grid.SmartFocus;
    end;
  end;
end;

procedure TXLEdit.SetEditCell(AView: TXLView; ACell: TXLCell);
var OEM: Boolean;
begin
  if (AView = View) or (AView = Nil) then begin
    OEM := Editing;
    if ACell = Nil then begin
      if FPopupSave <> Nil then Grid.PopupMenu := FPopupSave;
      if (FControl <> Nil) and not (csDestroying in ComponentState)
      then SetCell(Nil, True);
    end else begin
      FPopupSave := Grid.PopupMenu;
      Grid.PopupMenu := Nil;
      EditClass := XLManager.EditClasses[ACell.CellClass, ACell.Editor];
      if FControl <> Nil then begin
        if oPermEdit in Grid.Options then Entering := True;
        SetCell(ACell, True);
      end;
    end;
    if (OEM <> Editing) and Assigned(Grid.FOnEditModeChanged) then Grid.FOnEditModeChanged(Grid);
  end;
end;

procedure TXLEdit.SetEditClass(AClass: TWinControlClass);
begin
  if (FControl = Nil) or (AClass <> FControl.ClassType) then
  begin
    FControl.Free;
    if AClass <> Nil then
    begin
      FControl := AClass.Create(Self);
      FControl.FreeNotification(Self);
      FControl.Parent := Self;
//      FControl.Align := alClient;
      TEdit(FControl).ParentColor := True;
      FWorkControl := FControl;
      FWorkHandle := FControl.Handle;
      FControl.Perform(XL_EDITINFO, Integer(@FWorkControl), Integer(@FWorkHandle));
      TEdit(FWorkControl).OnKeyPress := ControlKeyPress;
      TEdit(FWorkControl).OnKeyDown := ControlKeyDown;
    end;
  end;
end;

procedure TXLEdit.SetEditing(Value: Boolean);
begin
  if (Value <> Editing) then with View do
  if HandleAllocated and ([csDesigning, csLoading, csReading] * ComponentState = [])  then
  if Value then SetEditCoord(Current)
  else SetEditCell(Nil, Nil);
end;

procedure TXLEdit.Show;
begin
  TEdit(FWorkControl).ImeMode := Grid.ImeMode;
  TEdit(FWorkControl).ImeName := Grid.ImeName;
  inherited Show;
  FWorkControl.SetFocus;
end;

procedure TXLEdit.ShowWithMessage(var Msg: TMessage);
begin
  Entering := True;
  if (FWorkControl <> Nil) and (FCell <> Nil) then
  begin
    with FWorkControl do begin
      Perform(CM_ENTER, 0, 0);
      Perform(EM_SETSEL, 0, -1);
      Perform(Msg.Msg, Msg.WParam, Msg.LParam);
//      PostMessage(Handle, Msg.Msg, Msg.WParam, Msg.LParam);
    end;
    Show;
  end;
end;

procedure TXLEdit.SendMessage(var Msg: TMessage);
begin
  if (FWorkControl <> Nil) and (FCell <> Nil)
  then Windows.SendMessage(FWorkControl.Handle, Msg.Msg, Msg.WParam, Msg.LParam);
end;

procedure TXLEdit.UpdateEditor;
var Layout: TXLLayout;
    C: TColor;
begin
  if Editing then begin
    C := EditCell.Color;
    if C = clNone then C := View.Section.BaseStyle.Color;
    Color := C;
    Layout := EditCell.Layout;
    Font := EditCell.FindProperty(prFont).Font;
    View.Section.PrepareFont(Font, Grid.Scale, True, False);
    Perform(CM_FONTCHANGED, 0, 0);
    FControl.Perform(CM_PARENTCOLORCHANGED, 0, 0);
    FControl.Perform(XL_LAYOUT, Integer(@Layout), 0);
    FAlign := Layout.VertAlign;
    Realign;
  end;
end;

procedure TXLEdit.Read;
begin
  if (csAssign in FCell.FStates) then exit;
  UpdateEditor;
  if Editing then FControl.Perform(XL_LOADCELL, Integer(EditCell), 0);
end;

procedure TXLEdit.ControlKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  case Key of
    VK_LEFT,  VK_RIGHT,
    VK_UP,    VK_DOWN,
    VK_HOME,  VK_END,
    VK_PRIOR, VK_NEXT: if Entering and (Shift <> [ssAlt]) then begin
                         View.KeyDown(Key, Shift);
                         Key := 0;
                       end;
    VK_F2: if Shift = [] then Entering := not Entering;
  end;
end;

procedure TXLEdit.ControlKeyPress(Sender: TObject; var Key: Char);
begin
  case Key of
   #13: ; // intercept in any case
   #27: if GetFocus <> FWorkHandle then exit; // only if pressed in edit
   else exit;
  end;
  View.KeyPress(Key);
  Key := #0;
end;

procedure TXLEdit.SetEditView(AView: TXLView);
begin
  if FView <> AView then begin
    Editing := False;
    Grid.ResetSelection(True);
    FView := AView;
    Parent := View;
  end;
end;

procedure TXLEdit.SetEntering(Value: Boolean);
begin
  if Entering <> Value then
  begin
    FEntering := Value;
    if Editing and Assigned(Grid.FOnEditModeChanged) then Grid.FOnEditModeChanged(Grid);
  end;
end;

procedure TXLEdit.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent = FControl) then begin
    FCell := Nil;
    FControl := Nil;
  end;
end;

procedure TXLEdit.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.ExStyle := Params.ExStyle or WS_EX_CLIENTEDGE;
end;

procedure TXLEdit.AlignControls(AControl: TControl; var ARect: TRect);
var
  CH: Integer;
begin
  inherited AlignControls(AControl, ARect);
  if (FControl <> Nil) and (FControl.Align = alNone) then begin
    CH := FControl.Height;
    case FAlign of
      vaTop: ARect.Bottom := ARect.Top + CH;
      vaBottom: ARect.Top := ARect.Bottom - CH;
      else begin
        ARect.Top := (ARect.Bottom + ARect.Top - CH) div 2;
        ARect.Bottom := ARect.Top + CH;
      end;
    end;
    FControl.BoundsRect := ARect;
  end;
end;


// TXLManager

constructor TXLManager.Create;
begin
  inherited Create;
  FCellClasses := TList.Create;
  FEditClasses := TList.Create;
  FCellFormats := TList.Create;
end;

destructor TXLManager.Destroy;
var I: Integer;
begin
  for I := 0 to FEditClasses.Count - 1 do TObject(FEditClasses[I]).Free;
  for I := 0 to FCellFormats.Count - 1 do TObject(FCellFormats[I]).Free;
  FEditClasses.Free;
  FCellFormats.Free;
  FCellClasses.Free;
  inherited Destroy;
end;

function TXLManager.FindClassBy(AHashCode: Integer): TXLCellClass;
var I: Integer;
begin
  for I := 0 to CellClassCount - 1 do
  begin
    Result := CellClasses[I];
    if AHashCode = HashCodeOf(Result) then exit;
  end;
  Result := nil;
end;

function TXLManager.HashCodeOf(AClass: TClass): Integer;
var I: Integer;
    S: String;
begin
  Result := 0;
  if AClass <> Nil then
  begin
    S := AClass.ClassName;
    for I := 1 to Length(S) do Inc(Result, Byte(S[I]));
  end;
end;

function TXLManager.GetCellClass(AIndex: Integer): TXLCellClass;
begin
  Result := TXLCellClass(FCellClasses[AIndex]);
end;

function TXLManager.GetCellClassCount: Integer;
begin
  Result := FCellClasses.Count;
end;

function TXLManager.GetEditClass(ACellClass: TXLCellClass;
  AIndex: Integer): TWinControlClass;
var CellClassIndex: Integer;
    EditList: TList;
begin
  Result := Nil;
  CellClassIndex := FCellClasses.IndexOf(ACellClass);
  if (CellClassIndex >= 0) then
  begin
    EditList := TList(FEditClasses[CellClassIndex]);
    if (EditList <> Nil) and (EditList.Count > AIndex)
    then Result := TWinControlClass(EditList[AIndex]);
  end;
end;

function TXLManager.GetEditClassCount(ACellClass: TXLCellClass): Integer;
var CellClassIndex: Integer;
    EditList: TList;
begin
  Result := 0;
  CellClassIndex := FCellClasses.IndexOf(ACellClass);
  if CellClassIndex >= 0 then
  begin
    EditList := TList(FEditClasses[CellClassIndex]);
    if EditList <> Nil then Result := EditList.Count;
  end;
end;

function TXLManager.GetFormats(ACellClass: TXLCellClass): TStrings;
var CellClassIndex: Integer;
begin
  Result := Nil;
  CellClassIndex := FCellClasses.IndexOf(ACellClass);
  if CellClassIndex >= 0 then Result := TStrings(FCellFormats[CellClassIndex]);
end;

procedure TXLManager.SetFormats(ACellClass: TXLCellClass; AFormats: TStrings);
begin
  Formats[ACellClass].Assign(AFormats);
end;

function TXLManager.EnsureCellClass(ACellClass: TXLCellClass): Integer;
begin
  Result := FCellClasses.IndexOf(ACellClass);
  if Result < 0 then
  begin
    Result := FCellClasses.Add(ACellClass);
    while FEditClasses.Count <= Result do FEditClasses.Add(TList.Create);
    while FCellFormats.Count <= Result do FCellFormats.Add(TStringList.Create);
  end;
end;

procedure TXLManager.RegisterCellClasses(const ACellClasses: Array of TXLCellClass);
var I: Integer;
begin
  for I := Low(ACellClasses) to High(ACellClasses) do EnsureCellClass(ACellClasses[I]);
end;

procedure TXLManager.RegisterClasses(const ACellClasses: Array of TXLCellClass;
  const ACellEdits: array of TWinControlClass);
var I, J: Integer;
    CellEdit: TWinControlClass;
begin
  for I := Low(ACellClasses) to High(ACellClasses) do
  with TList(FEditClasses[EnsureCellClass(ACellClasses[I])]) do
  for J := Low(ACellEdits) to High(ACellEdits) do
  begin
    CellEdit := ACellEdits[J];
    if IndexOf(CellEdit) < 0 then Add(CellEdit);
  end;
end;

function TXLManager.FindEditClass(ACellClass: TXLCellClass; AEditClass: TWinControlClass): Integer;
var
  CellIndex: Integer;
begin
  Result := -1;
  CellIndex := FCellClasses.IndexOf(Pointer(ACellClass));
  if CellIndex >= 0
  then Result := TList(FEditClasses[CellIndex]).IndexOf(AEditClass);
end;

procedure TXLManager.UnregisterCellClasses(const ACellClasses: array of TXLCellClass);
var CellClassIndex, I: Integer;
begin
  for I := Low(ACellClasses) to High(ACellClasses) do
  begin
    CellClassIndex := FCellClasses.Remove(ACellClasses[I]);
    if CellClassIndex >= 0 then
    begin
      TObject(FEditClasses[CellClassIndex]).Free;
      TObject(FCellFormats[CellClassIndex]).Free;
      FEditClasses.Delete(CellClassIndex);
      FCellFormats.Delete(CellClassIndex);
    end;
  end;
end;

procedure TXLManager.UnregisterEditClasses(const AEditClasses: array of TWinControlClass);
var I, J: Integer;
begin
  for I := 0 to CellClassCount - 1 do
  for J := Low(AEditClasses) to High(AEditClasses) do
  TList(FEditClasses[I]).Remove(AEditClasses[J]);
end;
procedure Register;
begin
  RegisterComponents('XLGrids', [TXLSheet,TXLGrid,TXLStyler]);
end;

(*procedure TXLView.WMLButtonDown(var Msg: TWMMouse);
var col,row:integer;
begin
{ TODO : ޸˲Դ룬˫쳣 }
{  col:=Grid.CurCol ;
  row:=Grid.CurRow;
  //Ϊͣ˫¼
  if Grid.Sheet.CellClasses[col,row]  =   TXLCStrings then
  begin
    if Grid.Sheet.Cells[col,row].Editor = 0 then
    begin
      Abort;
    end
    else  begin
      Inherited ;
    end;
  end
  else
  if Grid.Sheet.CellClasses[col,row]  =  TXLCDateTime then
 }   Inherited ;

end;*)

initialization
  HiddenBitmap := TBitmap.Create;
  HiddenBitmap.LoadFromResourceName(HInstance, 'HATCH');
  HiddenBrush := TBrush.Create;
  HiddenBrush.Bitmap := HiddenBitmap;

finalization
  HiddenBrush.Free;
  HiddenBitmap.Free;
  FXLClipboard.Free;
  FXLManager.Free;
end.


